function qq_2dfari(an)

global fariset Cal_X Sam_X Refdata Sampledata Samplegroupdata Results files 

fariset.an=an; % TEMP
qq_message(2); % CLEAR MESSAGE

% Reset
if an==0
    h=findobj('Tag','2DF-Win'); 
    if isempty(h)
        openwin % TEMP
        Refdata=[]; Sampledata=[]; files=[]; Cal_X=[]; Sam_X=[]; Samplegroupdata=[]; Results=[];
        fariset=[]; 
        sstr=fset('searchstr'); if isempty(sstr) fariset.searchstr='RESULTS_'; else fariset.searchstr=sstr; end
        dr=fset('directory'); if isempty(dr) fariset.directory='C:\qq\2D-FARI\data'; else fariset.directory=dr; end
        % Leser Refdata
        Refdata=tableread('C:\qq\2D-FARI\referencedata.txt',{'Code','FARIA','FARIB'});
        Refdata(1)=[];[m,n]=size(Refdata);
        for x=1:n
            Refdata(x).FARIA=str2double(Refdata(x).FARIA);
            Refdata(x).FARIB=str2double(Refdata(x).FARIB);
        end 
    end
end

% files
if an==1.1 h=findobj('Tag','SearchStrEdit'); fariset.searchstr=get(h,'String'); fset('searchstr',fariset.searchstr); getfiles; end
if an==1.2 h=findobj('Tag','DirectoryEdit'); fariset.directory=get(h,'String'); fset('directory',fariset.directory); getfiles; end

if an==1.3 
    h=findobj('Tag','FileList'); val=get(h,'Value'); f_name=files.all{val}
    %open([fariset.directory,'\',f_name]);
    qq_message(6,[fariset.directory,'\',f_name]);
end

% add reference
if an==2.1 & fariset.available_files>0 addref; end
% Remove reference
if an==2.2 & fariset.selected_refs>0  
    h=findobj('Tag','ReferenceFileList'); val=get(h,'Value'); 
    files.references(val)=[]; set(h,'Value',1); 
    Cal_X(:,val)=[]; [m,n]=size(files.references); fariset.selected_refs=n;  
    referencelist
end   
% Accept references
if an==2.3 & fariset.selected_refs>0  
    calfiles=files.references; 
    %save 'C:\qq\2D-FARI\cal_tempsave' calfiles Cal_X; 
    h=findobj('Tag','RefFnEdit'); filename=get(h,'String'); pathname=['C:\qq\2D-FARI\cal_' filename];
    save(pathname,'calfiles','Cal_X'); 
    %disp(['----- SAVED: ' pathname '-----']) % TEMP
    fariset.accepted_refs=fariset.selected_refs;
end
% Resume (references)
if an==2.4 
    %load 'C:\qq\2D-FARI\cal_tempsave' calfiles Cal_X; files.references=calfiles;  
    h=findobj('Tag','RefFnEdit'); filename=get(h,'String'); pathname=['C:\qq\2D-FARI\cal_' filename];
    load(pathname,'calfiles','Cal_X');
    %disp(['----- LOADED: ' pathname '-----']) % TEMP
    files.references=calfiles; [m,n]=size(files.references); fariset.selected_refs=n; fariset.accepted_refs=n;
    referencelist
end
if an==2.9 & isempty(Cal_X)==0
    sortresults('I'); referencelist
end

% add sample
if an==6.1 & fariset.available_files>0 addsample; end
% Remove Sample
if an==6.2 & fariset.selected_samples>0
    h=findobj('Tag','SampleFileList'); val=get(h,'Value'); 
    files.samples(val)=[]; Sampledata(val)=[]; set(h,'Value',1); 
    fariset.selected_samples=fariset.selected_samples-1;
end
% Group
if an==6.3 groupsamples; end
% Resume (Samples)
if an==6.4
    % load 'C:\qq\2D-FARI\smp_tempsave' Cal_X Refdata Sampledata fariset files Sam_X Samplegroupdata
    h=findobj('Tag','GroupFnEdit'); filename=get(h,'String'); pathname=['C:\qq\2D-FARI\smp_' filename];
    load(pathname, 'Cal_X','Refdata','Sampledata','fariset','files','Sam_X','Samplegroupdata')
    samplelist 
end
if an==6.5
    sortresults('I'); samplelist 
end

% PCA

if an>3.0 & an< 4.0
    ok=1; 
    [m,z]=size(Cal_X); 
    [o,p]=size(Sam_X); 
    if m+o==0 qq_message(1,'|r|No data'); ok=0; end
    if ok==1 & o==0 qq_message(1,'|r|No sample group'); ok=0; end
    if ok==1 & z>0 & (z~=p) qq_message(1,'|r|Different number of references and samples in group'); ok=0; end
    % PCA
    if an==3.1 & ok pca; end
    % dbregression
    if an==3.3 & ok dbregression; end
    % farireg
    if an==3.2 & ok==1 & m==0 qq_message(1,'|r|No references'); ok=0; end
    if an==3.2 & ok farireg; end  
end

% Select object
if an==4.1
    %val=get(gco,'value'); fariset.selected=val; 
    %disp('---- SELECT OBJECT ----')
    [pos,listpos]=getposition; fariset.selected=pos;
    h=findobj('Tag','Plotmarker'); if isempty(h)==0; set(h,'XData',Results(pos).plot_x,'YData',Results(pos).plot_y,'Marker','o'); end
    addinfo
    zoom(1)
end  

% Delete grouped sample
if an>4.1 & an<4.5 %& fariset.sample_objects>0 
    if an==4.2 delsample(1); end % delete selected
    if an==4.3 delsample(2); end % Delete group
    if an==4.4 delsample(3); end % Delete code
end

% ZOOM
if an==5.1 zoom(1.5); end
if an==5.2 zoom(0.667); end    
if an==5.3 plotlabels; end
if an==5.4 
    %getinfo; 
    h=findobj('Tag','ResultsList'); plottype=get(h,'UserData');
    if strmatch(plottype,'Farilist') farilist; plotlabels; end
    if strmatch(plottype,'Samplelist') samplelist; end
    if strmatch(plottype,'Referencelist') referencelist; end
end

% Set files
if an==8.1  fariset.edit_lib=get(gcbo,'String'); fset('edit_lib',fariset.edit_lib); end
if an==8.2  fariset.calib_file=get(gcbo,'String'); fset('calib_file',fariset.calib_file); end
if an==8.3  fariset.sample_file=get(gcbo,'String'); fset('sample_file',fariset.sample_file); end

% Export/info
if an==9.1 infowin; end
% Export Figure
if an==9.2
    h0=figure; set(h0,'Tag','ExpFig'); plotfari; 
    h=findobj(h0,'Tag','xy-plot'); set(h,'Tag','xy-plot-B','Position',[0.05 0.05 0.9 0.9]); 
end
% Sort results
if an==9.3 sortresults('C'); farilist; end
% Export Results
if an==9.4 exportresults; end
if an==9.5 exportraw; end
if an==9.6 getinfo; qq_2dfari_optires(1); end

  

% --------------------------------- UPDATE ----------------------------------
% Status



% Lister
h=findobj('Tag','SearchStrEdit'); 
if isfield(fariset,'searchstr') set(h,'String',fariset.searchstr); else set(h,'String',' '); end 
h=findobj('Tag','DirectoryEdit'); 
if isfield(fariset,'directory') set(h,'String',fariset.directory); else set(h,'String',' '); end 
h=findobj('Tag','ReferenceFileList'); 
if isfield(files,'references') set(h,'String',short(files.references)); else set(h,'String',' '); end
h=findobj('Tag','SampleFileList'); 
if isfield(files,'samples') set(h,'String',short(files.samples)); else set(h,'String',' '); end
h=findobj('Tag','FileList'); 
if isfield(files,'all') set(h,'String',short(files.all)); else set(h,'String',' '); end


%---------------------------------------------------------------------------------------
%------------------------------------- SUBFUNCTIONS ------------------------------------
%---------------------------------------------------------------------------------------

%======================================== LISTS ========================================
% samplelist
% referencelist
% farilist
% short

%------------------- SAMPLELIST ---------------------
function samplelist
global Sam_X Samplegroupdata

h=findobj('Tag','ShortToggle'); shortnames=get(h,'Value'); if shortnames==1 getinfo; end 

[m,n]=size(Sam_X); 
dispstr=[]; p=9; 
for x=1:m
    if shortnames        
        %if isempty(Samplegroupdata.Short{x}) getinfo; end
        str1=[Samplegroupdata.Short{x}]; str1=[str1,blanks(p+1-length(str1))];
    else
        str1=[Samplegroupdata.Code{x}]; str1=[str1,blanks(9-length(str1))];
    end
    str2=num2str(Samplegroupdata.group{x}); str2=[str2,blanks(3-length(str2))];
    str4=[];
    for y=1:n
        str3{y}=num2str(Sam_X(x,y),'%-1.3f'); if isnan(Sam_X(x,y)) str3{y}='-'; end
        str3{y}=[str3{y},blanks(8-length(str3{y}))]; str4=[str4 str3{y}];
    end
    dispstr{x}=[str2 str1 str4];
end

h=findobj('Tag','ResultsList'); set(h,'String',dispstr); set(h,'UserData','Samplelist');
if selected>m set(h,'Value',m); end
if selected==0 set(h,'Value',1); end
if m>0 h=findobj('Tag','Deleteline'); set(h,'Enable','on'); end

%------------------- REFERENCELIST ---------------------
function referencelist
global Cal_X Refdata

h=findobj('Tag','ShortToggle'); shortnames=get(h,'Value');
if isfield(Refdata,'Short')==0 getinfo; end; [o,p]=size(strvcat(Refdata.Short));

dispstr=''; [m,n]=size(Cal_X); % n=antall objekter
for x=1:m
    if shortnames
        if isempty(Refdata(x).Short) getinfo; end
        str1=[Refdata(x).Short]; str1=[str1,blanks(p-length(str1))];
    else
        str1=[Refdata(x).Code]; str1=[str1,blanks(7-length(str1))];
    end
    str5=num2str(x); str5=[blanks(2-length(str5)),str5];
    str4=[];
    for y=1:n
        str3{y}=num2str(Cal_X(x,y),'%-1.3f'); if isnan(Cal_X(x,y)) str3{y}='-'; end
        str3{y}=[blanks(8-length(str3{y})),str3{y}]; str4=[str4 str3{y}];
    end
    dispstr{x}=[str5 '  ' str1 str4];
end
    
h=findobj('Tag','ResultsList'); set(h,'String',dispstr); set(h,'UserData','Referencelist');
if selected>m set(h,'Value',m); end
if selected==0 set(h,'Value',1); end
if m>0 h=findobj('Tag','Deleteline'); set(h,'Enable','on'); end

% ------------------ FARILIST -----------------
function farilist
global Results fariset

h=findobj('Tag','ShortToggle'); shortnames=get(h,'Value');
if isfield(Results,'Short')==0 getinfo; end

[m,n_pred]=size(Results);
if isfield(Results,'Short')==0 getinfo; end
[o,p]=size(strvcat(Results.Short));
for x=1:n_pred
  str1=[num2str(Results(x).index)]; str1=[blanks(2-length(str1)),str1];
  if shortnames
      str2=[Results(x).Short]; str2=['  ',str2,blanks(p-length(str2))];
  else
      str2=[Results(x).Code]; str2=['  ',str2,blanks(7-length(str2))];
  end
  str3=[num2str(Results(x).plot_x,'%-1.3f')]; str3=[blanks(7-length(str3)),str3,' '];
  str4=[num2str(Results(x).plot_y,'%-1.3f')]; str4=[blanks(6-length(str4)),str4];
  if isfield(Results,'sep_A') 
      str5=[num2str(Results(x).sep_A,'%-1.3f')]; str5=[blanks(7-length(str5)),str5]; 
      str6=[num2str(Results(x).sep_B,'%-1.3f')]; str6=[blanks(7-length(str6)),str6];
  else
      str5=''; str6='';
  end
  if Results(x).group==0 str7='Cal'; else str7=[num2str(Results(x).group)]; end; str7=['  ',str7,blanks(3-length(str7))];
  if isfield(Results,'Note') & isempty(Results(x).Note)==0; str8=[Results(x).Note]; else str8=' '; end 

  dispstr{x}=[str1 str2 str3 str4 str5 str6 str7 str8];
end   

if isfield(fariset,'selected')==0; fariset.selected=1; end
if fariset.selected==0; fariset.selected=1; end
[m,n]=size(dispstr); if fariset.selected>n fariset.selected=n; end 

h=findobj('Tag','ResultsList'); set(h,'String',dispstr); set(h,'Value',fariset.selected); set(h,'UserData','Farilist');
h=findobj('Tag','Deleteline'); set(h,'Enable','off'); % Enable delete line

% ------------------- SHORT -----------------------
function listtext=short(listtext)
global fariset
% Forkorter filnavn ved  trekke fra Searchstring

le=length(fariset.searchstr);
[m,n]=size(listtext);
if le>2 for x=1:n listtext{x}=strrep(listtext{x},fariset.searchstr,'..'); end; end

%======================================= end lists ============================================

%======================================= PLOTTING ========================================
% plotfari
% plotlabels
% zoom

% ------------------ PLOTFARI -----------------
function plotfari
global Results Cal_X fariset

[m,n_pred]=size(Results);
[n_calib,n]=size(Cal_X);

% plot
h=findobj('Tag','ResultsList'); pos=get(h,'Position'); pos=pos+[0 -0.43 0 0];
h=subplot('Position',pos); set(h,'Tag','xy-plot');
children=get(h,'Children'); delete(children);
minx=min(cat(2,Results.plot_x)); maxx=max(cat(2,Results.plot_x)); xr=(maxx-minx)/10; xlim(h,[minx-xr maxx+xr]); 
miny=min(cat(2,Results.plot_y)); maxy=max(cat(2,Results.plot_y)); yr=(maxy-miny)/10; ylim(h,[miny-yr maxy+yr]);

hold on
for x=1:n_pred
    h=plot(Results(x).plot_x,Results(x).plot_y,'.','MarkerSize',10,'Tag',['Plottag_' num2str(x)]);
    %h=plot(Results(x).FARIA,Results(x).FARIB,'.','MarkerSize',10,'Tag',['Plottag_' Results(x).Code]);
    if x<=n_calib
        set(h,'MarkerFaceColor',[0 0.7 0],'MarkerEdgeColor',[0 0.7 0]); 
    else 
        set(h,'MarkerFaceColor',[0 0 1],'MarkerEdgeColor',[0 0 1]); 
    end
    if isfield(Results,'leftout') & isempty(Results(x).leftout)==0 set(h,'MarkerFaceColor',[1 0 0], 'MarkerEdgeColor',[1 0 0]); end    
end
% Marker
h=plot(mean(xlim),mean(ylim),...
    'MarkerSize',8,...
    'Tag','Plotmarker',...
    'Marker','none',...
    'MarkerEdgeColor',[0 0 0],...
    'LineWidth',2,...
    'MarkerFaceColor','none');
hold off

% GRIDS
grid=0;
if strmatch(fariset.resultstype,'Regression') grid=1; end 
if strmatch(fariset.resultstype,'2D-FARI') grid=1; end 
if grid==1
    minx=min(cat(2,Results.plot_x));maxx=max(cat(2,Results.plot_x));miny=min(cat(2,Results.plot_y));maxy=max(cat(2,Results.plot_y));
    miny=round(miny)-0.5; maxy=round(maxy)+0.5; minx=round(minx)-0.5; maxx=round(maxx)+0.5;
    a=miny:1:maxy; for x=1:length(a) line('XData',[minx maxx],'YData',[a(x) a(x)],'LineStyle',':'); end
    a=minx:1:maxx; for x=1:length(a) line('XData',[a(x) a(x)],'YData',[miny maxy],'LineStyle',':'); end 
end

% ------------------- PLOTLABELS -----------------------
function plotlabels
global Results fonts

h=findobj('Tag','ShortToggle'); shortnames=get(h,'Value');
if isfield(Results,'Short')==0 getinfo; end

if shortnames labels=str2mat(Results.Short); else labels=str2mat(Results.Code); end
[m,n]=size(labels); labels=[repmat('  ',m,1) labels];

ploth=[findobj('Tag','xy-plot') findobj('Tag','xy-plot-B')];
%if isempty(ploth)==0
for x=1:length(ploth)
    axes(ploth(x));
    buttonh=findobj('Tag','LabelsToggle'); labelsh=findobj('Tag','Textlabel'); delete(labelsh)
    if get(buttonh,'Value')==1 
        text(cat(2,Results.plot_x),cat(2,Results.plot_y),labels,'Tag','Textlabel','FontSize',fonts(1));
    end
end
h=findobj('Tag','Textlabel'); set(h,'Clipping','on')


% ------------------- ZOOM -----------------------
function zoom(fact)

h=findobj('Tag','xy-plot');
if isempty(h)==0
    
    xax=xlim(h); xrange=xax(2)-xax(1); yax=ylim(h); yrange=yax(2)-yax(1);
    markh=findobj('Tag','Plotmarker'); xcent=get(markh,'XData'); ycent=get(markh,'YData');

    xrange=xrange/fact; yrange=yrange/fact;
    xax=[xcent-xrange/2 xcent+xrange/2];
    yax=[ycent-yrange/2 ycent+yrange/2];
    xlim(h,xax); ylim(h,yax);
end


%======================================= end plotting ============================================


%======================================= CALCULATIONS ============================================
% farireg
% regression
% crossvalidation

% ------------------- FARIREG -----------------------
function farireg
global Cal_X Refdata Sam_X Samplegroupdata Results fariset files

Results=[];Results.Note=[]; Results.leftout=[];

X_cal=Cal_X;
X_pred=[Cal_X; Sam_X];  % Prediksjonssett = kalibrering 

FARIA_cal=cat(1,Refdata.FARIA);
[FARIA_p,sep_A]=regression(X_cal,FARIA_cal,X_pred,0);
FARIB_cal=cat(1,Refdata.FARIB);
[FARIB_p,sep_B]=regression(X_cal,FARIB_cal,X_pred,0);

ind=find(isnan(FARIA_p)); n_nan=length(ind);
for x=1:n_nan
    ind2=find(isnan(X_pred(ind(x),:)));
    Xl_cal=X_cal; Xl_cal(:,ind2)=[];
    Xl_pred=X_pred(ind(x),:); Xl_pred(:,ind2)=[];
    [FARIA_p(ind(x)),sep_A(ind(x))]=regression(Xl_cal,FARIA_cal,Xl_pred,0);
    [FARIB_p(ind(x)),sep_B(ind(x))]=regression(Xl_cal,FARIB_cal,Xl_pred,0);
    Results(ind(x)).leftout=(ind2); Results(ind(x)).Note=[Results(ind(x)).Note, '/X-var:' num2str(ind2)];
end

% Results
[n_pred,n]=size(X_pred);
[n_calib,n]=size(X_cal);
for x=1:n_pred
    Results(x).index=x;
    Results(x).FARIA=FARIA_p(x);
    Results(x).FARIB=FARIB_p(x);
    Results(x).sep_A=sep_A(x);
    Results(x).sep_B=sep_B(x);
    if x<=n_calib Results(x).group=0; else Results(x).group=Samplegroupdata.group{x-n_calib}; end
    if x<=n_calib Results(x).Code=Refdata(x).Code; else Results(x).Code=Samplegroupdata.Code{x-n_calib}; end   
    % Filnavn
    Results(x).cal_files=files.references;
    if Results(x).group>1
        Results(x).files=files.sampleclass{Results(x).group};   
    else
        Results(x).files=Results(x).cal_files;
    end
    Results(x).calctime=now;
end

fariset.resultstype='2D-FARI';
[Results(:).plot_x]=deal(Results(:).FARIA); [Results(:).plot_y]=deal(Results(:).FARIB);
plotfari; plotlabels; farilist


% ----------------------- DBREGRESSION -----------------------
function dbregression
global Refdata Samplegroupdata Cal_X Sam_X Results fariset
Results=[]; Results.Note=[]; Results.leftout=[];

X=[Cal_X; Sam_X]; 
[n_pred,n]=size(X);
[n_calib,n]=size(Cal_X);
[n_sampl,n]=size(Sam_X);
for x=1:n_pred
    Results(x).index=x; 
    if x<=n_calib Results(x).group=0; else Results(x).group=Samplegroupdata.group{x-n_calib}; end
    if x<=n_calib Results(x).Code=Refdata(x).Code; else Results(x).Code=Samplegroupdata.Code{x-n_calib}; end   
end

if isfield(Samplegroupdata,'Carb')==0; getinfo; end
if isfield(Refdata,'Carb')==0; getinfo; end

for a=1:2

    if a==1 
        if n_calib>0 y1=cat(1,Refdata.Carb); else y1=[]; end
        if n_sampl>0 y2=cat(1,Samplegroupdata.Carb{:}); else y2=[]; end
        y=[y1; y2]; 
    end %
    if a==2 
        if n_calib>0 y1=cat(1,Refdata.Dbb); else y1=[]; end
        if n_sampl>0 y2=cat(1,Samplegroupdata.Dbb{:}); else y2=[]; end
        y=[y1; y2]; 
    end

    [m,n]=size(X);
    index=(1:m)';
    % finner missing
    [missing_X,dummy]=find(isnan(X)); missing_y=find(isnan(y)); missing=[missing_X; missing_y]; % missing=unique(missing); 
    % fjerner missing
    X_loc=X; X_loc(missing,:)=[]; y_loc=y; y_loc(missing)=[]; index(missing)=[];
    % Regresjon
    [y_pred,sep_c]=regression(X_loc,y_loc,0,1);
    for x=1:length(y_loc)
        if a==1; Results(index(x)).Carb_p=y_pred(x); Results(index(x)).sep_A=sep_c(x); end
        if a==2; Results(index(x)).Dbb_p=y_pred(x); Results(index(x)).sep_B=sep_c(x);end
    end
    
    % Manglende variabler
    lm=length(missing);
    for x=1:lm
        Xl=X; yl=y; [m,n]=size(X); index=(1:m)' ;
        Xm=X(missing(x),:); ym=y(missing(x));
        [dummy,ind2]=find(isnan(Xm));                        % ind2: variabel som mangler
        if isempty(ind2)==0 
            Results(missing(x)).leftout=ind2; 
            Results(missing(x)).Note=['/X-var:' num2str(ind2)]; 
        end
        Xm(ind2)=[]; Xl(:,ind2)=[];             % Fjerner variabel, ny X er Xl
        [ind3,ind4]=find(isnan(Xl));
        Xl(ind3,:)=[]; yl(ind3)=[]; index(ind3)=[]; % Fjerner tomme rader fra Xl, yl og ind.
        [ind5]=find(isnan(yl)); Xl(ind5,:)=[]; yl(ind5)=[]; index(ind5)=[];  % Fjerner rader med tomme yl
        
        % Missing, Dersom y-variabler
        if isnan(ym)==0
            [y_pred,sep_c]=regression(Xl,yl,0,1);
            pos=find(index==missing(x));
            if a==1; 
                Results(missing(x)).Carb_p=y_pred(pos); 
                Results(missing(x)).sep_A=sep_c(pos);
            end
            if a==2; 
                Results(missing(x)).Dbb_p=y_pred(pos); 
                Results(missing(x)).sep_B=sep_c(pos); 
            end
        end
        % Missing, Dersom y mangler
        if isnan(ym)==1
            [y_pred,sep_c]=regression(Xl,yl,Xm,0);
            if a==1; 
                Results(missing(x)).Carb_p=y_pred; Results(missing(x)).sep_A=sep_c;
                Results(missing(x)).Note=[Results(missing(x)).Note, '/y-var:Carbons'];
            end
            if a==2; 
                Results(missing(x)).Dbb_p=y_pred; Results(missing(x)).sep_B=sep_c;
                Results(missing(x)).Note=[Results(missing(x)).Note, '/y-var:Dbb'];
            end
        end      
    end    
end

fariset.resultstype='Regression';
[Results(:).plot_x]=deal(Results(:).Carb_p); [Results(:).plot_y]=deal(Results(:).Dbb_p);
plotfari; plotlabels; farilist


% ------------------- REGRESSION -----------------------
function [y_pred,sep]=regression(X_cal,y_cal,X_pred,crossvalidation)
addconst=1;

% fjerner NaN i kalibreringssett
[i1,i2]=find(isnan(X_cal)); if isempty(i1)==0 X_cal(i1,:)=[]; y_cal(i1)=[]; end % sletter NaN i kalibrering

% Kryssvalidering:
[sep,n_comp]=crossvalidation(X_cal,y_cal); 

[U,S,V]=svd(X_cal); P=U*S;   % ------ P=X*V ----
Pc=P(:,1:n_comp); % Trunkerer
% addconst:
[m,n]=size(Pc); if addconst constv=ones(m,1); Pc=[constv Pc]; end

if crossvalidation==0
    b=Pc\y_cal; %Kalkuler b, Pe: Regression P
    Pp=X_pred*V;     % Beregner P for prediksjoner
    Pp=Pp(:,1:n_comp); % Trunkerer
    [m,n]=size(Pp); if addconst constv=ones(m,1); Pp=[constv Pp]; end   
    y_pred=(b'*Pp')'; % prediksjon
end
% Kryssvalidert, Benytter kun X_Cal
if crossvalidation==1
    [m,n]=size(Pc);
    for x=1:m  
        Pl=Pc; Pl(x,:)=[];
        yl=y_cal; yl(x)=[];
        b=Pl\yl;
        Pp=Pc(x,:);
        y_pred(x)=(b'*Pp')';    
    end
    y_pred=y_pred';
end

sep=repmat(sep,m,1);

% ------------------- CROSSVALIDATION -----------------------
function [sep,n_comp]=crossvalidation(X_var,y_var)
addconst=1; normalize=0;
%disp('--- Crossvalidation ---')

[U,S,V]=svd(X_var); P=U*S;

[m,n]=size(P);
for x=1:n
    X_var=P(:,1:x);
    if normalize==1
        [m,n]=size(X_var); sumX=sum(X_var,2); const=100./sumX; const=repmat(const,1,n); X_var=X_var.*const;
    end
    
    if addconst constv=ones(length(y_var),1); X_var=[constv X_var]; end

    for n=1:length(y_var);
        X=X_var; y=y_var;
        y_test(n)=y(n,:); X_test=X(n,:);
        X(n,:)=[]; y(n,:)=[];
        b=X\y; y_pred(n)=b'*X_test';  
    end
    diff=y_test-y_pred; 
    sep(x)=std(diff);
    bias=mean(diff);
end
sep=[std(y_var) sep]; % legger til PC-0
minsep=min(sep); minsep=minsep*1.01; ind=find(sep<minsep); ind=ind(1); sep=sep(ind); % 1% offset
n_comp=min(ind)-1; % frste som gir SEP p mindre enn 1% over min.


% ----------------------- PCA -----------------------
function pca
global Cal_X Refdata Sam_X Samplegroupdata Results fariset

Results=[]; Results.Note=[];

X_cal=Cal_X; X_sam=Sam_X;
X=[X_cal; X_sam];  % Prediksjonssett = kalibrering 
[m,n]=size(X); 
indices=1:m;           % indekser for  holder orden p objekter

% Trunkerer, fjerner objekter med manglende data
Xl=X;
X_sum=(sum(Xl'))'; missing=find(isnan(X_sum));
Xl(missing,:)=[];
indices(missing)=[];

% Sentrering
Xl=Xl-repmat(mean(Xl),m,1); 

% SVD/PCA
[U,S,V]=svd(Xl); P=U*S; S=sum(S);
[o,p]=size(Xl); for x=1:o  Results(indices(x)).PC1=P(x,1); Results(indices(x)).PC2=P(x,2); end

%Results.PC1 % TEMP

% Missing values
for x=1:length(missing)
    Xl_p=X(missing(x),:); ind2=find(isnan(Xl_p)); Xl_p(ind2)=[]; % Prediction X
    Xl_c=Xl; Xl_c(:,ind2)=[]; % Calibration X
    y_c=P(:,1); [Results(missing(x)).PC1,sep]=regression(Xl_c,y_c,Xl_p,0);
    y_c=P(:,2); [Results(missing(x)).PC2,sep]=regression(Xl_c,y_c,Xl_p,0);
    Results(missing(x)).leftout=ind2; Results(missing(x)).Note=[Results(missing(x)).Note, ' / X-var: ' num2str(ind2)];
end

%Results
[Results(:).plot_x]=deal(Results(:).PC1); [Results(:).plot_y]=deal(Results(:).PC2);

% Results
[n_pred,n]=size(X);
[n_calib,n]=size(X_cal);
for x=1:n_pred
    Results(x).index=x;
    if x<=n_calib Results(x).group=0; else Results(x).group=Samplegroupdata.group{x-n_calib}; end
    if x<=n_calib Results(x).Code=Refdata(x).Code; else Results(x).Code=Samplegroupdata.Code{x-n_calib}; end   
end

fariset.resultstype='PCA';
plotfari; plotlabels; farilist


%======================================= end calculations ========================================

%======================================= DATA HANDLING ============================================
% getfiles              Henter alle lesbare filer
% addref                Velger referanser
% addsample             Velger prver
% readfile              Brukes av 'addsample' og 'addref'
% getinfo               Henter opp info fra register
% tableread             Generell for  lese tabeller i tekstfiler
% group                 Grupperer samples
% delsample             Sletter sample fra liste


%-------------------- GETFILES -------------------
function getfiles
global fariset files

%[fariset.directory,'\',fariset.searchstr,'*.txt']
D=dir([fariset.directory,'\',fariset.searchstr,'*.txt']);
[m,n]=size(D); dirs=cat(2,D.isdir); D(find(dirs==1))=[]; 
DD=struct2cell(D); files.all=DD(1,:);
[m,n]=size(D); fariset.available_files=m;


%-------------------- ADDREF -------------------
function addref
global fariset Refdata Cal_X files

% Number of files
f_name=files.all(get(findobj('Tag','FileList'),'Value'));
if isfield(files,'references'); [m,n]=size(files.references); else n=0; end

% Newfile
newfile=1; if n>0 for x=1:n  if strcmp(files.references(x),f_name) newfile=0; end; end; end

% les
if newfile==1
    Ridat=readfile(f_name);
    if isempty(Ridat)==0 
        files.references{n+1}=f_name{:}; h=findobj('Tag','ReferenceFileList'); set(h,'String',short(files.references)); % Oppdaterer filliste
        [m,n]=size(Refdata); [o,p]=size(Cal_X); p=p+1;
        ri=cat(2,Ridat.Retind);
        missing=[];
        for x=1:n
            ind=strmatch(Refdata(x).Code,strvcat(Ridat.Code)); 
            if isempty(ind)==0 
                t=ri(ind); Cal_X(x,p)=t; 
            else 
                Cal_X(x,p)=NaN; 
                missing=[missing ' ' Refdata(x).Code];
            end  
        end
        if isempty(missing)==0 qq_message(1,['|r|WARNING: Missing data for: ',missing]); end   
    end
end
[m,n]=size(files.references); fariset.selected_refs=n;
referencelist


%-------------------- ADDSAMPLE -------------------
function addsample
global fariset Refdata Cal_X files Sampledata

% Number of files
f_name=files.all(get(findobj('Tag','FileList'),'Value'));
if isfield(files,'samples'); [m,n]=size(files.samples); else n=0; end

% Newfile
newfile=1; if n>0 for x=1:n  if strcmp(files.samples(x),f_name) newfile=0; end; end; end

% les
if newfile==1
    Ridat=readfile(f_name);
    if isempty(Ridat)==0 
        files.samples{n+1}=f_name{:}; h=findobj('Tag','SampleFileList'); set(h,'String',short(files.samples)); % Oppdaterer filliste   
        Sampledata{n+1}=Ridat;  
    end
end
[m,n]=size(Sampledata); fariset.selected_samples=n;


%-------------------- READFILE -------------------
function Ridat=readfile(f_name)
global fariset

filename=[fariset.directory,'\',f_name{:}];
fieldnames={'Retind','Code','Short','Name'};
Ridat=tableread(filename,fieldnames);

% Konverterer og trunkerer
[k,l]=size(Ridat);
for x=1:l Ridat(x).Retind=str2double(Ridat(x).Retind); end % Konverterer tekst til tall
ris=cat(2,Ridat.Retind);ind=find(isnan(ris));Ridat(ind)=[]; % Fjerner NaN
ris=cat(2,Ridat.Retind);ind=find(ris==0);Ridat(ind)=[]; % Fjerner 0

% Sjekk for multiple codes
[m,n]=size(Ridat); duplets=[];
for x=1:n 
    match=strmatch(Ridat(x).Code, strvcat(Ridat(x:n).Code)); 
    if length(match)>1 duplets=[duplets,' ', Ridat(x).Code];  end
end
if isempty(duplets)==0 qq_message(1,['|r|WARNING: More than one entry for ',duplets]); duplets=1; end
if duplets==1; Ridat=[]; end % Henter ikke data dersom dubletter i fil

%------------------- GETINFO -------------------
function getinfo
global metset Infodat Refdata Sampledata Samplegroupdata Results

filename=[metset.file_librarypath,'\class_',metset.global_class,'\Register_rep.txt'];
fieldnames={'Code','Short','Name','Carb','Dbb'};
Infodat=tableread(filename,fieldnames);
Codes=str2mat(Infodat.Code); Short=str2mat(Infodat.Short); Name=str2mat(Infodat.Name); Carb=str2mat(Infodat.Carb); Dbb=str2mat(Infodat.Dbb);

% Refdata
if exist('Refdata') & isempty(Refdata)==0  
    [m,n]=size(Refdata); 
    for x=1:n
        ind=strmatch(Refdata(x).Code,Codes); 
        if isempty(ind) 
            Refdata(x).Short='-'; Refdata.Name='-'; Refdata.Carb=NaN; Refdata.Dbb=NaN;
        else
            ind=ind(1,1);
            Refdata(x).Short=deblank(Short(ind,:)); Refdata(x).Name=deblank(Name(ind,:)); 
            Refdata(x).Carb=str2num(Carb(ind,:)); Refdata(x).Dbb=str2num(Dbb(ind,:));
        end 
    end 
end

% Results
if exist('Results') & isempty(Results)==0  
    [m,n]=size(Results); 
    for x=1:n
        ind=strmatch(Results(x).Code,Codes); 
        if isempty(ind) 
            Results(x).Short='-'; 
            Results(x).Name='-'; 
            Results(x).Carb=NaN; 
            Results(x).Dbb=NaN;
        else
            ind=ind(1,1);
            Results(x).Short=deblank(Short(ind,:)); Results(x).Name=deblank(Name(ind,:)); 
            Results(x).Carb=str2num(Carb(ind,:)); Results(x).Dbb=str2num(Dbb(ind,:));
        end 
    end 
end

% Sampledata

if isstruct(Samplegroupdata) & isempty(Samplegroupdata)==0
    [m,n]=size(Samplegroupdata.Code);
    for x=1:n
        ind=strmatch(Samplegroupdata.Code{x},Codes); 
        if isempty(ind)
            Samplegroupdata.Short{x}='-';Samplegroupdata.Name{x}='-';Samplegroupdata.Carb{x}=NaN;Samplegroupdata.Dbb{x}=NaN;
        else
            ind=ind(1);
            Samplegroupdata.Short{x}=deblank(Short(ind,:)); Samplegroupdata.Name{x}=deblank(Name(ind,:)); 
            Samplegroupdata.Carb{x}=str2num(Carb(ind,:)); Samplegroupdata.Dbb{x}=str2num(Dbb(ind,:));
        end    
    end
end


%------------------- TABLEREAD ------------------
function tabledata=tableread(filename,field_nam)
% Leser tekstfil som tabell. Kolonnenavn spesifiseres i 'fieldnames'.
% Data er separert med space. Data m starte p samme horisontale posisjon som kolonnenavnet.
% Space kan kun benyttes som kolonneseparatorer, flere space etterhverandre er tillatt. 

F=textread(filename,'%s','delimiter','\n'); [m,n]=size(F);
separator='  ';
% LESER FELT og legger svar i tabledata
[d,n_fields]=size(field_nam);
for fn=1:n_fields
    for x=1:m p=strfind(F{x,:},field_nam{fn}); if isempty(p)==0; hpos=p; vpos=x; end; end
    for x=vpos+1:m 
        l=length(F{x,:});
        if l>=hpos 
            string=(F{x,:}(hpos:l)); if isempty(string) string='-'; end 
            upind=strfind(string,separator); 
            upind=min(upind); 
            if isempty(upind) upind=length(string)+1; end
            tabledata(x).(field_nam{fn})=string(1:upind-1); 
        end
    end    
end


% ------------------- GROUP -----------------------
function groupsamples
global Cal_X Refdata Sampledata fariset files Sam_X Samplegroupdata

% tester    
ok=1; 
if isfield(fariset,'selected_samples')==0
    ok=0; qq_message(1,'|r|No files selected'); 
else
    if fariset.selected_samples==0 ok=0; qq_message(1,'|r|No files selected'); end
end
if isfield(fariset,'sample_variables') & fariset.sample_variables~=fariset.selected_samples;
    qq_message(1,['|r|Number of samplefiles must be ' num2str(fariset.sample_variables)]); ok=0;
end

if ok
    [m,n]=size(Sampledata); Loc_X=[];
    Register=[]; n_reg=0;
    for x=1:n % n=antall samples
        Sample=Sampledata{x};
        [o,p]=size(strvcat(Sample.Code)); % o=antall koder
        for y=1:o
            if n_reg==0; 
                Register{1}=Sampledata{x}(y).Code; 
                n_reg=1;    
            end
            if n_reg>0
                if isempty(strmatch(Sampledata{x}(y).Code,Register))
                    n_reg=n_reg+1; Register{n_reg}=Sampledata{x}(y).Code;  
                    Loc_X(n_reg,x)=Sampledata{x}(y).Retind;  
                else
                    ind=strmatch(Sampledata{x}(y).Code,Register);
                    Loc_X(ind,x)=Sampledata{x}(y).Retind;  
                end
            end        
        end   
    end

    % Erstatt 0 med NaN
    Loc_X(find(Loc_X==0))=NaN;

    % Catenation
    Sam_X=[Sam_X; Loc_X]; [fariset.sample_objects,fariset.sample_variables]=size(Sam_X); 
    if isfield(fariset,'n_samplegroups') fariset.n_samplegroups=fariset.n_samplegroups+1; else fariset.n_samplegroups=1; end
    files.sampleclass{fariset.n_samplegroups}=files.samples;

    % Resetter samples (klar for neste gruppe)
    files.samples=[]; h=findobj('Tag','SampleFileList'); set(h,'String',short(files.samples))
    Sampledata=[];

    % VARIABLER
    if isfield(Samplegroupdata,'Code')==0
        Samplegroupdata.Code=Register;
    else
        Samplegroupdata.Code=[Samplegroupdata.Code, Register];
    end

    % group
    [m,n]=size(Samplegroupdata.Code);[o,p]=size(Register); old_n=n-p; n_reg=p;
    for x=1:p Samplegroupdata.group{x+old_n}=fariset.n_samplegroups; end
    samplelist
    
    % Tempsave
    fariset.selected_samples=0;
    %save 'C:\qq\2D-FARI\smp_tempsave' Cal_X Refdata Sampledata fariset files Sam_X Samplegroupdata
    
    h=findobj('Tag','GroupFnEdit'); filename=get(h,'String'); pathname=['C:\qq\2D-FARI\smp_' filename];
    save(pathname, 'Cal_X','Refdata','Sampledata','fariset','files','Sam_X','Samplegroupdata')

end


%------------------- DELSAMPLE ---------------------
function delsample(call)
global Samplegroupdata Sam_X Cal_X Refdata fariset files

getinfo;
h=findobj('Tag','ResultsList'); listtype=get(h,'UserData');
if strmatch(listtype,'Samplelist') & isempty(Sam_X)==0
    if call==1; ind=selected; end
    if call==2; ind=find(cat(1,Samplegroupdata.group{:})==Samplegroupdata.group{selected}); end
    if call==3; h=findobj('Tag','DeleteEdit'); str=get(h,'String'); ind=strmatch(str,Samplegroupdata.Code); end % del group
    fnames=fieldnames(Samplegroupdata);
    [m,n]=size(fnames);   
    Sam_X(ind,:)=[]; [fariset.sample_objects,n]=size(Sam_X); 
    for x=1:m 
        Samplegroupdata.(fnames{x})(ind)=[]; 
    end;  
    if isempty(Sam_X) fariset=rmfield(fariset,{'sample_variables','sample_objects'}); end
   
    samplelist   
    %[m,n]=size(Sam_X); if m==0; fariset=rmfield(fariset,{'sample_variables','sample_objects'}); Sam_X=[]; end
end

if strmatch(listtype,'Referencelist')
    if call==1; ind=selected; end
    %if call==2; ind=find(cat(1,Refdata(:).group)==Refdata(selected).group); end
    if call==2 
        qq_message(1,'|b|Calibration set cleared'); 
        [m,n]=size(Cal_X); ind=1:m; 
        %files=rmfield(files,'references')
        files.references=[];
    end
    if call==3; h=findobj('Tag','DeleteEdit'); str=get(h,'String'); 
        ind=strmatch(str,strvcat(Refdata.Code)); 
    end
    Cal_X(ind,:)=[]; %[fariset.sample_objects,n]=size(Sam_X);
    %Refdata(ind)=[];
    referencelist  
end

    

%======================================== DIVERSE ========================================

% ------------------- SORTRESULTS --------------------
function sortresults(inp)
global Results

% Sorterer etter code
if inp=='C' codes=strvcat(Results.Code); end
if inp=='I' codes=strvcat(Results.index); end
if inp=='S' codes=strvcat(Results.Short); end

[dummy,ind]=sortrows(codes);
n=length(Results); Results(1:n)=Results(ind); 


% ------------------- EXPORTRESULTS --------------------
function exportresults
global Results fariset

for x=1: length(Results)
    p=0; 
    p=p+1; str{x,p}=[Results(x).Code blanks(2)]; titlestr{1}='Code';
    p=p+1; str{x,p}=[Results(x).Short blanks(2)]; titlestr{2}='Short'; 
    p=p+1; str{x,p}=[Results(x).Name blanks(2)]; titlestr{3}='Name'; 
    if isfield(Results,'FARIA')
        p=p+1; str{x,p}=[num2str(Results(x).FARIA,'%10.3f') blanks(2)]; titlestr{4}='FARI-A';  
        p=p+1; str{x,p}=[num2str(Results(x).FARIB,'%10.3f') blanks(2)]; titlestr{5}='FARI-B'; 
        p=p+1; str{x,p}=[num2str(Results(x).sep_A,'%10.3f') blanks(2)]; titlestr{6}='SEP-A'; 
        p=p+1; str{x,p}=[num2str(Results(x).sep_B,'%10.3f') blanks(2)]; titlestr{7}='SEP-B'; 
    end
    
    % Filenames
    fstr=strvcat(Results(x).files);
    for y=1:length(Results(x).files)-1; u(:,y)= (fstr(1,:) == fstr(y+1,:)); end; sumu=sum(u');
    unik=find(sumu<y); diff=find(sumu==y);
    mainstr=fstr(1,:); mainstr(unik)='.'; mainstr(min(unik))='<'; mainstr(max(unik))='>';
    unikstr=[]; for y=1: length((Results(x).files)); unikstr=[unikstr '<' fstr(y,unik) '> ']; end
    if strmatch(fariset.searchstr,mainstr) mainstr(1:length(fariset.searchstr))=[]; end
    p=p+1; str{x,p}=[mainstr ' ' unikstr]; titlestr{8}='Files';

end   
%titlestr={'Code','Short','Name','FARI-A','FARI-B','sep-A','sep-B','Files'};

printstr=[]; alltitle=[];
for x=1:p
    strx=strvcat(str(:,x)); 
    printstr=[printstr,strx];
    [a,len]=size(strx); % len=lengde p streng
    titlestr{x}=[titlestr{x},blanks(len-length(titlestr{x}))];titlestr{x}=[titlestr{x}(1:len-1),' '];
    alltitle=[alltitle,titlestr{x}];
end
[a,len]=size(printstr); separator=repmat('-',1,len); printstr=[strvcat(alltitle,separator,printstr)];

% Write to file
exportpath=fset('faripath'); namepath=[exportpath '\2D-FARI-RESULTS.txt'];
fh=fopen(namepath,'w');
[n_lines,len]=size(printstr); for x=1:n_lines fprintf(fh,[printstr(x,:),'\n']); end
fclose(fh); qq_message(6,namepath); qq_message(1,['|b| Data exported to ', namepath]);

% ------------------- EXPORTRAW --------------------
function exportraw
global fariset Samplegroupdata Sam_X files

getinfo
Samplegroupdata

[m,n]=size(Sam_X);
for x=1:m
    p=0; 
    p=p+1; str{x,p}=[Samplegroupdata.Code{x} blanks(2)]; titlestr{p}='Code';
    p=p+1; str{x,p}=[Samplegroupdata.Short{x} blanks(2)]; titlestr{p}='Short'; 
    p=p+1; str{x,p}=[Samplegroupdata.Name{x} blanks(2)]; titlestr{p}='Name'; 
    p=p+1; str{x,p}=[num2str(Samplegroupdata.group{x}) blanks(2)]; titlestr{p}='Gr'; 
    for y=1:n
        p=p+1; str{x,p}=[num2str(Sam_X(x,y),'%10.3f') blanks(2)]; 
    end
    
    % Filenames    
    fstr=strvcat(files.sampleclass{Samplegroupdata.group{x}});
    for y=1:n-1; u(:,y)= (fstr(1,:) == fstr(y+1,:)); end; sumu=sum(u');
    unik=find(sumu<y); diff=find(sumu==y);
    mainstr=fstr(1,:); mainstr(unik)='.'; mainstr(min(unik))='<'; mainstr(max(unik))='>';
    unikstr=[]; for y=1:n; unikstr=[unikstr '<' fstr(y,unik) '> ']; titlestr{4+y}=['#',fstr(y,unik)]; end
    if strmatch(fariset.searchstr,mainstr) mainstr(1:length(fariset.searchstr))=[]; end
    p=p+1; str{x,p}=[mainstr ' ' unikstr]; titlestr{p}='Files';
end   

printstr=[]; alltitle=[];
for x=1:p
    strx=strvcat(str(:,x)); 
    printstr=[printstr,strx];
    [a,len]=size(strx); % len=lengde p streng
    titlestr{x}=[titlestr{x},blanks(len-length(titlestr{x}))];titlestr{x}=[titlestr{x}(1:len-1),' '];
    alltitle=[alltitle,titlestr{x}];
end
[a,len]=size(printstr); separator=repmat('-',1,len); printstr=[strvcat(alltitle,separator,printstr)];

% Write to file
exportpath=fset('faripath'); namepath=[exportpath '\2D-FARI-RAW.txt'];
fh=fopen(namepath,'w');
[n_lines,len]=size(printstr); for x=1:n_lines fprintf(fh,[printstr(x,:),'\n']); end
fclose(fh); qq_message(6,namepath); qq_message(1,['|b| Data exported to ', namepath]);


% ------------------- INFOWIN --------------------
function infowin
global colors

winpar={'I-Win','Additional Info',[0.1 0.5 0.25 0.4]};
p=0; p=p+1; [ui{p,1:7}] = deal('','Text',colors.bc,[0.05 0.05 0.9 0.9],'',2,'I-Txt');
p=p+1; [ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[0.75 0.05 0.2 0.1],'close(gcbf)',2,'');
h0=qq_drawwin(winpar,ui,''); addinfo
%get(h0) % TEMP

% ------------------- ADDINFO --------------------
function addinfo
global fariset Cal_X Sam_X Refdata Sampledata Samplegroupdata Results files 

h=findobj('Tag','ResultsList'); listtype=get(h,'UserData');
% Finn liste: resultslist, Reflist, Samplelist
[pos,listpos]=getposition;

n=length(Results);
if n>=pos
    p=0;
    p=p+1; str{p}=['Name: ' Results(pos).Name];
    p=p+1; str{p}=['Short: ' Results(pos).Short];
    p=p+1; str{p}=['Code: ' Results(pos).Code];
    
    if isfield(Results,'FARIA')
        p=p+2; str{p}=['FARI-A: ' num2str(Results(pos).FARIA) '  SEP: ' num2str(Results(pos).sep_A)];
        p=p+1; str{p}=['FARI-B: ' num2str(Results(pos).FARIB) '  SEP: ' num2str(Results(pos).sep_B)];
    end
    if isfield(Results,'PC1')
        p=p+2; str{p}=['PC1: ' num2str(Results(pos).PC1) ' PC2: ' num2str(Results(pos).PC2)];
    end
    if Results(pos).group==0;
        p=p+2; str{p}=['Group: Calibration'];
    else
        p=p+2; str{p}=['Group: ' num2str(Results(pos).group) ];
    end
    
    if isfield(Results,'files')
        p=p+2; str{p}=['Source Files:'];
        for x=1:length(Results(pos).files);
            p=p+1; str{p}=Results(pos).files{x};
        end
    end

    h=findobj('Tag','I-Txt'); set(h,'String',str);
end


% ------------------- getposition --------------------
function [pos,listpos]=getposition
global Cal_X
% Returnerer posisjon i liste og i Results

h=findobj('Tag','ResultsList');listpos=get(h,'value');listtype=get(h,'UserData');
if strmatch(listtype,'Farilist')
    pos=listpos;    
end
if strmatch(listtype,'Referencelist')
    pos=listpos;    
end
if strmatch(listtype,'Samplelist')
    [m,n]=size(Cal_X);
    pos=listpos+m;    
end


% ------------------- SELECTED --------------------
function out=selected
% Returnerer valgt linjenummer for Resultslist

h=findobj('Tag','ResultsList');
out=get(h,'Value');

% ------------------- FSET --------------------
function setout=fset(name,setinn)
% Leser/Lagrer settings til fil

pathname='C:\qq\2D-FARI\FILESET.MAT';
D=dir(pathname);
if isempty(D)
    filesettings.faripath='C:\qq\2D-FARI\'; save(pathname,'filesettings');
end
load(pathname);

% lagrer og setter ut lik inn
if nargin==2 
    filesettings.(name)=setinn; save(pathname,'filesettings'); setout=setinn; 
end
% Returnerer fil-innhold
if nargin==1
    if isfield(filesettings,name)==1 setout=filesettings.(name); else setout=[]; end
end
% returnerer hele filesetiings
if nargin==0; 
    setout=filesettings; 
end 

%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global fonts positions colors

bw=positions.bw;
bh=positions.bh;
eh=positions.eh;
gh=positions.gh;% grid height
o2=(bw*2+(bw*2/3))/3; 
x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % horisontalt grid

fileset=fset
if isfield(fileset,'calib_file'); calib_file=fileset.calib_file; else calib_file='Default'; end
if isfield(fileset,'sample_file'); sample_file=fileset.sample_file; else sample_file='Default'; end
if isfield(fileset,'editlib'); editlib=fileset.editlib; else editlib='Default'; end

winpar{1}='2dfWin'; winpar{2}='2DFARI';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0; o=bw/2;
% CLOSE
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_closewin',3,'CloseBtn');
% AVAILABLE FILES
p=p+1;[ui{p,1:7}] = deal('Searchstring','text',colors.bc,[x(1) y(15) bw*2 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','edit',[1 1 1],[x(1) y(16) bw*2 bh],'qq_2dfari(1.1)',2,'SearchStrEdit');
p=p+1;[ui{p,1:7}] = deal('Directory','text',colors.bc,[x(1) y(17) bw*2 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','edit',[1 1 1],[x(1) y(18) bw*2 bh],'qq_2dfari(1.2)',2,'DirectoryEdit');
p=p+1;[ui{p,1:7}] = deal('Available files','text',colors.bc,[x(1) y(1) bw*2 eh],'',3,'');
p=p+1;[ui{p,1:7}] = deal('','listbox',[1 1 1],[x(1) y(14) bw*2 gh*12+bh],'',2,'FileList');
p=p+1;[ui{p,1:7}] = deal('Edit','pushbutton',colors.btn{5},[x(3)-bw/2 y(1) bw/2 bh],'qq_2dfari(1.3)',2,'');
% REFERENCES
p=p+1;[ui{p,1:7}] = deal('References (2D-FARI)','text',colors.bc,[x(3)+bw/2 y(1) bw*2 eh],'',3,'');
p=p+1;[ui{p,1:7}] = deal('','listbox',[1 1 1],[x(3)+bw/2 y(4) bw*2 gh*2+bh],'',2,'ReferenceFileList');
p=p+1;[ui{p,1:7}] = deal('>','Pushbutton',colors.accept,[x(3) y(3) bw/2 bh],'qq_2dfari(2.1)',4,'AddReference');
p=p+1;[ui{p,1:7}] = deal('<','Pushbutton',colors.reset,[x(3) y(4) bw/2 bh],'qq_2dfari(2.2)',4,'DeleteReference');
p=p+1;[ui{p,1:7}] = deal('Save','Pushbutton',colors.btn{1},[x(6)-bw/2 y(3) bw*2/3 bh],'qq_2dfari(2.3)',2,'');
p=p+1;[ui{p,1:7}] = deal('Resume','Pushbutton',colors.btn{1},[x(6)-bw/2 y(4) bw*2/3 bh],'qq_2dfari(2.4)',2,'');
p=p+1;[ui{p,1:7}] = deal('List','Pushbutton',colors.btn{5},[x(6)-bw/2 y(2) bw*2/3 bh],'qq_2dfari(2.9)',2,'');
p=p+1;[ui{p,1:7}] = deal('Ref. File:','Text',colors.bc,[x(3)+bw/2 y(5) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(calib_file,'Edit',[1 1 1],[x(4)+bw/2 y(5) bw*1.66 eh],'qq_2dfari(8.2)',2,'RefFnEdit');
% SAMPLES
p=p+1;[ui{p,1:7}] = deal('Samples','text',colors.bc,[x(3)+bw/2 y(6) bw*2 eh],'',3,'');
p=p+1;[ui{p,1:7}] = deal('','listbox',[1 1 1],[x(3)+bw/2 y(9) bw*2 gh*2+bh],'',2,'SampleFileList');
p=p+1;[ui{p,1:7}] = deal('>','Pushbutton',colors.accept,[x(3) y(8) bw/2 bh],'qq_2dfari(6.1)',4,'AddSample');
p=p+1;[ui{p,1:7}] = deal('<','Pushbutton',colors.reset,[x(3) y(9) bw/2 bh],'qq_2dfari(6.2)',4,'DeleteSample');
p=p+1;[ui{p,1:7}] = deal('Group','Pushbutton',colors.btn{1},[x(6)-bw/2 y(8) bw*2/3 bh],'qq_2dfari(6.3)',2,'');
p=p+1;[ui{p,1:7}] = deal('Resume','Pushbutton',colors.btn{1},[x(6)-bw/2 y(9) bw*2/3 bh],'qq_2dfari(6.4)',2,'');
p=p+1;[ui{p,1:7}] = deal('List','Pushbutton',colors.btn{5},[x(6)-bw/2 y(7) bw*2/3 bh],'qq_2dfari(6.5)',2,'');
p=p+1;[ui{p,1:7}] = deal('Group File:','Text',colors.bc,[x(3)+bw/2 y(10) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(sample_file,'Edit',[1 1 1],[x(4)+bw/2 y(10) bw*1.66 eh],'qq_2dfari(8.3)',2,'GroupFnEdit');
% RESULTSLIST
p=p+1;[ui{p,1:7}] = deal('','listbox',[1 1 1],[x(6)+bw/2 y(9) bw*3.5 gh*7+bh],'qq_2dfari(4.1)',2,'ResultsList');
p=p+1;[ui{p,1:7}] = deal('Del. Sample','Pushbutton',colors.btn{3},[x(6)+bw/2 y(10) bw bh],'qq_2dfari(4.2)',2,'Deleteline');
p=p+1;[ui{p,1:7}] = deal('Del. Group','Pushbutton',colors.btn{3},[x(7)+bw/2 y(10) bw bh],'qq_2dfari(4.3)',2,'Deleteline');
p=p+1;[ui{p,1:7}] = deal('Del. Code','Pushbutton',colors.btn{3},[x(8)+bw/2 y(10) bw bh],'qq_2dfari(4.4)',2,'Deleteline');
p=p+1;[ui{p,1:7}] = deal('SAN','Edit',colors.btn{3},[x(9)+bw/2 y(10) bw/2 bh],'',2,'DeleteEdit');
% 2D-FARI
fl=x(3)+o*0.75; fw=bw*2.9; vo=gh*0.25; % Frame left/width
p=p+1;[ui{p,1:7}] = deal('','Frame',colors.bc,[fl y(15)-vo fw gh*4.4],'',2,'');
p=p+1;[ui{p,1:7}] = deal('2D-FARI','Pushbutton',colors.btn{4},[x(3)+o y(12) o2 bh],'qq_2dfari(3.2)',2,'');
% Library
p=p+1;[ui{p,1:7}] = deal('Library:','text',colors.bc,[x(3)+o y(14) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','text',colors.bc,[x(3)+o y(15) bw*2 eh],'',2,'EntriesTxt');
p=p+1;[ui{p,1:7}] = deal(editlib,'Edit',[1 1 1],[x(4)+o y(14) bw*1.66 eh],'qq_2dfari(8.1)',2,'LibEdit');

p=p+1;[ui{p,1:7}] = deal('Search Libr.','Pushbutton',colors.btn{2},[x(3)+o y(13) o2 bh],'qq_2dfari_searchlib(1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Add Sel.','Pushbutton',colors.btn{2},[x(3)+o+o2 y(13) o2 bh],'qq_2dfari_addlib(1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Edit Libr','Pushbutton',colors.btn{2},[x(3)+o+2*o2 y(13) o2 bh],'qq_2dfari_editlib(1)',2,'');

% PCA/DBB REGR
%p=p+1;[ui{p,1:7}] = deal('','Frame',colors.bc,[fl y(17)-vo fw gh*1.2],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Frame',colors.bc,[fl y(18)-vo fw gh*2.4],'',2,'');
p=p+1;[ui{p,1:7}] = deal('PCA','Pushbutton',colors.btn{4},[x(3)+o y(17) o2 bh],'qq_2dfari(3.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('C/DB Regr.','Pushbutton',colors.btn{4},[x(3)+o y(18) o2 bh],'qq_2dfari(3.3)',2,'');

% PLOT
n=4; lbw=bw*n/4.5;
p=p+1;[ui{p,1:7}] = deal('Zoom in','Pushbutton',colors.btn{3},[x(6)+o y(20) lbw bh],'qq_2dfari(5.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Zoom out','Pushbutton',colors.btn{3},[x(6)+o+lbw y(20) lbw bh],'qq_2dfari(5.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('Labels','Togglebutton',colors.btn{3},[x(6)+o+lbw*2 y(20) lbw bh],'qq_2dfari(5.3)',2,'LabelsToggle');
p=p+1;[ui{p,1:7}] = deal('Short','Togglebutton',colors.btn{3},[x(6)+o+lbw*3 y(20) lbw bh],'qq_2dfari(5.4)',2,'ShortToggle');

% EXPORT/INFO/EXP.FIGURE
p=p+1;[ui{p,1:7}] = deal('Exp. Raw','Pushbutton',colors.btn{5},[x(2)+o y(20) lbw eh],'qq_2dfari(9.5)',2,'');
p=p+1;[ui{p,1:7}] = deal('Exp. Res.','Pushbutton',colors.btn{5},[x(3)+o y(20) lbw eh],'qq_2dfari(9.4)',2,'');
p=p+1;[ui{p,1:7}] = deal('Exp. Fig.','Pushbutton',colors.btn{5},[x(3)+o+o2 y(20) lbw eh],'qq_2dfari(9.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('Add. Info','Pushbutton',colors.btn{5},[x(3)+o+2*o2 y(20) lbw eh],'qq_2dfari(9.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Sort Res.','Pushbutton',colors.btn{5},[x(2)+o y(19) lbw eh],'qq_2dfari(9.3)',2,'');
p=p+1;[ui{p,1:7}] = deal('Optimize','Pushbutton',colors.btn{5},[x(3)+o y(19) lbw eh],'qq_2dfari(9.6)',2,'');

updfcn='qq_2dfari(100)';
h0=qq_drawwin(winpar,ui,updfcn); 
set(h0,'KeyPressFcn','qq_2dfari(96)')
drawnow







