function qq_2dfari_editlib(an)

global fariset Farilib

qq_message(2)

if an==1
    openwin
    getlibs
end

if an==2.1
    h=findobj('Tag','2DF_LibsList'); val=get(h,'Value');
    fariset.edit_lib=fariset.all_libs{val};
    load(pathname,'Farilib')
    listlib
    showentry
end

% Select Entry
if an==2.2
    showentry  
end

% Delete
if an==3.1
    delentry
end
%Accept edit
if an==3.2
    readentry
end
%Save
if an==3.3
    save(pathname,'Farilib')
end
%--------------------------------------------------------------------------
%                       S U B F U N C T I O N S
%--------------------------------------------------------------------------

% --------------- readentry -------------- 
function readentry
global fariset Farilib

h=findobj('Tag','LibrList'); fariset.selected=get(h,'Value');
str=get(findobj('Tag','NameEdit'),'String'); Farilib(fariset.selected).Name=str;
str=get(findobj('Tag','ShortEdit'),'String'); Farilib(fariset.selected).Short=str;
str=get(findobj('Tag','CodeEdit'),'String'); Farilib(fariset.selected).Code=str;
str=get(findobj('Tag','NoteEdit'),'String'); Farilib(fariset.selected).Note=str;
qq_message(1,'|b|Press Accept to save changes') 

% --------------- delentry -------------- 
function delentry
global fariset Farilib

h=findobj('Tag','LibrList'); fariset.selected=get(h,'Value');
Farilib(fariset.selected)=[];
listlib; showentry
qq_message(1,'|b|Press Accept to save changes') 


% --------------- showentry -------------- 
function showentry
global fariset Farilib

h=findobj('Tag','LibrList'); fariset.selected=get(h,'Value');

set(findobj('Tag','NameEdit'),'String',Farilib(fariset.selected).Name)
set(findobj('Tag','ShortEdit'),'String',Farilib(fariset.selected).Short)
set(findobj('Tag','CodeEdit'),'String',Farilib(fariset.selected).Code)
set(findobj('Tag','NoteEdit'),'String',Farilib(fariset.selected).Note)

Info1{1}=['FARI-A: ' num2str(Farilib(fariset.selected).FARIA,'%-1.3f') '  (SEP: ' num2str(Farilib(fariset.selected).sep_A,'%-1.3f') ')'];
Info1{2}=['FARI-B: ' num2str(Farilib(fariset.selected).FARIB,'%-1.3f') '   (SEP: ' num2str(Farilib(fariset.selected).sep_B,'%-1.3f') ')'];
Info1{3}='';
Info1{4}=['Calculated: ' datestr(Farilib(fariset.selected).calctime)];
Info1{5}=['Added to Libr: ' datestr(Farilib(fariset.selected).libtime)];
set(findobj('Tag','InfoTxt1'),'String',Info1)

Info2=Farilib(fariset.selected).files; Info2=strvcat(Info2); Info2=strvcat('Files:',Info2);
set(findobj('Tag','InfoTxt2'),'String',Info2)

Info3=Farilib(fariset.selected).cal_files; Info3=strvcat(Info3); Info3=strvcat('Calibr. Files:',Info3);
set(findobj('Tag','InfoTxt3'),'String',Info3)

Info4='';
if isempty(Farilib(fariset.selected).leftout)==0
    Info4='Warning: Compound is missing in one or more GC programs. Reduced accuracy may be expected. See Note for details';
end
set(findobj('Tag','InfoTxt4'),'String',Info4)
    




% --------------- getlibs -------------- 
function getlibs
global fariset

%disp('-------- GETLIBS --------')
fariset.libdir='C:\qq\2D-FARI\Libraries';
searchpath=[fariset.libdir,'\2D-FARILIB_*.mat'];

DD=dir(searchpath);D=struct2cell(DD); 
names=D(1,:);
delstr='2D-FARILIB_'; ldel=length(delstr);
[m,n]=size(names); 
for x=1:n
    libname=names{x}; le=length(libname); fariset.all_libs{x}=libname(ldel+1:le-4);
end
h=findobj('Tag','2DF_LibsList'); set(h,'String',fariset.all_libs)

% --------------- pathname --------------   
function pathname=pathname;
global fariset

fariset.libdir='C:\qq\2D-FARI\Libraries';
pathname=[fariset.libdir,'\2D-FARILIB_',fariset.edit_lib,'.mat'];

% --------------- LibrList --------------   
function listlib

global Farilib

n=length(Farilib);
for x=1:n
    str0=[num2str(x) blanks(5)]; str0=str0(1:4);
    str1=[Farilib(x).Code blanks(10)]; str1=str1(1:9);
    str2=[Farilib(x).Short blanks(15)]; str2=str2(1:15);
    str3=[Farilib(x).Name blanks(30)]; str3=str3(1:30);
    dispstr{x}=[str0 str1 str2 str3];
end
h=findobj('Tag','LibrList'); set(h,'String',dispstr,'Value',1);



%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global fonts positions colors

bw=positions.bw;
bh=positions.bh;
eh=positions.eh;
gh=positions.gh;% grid height
o2=(bw*2+(bw*2/3))/3; 

x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % horisontalt grid


winpar{1}='2dfLibEditWin'; winpar{2}='2DFARI: Edit Libr';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0; o=bw/2;
% CLOSE
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_closewin',3,'CloseBtn');
%p=p+1;[ui{p,1:7}] = deal('Save','Pushbutton',colors.accept,[x(2) y(20) bw bh*1.5],'qq_2dfari_editlib(3.3)',3,'');
% Lister
p=p+1;[ui{p,1:7}] = deal('Select Library','Text',colors.bc,[x(1) y(17) bw*1.5 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('------','Popupmenu',[1 1 1],[x(1) y(18) bw*1.5 bh],'qq_2dfari_editlib(2.1)',2,'2DF_LibsList');
p=p+1;[ui{p,1:7}] = deal('','listbox',[1 1 1],[x(5)+bw/2 y(19) bw*4.5 gh*17+bh],'qq_2dfari_editlib(2.2)',2,'LibrList');
%
vp=1;
vp=vp+1; p=p+1;[ui{p,1:7}] = deal('Name:','Text',colors.bc,[x(1) y(vp) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(2) y(vp) bw*3 eh],'qq_2dfari_editlib(3.2)',2,'NameEdit');

vp=vp+1;p=p+1;[ui{p,1:7}] = deal('Short:','Text',colors.bc,[x(1) y(vp) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(2) y(vp) bw*3 eh],'qq_2dfari_editlib(3.2)',2,'ShortEdit');

vp=vp+1;p=p+1;[ui{p,1:7}] = deal('Code:','Text',colors.bc,[x(1) y(vp) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(2) y(vp) bw*3 eh],'qq_2dfari_editlib(3.2)',2,'CodeEdit');

vp=vp+1;p=p+1;[ui{p,1:7}] = deal('Note:','Text',colors.bc,[x(1) y(vp) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(2) y(vp) bw*3 eh],'qq_2dfari_editlib(3.2)',2,'NoteEdit');

vp=vp+1;p=p+1;[ui{p,1:7}] = deal('Delete','Pushbutton',colors.reset,[x(4) y(vp) bw bh],'qq_2dfari_editlib(3.1)',2,'');
vp=vp+1;p=p+1;[ui{p,1:7}] = deal('Accept / Save','Pushbutton',colors.accept,[x(4) y(vp) bw bh],'qq_2dfari_editlib(3.3)',2,'');

vp=vp+1; p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[x(1) y(vp) bw*3 bh*3.5],'',2,'InfoTxt1');
vp=vp+3; p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[x(1) y(vp) bw*3 bh*3.7],'',2,'InfoTxt2');
vp=vp+3; p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[x(1) y(vp) bw*3 bh*3.7],'',2,'InfoTxt3');
vp=vp+2; p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[x(1) y(vp) bw*3 bh*2.1],'',2,'InfoTxt4');

updfcn='qq_2dfari_editlib(100)';
h0=qq_drawwin(winpar,ui,updfcn); 
set(h0,'KeyPressFcn','qq_2dfari_editlib(96)')

h=findobj('Tag','InfoTxt4'); set(h,'ForegroundColor',[1 0 0]); 

drawnow