function qq_2dfari_optires(an)

% function qq_2dfari_optires(an)
% Subrutine til qq_2dfari
% Analyserer forhold mellom ECL-verdier og finner optimale 'vinduer' for
% vanskelige separasjoner
% S.A.M. 
% Sist endret: 16.feb.05


global fariset Sam_X Samplegroupdata files % Data fra 2D-FARI
global Optidata Targetdata Masterdata

qq_message(2)

if nargin==0; an=1; end

if an==1; 
    Targetdata=[]; 
    Masterdata=[]; 
    Optidata=[]; 
    makedata; 
    openwin; 
    datalist   
end

% Datalist/Class/Average/Select
if an==2.1 datalist; end
if an==2.2 average; datalist; end
if an==2.3 setclass; datalist; end
if an==2.4 h=findobj('Tag','DataList'); val=get(h,'Value'); [Optidata(val).Selected]=deal(1); datalist; end
if an==2.5 h=findobj('Tag','DataList'); val=get(h,'Value'); [Optidata(val).Selected]=deal(0); datalist; end
if an==2.6 delsample; datalist; end

% Add/Remove Target/Master
if an==3.1; addTarget; end
if an==3.2; remTarget; end
if an==3.3; setMaster; end

% Plot
if an==4.1 selplot; end
if an==4.2 regression; datalist; end
if an==4.3 linplot; end
if an==4.4 peakplot; end
if an==4.5 optisearch; end

% Adjust ECL
if an>5.0 & an<6.0
    h=findobj('Tag','ECL-Edit'); ECL=str2double(get(h,'String'));
    if an==5.1 ECL=ECL-0.1; end
    if an==5.2 ECL=ECL-0.01; end
    if an==5.3 ECL=ECL+0.01; end
    if an==5.4 ECL=ECL+0.1; end
    set(h,'String',num2str(ECL));
end

%Save/Resume

if an>6.0 & an<7.0 h=findobj('Tag','FnEdit'); str=get(h,'String'); end
if an==6.1 save(['C:\QQ\2D-FARI\TEMPSAVE_OPTIRES_' str '.mat'],'Optidata','Masterdata','Targetdata'); end
if an==6.2 
    load(['C:\QQ\2D-FARI\TEMPSAVE_OPTIRES_' str '.mat'],'Optidata','Masterdata','Targetdata');
    datalist; dispTarget; dispmaster
end

% Export
if an==7.1 dataexp(1); end
if an==7.15 dataexp(2); end
if an==7.2 figexp; end
    

%======================================== SUBFUNCTIONS ========================================
% ------------------- DELSAMPLE --------------------
function delsample
global Optidata

h=findobj('Tag','DataList'); val=get(h,'Value'); n_val=length(val);

Optidata(val)=[];
for x=1:length(Optidata); Optidata(x).ind=x; end


% ------------------- DATAEXP --------------------
function dataexp(inp)
global Optidata Masterdata fariset

if inp==1 sel=1:length(Optidata); else sel=find(cat(2,Optidata.Selected)); end; n_sel=length(sel);

for x=1:n_sel
    p=0;
    p=p+1; str{x,p}=[num2str(Optidata(sel(x)).ind) ') ']; str{x,p}=[str{x,p} blanks(5-length(str{x,p}))];
    p=p+1; str{x,p}=[Optidata(sel(x)).Code '/' Optidata(sel(x)).Short]; str{x,p}=[str{x,p} blanks(18-length(str{x,p}))];

    if isfield(Optidata,'polynom')
        p=p+1; str{x,p}=[num2str(Optidata(sel(x)).polynom(1),'%-1.3f') '/' num2str(Optidata(sel(x)).polynom(2),'%-1.3f')]; 
        str{x,p}=[str{x,p} blanks(15-length(str{x,p}))]; titlestr{p}='y=ax+b (a/b)';
    end
    if isfield(Optidata,'SEC')
        p=p+1; str{x,p}=[num2str(Optidata(sel(x)).SEC,'%-1.4f')]; str{x,p}=[str{x,p} blanks(8-length(str{x,p}))]; titlestr{p}='SEC';
    end
    if isfield(Optidata,'R2')
        p=p+1; str{x,p}=[num2str(Optidata(sel(x)).R2,'%-1.4f')]; str{x,p}=[str{x,p} blanks(8-length(str{x,p}))]; titlestr{p}='R2';
    end  
    n_files=length(Optidata(sel(x)).ECL_raw); startfiles=p;
    for y=1:n_files
        p=p+1; str{x,p}=[num2str(Optidata(sel(x)).ECL_raw(y),'%-1.3f')]; str{x,p}=[str{x,p} blanks(8-length(str{x,p}))];
    end
    
    % files
    n=length(Optidata(sel(x)).Files);
    if n>1
        fstr=strvcat(Optidata(sel(x)).Files);
        for y=1:n-1; u(:,y)= (fstr(1,:) == fstr(y+1,:)); end; sumu=sum(u');
        unik=find(sumu<y); diff=find(sumu==y);
        mainstr=fstr(1,:); mainstr(unik)='.'; mainstr(min(unik))='<'; mainstr(max(unik))='>';
        unikstr=[]; 
        for y=1:n; 
            unikstr=[unikstr '<' fstr(y,unik) '> ']; 
            %titlestr{startfiles+y}=['#',fstr(y,unik)]; 
            titlestr{startfiles+y}=['<',fstr(y,unik),'>']; 
            %titlestr{startfiles+y}=unikstr; 
        end
        if strmatch(fariset.searchstr,mainstr) mainstr(1:length(fariset.searchstr))=[]; end
        %p=p+1; str{x,p}=[mainstr ' ' unikstr]; titlestr{p}='Files';
        p=p+1; str{x,p}=[mainstr]; titlestr{p}='Files';
    else
        p=p+1; str{x,p}='Average'; titlestr{p}='Files';
    end
end

titlestr{1}='Ind'; titlestr{2}='Code/Short';

printstr=[]; alltitle=[];
for x=1:p
    strx=strvcat(str(:,x));
    printstr=[printstr,strx];
    [a,len]=size(strx); % len=lengde p streng
    titlestr{x}=[titlestr{x},blanks(len-length(titlestr{x}))];titlestr{x}=[titlestr{x}(1:len-1),' '];
    alltitle=[alltitle,titlestr{x}];
end
[a,len]=size(printstr); separator=repmat('-',1,len); printstr=[strvcat(alltitle,separator,printstr)];

maststr=['Master: ' num2str(Masterdata.ind) ') ' Masterdata.Code '/' Masterdata.Short];
headstr{1}='Optisearch Export';
if inp==1 headstr{2}='All compounds'; else headstr{2}='Selected compounds'; end
headstr=strvcat(headstr);

printstr=[strvcat(headstr,separator,printstr,separator,maststr)];

% Write to file
exportpath=fset('faripath'); namepath=[exportpath '\2D-FARI-OPTISEARCH.txt'];
fh=fopen(namepath,'w');
[n_lines,len]=size(printstr); for x=1:n_lines fprintf(fh,[printstr(x,:),'\n']); end
fclose(fh); qq_message(6,namepath); qq_message(1,['|b| Data exported to ', namepath]);

% ------------------- FSET --------------------
function setout=fset(name,setinn)
% Leser/Lagrer settings til fil

pathname='C:\qq\2D-FARI\FILESET.MAT';
D=dir(pathname);
if isempty(D)
    filesettings.faripath='C:\qq\2D-FARI\'; save(pathname,'filesettings');
end
load(pathname);

% lagrer og setter ut lik inn
if nargin==2 
    filesettings.(name)=setinn; save(pathname,'filesettings'); setout=setinn; 
end
% Returnerer fil-innhold
if nargin==1
    if isfield(filesettings,name)==1 setout=filesettings.(name); else setout=[]; end
end
% returnerer hele filesetiings
if nargin==0; 
    setout=filesettings; 
end 

% ----------------------- FIGEXP ------------------------
function figexp

orig=findobj('Tag','OptiPlot'); child=get(orig,'Children');
figure
axes
copyobj(child,gca)
xax=get(orig,'xlim'); xlim(xax);
yax=get(orig,'ylim'); ylim(yax);


% ----------------------- OPTISEARCH ------------------------
function optisearch
global Optidata Targetdata Masterdata
colors=get(gca,'ColorOrder');

%Oppdater Target
tind=cat(1,Targetdata.ind); n_targets=length(tind);
for x=1:n_targets 
    Targetdata(x).polynom=Optidata(tind(x)).polynom; 
    Targetdata(x).Class=Optidata(tind(x)).Class; 
end

mean_ECL=mean(Masterdata.ECL_raw); 
h=findobj('Tag','OptiRangeEdit'); range=str2double(get(h,'String'));

testvect=(mean_ECL-range/2):range/1000:(mean_ECL+range/2);

sel=find(cat(2,Optidata.Selected)); n_sel=length(sel);
delind=[]; for x=1:n_targets delind=[delind find(tind(x)==sel)]; end; sel(delind)=[]; % Sletter targets fra 'sel'


testpolys=cat(1,Optidata(sel).polynom);
targetpolys=cat(1,Targetdata(:).polynom);

for x=1:length(testvect)
%for x=1:1   
    opticalc=testpolys(:,1)*testvect(x)+testpolys(:,2);
    targetcalc=targetpolys(:,1)*testvect(x)+targetpolys(:,2);
    
    for y=1:n_targets
        absdiff=abs(targetcalc(y)-opticalc);
        minres(x,y)=min(absdiff);
    end
    
end

h=findobj('Tag','OptiPlot'); pos=get(h,'Position');
set(gcf,'CurrentAxes',h); child=get(gca,'Children'); delete(child);

hold on
for x=1:n_targets
    h=plot(testvect,minres(:,x));
    if Targetdata(x).Class==0; 
        set(h,'Color',[0 0 0]); 
    else 
        set(h,'Color',colors(Targetdata(x).Class,:)); 
    end
end

if n_targets>1 minminres=min(minres'); else minminres=minres; end

h=plot(testvect,minminres,'--','LineWidth',2);

axis tight

[best_res, best_pos]=max(minminres); best_ECL=testvect(best_pos);
a=ylim; y_low=a(1); y_high=a(2);
line([best_ECL best_ECL],[y_low y_high],'LineStyle','--','Color',[0 0 0],'LineWidth',3)

str{1}=['   Best Separation: ' num2str(best_res,'%-1.3f') ' units   '], 
str{2}=['   Master ECL: ' num2str(best_ECL,'%-1.3f') '   '];
if best_ECL<mean(testvect)
    text(best_ECL,y_high*0.9,str,'HorizontalAlignment','left');
else
    text(best_ECL,y_high*0.9,str,'HorizontalAlignment','right');    
end

h=findobj('Tag','ECL-Edit'); set(h,'String',num2str(best_ECL));

hold off

for x=1:length(Masterdata.ECL_raw)
    line([Masterdata.ECL_raw(x) Masterdata.ECL_raw(x)],[ylim],'Color',[0.5 0.5 0.5],'LineStyle','--')
end

h=findobj('Tag','ShortToggle2'); short=get(h,'Value');
str{1}='Targets:';
for x=1:length(Targetdata)
    if short str{1+x}=Targetdata(x).Short; else str{1+x}=Targetdata(x).Code; end
end
text(0.02,0.95,str,'Units','Normalized','FontWeight','bold')

    


% ----------------------- PEAKPLOT ------------------------
function peakplot
global Optidata Targetdata Masterdata
h=findobj('Tag','ShortToggle2'); short=get(h,'Value');

%disp('-------- peakplot ---------')

h=findobj('Tag','OptiPlot'); pos=get(h,'Position');
set(gcf,'CurrentAxes',h); child=get(gca,'Children'); delete(child);

h=findobj('Tag','ECL-Edit'); ECL=str2double(get(h,'String'));

colors=get(gca,'ColorOrder');

sel=find(cat(2,Optidata.Selected)); n_sel=length(sel);

% Sigma (beregning av kurve)
h=findobj('Tag','SigmaEdit'); whh=str2double(get(h,'String')); 
s=whh/2.354; % Konverterer whh til std.dev.

hold on
offdiff=0.25/n_sel
for x=1:n_sel
%for x=1:5
    ply=Optidata(sel(x)).polynom; a=ply(1); b=ply(2);
    %y=ax+b
    ECL_current=a*ECL+b;
    xvect=(ECL_current-4*s):s/5:(ECL_current+4*s);
    yvect=normdist(xvect,ECL_current,s);
    h=plot(xvect,yvect);
    
    o=x*offdiff;
    text(ECL_current,0.83-o,num2str(Optidata(sel(x)).ind),'HorizontalAlignment','center')
    if short 
        text(ECL_current,0.8-o,Optidata(sel(x)).Short,'HorizontalAlignment','center')
    else
        text(ECL_current,0.8-o,Optidata(sel(x)).Code,'HorizontalAlignment','center') 
    end
    if Optidata(sel(x)).Class==0; 
        set(h,'Color',[0 0 0]); 
    else 
        set(h,'Color',colors(Optidata(sel(x)).Class,:)); 
    end
end

hold off
axis tight

str{1}=['Selected ECL: ' num2str(ECL)];
str{2}=['WHH: ' num2str(whh)];
text(0.1,0.95,str,'Units','Normalized','FontWeight','bold')


% --------------------- NORMDIST -------------------------
function h=normdist(x,u,s)
% x=estimat, u=senter, s=sigma
ex=exp(-((x-u).^2)/(2*s^2));
br=1/((2*pi*s)^0.5);
h=br*ex;
maxh=max(h); h=h/maxh(1);



% --------------------- LINPLOT -------------------------
function linplot
global Masterdata Optidata
colors=get(gca,'ColorOrder')
h=findobj('Tag','ShortToggle2'); short=get(h,'Value');

h=findobj('Tag','OptiPlot'); pos=get(h,'Position');
set(gcf,'CurrentAxes',h); child=get(gca,'Children'); delete(child);

% setter min/max/range
mean_ECL=mean(Masterdata.ECL_raw); 
h=findobj('Tag','OptiRangeEdit'); range=str2double(get(h,'String'));
minx=mean_ECL-range/2;
maxx=mean_ECL+range/2;

sel=find(cat(2,Optidata.Selected)) 
n_sel=length(sel);

hold on
maxy=maxx; miny=minx;
for x=1:n_sel
%for x=1:1 
    polyn=Optidata(sel(x)).polynom;
    lowy=minx*polyn(1)+polyn(2);
    highy=maxx*polyn(1)+polyn(2);
    h=plot([minx maxx],[lowy highy]); 
    
    if short
        h2=text(maxx,highy,Optidata(sel(x)).Short)
    else
        h2=text(maxx,highy,Optidata(sel(x)).Code)
    end
    
    if Optidata(sel(x)).Class==0; 
        set(h,'Color',[0 0 0]); set(h2,'Color',[0 0 0]); 
    else 
        set(h,'Color',colors(Optidata(sel(x)).Class,:)); set(h2,'Color',colors(Optidata(sel(x)).Class,:)); 
    end
    %if lowy<miny miny=lowy; end; if highy>maxy; maxy=highy; end
    
    
    
    
end
hold off
axis tight

for x=1:length(Masterdata.ECL_raw)
    line([Masterdata.ECL_raw(x) Masterdata.ECL_raw(x)],[ylim],'Color',[0.5 0.5 0.5],'LineStyle','--')
end


% --------------------- REGRESSION -------------------------
function regression
global Optidata Masterdata


if isempty(Masterdata) 
    qq_message(1,'|r|Select Master')
else
    %xdat=Masterdata.ECL_raw
    x=Masterdata.ECL_raw;
    %ind=Masterdata.ind % TEMP

    warning off MATLAB:divideByZero

    for ii=1:length(Optidata)
    %for ii=26:26
        y=Optidata(ii).ECL_raw;
    
        % y=ax+b    
        xd=x-mean(x); yd=y-mean(y);    
        a=sum(xd.*yd)/sum((xd).^2);
        b=mean(y)-a*mean(x);
    
        % Feilestimater
        ycalc=a*x+b;   
        R=corrcoef(y,ycalc); 
        SEC=std(y-ycalc);
    
        % Oppdaterer Optidata
        Optidata(ii).polynom=[a b];
        Optidata(ii).SEC=SEC;
        Optidata(ii).R2=R(1,2)^2;
        Optidata(ii).Master={Masterdata.ind,Masterdata.Code, Masterdata.Short};
    
    end
    warning on MATLAB:divideByZero
end

% --------------------- SETMASTER -------------------------
function setMaster
global Optidata Masterdata

h=findobj('Tag','DataList'); val=get(h,'Value'); n_val=length(val);
if n_val>1; 
    qq_message(1,'|r|Select only one');
else
    Masterdata=Optidata(val);
end
dispmaster

% --------------------- DISPMASTER -------------------------
function dispmaster
global Masterdata

str1=num2str(Masterdata.ind)
h=findobj('Tag','ShortToggle2'); short=get(h,'Value');
if short str2=Masterdata.Short; else str2=Masterdata.Code; end
str=[str1 '  ' str2];
h=findobj('Tag','MasterEdit'); set(h,'String',str); 

ECL_mean=mean(Masterdata.ECL_raw); ECL_mean=(round(ECL_mean*100))/100;
h=findobj('Tag','ECL-Edit'); set(h,'String',num2str(ECL_mean));



% --------------------- SELPLOT -------------------------
function selplot
global Masterdata Optidata fonts

h=findobj('Tag','OptiPlot'); pos=get(h,'Position');
set(gcf,'CurrentAxes',h); child=get(gca,'Children'); delete(child);

h=findobj('Tag','ShortToggle2'); short=get(h,'Value');
h=findobj('Tag','DataList'); val=get(h,'Value');
n_ref=length(val);

x=Masterdata.ECL_raw; n_programs=length(x);
mean_x=mean(x); h=findobj('Tag','OptiRangeEdit'); xrange=str2double(get(h,'String')); 
minx=mean_x-xrange/2;maxx=mean_x+xrange/2; 

hold on
for ii=1:n_ref
    y=Optidata(val(ii)).ECL_raw;
    plot(x,y,'o')
    % Beregn koeffisienter: y=ax+b      
    xd=x-mean(x); yd=y-mean(y); a=sum(xd.*yd)/sum((xd).^2); b=mean(y)-a*mean(x);
    % Line
    y_low=a*minx+b; y_high=a*maxx+b; line([minx maxx],[y_low y_high]);
    % Text
    if short str=Optidata(val(ii)).Short; else str=Optidata(val(ii)).Code; end
    str=[num2str(Optidata(val(ii)).ind) ') ' str];
    xp=mean([max(x)]); yp=a*xp+b;
    h=text(xp,yp,['\leftarrow ' str],'HorizontalAlignment','left');
    
    % feilestimater
    ycalc=a*x+b;   
    R=corrcoef(y,ycalc); R=R(1,2); R2=R^2;
    SEC=std(y-ycalc);
    
    if short 
        dispstr{ii}=[num2str(Optidata(val(ii)).ind) ') ' Optidata(val(ii)).Short ', SEC: ' num2str(SEC,'%-1.4f') ', R2: ' num2str(R2,'%-1.4f')];
    else
        dispstr{ii}=[num2str(Optidata(val(ii)).ind) ') ' Optidata(val(ii)).Code ', SEC: ' num2str(SEC,'%-1.4f') ', R2: ' num2str(R2,'%-1.4f')];   
    end 
end

text(0.025, 0.97, dispstr,'Units','Normalized','VerticalAlignment','Top','FontSize',fonts(1));

% y-akse
axis tight; a=ylim; miny=a(1); maxy=a(2); yrange=maxy-miny; ylim([(miny-yrange/10) (maxy+yrange/10)]); 
% setter x-akse
xlim([minx maxx]); 


% --------------------- REMTarget -------------------------
function remTarget
global Targetdata

h=findobj('Tag','TargetList'); val=get(h,'Value');
n_mast=length(Targetdata);
if n_mast>0 Targetdata(val)=[]; end
set(h,'Value',1); 

dispTarget

% --------------------- ADDTarget -------------------------
function addTarget
global Optidata Targetdata

h=findobj('Tag','DataList'); val=get(h,'Value');
n_sel=length(val);

n_mast=length(Targetdata);
if n_mast>0 
    ind=unique([cat(2,Targetdata.ind) cat(2,Optidata(val).ind)]);
else 
    ind=cat(2,Optidata(val).ind); 
end

n_mast=length(ind);
for x=1:n_mast
    Targetdata(x).Code=Optidata(ind(x)).Code;
    Targetdata(x).Short=Optidata(ind(x)).Short;
    Targetdata(x).Name=Optidata(ind(x)).Name;
    Targetdata(x).ind=Optidata(ind(x)).ind;
    Targetdata(x).ECL_raw=Optidata(ind(x)).ECL_raw;
end

dispTarget

% --------------------- DISPTarget -------------------------
function dispTarget
global Targetdata

h=findobj('Tag','ShortToggle2'); short=get(h,'Value'); 

printstr='';
for x=1:length(Targetdata)
    
    p=1; str{p}=num2str(Targetdata(x).ind); str{p}=[str{p} blanks(3-length(str{p}))]; 
    if short
        p=p+1; str{p}=Targetdata(x).Short; str{p}=[str{p} blanks(6-length(str{p}))]; 
    else
        p=p+1; str{p}=Targetdata(x).Code; str{p}=[str{p} blanks(6-length(str{p}))]; 
    end

    printstr{x}=''; for y=1:length(str); printstr{x}=[printstr{x} str{y}]; end
end

h=findobj('Tag','TargetList'); set(h,'String',strvcat(printstr))
    


% --------------------- MAKEDATA -------------------------
function makedata
global fariset Sam_X Samplegroupdata files Optidata

[m,n]=size(Sam_X);
for x=1:m
    Optidata(x).Code=Samplegroupdata.Code{x};
    Optidata(x).Short=Samplegroupdata.Short{x};
    Optidata(x).Name=Samplegroupdata.Name{x};
    Optidata(x).Group=Samplegroupdata.group{x};
    Optidata(x).ECL_raw=Sam_X(x,:);
    Optidata(x).Files=files.sampleclass{Optidata(x).Group};
    Optidata(x).Class=0; % Klassifisering av topper
    Optidata(x).Selected=1; % Valgt/Ikke valgt
end
% Sorterer
[dummy, ind]=sortrows(strvcat(Optidata.Code)); Optidata=Optidata(ind);
for x=1:m Optidata(x).ind=x; end


% --------------------- AVERAGE -------------------------
function average
global Optidata

ok=1;
h=findobj('Tag','DataList'); val=get(h,'Value'); n_sel=length(val);
%codes=strvcat(Optidata(val).Code);

match=strmatch(Optidata(val(1)).Code,strvcat(Optidata.Code)); 
if length(match)<n_sel qq_message(1,'|r|Codes must be identical'); ok=0; end
if n_sel<2 qq_message(1,'|r|Only one sample selected'); ok=0; end

n=length(Optidata)+1;
if ok==1
    Optidata(n).Code=Optidata(val(1)).Code;
    Optidata(n).Short=Optidata(val(1)).Short;
    Optidata(n).Name=Optidata(val(1)).Short;
    Optidata(n).Group=0;
    Optidata(n).Files={''};
    Optidata(n).Selected=1;
    Optidata(n).ECL_raw=sum(cat(1,Optidata(val).ECL_raw))/n_sel;
    Optidata(n).ind=n;
    classes=unique(cat(2,Optidata(val).Class));
    if length(classes)==1 Optidata(n).Class=classes; else Optidata(n).Class=0; end
    
    [Optidata(val).Selected]=deal(0);
end

% --------------------- SETCLASS -------------------------
function setclass
global Optidata

h=findobj('Tag','DataList'); val=get(h,'Value'); n_sel=length(val);
h=findobj('Tag','ClassEdit'); selclass=str2double(get(h,'String')); 
[Optidata(val).Class]=deal(selclass);



% --------------------- DATALIST -------------------------
function datalist
global Optidata fariset

h=findobj('Tag','ShortToggle2'); short=get(h,'Value'); 
h=findobj('Tag','ValuesToggle'); values=get(h,'Value'); 

for x=1:length(Optidata)
    
    p=1; str{p}=num2str(Optidata(x).ind); str{p}=[str{p} blanks(3-length(str{p}))]; 
    p=p+1; if Optidata(x).Selected==1 str{p}='+ '; else str{p}='- '; end 
    
    if short
        p=p+1; str{p}=[Optidata(x).Short blanks(10-length(Optidata(x).Short))]; 
    else   
        p=p+1; str{p}=[Optidata(x).Code blanks(10-length(Optidata(x).Code))];   
    end 
    
    p=p+1; str{p}=['Gr.' num2str(Optidata(x).Group)]; str{p}=[str{p} blanks(6-length(str{p}))]; 
    p=p+1; str{p}=['#' num2str(Optidata(x).Class)]; str{p}=[str{p} blanks(4-length(str{p}))]; 
    
    % Polynom
    if isfield(Optidata,'R2') & isempty(Optidata(x).R2)==0
        p=p+1; str{p}=['R2=' num2str(Optidata(x).R2,'%-1.3f')]; str{p}=[str{p} blanks(10-length(str{p}))];
        p=p+1; str{p}=['b=' num2str(Optidata(x).polynom(1),'%-1.3f') ';' num2str(Optidata(x).polynom(2),'%-1.3f')]; str{p}=[str{p} blanks(18-length(str{p}))];
    end
    if isfield(Optidata,'R2') & isempty(Optidata(x).R2)
        p=p+1; str{p}=['R2= - ']; str{p}=[str{p} blanks(10-length(str{p}))];
        p=p+1; str{p}=['b= - ' '; - ' ]; str{p}=[str{p} blanks(18-length(str{p}))];
    end
    
    if values
        for y=1:length(Optidata(x).ECL_raw); 
            p=p+1; str{p}=num2str(Optidata(x).ECL_raw(y),'%-1.3f'); str{p}=[str{p} blanks(8-length(str{p}))];
        end
    end

    printstr{x}=''; for y=1:length(str) printstr{x}=[printstr{x} str{y}]; end   
end

h=findobj('Tag','DataList'); set(h,'String',printstr,'Max',2);








%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global fonts positions colors

bw=positions.bw;
bh=positions.bh;
eh=positions.eh;
gh=positions.gh;% grid height
o2=(bw*2+(bw*2/3))/3; 
x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % horisontalt grid

winpar{1}='OptiresWin'; winpar{2}='OptiRes';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0; o=bw/2;
% CLOSE
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'close(gcbf)',3,'CloseBtn');
% Files
p=p+1;[ui{p,1:7}] = deal('Add Target ->','Pushbutton',colors.btn{1},[x(1) y(16) bw bh],'qq_2dfari_optires(3.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Remove <-','Pushbutton',colors.btn{1},[x(1) y(17) bw bh],'qq_2dfari_optires(3.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('','listbox',[1 1 1],[x(2) y(17) bw*2 abs(y(16)-y(17))+bh],'',2,'TargetList');
p=p+1;[ui{p,1:7}] = deal('Compounds','text',colors.bc,[x(1) y(1) bw*2 eh],'',3,'');
p=p+1;[ui{p,1:7}] = deal('','listbox',[1 1 1],[x(1) y(14) bw*4 gh*12+bh],'',2,'DataList');
p=p+1;[ui{p,1:7}] = deal('Master ->','Pushbutton',colors.btn{1},[x(1) y(18) bw bh],'qq_2dfari_optires(3.3)',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(2) y(18) bw*2 bh],'',2,'MasterEdit');

lw=bw*4/6
p=p+1;[ui{p,1:7}] = deal('Short','Togglebutton',colors.btn{3},[x(1) y(15) lw bh],'qq_2dfari_optires(2.1)',2,'ShortToggle2');
p=p+1;[ui{p,1:7}] = deal('Values','Togglebutton',colors.btn{3},[x(1)+lw y(15) lw bh],'qq_2dfari_optires(2.1)',2,'ValuesToggle');
p=p+1;[ui{p,1:7}] = deal('Select','Pushbutton',colors.btn{3},[x(1)+2*lw y(15) lw bh],'qq_2dfari_optires(2.4)',2,'');
p=p+1;[ui{p,1:7}] = deal('Deselect','Pushbutton',colors.btn{3},[x(1)+3*lw y(15) lw bh],'qq_2dfari_optires(2.5)',2,'');
p=p+1;[ui{p,1:7}] = deal('Average','Pushbutton',colors.btn{3},[x(1)+4*lw y(15) lw bh],'qq_2dfari_optires(2.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('Class','Pushbutton',colors.btn{3},[x(1)+5*lw y(15) lw*0.75 bh],'qq_2dfari_optires(2.3)',2,'');
p=p+1;[ui{p,1:7}] = deal('0','Edit',colors.btn{3},[x(1)+lw*5.75 y(15) lw*0.25 bh],'',2,'ClassEdit');
p=p+1;[ui{p,1:7}] = deal('Delete','Pushbutton',colors.reset,[x(1)+5*lw y(16) lw bh],'qq_2dfari_optires(2.6)',2,'');

% PLOTT/CALC
p=p+1;[ui{p,1:7}] = deal('Plot Sel.','Pushbutton',colors.btn{2},[x(5)+o y(16) bw bh],'qq_2dfari_optires(4.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Lineplot','Pushbutton',colors.btn{2},[x(6)+o y(16) bw bh],'qq_2dfari_optires(4.3)',2,'');
p=p+1;[ui{p,1:7}] = deal('Regression','Pushbutton',colors.btn{2},[x(5)+o y(17) bw bh],'qq_2dfari_optires(4.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('Peakplott','Pushbutton',colors.btn{2},[x(7)+o y(16) bw bh],'qq_2dfari_optires(4.4)',2,'');
p=p+1;[ui{p,1:7}] = deal('Optisearch','Pushbutton',colors.btn{2},[x(5)+o y(19) bw bh],'qq_2dfari_optires(4.5)',2,'');

% Range (optisearch)
p=p+1;[ui{p,1:7}] = deal('Range:','Text',colors.bc,[x(6)+o+bw/10 y(19) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('1.0','Edit',[1 1 1],[x(6)+o+bw*2/3 y(19) bw*2/3 bh],'',4,'OptiRangeEdit');

% Select ECL
p=p+1;[ui{p,1:7}] = deal('Sel. ECL','Text',colors.bc,[x(5)+o y(18) bw eh],'',3,'');
p=p+1;[ui{p,1:7}] = deal('<<','Pushbutton',colors.btn{4},[x(6)+o y(18) bw/3 bh],'qq_2dfari_optires(5.1)',4,'');
p=p+1;[ui{p,1:7}] = deal('<','Pushbutton',colors.btn{4},[x(6)+o+bw/3 y(18) bw/3 bh],'qq_2dfari_optires(5.2)',4,'');
p=p+1;[ui{p,1:7}] = deal('>','Pushbutton',colors.btn{4},[x(6)+o+bw*4/3 y(18) bw/3 bh],'qq_2dfari_optires(5.3)',4,'');
p=p+1;[ui{p,1:7}] = deal('>>','Pushbutton',colors.btn{4},[x(6)+o+bw*5/3 y(18) bw/3 bh],'qq_2dfari_optires(5.4)',4,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(6)+o+bw*2/3 y(18) bw*2/3 bh],'qq_2dfari_optires(5.5)',4,'ECL-Edit');
p=p+1;[ui{p,1:7}] = deal('WHH','Text',colors.bc,[x(8)+o+bw/20 y(18) bw/2 eh],'',3,'');
p=p+1;[ui{p,1:7}] = deal('0.03','Edit',[1 1 1],[x(8)+o+bw/2 y(18) bw/2 bh],'',4,'SigmaEdit');

% Save/Resume
p=p+1;[ui{p,1:7}] = deal('Save','Pushbutton',colors.btn{5},[x(5)+o y(20) bw bh],'qq_2dfari_optires(6.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Resume','Pushbutton',colors.btn{5},[x(6)+o y(20) bw bh],'qq_2dfari_optires(6.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('Default','Edit',[1 1 1],[x(7)+o y(20) bw bh],'',2,'FnEdit');

% Export
p=p+1;[ui{p,1:7}] = deal('Exp. All','Pushbutton',colors.btn{6},[x(3) y(20) bw*2/3 bh],'qq_2dfari_optires(7.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Exp. Sel.','Pushbutton',colors.btn{6},[x(3)+bw*2/3 y(20) bw*2/3 bh],'qq_2dfari_optires(7.15)',2,'');
p=p+1;[ui{p,1:7}] = deal('Exp. Fig.','Pushbutton',colors.btn{6},[x(3)+bw*4/3 y(20) bw*2/3 bh],'qq_2dfari_optires(7.2)',2,'');

level='';
h0=qq_drawwin(winpar,ui,level); 
drawnow

h=axes('Position',[x(5)+o y(14) bw*4 gh*12+bh],'Tag','OptiPlot');
