function qq_2dfari_searchlib(an)

global fariset Results FariSearchLib

%disp('---- Search ----')
qq_message(2)

if an==1   
    if strmatch(fariset.resultstype,'2D-FARI')
        openwin
        an=2;   % UPDATE
    else
        qq_message(1,'|r|Not 2D-FARI Results')
        an=9000; % Dummy-verdi
    end
end

% ZOOM
if an==5.1 zoom(1.5); end
if an==5.2 zoom(0.667); end    
if an==5.3 plotlabels; end

% SELECT LIBS
% Initiate
if an>6 & an<7; 
    if isfield(fariset,'search_libs')==0; fariset.search_libs=[]; end   
    AllLibsList=findobj('Tag','2DF_LibsList'); SearchLibsList=findobj('Tag','2DF_SearchLibsList');
    val=get(AllLibsList,'Value'); sel_lib=fariset.all_libs{val};
    [m,n]=size(fariset.search_libs);
end
% ADD
if an==6.1 & isempty(strmatch(sel_lib,fariset.search_libs,'exact')) fariset.search_libs{n+1}=sel_lib; end
% DEL
if an==6.2  val=get(SearchLibsList,'Value'); if n>0; fariset.search_libs(val)=[]; end; end
% ADD ALL
if an==6.3  fariset.search_libs=fariset.all_libs; end
% EditLib
if an==6.4 & isempty(fariset.search_libs)==0 fariset.edit_lib=sel_lib; end
% Update    
if an>6 & an<7; updlibs; end

% Constrain
if an==7.1 
    h=findobj('Tag','SearchShortEdit'); set(h,'String','','Value',0)
    h=findobj('Tag','SearchCodeEdit'); set(h,'Value',1)    
end
if an==7.2 
    h=findobj('Tag','SearchCodeEdit'); set(h,'String','','Value',0)
    h=findobj('Tag','SearchShortEdit'); set(h,'Value',1)     
end

h=findobj('Tag','AutoToggle'); val=get(h,'Value');
if an==2 | val==1;
    getlibs
    loadlibs
    updlibs   
    if exist('FariSearchLib') & isempty(FariSearchLib)==0 
        plotfari
        plotlabels   
        bestmatch
    else
        clearplots
    end
end

%FariSearchLib % TEMP
%fariset % TEMP

%--------------------------------------------------------------------------
%                          S U B F U N C T I O N S
%--------------------------------------------------------------------------

% --------------- CLEARPLOTS--------------
function clearplots

%disp('---- Clearplots ----')

Reslist=findobj('Tag','S_ResultsList'); set(Reslist,'String','')
Plotlab=findobj('Tag','Lib-plot'); children=get(Plotlab,'Children'); delete(children); set(Plotlab,'Tag','Dummyplot')
if isempty(Plotlab)
    pos=get(Reslist,'Position'); pos=pos+[0 -0.43 0 0];
    plotlab=subplot('Position',pos); set(plotlab,'Tag','Dummyplot');
    xlim([8 28]); ylim([0 6])
end


% --------------- CONSTRAIN --------------
function constrain

global FariSearchLib 

search_code=get(findobj('Tag','SearchCodeEdit'),'Value');
search_short=get(findobj('Tag','SearchShortEdit'),'Value');

if search_code
    str=get(findobj('Tag','SearchCodeEdit'),'String');
    ind=strmatch(str,strvcat(FariSearchLib.Code));
end
if search_short
    str=get(findobj('Tag','SearchShortEdit'),'String');
    ind=strmatch(str,strvcat(FariSearchLib.Short));
end
if search_code | search_short
    FariSearchLib=FariSearchLib(ind);
    [m,n]=size(FariSearchLib); for x=1:n; FariSearchLib(x).entrynr=x; end
end


   

% --------------- BESTMATCH --------------
function bestmatch

global fariset FariSearchLib Results

%FariSearchLib % TEMP

[m,n]=size(FariSearchLib);
dispstr='';
if n>0
    X=[cat(1,FariSearchLib.FARIA) cat(1,FariSearchLib.FARIB) cat(1,FariSearchLib.entrynr)];
    % Beregner diff (Euklidisk avstand)
    X(:,4)=((X(:,1)-Results(fariset.selected).FARIA).^2 + (X(:,2)-Results(fariset.selected).FARIB).^2).^0.5;
    X=sortrows(X,4);

    %if n>20 n=20; end % Antall i liste

    h=findobj('Tag','S_ShortToggle'); val=get(h,'Value');

    for x=1:n
        if val==1; str1=[FariSearchLib(X(x,3)).Short, blanks(20)]; str1=str1(1:10); 
        else str1=[FariSearchLib(X(x,3)).Code, blanks(20)]; str1=str1(1:10);
        end
        str2=[num2str(FariSearchLib(X(x,3)).FARIA,'%-1.3f') blanks(10)]; str2=str2(1:8); 
        str3=[num2str(FariSearchLib(X(x,3)).FARIB,'%-1.3f') blanks(10)]; str3=str3(1:8); 
        str4=[num2str(X(x,4),'%-1.3f') blanks(10)]; str4=str4(1:8); 
        str5=[FariSearchLib(X(x,3)).library blanks(10)]; str5=str5(1:10);   
        dispstr{x}=[str1 str2 str3 str4 str5]; 
    end

    
else
    qq_message(1,'|r|No Entries')
end
h=findobj('Tag','S_ResultsList'); set(h,'String',dispstr,'Value',1)
    

% --------------- UPDLIBS --------------
function updlibs

global fariset

%disp('-------- UPDLIBS --------')

if isfield(fariset,('all_libs'))
    AllLibsList=findobj('Tag','2DF_LibsList'); set(AllLibsList,'String',fariset.all_libs)
end
if isfield(fariset,('search_libs'))
    SearchLibsList=findobj('Tag','2DF_SearchLibsList'); set(SearchLibsList,'String',fariset.search_libs,'Value',1)
end
if isfield(fariset,('edit_lib'))
    Libedit=findobj('Tag','2DF_LibraryEdit'); set(Libedit,'String',fariset.edit_lib)
end


% --------------- getlibs -------------- 
function getlibs

global fariset

%disp('-------- GETLIBS --------')

fariset.libdir='C:\qq\2D-FARI\Libraries';
searchpath=[fariset.libdir,'\2D-FARILIB_*.mat'];

DD=dir(searchpath);D=struct2cell(DD); 
names=D(1,:);
delstr='2D-FARILIB_'; ldel=length(delstr);
[m,n]=size(names); 
for x=1:n
    libname=names{x}; le=length(libname); fariset.all_libs{x}=libname(ldel+1:le-4);
end
h=findobj('Tag','2DF_LibsList'); set(h,'String',fariset.all_libs)

% --------------- LOADLIBS -------------- 
function loadlibs

global fariset FariSearchLib

%disp('-------- LOADLIBS --------')

fariset.libdir='C:\qq\2D-FARI\Libraries'; % TEMP
p=0; nn=0; if isfield(fariset,'search_libs') [mm,nn]=size(fariset.search_libs); end
if nn>0
    for x=1:nn
        pathname=[fariset.libdir,'\2D-FARILIB_',fariset.search_libs{x},'.mat'];
        load(pathname,'Farilib')
        Farilib % TEMP
        [m,n]=size(Farilib);
        for y=1:n
            Farilib(y).library=fariset.search_libs{x}; Farilib(y).entrynr=p+1;
            p=p+1; Templib(p)=Farilib(y); 
        end
    end
    
    FariSearchLib=Templib;

    constrain
else
    qq_message(1,'|r|No Libraries'); h=findobj('Tag','2DF_SearchLibsList'); set(h,'Value',1); 
    fn=fieldnames(FariSearchLib); n=length(fn); for x=1:n  dummylib.(fn{x})=[]; end; dummylib(1)=[]; FariSearchLib=dummylib;
end


% ------------------ PLOTFARI -----------------
function plotfari
global fariset FariSearchLib positions Results

%disp('-------- PLOTFARI --------')
Libentry=Results(fariset.selected);
 
oldplot=findobj('Tag','Lib-plot'); 
if isempty(oldplot)==0; 
    oldx=xlim(oldplot);
    oldy=ylim(oldplot);
end

% plot
h=findobj('Tag','ResultsList'); pos=get(h,'Position'); pos=pos+[0 -0.43 0 0];
plotlab=subplot('Position',pos); set(plotlab,'Tag','Lib-plot');
children=get(plotlab,'Children'); delete(children);

if isempty(oldplot)
    xspan=[cat(2,FariSearchLib.FARIA) Libentry.FARIA];
    yspan=[cat(2,FariSearchLib.FARIB) Libentry.FARIB];
    minx=min(xspan); maxx=max(xspan); xr=(maxx-minx)/10; xlim(plotlab,[minx-xr maxx+xr]); 
    miny=min(yspan); maxy=max(yspan); yr=(maxy-miny)/10; ylim(plotlab,[miny-yr maxy+yr]);
end


[m,n]=size(FariSearchLib);

hold on
% Plot Selected
h=plot(Libentry.FARIA,Libentry.FARIB,'o','MarkerSize',9,'MarkerEdgeColor',[0 0.7 0],'LineWidth',3,'Tag','SelMarker');
% Plot library
for x=1:n
    h=plot(FariSearchLib(x).FARIA,FariSearchLib(x).FARIB,'.','MarkerSize',10,'Tag','Libmarker','UserData',x);
    if isfield(FariSearchLib,'leftout') & isempty(FariSearchLib(x).leftout)==0 set(h,'MarkerFaceColor',[1 0 0], 'MarkerEdgeColor',[1 0 0]); end    
end

% GRIDS
grid=1;
if grid==1
    minx=min(cat(2,FariSearchLib.FARIA));maxx=max(cat(2,FariSearchLib.FARIA));miny=min(cat(2,FariSearchLib.FARIB));maxy=max(cat(2,FariSearchLib.FARIB));
    miny=round(miny)-0.5; maxy=round(maxy)+0.5; minx=round(minx)-0.5; maxx=round(maxx)+0.5;
    a=miny:1:maxy; for x=1:length(a) line('XData',[minx maxx],'YData',[a(x) a(x)],'LineStyle',':'); end
    a=minx:1:maxx; for x=1:length(a) line('XData',[a(x) a(x)],'YData',[miny maxy],'LineStyle',':'); end 
end



% ------------------- ZOOM -----------------------
function zoom(fact)

h=findobj('Tag','Lib-plot');
if isempty(h)==0
    
    xax=xlim(h); xrange=xax(2)-xax(1); yax=ylim(h); yrange=yax(2)-yax(1);
    markh=findobj('Tag','SelMarker');
    xcent=get(markh,'XData'); ycent=get(markh,'YData');

    xrange=xrange/fact; yrange=yrange/fact;
    xax=[xcent-xrange/2 xcent+xrange/2];
    yax=[ycent-yrange/2 ycent+yrange/2];
    xlim(h,xax); ylim(h,yax);
end

% ------------------- PLOTLABELS -----------------------
function plotlabels
global fonts FariSearchLib

%disp('-------- PLOTLABELS --------')

h=findobj('Tag','S_ShortToggle'); shortnames=get(h,'Value');

if shortnames labels=str2mat(FariSearchLib.Short); else labels=str2mat(FariSearchLib.Code); end
[m,n]=size(labels); labels=[repmat('  ',m,1) labels];

ploth=findobj('Tag','Lib-plot'); 
if isempty(ploth)==0
    axes(ploth);
    buttonh=findobj('Tag','S_LabelsToggle'); labelsh=findobj('Tag','LibTextlabel'); delete(labelsh)
    if get(buttonh,'Value')==1 
        text(cat(2,FariSearchLib.FARIA),cat(2,FariSearchLib.FARIB),labels,'Tag','LibTextlabel','FontSize',fonts(1));
    end
end
h=findobj('Tag','LibTextlabel'); set(h,'Clipping','on');



%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global fonts positions colors

bw=positions.bw;
bh=positions.bh;
eh=positions.eh;
gh=positions.gh;% grid height
o2=(bw*2+(bw*2/3))/3; 

x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % horisontalt grid


winpar{1}='2dfLibSearchWin'; winpar{2}='2DFARI: Search Libr';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0; o=bw/2;
% CLOSE
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'close(gcbf)',3,'CloseBtn');
% UPDATE
p=p+1;[ui{p,1:7}] = deal('Update','Pushbutton',colors.btn{1},[x(1)+bw/2 y(15) bw bh],'qq_2dfari_searchlib(2)',2,'');
p=p+1;[ui{p,1:7}] = deal('Auto','Togglebutton',colors.btn{1},[x(1) y(15) bw/2 bh],'qq_2dfari_searchlib(2)',2,'AutoToggle');

% PLOT
n=4; lbw=bw*n/4.5;
p=p+1;[ui{p,1:7}] = deal('Zoom in','Pushbutton',colors.btn{3},[x(6)+o y(20) lbw bh],'qq_2dfari_searchlib(5.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Zoom out','Pushbutton',colors.btn{3},[x(6)+o+lbw y(20) lbw bh],'qq_2dfari_searchlib(5.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('Labels','Togglebutton',colors.btn{3},[x(6)+o+lbw*2 y(20) lbw bh],'qq_2dfari_searchlib(5.3)',2,'S_LabelsToggle');
p=p+1;[ui{p,1:7}] = deal('Short','Togglebutton',colors.btn{3},[x(6)+o+lbw*3 y(20) lbw bh],'qq_2dfari_searchlib(5.3)',2,'S_ShortToggle');
% Lister
p=p+1;[ui{p,1:7}] = deal('Available Libraries','Text',colors.bc,[x(1) y(1) bw*1.5 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Listbox',[1 1 1],[x(1) y(8) bw*1.5 y(1)-y(8)],'',2,'2DF_LibsList');
p=p+1;[ui{p,1:7}] = deal('Search In','Text',colors.bc,[x(3) y(1) bw*1.5 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Listbox',[1 1 1],[x(3) y(6) bw*1.5 y(1)-y(6)],'',2,'2DF_SearchLibsList');
p=p+1;[ui{p,1:7}] = deal('Edit Library','Text',colors.bc,[x(3) y(7) bw*1.5 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(3) y(8) bw*1.5 bh],'',2,'2DF_LibraryEdit');
p=p+1;[ui{p,1:7}] = deal('','listbox',[1 1 1],[x(6)+bw/2 y(9) bw*3.5 gh*7+bh],'',2,'S_ResultsList');
% Select Searchlibs
p=p+1;[ui{p,1:7}] = deal('->','Pushbutton',colors.accept,[x(2)+bw/2 y(2) bw/2 bh],'qq_2dfari_searchlib(6.1)',4,'');
p=p+1;[ui{p,1:7}] = deal('<-','Pushbutton',colors.reset,[x(2)+bw/2 y(3) bw/2 bh],'qq_2dfari_searchlib(6.2)',4,'');
p=p+1;[ui{p,1:7}] = deal('All','Pushbutton',colors.accept,[x(2)+bw/2 y(4) bw/2 bh],'qq_2dfari_searchlib(6.3)',2,'');
p=p+1;[ui{p,1:7}] = deal('->','Pushbutton',colors.accept,[x(2)+bw/2 y(8) bw/2 bh],'qq_2dfari_searchlib(6.4)',4,'');
% Constrain Res.
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(3) y(10) bw*1.5 bh],'qq_2dfari_searchlib(7.1)',2,'SearchCodeEdit');
p=p+1;[ui{p,1:7}] = deal('Search Code','Text',colors.bc,[x(2) y(10) bw*1 bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(3) y(11) bw*1.5 bh],'qq_2dfari_searchlib(7.2)',2,'SearchShortEdit');
p=p+1;[ui{p,1:7}] = deal('Search Short','Text',colors.bc,[x(2) y(11) bw*1 bh],'',2,'');

updfcn='';
qq_drawwin(winpar,ui,updfcn); 

h=findobj('Tag','AutoToggle'); set(h,'Value',1);

drawnow
