function qq_addlib(an,selected_inp)
% function qq_addlib

global fileset metset RE labels locset
persistent LIB selected

if isfield(locset,'tracker')==1 && locset.tracker==1 disp(['----- ADDLIB -----: ' num2str(an)]); end

% pner vindu
if an==1; 
    selected=selected_inp;
    LIB.S=RE(selected).S;             % Spektrum
    LIB.pn=selected;                  % Peak number  
    LIB.rt=RE(selected).rt; % Retensjonstid
    LIB.ri_calc=RE(selected).ri_calc; % Retensjonsindex beregnet
    LIB.clunr=RE(selected).clu_nr;    % cluster nr
    LIB.single='Extracted'; if RE(selected).peaksincl==1 LIB.single='Single'; end
    LIB.ions=fileset.ions;
    openwin(LIB); qq_lib_descriptors(0);
    %h=findobj('Tag','SubWin'); set(h,'Visible','off') % Lukker Subwindow
    peakinfo(selected); 
    LIB % TEMP
end

% Oppdaterer metset.library_name
if an == 2
    AddLibraryEdit=findobj('Tag','AddLibraryEdit'); metset.library_name=get(AddLibraryEdit,'String');
end
    
% Oppdaterer n_entries
if an==1 | 2
    AddLibraryEdit=findobj('Tag','AddLibraryEdit'); 
    metset.library_name=get(AddLibraryEdit,'String');
    filename=[locset.path_library,'\class_',metset.global_class,'\lib_',metset.library_name];
    [n_entries,Library]=getlib(filename); 
    EntriesTxt=findobj('Tag','EntriesTxt');
    set(EntriesTxt,'String',[num2str(n_entries),' Entries']);
end

% ACCEPT LES resultater og lagrer i Library
if an==0;  
    CompoundNameEdit=findobj('Tag','CompoundNameEdit'); LIB.cmp_name=get(CompoundNameEdit,'String');
    if isempty(LIB.cmp_name) LIB.cmp_name='-'; end 
    CompoundCodeEdit=findobj('Tag','CompoundCodeEdit'); LIB.cmp_shortname=get(CompoundCodeEdit,'String');
    if isempty(LIB.cmp_shortname) LIB.cmp_shortname='-'; end 
    CasNrEdit=findobj('Tag','CasNrEdit'); LIB.cmp_code=get(CasNrEdit,'String');  
    if isempty(LIB.cmp_code) LIB.cmp_code='-'; end 
    RiDefEdit=findobj('Tag','RiDefEdit'); LIB.ri_def=str2double(get(RiDefEdit,'String')); 
    RiEdit=findobj('Tag','RiEdit'); LIB.ri_calc=str2double(get(RiEdit,'String')); 
    CommentsEdit=findobj('Tag','CommentsEdit'); LIB.comments=(get(CommentsEdit,'String')); 
    LIB.file_name=fileset.global_filename;
    LIB.column=metset.global_selcol;   
    LIB.mdescr=qq_lib_descriptors(1);
    LIB=orderfields(LIB);
 
    % Sjekker om library eksisterer     
    AddLibraryEdit=findobj('Tag','AddLibraryEdit'); metset.library_name=get(AddLibraryEdit,'String');
    filename=[locset.path_library,'\class_',metset.global_class,'\lib_',metset.library_name];
    [n_entries,Library]=getlib(filename);  
    % Henter bibliotek, n_entries=0 hvis bibliotek ikke eksisterer
    if n_entries==0
        Library=LIB;
    else
        fn=fieldnames(LIB);
        for x=1:length(fn)
            Library(n_entries+1).(fn{x})=LIB.(fn{x});
        end
        %Library(n_entries+1)=LIB;
    end
    
    %save(filename,'Library')
    qq_savefile(filename,Library,'-o -s')
    
    % Lagrer i register, M sjekkes TEMP
    UpdRegCheck=findobj('Tag','UpdRegCheck');
    val=get(UpdRegCheck,'Value');
    metset.library_update=val;
    if val==1; qq_register(5); end

    % LUKKER VINDU
    qq_closewin;
end

% Edit comments template
if an==4
    CommentsTemplateEdit=findobj('Tag','CommentsTemplateEdit');
    CommentsEdit=findobj('Tag','CommentsEdit');
    metset.library_commentstemplate=get(CommentsTemplateEdit,'String');
    set(CommentsEdit,'String',metset.library_commentstemplate);   
end
  
% set retention index
if an==5.1
    RiEdit=findobj(gcf,'Tag','RiEdit'); val=str2double(get(RiEdit,'String'));
    if ~isnan(val)
        set(RiEdit,'BackgroundColor',[1 1 1])
    else
        set(RiEdit,'BackgroundColor',[1 1 0],'String','')
    end
end
if an==5.2
    %disp('--- set RI_def ---')
    RiEdit=findobj(gcf,'Tag','RiEdit'); RiDefEdit=findobj(gcf,'Tag','RiDefEdit');
    val=str2double(get(RiDefEdit,'String'));
    rion=strcmp(get(RiEdit,'Enable'),'on');
    if ~isnan(val) && isempty(RE(selected).ri_calc) && rion
        set(RiEdit,'String',num2str(val),'Enable','on','BackgroundColor',[1 1 0],'String',num2str(val));
        qq_message(1,'|r|Check: Retention index was set equal to RI Def');      
    end
    
end



 % CLOSE
 if an==8
     %h=findobj('Visible','off'); set(h,'Visible','on')
     qq_closewin;
 end

 % Keypress
 if an==96
     %
 end
 
 % UPDATE
 if an==100;
     %
 end
 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                            S U B F U N C T I O N S
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% ------------- FUNCTION: GETLIB --------------------------------------------------------

    function [n_entries,Library]=getlib(filename)
    
    D=dir([filename,'.mat']);
    DD=struct2cell(D);[m,n]=size(DD);
    if n>0
        load(filename,'Library');
        d=struct2cell(Library);
        [m,n_entries]=size(d);
    else
        n_entries=0; Library=[];
    end


% --------- SUBFUNCTION: SPECTRUM --------------------------------------------
function spectrum(LIB)

subplot('position',[0.6 0.05 0.35 0.4]); plot(0);
miny=min(LIB.S); if miny>0; miny=0; end 
bar(LIB.ions,LIB.S)
ylim([miny 100])

% --------- SUBFUNCTION: PEAKINFO --------------------------------------------
function peakinfo(selected)
global RE labels metset
 
if RE(selected).identified==1
    str{1}='Identified as:';
    str{2}=['Name: ',RE(selected).cmp_name];
    str{3}=['Short name: ',RE(selected).cmp_shortname];
    str{4}=['Reg Code: ',RE(selected).cmp_code];
else
    str{1}='Not indentified';
end
IdentificationTxt=findobj('Tag','IdentificationTxt');
set(IdentificationTxt,'String',str)

if RE(selected).identified==1
    CompoundNameEdit=findobj('Tag','CompoundNameEdit');
    set(CompoundNameEdit,'String',RE(selected).cmp_name);
    CompoundCodeEdit=findobj('Tag','CompoundCodeEdit');
    set(CompoundCodeEdit,'String',RE(selected).cmp_shortname);
    CasNrEdit=findobj('Tag','CasNrEdit');
    set(CasNrEdit,'String',RE(selected).cmp_code);  
    % Search for entry in register
    qq_register(2); 
    qq_register(3);
    
end
   
% sets ri_def
if isnan(RE(selected).ri_def)==0
    RiDefEdit=findobj('Tag','RiDefEdit'); set(RiDefEdit,'String',num2str(RE(selected).ri_def));
end

% if retention index calculated, disable ri edit
if ~isempty(RE(selected).ri_calc)
    RiEdit=findobj('Tag','RiEdit'); set(RiEdit,'String',num2str(RE(selected).ri_calc),'Enable','off');
end

% if retention index not calculated and ri_def exists, enable edit and set RI equal to ri_def 
if isempty(RE(selected).ri_calc) && ~isnan(RE(selected).ri_def)
    RiEdit=findobj('Tag','RiEdit'); set(RiEdit,'String',num2str(RE(selected).ri_def),'Enable','on','BackgroundColor',[1 1 0]);
    qq_message(1,'|r|Check: Retention index not calculated, was set equal to RI Def'); 
end
        
% Setter comments
if isfield(metset,'library_commentstemplate') 
    CommentsTemplateEdit=findobj('Tag','CommentsTemplateEdit');
    set(CommentsTemplateEdit,'String',metset.library_commentstemplate);
    CommentsEdit=findobj('Tag','CommentsEdit');
    set(CommentsEdit,'String',metset.library_commentstemplate);
end
    



%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin(LIB)

global positions colors metset fileset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;

x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='AddLibWin'; winpar{2}='Q: Add Libr.';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0;
% RESET/CLOSE/ACCEPT
p=p+1;[ui{p,1:7}] = deal('Discard','Pushbutton',colors.reset,[x(1) y(20) bw bh*1.5],'qq_addlib(8)',3,'');
%p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(2) y(20) bw bh*1.5],'qq_closewin',3,'');
p=p+1;[ui{p,1:7}] = deal('Accept','Pushbutton',colors.accept,[x(2) y(20) bw bh*1.5],'qq_addlib(0)',3,'');
p=p+1;[ui{p,1:7}] = deal('TEMP','Pushbutton',colors.btn{4},[x(4) y(20) bw bh*1.5],'qq_lib_descriptors(1);',3,'TempButton');

% FRAME
p=p+1;[ui{p,1:7}] = deal('','Frame',colors.bc,[x(1)-bw/5 y(14) bw*4.5 y(1)-y(15)],'',3,'');
p=p+1;[ui{p,1:7}] = deal('Add to Library:','Text',colors.bc,[x(1) y(1) bw*3 bh],'',4,'');
% NAME
p=p+1;[ui{p,1:7}] = deal('Name:','Text',colors.bc,[x(1) y(2) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(2) y(2) bw*3 eh],'',2,'CompoundNameEdit');
% Short Name
p=p+1;[ui{p,1:7}] = deal('Short name:','Text',colors.bc,[x(1) y(3) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(2) y(3) bw*3 eh],'',2,'CompoundCodeEdit');
% Code
p=p+1;[ui{p,1:7}] = deal('Reg. code:','Text',colors.bc,[x(1) y(4) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(2) y(4) bw eh],'',2,'CasNrEdit');
% Retention index
p=p+1;[ui{p,1:8}] = deal('RI:  ','Text',colors.bc,[x(3) y(4) bw/2 eh],'',2,'','-r');
p=p+1;[ui{p,1:8}] = deal('','Edit',[1 1 1],[x(3)+bw/2 y(4) bw/2 eh],'qq_addlib(5.1)',2,'RiEdit','-r');
% Ri def
p=p+1;[ui{p,1:8}] = deal('RI Def:  ','Text',colors.bc,[x(4) y(4) bw/2 eh],'',2,'','-r');
p=p+1;[ui{p,1:8}] = deal('','Edit',[1 1 1],[x(4)+bw/2 y(4) bw/2 eh],'qq_addlib(5.2)',2,'RiDefEdit','-r');
% Carbons
%p=p+1;[ui{p,1:7}] = deal('Carbons:','Text',colors.bc,[x(1) y(5) bw eh],'',2,'');
%p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(2) y(5) bw eh],'',2,'CarbonsEdit');
% Dbbounds
%p=p+1;[ui{p,1:7}] = deal('Db. Bonds:','Text',colors.bc,[x(3) y(5) bw eh],'',2,'');
%p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(4) y(5) bw eh],'',2,'DbbEdit');
% Comments
p=p+1;[ui{p,1:7}] = deal('Comments:','Text',colors.bc,[x(1) y(5) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(2) y(5) bw*3 eh],'',2,'CommentsEdit');
% Blank
p=p+1;[ui{p,1:7}] = deal('Blank','Pushbutton',colors.btn{6},[x(4)+bw*0.25 y(1) bw*0.75 bh],'qq_register(4)',2,'');
% Info-vindu
info(1)={['File: ',fileset.global_filename,]};
info(2)={['Peak number: ',num2str(LIB.pn)]};
info(3)={['Cluster number: ',num2str(LIB.clunr)]};
info(4)={['Single/Extracted: ',LIB.single]};
info(5)={['Retention time: ',num2str(LIB.rt)]};
info(6)={['Retention index: ',num2str(LIB.ri_calc)]};
p=p+1;[ui{p,1:7}] = deal(info,'Text',colors.bc,[x(1) y(10) bw*2 bh*4],'',2,'InfoTxt');
% Register
p=p+1;[ui{p,1:7}] = deal('Register:','Text',colors.bc,[x(1) y(11) bw bh],'',4,'');
p=p+1;[ui{p,1:7}] = deal('Add new entry','Checkbox',colors.bc,[x(1) y(12) bw*2 bh],'',2,'UpdRegCheck');
p=p+1;[ui{p,1:7}] = deal('Search','Pushbutton',colors.btn{6},[x(2) y(13) bw*0.75 bh],'qq_register(2)',2,'');
p=p+1;[ui{p,1:7}] = deal('Build','Pushbutton',colors.btn{6},[x(1) y(13) bw*0.75 bh],'qq_register(1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Get code','Pushbutton',colors.bc,[x(2) y(11) bw*0.75 bh],'qq_register(8)',2,'');
% Liste
p=p+1;[ui{p,1:7}] = deal('Reg.code  Short name    Name','Text',[1 1 1],[x(6) y(1) bw*4 eh],'',2,'ListHead');
p=p+1;[ui{p,1:7}] = deal('Searching...','Listbox',[1 1 1],[x(6) y(13) bw*4 y(1)-y(13)],'qq_register(3)',2,'RegisterList');
% Temp Ident.
p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[x(6) y(17) bw*4 bh*3],'',2,'IdentificationTxt');
% Comments Template
p=p+1;[ui{p,1:7}] = deal('Comments Template:','Text',colors.bc,[x(6) y(18) bw*2 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(6) y(19) bw*4 eh],'qq_addlib(4)',2,'CommentsTemplateEdit');
% Library
p=p+1;[ui{p,1:7}] = deal('Library:','Text',colors.bc,[x(1) y(16) bw*2 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(metset.library_name,'Edit',[1 1 1],[x(1) y(17) bw*2 eh],'qq_addlib(2)',2,'AddLibraryEdit');
p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[x(1) y(18) bw*2 eh],'',2,'EntriesTxt');

updfcn='qq_addlib(100)';
h0=qq_drawwin(winpar,ui,updfcn); 

h=findobj('Tag','UpdRegCheck'); set(h,'Value',1); 
h=findobj('Tag','ListHead'); set(h,'FontName','FixedWidth','FontWeight','normal'); 
h=findobj('Tag','RegisterList'); set(h,'ButtonDownFcn','qq_register(3)','Value',1);
h=findobj('Tag','IdentificationTxt'); set(h,'ForegroundColor',[1 0 0]);
h=findobj('Tag','TempButton'); set(h,'Enable','off');
drawnow






