function qq_batchcall(inp)

 
global XR XBL CL RE metset fileset locset
persistent dirval D

%%% M TILPASSES LOCSET
%%% LEGG INN BATCHSET


if nargin<1 inp=0; end

FileEdit=findobj('Tag','FileEdit');
PathEdit=findobj('Tag','PathEdit');
DirList=findobj('Tag','DirList');
ContentsList=findobj('Tag','ContentsList');

qq_message(1,'');

% ------------------- FIRST CALL ---------------------------
if inp==0 
    openwin;
    if strmatch(get(gcf,'Tag'),'BatchWin')
        metset.file_type='QQ-Rawdata'; tempset.file_ext='*.mat';
        tempset.file_isdir=1;         
        setpath    
        D=readdir; D=sortdir(D); showdir(D); %(tempset.file_ext,metset.file_type);
        templatesload
        dirval=0;
    end
end

% -------------------- SET PATH ---------------------------
if inp==1
   tempset.file_filepath=get(gcbo,'String')
   cd(tempset.file_filepath);
   D=readdir; % (tempset.file_ext,metset.file_type);
   D=sortdir(D);
   showdir(D);
end

% -------------------- DIRECTORY LISTE ---------------------
% Hyreklikk
if inp==2    % ButtonDownFcn (Hyreklikk)
   dirval=get(DirList,'Value');   
   if D{4,dirval}==1
      cd(D{1,dirval})
      D=readdir; %(tempset.file_ext,metset.file_type);
      D=sortdir(D);
      showdir(D);
      dirval=0;
   end
end

% Venstreklikk
if inp==2.5   % CallBack
   lastval=dirval;                % Forrige fil
   dirval=get(DirList,'Value'); 
   if D{4,dirval}==1
      tempset.file_isdir=1;
      qq_message(1,'Right click to change directory')
   end
   if D{4,dirval}==0
      tempset.file_isdir=0;
      tempset.file_filename=D{1,dirval};             % tempset.file_filename: Current file (persistent)
      if lastval~=dirval
         FCont=[]; 
      end
   end   
end

% -------------------- SEARCH STRING ---------------------------
if inp==4
    h=findobj('Tag','FileEdit'); str=get(h,'String');
    D=readdir; %(tempset.file_ext,metset.file_type); 
    D=sortdir(D); showdir(D);
end


% -------------------- DIRECTORY UP ---------------------------
if inp==6
   cd ..
   D=readdir; %(tempset.file_ext,metset.file_type); 
   D=sortdir(D); showdir(D);
end

% -------------------- SELECT FILES ---------------------------
if inp>7 & inp<8
    sh=findobj('Tag','SelectedList'); sstr=get(sh,'String'); sval=get(sh,'Value'); nsel=length(sstr);
    fh=findobj('Tag','DirList');  fstr=get(fh,'String'); fval=get(fh,'Value');
end
if inp==7.1    
    if D{4,fval}==1 qq_message(1,'|r|Right click to change directory'); 
    else
        if isempty(strmatch(D{1,fval},sstr)) sstr{nsel+1}=D{1,fval}; end
    end   
end
if inp==7.3 & nsel>0
    sstr(sval)=[]; nsel=nsel-1; if sval>nsel & nsel>0 set(sh,'Value',nsel); end
end
if inp==7.2
    [m,n]=size(fstr);
    for x=1:m
        if D{4,x}==0 
            if isempty(strmatch(D{1,x},sstr)) nsel=nsel+1; sstr{nsel}=D{1,x}; end    
        end
    end    
end
if inp==7.4 sstr=[]; set(sh,'Value',1); end
if inp>7 & inp<8 sstr=sort(sstr); set(sh,'String',sstr); end

% ------------------------ RUN --------------------------
if inp==10
    % Init. settings
    rl=0; lowcorr=0; err2=0;
    % Progressbar
    h=findobj('Tag','Progframe'); framepos=get(h,'Position'); maxw=framepos(3); 
    h=findobj('Tag','Progbar'); set(h,'Visible','off'); drawnow; 
    % Load Template
    tlh=findobj('Tag','TemplatesList'); tlv=get(tlh,'Value'); tls=get(tlh,'String'); 
    tnam=[metset.file_exportpath,'\TEMPLATE_',tls{tlv},'.mat'];
    rl=rl+1; rs{rl}=['BATCH ANALYSIS USING TEMPLATE ' tls{tlv}];
    rl=rl+1; rs{rl}=['----------------------------------------------------------------------'];
    Templ=load(tnam); npeaks=length(Templ.RE);
    % Load File
    slh=findobj('Tag','SelectedList'); sls=get(slh,'String');
    for x=1:length(sls)
        err=0; % Errorflag
        h=findobj('Tag','PathEdit'); datapath=get(h,'String');
        tnam=[datapath,'\QQ_RAW_',sls{x},'.mat']; 
        [X,fileset.rt,fileset.ions,Info]=qqload(tnam);
        [X,fileset.rt,fileset.ions]=truncate(X,fileset.rt,fileset.ions);
        rl=rl+1; rs{rl}=['LOADING FILE ' sls{x} ', ' num2str(length(fileset.ions)) ' ions'];
        % Initialize
        fn=fieldnames(fileset); fileset=rmfield(fileset,fn);       
        XR=X; XBL=X; CL=[]; RE=[];
        fileset.chrom_plotlab=fileset.rt;
        fileset.chrom_tic0=sum(XR');
        fileset.chrom_tic1=sum(XBL');
        fileset.chrom_li=1;
        fileset.chrom_ri=length(fileset.rt);
        fileset.chrom_plotlab=fileset.rt;
        fileset.global_filename=Info.File_Name;
        fileset.info=Info;
        fileset.file_type='QQ-Rawdata';
        % BL-subtract
        qq_blcall(1.1); %figure; qq_chrom(5)   
        
        % Find clusters
        if isempty(metset.batch_startrt)==0 l_ind=find(fileset.rt<metset.batch_startrt); else l_ind=1; end
        if isempty(metset.batch_endrt)==0 r_ind=find(fileset.rt>metset.batch_endrt); else r_ind=length(fileset.chrom_ri); end        
        fileset.chrom_tic2=sum(XBL'); ticmax=max(fileset.chrom_tic2); ticmin=min(fileset.chrom_tic2);
        treshold=(ticmax-ticmin)*(metset.peak_treshpct/100);
        detvector=fileset.chrom_tic1>treshold; detvector(length(detvector))=0; detvector(l_ind)=0; detvector(r_ind)=0;
        qq_peakcall(101); %CL
        rl=rl+1; rs{rl}=['Found ' num2str(length(CL)) ' clusters'];
        % Quantify
        qq_quantcall(14.3);
        % Results
        qq_resultscall(100);
        rl=rl+1; rs{rl}=['Quantified ' num2str(length(RE)) ' peaks'];
        % Identifiser
        if length(RE)==length(Templ.RE)
            for y=1:length(RE)
                RE(y).identified=1;
                RE(y).cmp_name=Templ.RE(y).cmp_name;
                RE(y).cmp_shortname=Templ.RE(y).cmp_shortname;
                RE(y).cmp_code=Templ.RE(y).cmp_code;
                RE(y).ri_def=Templ.RE(y).ri_def;
                corr(y)=checkcorr(fileset.ions, RE(y).S, Templ.ions, Templ.RE(y).S);
            end
            lowcorr(x)=min(corr);
            rl=rl+1; rs{rl}=['Lowest spectral correlation: ' num2str(lowcorr(x)) ' pct.'];
        else
            err=1; err2=1; % Error: Forskj antall topper
            rl=rl+1; rs{rl}=['WARNING: Number of peaks in file (' num2str(length(RE)) ') does not match template (' num2str(length(Templ.RE)) ')'];
        end
        % Export spectra
        
        if err==0 & get(findobj('Tag','SpecCheck'),'Value')
            oldpath=metset.file_exportpath; h=findobj('Tag','Specpathadd'); str=get(h,'String'); 
            if isempty(str)==0 
                checkdir(metset.file_exportpath,str); str=['\' str]; metset.file_exportpath=[metset.file_exportpath, str]
            end
            qq_maincall(96); h=findobj('Tag','MessageTxt'); str=get(h,'String'); str=str{1}; rl=rl+1; rs{rl}=[str]; 
            metset.file_exportpath=oldpath;
        end
        % Rapporter resultater 
        if err==0 & get(findobj('Tag','ReportsCheck'),'Value')
            oldpath=metset.file_reportspath; h=findobj('Tag','Reportspathadd'); str=get(h,'String'); 
            if isempty(str)==0 
                checkdir(metset.file_reportspath,str); str=['\' str]; metset.file_reportspath=[metset.file_reportspath, str]
            end            
            qq_resultscall(7.1); h=findobj('Tag','MessageTxt'); str=get(h,'String'); str=str{1}; rl=rl+1; rs{rl}=[str]; 
            metset.file_reportspath=oldpath;
        end
        % Save resultater
        if get(findobj('Tag','ResultsCheck'),'Value')
            usepath=metset.file_resultspath; h=findobj('Tag','Resultspathadd'); str=get(h,'String');
            if isempty(str)==0 checkdir(usepath,str); usepath=[usepath '\' str]; end
            fnam=[usepath,'\res_',fileset.global_filename,'_bat'];
            save(fnam,'CL','XBL','XR','RE','fileset','metset');
            qq_message(1,['|b|Results saved in: ',fnam]);
            h=findobj('Tag','MessageTxt'); str=get(h,'String'); str=str{1}; rl=rl+1; rs{rl}=[str];
        end
        rl=rl+1; rs{rl}=['----------------------------------------------------------------------'];       
        
        % Progress
        prog=x/length(sls); framepos(3)=prog*maxw;
        h=findobj('Tag','Progbar'); set(h,'Position',framepos,'Visible','on'); drawnow;   
    end

    if err2==1 rl=rl+1; rs{rl}=['']; rl=rl+1; rs{rl}=['                   **** CHECK WARNINGS ****']; end

    % SKRIV OG PNE RAPPORT
    %strvcat(rs)  % TEMP
    fh=-1;
    while fh==-1
        filename=['BATCH REPORT_',datestr(now,30)]; 
        fh=fopen([metset.file_exportpath,'\',filename,'.txt'],'w');
    end
    for x=1:length(rs)
        ind = strfind(rs{x},'\');rs{x}(ind)='/'; 
        fprintf(fh,[rs{x},'\n']);
    end
    fclose(fh); 
    qq_message(1,['|b|Report saved in: ',metset.file_exportpath,'\',filename,'.txt']);
    qq_message(6,[metset.file_exportpath,'\',filename,'.txt']); 
   
    if err==1 qq_message(1,['|r|WARNING: Errors found, Lowest spectral correlation: ' num2str(min(lowcorr))]);
    else qq_message(1,['|b|Lowest spectral correlation: ' num2str(min(lowcorr))]);
    end
end


% ------------------------ CLOSE --------------------------
if inp==99
   load('c:\qq\qq_batchtempsave','CL','XBL','XR','RE','fileset')
   qq_closewin;
end


% --------------- WINDOW UPDATE ----------------------

PathEdit=findobj('Tag','PathEdit');
set(PathEdit,'String',pwd);           % pwd er current working directory


% --------------- S U B F U N C T I O N S -------------
% --------------- CHECKDIR -------------
function checkdir(parent,checkdir)

a=dir([parent '\' checkdir]);
if isempty(a)
    mkdir(parent,checkdir);
end

% --------------- CHECKCORR -------------
function corr=checkcorr(ions1,S1,ions2,S2)

if isequal(ions1,ions2)==0
   p=0; delind=[];
   for x=1:length(ions1) 
       if sum(ions1(x)==ions2)==0; p=p+1; delind(p)=x; end
   end
   ions1(delind)=[]; S1(delind)=[];
   p=0; delind=[];
   for x=1:length(ions2) 
       if sum(ions2(x)==ions1)==0; p=p+1; delind(p)=x; end
   end
   ions2(delind)=[]; S2(delind)=[];   
end
corr = corrcoef(S1,S2)*100; corr=corr(1,2);



% -------------- SUBFUNCTION TEMPLATESLOAD --------------
function templatesload
global metset

fnam=[metset.file_exportpath,'\TEMPLATE_*.mat'];
D=dir(fnam); nfiles=length(D);
for x=1:nfiles
    ind1=strfind(D(x).name,'.mat'); str{x}=D(x).name(10:ind1-1); 
end
h=findobj('Tag','TemplatesList'); set(h,'String',str);

% -------------- SUBFUNCTION SETPATH --------------
function setpath
global metset

str=metset.file_qqrawpath; str2='*.mat';
PathEdit=findobj('Tag','PathEdit');
set(PathEdit,'String',str); cd(str)
FileEdit=findobj('Tag','FileEdit');
%set(FileEdit,'String',str2); 
cd(str);

% -------------- SUBFUNCTION SHOWDIR --------------
function showdir(D)

% LAGER OUTPUTARRAY
maxname=27;
dimD=size(D);nfiles=dimD(2);
for i1=1:nfiles
   name=(D{1,i1}); namesize=length(name); %namesize=namesize(2);
   if namesize>maxname
      namesize=maxname;
   end
   
   name=[name(1:namesize) blanks(maxname-namesize)];
   
   dato=(D{2,i1});
   
   storr=num2str(D{3,i1});
   if D{3,i1}>9999999
      storr=num2str(D{3,i1},'%-1.1e');
      storr(6)=[];
   end
   storrsize=size(storr);storrsize=storrsize(2);
   if storrsize>7
      storrsize=7;
   end
   storr=[blanks(7-storrsize) storr];
   
   if D{4,i1}==1, name(maxname-2:maxname)='DIR';
   end
   printdir(i1,:)=[name '  ' storr '  ' dato(1:17)];    
   
end

DirList=findobj('Tag','DirList');
set(DirList,'Value',1);
set(DirList,'String',printdir);


% -------------- SORTDIR -------------------
function DDS=sortdir(D)

% Returnerer cell array med sortert Directory
% Directories frst, deretter alfabetisk
% D m vre cell array: D=dir;D=struct2cell(D);

dimD=size(D);nfiles=dimD(2);
maxname=32; % Max antall tegn i filnavnet

% ALFABETISK SORTERING
% Lager matrise med filnavn 'FN'
for i1=1:nfiles
   name=(D{1,i1});
   name=lower(name); % Ungr case-sensitiv sortering
   namesize=size(name); namesize=namesize(2);
   if namesize>maxname
      namesize=maxname;
   end
   FN(i1,:)=[name(1:namesize) blanks(maxname-namesize)];
end
[sortv, ind]=sortrows(FN); % Finner indexer
DS(:,1:nfiles)=D(:,ind(:)); % Sortert Cell array DS

% SETTER DIRECTORIES VERST
for i1=1:nfiles
   dind(i1)=DS{4,i1}; % Siste celle i DS inneholder info om dir (1 eller 0)
end
dind=dind*-1; [sortv, ind]=sort(dind); % Indexer for sortering, "ind"
DDS(:,1:nfiles)=DS(:,ind(:)); % Returnerer cell array med dir verst, DDS


% -------------- SUBFUNCTION READDIR -------------------
function DE=readdir 
h=findobj('Tag','FileEdit'); str=get(h,'String');
dirstr=['QQ_RAW_' str '.mat'];

D=dir(dirstr); type=cat(2,D.isdir);
for x=1:length(D) ind1=strfind(D(x).name,'.mat'); D(x).name=D(x).name(8:ind1-1); end % Fjerner identifier fra filnavn 
D=D(find(type==0)); dimD=size({D.name}); nfiles=dimD(2); 

DD=dir; type=cat(2,DD.isdir); 
DD=DD(find(type)); dimDD=size({DD.name}); ndirs=dimDD(2); 

if nfiles>0 DE=[DD; D]; end
if nfiles==0 DE=DD; end
DE=struct2cell(DE);

% -------------- SUBFUNCTION TRUNCATE -------------------
function [X, labels, ions]=truncate(X, labels, ions)
% Fjerner tomme ioner eller retensjonstider
null=find (sum(X)==0);
X(:,null)=[];
ions(null)=[];
null=find (sum(X')==0);
X(null,:)=[];
labels(null)=[];

% -------------- SUBFUNCTION QQLOAD -------------------
function [X,labels,ions,Info]=qqload(filename)

X=[];labels=[];ions=[]; Info.dummy=[]; Info=rmfield(Info,'dummy'); 
S=load(filename); 
names=fieldnames(S); firstname=names(1); firstname=firstname{1};
if isfield(S,'XR'); X=S.XR; end
if isfield(S,'XBL'); X=S.XBL; end
if isfield(S,'Info'); Info=S.Info; end

dim=size(X); n_obj=dim(1); n_ions=dim(2);
Objstr=S.Objects; 
for i1=1:n_obj   
 labels(i1)=str2double(Objstr(i1,:));
end
Varstr=S.Variables;
for i1=1:n_ions   
 ions(i1)=str2double(Varstr(i1,:));
end


%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;% grid height

bo=bw/5;
x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='BatchWin'; winpar{2}='Q: Batch';

if isfield(metset,'peak_treshpct')==0 metset.peak_treshpct=25; end

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0; o=bw/2;
% CLOSE
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(2) y(20) bw bh*1.5],'qq_batchcall(99)',3,'CloseBtn');
p=p+1;[ui{p,1:7}] = deal('Run','Pushbutton',colors.accept,[x(1) y(20) bw bh*1.5],'qq_batchcall(10)',3,'RunBtn');
% Path, lister, og file ext.
p=p+1;[ui{p,1:7}] = deal(' ','text',[1 1 1],[0 y(12) 1 bh],'',3,'');
p=p+1;[ui{p,1:7}] = deal('Path:','text',[1 1 1],[x(2)-bw*0.55 y(12)+eo bw/2 eh],'',3,'rjust');
p=p+1;[ui{p,1:7}] = deal(' ','edit',[1 1 1],[x(2) y(12)+eo bw*3 eh],'qq_batchcall(1)',2,'PathEdit');
p=p+1;[ui{p,1:7}] = deal('Searchstring:','text',[1 1 1],[x(6)-bw/2 y(12)+eo bw eh],'',3,'');
p=p+1;[ui{p,1:7}] = deal('*','edit',[1 1 1],[x(7)-bw/2 y(12)+eo bw*1.5 eh],'qq_batchcall(4)',2,'FileEdit'); % Sjekk Call
% FilesList
p=p+1;[ui{p,1:7}] = deal('Searching...','listbox',[1 1 1],[x(1) y(11) bw*4 y(2)-y(12)+bh],'qq_batchcall(2.5)',2,'DirList');
p=p+1;[ui{p,1:7}] = deal('','listbox',[1 1 1],[x(6)-bw/2 y(11) bw*1.5 y(2)-y(12)+bh],'qq_batchcall(3.5)',2,'SelectedList');
p=p+1;[ui{p,1:7}] = deal('','listbox',[1 1 1],[x(8) y(11) bw*1.5 y(2)-y(12)+bh],'',2,'TemplatesList');
% Dir up
p=p+1;[ui{p,1:7}] = deal('Dir Up','Pushbutton',[1 1 1],[x(1) y(12) bw/2 bh],'qq_batchcall(6)',2,'');
% Select files
p=p+1;[ui{p,1:7}] = deal('>','Pushbutton',colors.accept,[x(5) y(5) bw/2 bh],'qq_batchcall(7.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('All','Pushbutton',colors.accept,[x(5) y(6) bw/2 bh],'qq_batchcall(7.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('<','Pushbutton',colors.reset,[x(5) y(7) bw/2 bh],'qq_batchcall(7.3)',2,'');
p=p+1;[ui{p,1:7}] = deal('All','Pushbutton',colors.reset,[x(5) y(8) bw/2 bh],'qq_batchcall(7.4)',2,'');
% Peak settings
p=p+1;[ui{p,1:7}] = deal('Peak settings:','text',colors.bc,[x(1) y(13) bw*2 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Treshold pct','text',colors.bc,[x(1) y(14) bw*2 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(num2str(metset.peak_treshpct),'edit',[1 1 1],[x(2) y(14) bw/2 eh],'qq_eval(''pn'')',2,'metset.peak_treshpct');
p=p+1;[ui{p,1:7}] = deal('Min scans/whh','text',colors.bc,[x(1) y(15) bw*2 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(num2str(metset.peak_minwhh),'edit',[1 1 1],[x(2) y(15) bw/2 eh],'qq_eval(''pn'')',2,'metset.peak_minwhh');
p=p+1;[ui{p,1:7}] = deal('Working range:','text',colors.bc,[x(1) y(16) bw*2 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Start Rt:','text',colors.bc,[x(1) y(17) bw*2 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(num2str(metset.batch_startrt),'edit',[1 1 1],[x(2) y(17) bw/2 eh],'qq_eval(''pn-'')',2,'metset.batch_startrt');
p=p+1;[ui{p,1:7}] = deal('End Rt:','text',colors.bc,[x(1) y(18) bw*2 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(num2str(metset.batch_endrt),'edit',[1 1 1],[x(2) y(18) bw/2 eh],'qq_eval(''pn-'')',2,'metset.batch_endrt');
% File settings
p=p+1;[ui{p,1:7}] = deal('Export','text',colors.bc,[x(3) y(13) bw*2 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Spectra to:','Checkbox',colors.bc,[x(3) y(14) bw eh],'',2,'SpecCheck');
p=p+1;[ui{p,1:7}] = deal([metset.file_exportpath,'\'],'Edit',[1 1 1],[x(4) y(14) bw*2 eh],'',2,'Exportpath');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(6) y(14) bw eh],'',2,'Specpathadd');
p=p+1;[ui{p,1:7}] = deal('Reports to:','Checkbox',colors.bc,[x(3) y(15) bw eh],'',2,'ReportsCheck');
p=p+1;[ui{p,1:7}] = deal([metset.file_reportspath,'\'],'Edit',[1 1 1],[x(4) y(15) bw*2 eh],'',2,'Reportspath');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(6) y(15) bw eh],'',2,'Reportspathadd');
p=p+1;[ui{p,1:7}] = deal('Results to:','Checkbox',colors.bc,[x(3) y(16) bw eh],'',2,'ResultsCheck');
p=p+1;[ui{p,1:7}] = deal([metset.file_resultspath,'\'],'Edit',[1 1 1],[x(4) y(16) bw*2 eh],'',2,'Resultspath');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(6) y(16) bw eh],'',2,'Resultspathadd');
% Progress
p=p+1;[ui{p,1:7}] = deal('Progress:','text',colors.bc,[x(3) y(18) bw*2 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Frame',colors.bc,[x(4) y(18) bw*3 eh],'',2,'Progframe');
p=p+1;[ui{p,1:7}] = deal('','Frame',colors.btn{4},[x(4) y(18) bw/1000 eh],'',2,'Progbar');

updfcn='qq_batchcall(100)';
h0=qq_drawwin(winpar,ui,updfcn);
set(h0,'KeyPressFcn','qq_batchcall(96)')
set(h0,'CloseRequestFcn','qq_batchcall(99)')

h=findobj('Tag','DirList'); set(h,'ButtonDownFcn','qq_batchcall(2)','TooltipString','Right click to change directory') 
h=findobj('Tag','ContentsList'); set(h,'ButtonDownFcn','qq_batchcall(3)','TooltipString','Right click to Load') 
h=findobj('Tag','rjust'); set(h,'HorizontalAlignment','right')
h=findobj('Tag','SpecCheck'); set(h,'Value',1)
h=findobj('Tag','ReportsCheck'); set(h,'Value',1)
h=findobj('Tag','ResultsCheck'); set(h,'Value',1)
h=findobj('Tag','Exportpath'); set(h,'Enable','off'); 
h=findobj('Tag','Reportspath'); set(h,'Enable','off'); 
h=findobj('Tag','Resultspath'); set(h,'Enable','off'); 

drawnow


















   



        


















   






   






