function qq_blcall(an)

% function blcall(an)
% Beregner og subtraherer baselinje
% an er handling bestemt fra grafisk grenesnitt

% GLOBALE OG PERSISTENTE VARIABLER %
global XR XBL metset fileset locset
global Blset 
% XL=Local; XBL set equal to XL on accept

qq_message(2); % Blank

%if (an==0 | an==100) % Dersom frste call   
%   fileset.bl_zerovector=zeros(1,length(fileset.chrom_plotlab)); 
%end

% --------------- PNER VINDUET ------------
if an==0 && isempty(XR)==0
   fileset.bl_zerovector=zeros(1,length(fileset.chrom_plotlab)); 
   if isfield(metset,'baseline_codawin')==0 metset.baseline_codawin=5; end
   if isfield(metset,'baseline_codathresh')==0 metset.baseline_codathresh=0.89; end   
   openwin; 
   getfilters; readfilter
   if strmatch(get(gcf,'Tag'),'BlWin')
       metset.baseline_plottype=1;
       Blset.XL=XBL;
       Blset.ions=fileset.ions;
       Blset.ions_in=fileset.ions;
       %Blset.deleteions=[]; Blset.keepions=[]; Blset.protections=[];
       if isfield(fileset,'ions_raw')==0 fileset.ions_raw=fileset.ions; end
       fileset.chrom_tic4=sum(XBL');
       fileset.chrom_tic3=sum(Blset.XL'); % tic_3 is working-tic
       qq_plot_blchrom(1); qq_plot_scale(100);
       if isfield(metset,'baseline_thresh')==0 % metset.baseline_thresh
           blfindthres
       else
           fileset.baseline_thresh=metset.baseline_thresh;
           if fileset.baseline_thresh>max(fileset.chrom_tic3) | fileset.baseline_thresh<min(fileset.chrom_tic3) 
               blfindthres
           end
       end
       set(findobj('Tag','thresholdline'),'ydata',[fileset.baseline_thresh, fileset.baseline_thresh]);   
       set(findobj('Tag','ThresholdEdit'),'String',num2str(fileset.baseline_thresh));
       value=(fileset.baseline_thresh*(100^4/max(fileset.chrom_tic3)))^0.25; 
       set(findobj(gcf,'Tag','ThresholdSlider'),'Value',value);
   end
end
if an==0 && isempty(XR)==1 qq_message(1,'|r|No data'); end

% --------------- AUTO BASELINE ---------------
% Beregner threshold, fileset.bl_zerovector og setter an til 'accept'
if an==1 && isempty(XR)==0 % Call fra Maincall
    fileset.chrom_tic3=fileset.chrom_tic1;
    blfindthres
    blzerocomp
    blspikefilter
    XBL=blblsubtract(XR);                % Subtraherer baselinjen                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
    fileset.baseline_subtracted=1;
    qq_plot_mainchrom(0); qq_plot_scale(100);
end
if an==1 && isempty(XR)==1 qq_message(1,'|r|No data'); end

if an==1.1 % call fra Batchcall
    fileset.chrom_tic3=fileset.chrom_tic1;
    blfindthres;
    blzerocomp;
    blspikefilter;
    XBL=blblsubtract(XR);   
    fileset.baseline_subtracted=1;
end

% --------------- RESET BASELINE ---------------
if an==2
    XBL=XR; 
    if isfield(fileset,'ions_raw') fileset.ions=fileset.ions_raw; end
    qq_message(1,'|b|Baseline has been reset')
    clearfields
end

% ---------------------- CALC.TRESH.-----------------
if an==6.1
    blfindthres                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
    val=(fileset.baseline_thresh*(100^4/max(fileset.chrom_tic3)))^0.25; set(findobj(gcbf,'Tag','ThresholdSlider'),'Value',val); 
    set(findobj('Tag','ThresholdEdit'),'String',num2str(fileset.baseline_thresh));
    set(findobj('Tag','thresholdline'),'ydata',[fileset.baseline_thresh, fileset.baseline_thresh]);  
    qq_plot_scale(103)
end
% ---------------------- SET TRESHOLD --------------
if an==6.2 
    % Read thresholdslider
    slide=findobj(gcbf,'Tag','ThresholdSlider');                               
    value=get(slide,'Value'); value=value^4; value=value*(max(fileset.chrom_tic3)/100^4);        
    fileset.baseline_thresh=value;    
    set(findobj('Tag','thresholdline'),'ydata',[fileset.baseline_thresh, fileset.baseline_thresh]);    
    set(findobj('Tag','ThresholdEdit'),'String',num2str(fileset.baseline_thresh));
end
if an==6.3
    % read edit
    threshedit=findobj('Tag','ThresholdEdit'); thresh=str2double(get(threshedit,'String'));
    if isempty(thresh)==0 && thresh>min(fileset.chrom_tic3) && thresh<max(fileset.chrom_tic3) 
        fileset.baseline_thresh=thresh;  
        value=(fileset.baseline_thresh*(100^4/max(fileset.chrom_tic3)))^0.25; 
        set(findobj(gcf,'Tag','ThresholdSlider'),'Value',value);
        set(findobj('Tag','thresholdline'),'ydata',[fileset.baseline_thresh, fileset.baseline_thresh]); 
    else
       set(findobj('Tag','ThresholdEdit'),'String',num2str(fileset.baseline_thresh));
       qq_message(1,'|r|Out of range');
    end
end
% set method
if an==6.4
    thresh=str2double(get(findobj('Tag','ThresholdEdit'),'String'));
    if isempty(thresh)==0 metset.baseline_thresh=thresh; end
end
% Set sensitivity
if an==6.5
    h=findobj('Tag','SensEdit'); val=str2double(get(h,'String'));
    if val>4 & val<96 metset.baseline_sens=val; else qq_message(1,'|r|Out of range (5-95)'); end
    set(h,'String',num2str(metset.baseline_sens)); 
end

% ---------------------- ZEROWINDOW ------------------
if an==7                                                                                                                           
   blzerocomp; qq_plot_blchrom(1); qq_plot_scale(100);
end

% ---------------------- SPIKEFILTER -----------------
if an==8 && sum(fileset.bl_zerovector)==0
    qq_message(1,'|r|No baseline windows')
end

if an==8 && sum(fileset.bl_zerovector)>0
   blspikefilter; qq_plot_blchrom(1); qq_plot_scale(100);
end   

%----------------- RESET VISIBLE -----------------
if an==9 && isfield(fileset,'bl_zerovector')
    fileset.bl_zerovector(fileset.chrom_li:fileset.chrom_ri)=0;
    qq_plot_blchrom(1); qq_plot_scale(100);
end
if an==9.1 && isfield(fileset,'bl_zerovector')
    fileset.bl_zerovector(1:length(fileset.rt))=0;
    qq_plot_blchrom(1); qq_plot_scale(100);
end

%----------------- MANIPULATE TIC -----------------
if an==10.1
    fileset.chrom_tic4=sum(XBL');
    fileset.chrom_tic3=sum(Blset.XL'); % tic_3 is working-tic   
    qq_plot_blchrom(0); qq_plot_scale(100); qq_plot_scale(3.2);
end

if an==10.2
    metset.baseline_plottype=1;
    fileset.chrom_tic3=varwin(Blset.XL,metset.baseline_winsize);
    fileset.chrom_tic4=varwin(XBL,metset.baseline_winsize);
    qq_plot_blchrom(0); qq_plot_scale(100); qq_plot_scale(3.2);
end
if an==10.4
    metset.baseline_plottype=2;
    fdim=5; 
    fileset.chrom_tic3=smooth(fileset.chrom_tic3,metset.baseline_winsize);
    fileset.chrom_tic4=smooth(fileset.chrom_tic4,metset.baseline_winsize);
    qq_plot_blchrom(0); qq_plot_scale(100); qq_plot_scale(3.2);
end

% Subtract baseline
if an==11
    if sum(fileset.bl_zerovector)>0 
        Blset.XL=blblsubtract(Blset.XL); 
        fileset.chrom_tic4=sum(XBL');
        fileset.chrom_tic3=sum(Blset.XL'); 
        qq_plot_blchrom(0); qq_plot_scale(103)
    else
        qq_message(1,'|r|No baseline points')
    end
end
% Undo
if an==12
    Blset.XL=XBL;
    Blset.ions=Blset.ions_in;
    fileset.chrom_tic4=sum(XBL');
    fileset.chrom_tic3=sum(Blset.XL'); 
    qq_plot_blchrom(0); qq_plot_scale(103)
end
% Reset Baseline
if an==13
    Blset.XL=XR;
    if isfield(fileset,'ions_raw') Blset.ions=fileset.ions_raw; end
    fileset.chrom_tic4=sum(XBL');
    fileset.chrom_tic3=sum(Blset.XL'); 
    qq_plot_blchrom(0); qq_plot_scale(103)
end

% CODA
if an==15
    ninion=length(Blset.ions);
    [dels,keeps,mcq] = qq_coda(Blset.XL,metset.baseline_codawin,metset.baseline_codathresh);
    
    protected=[]; p=0; 
    for x=1:length(Blset.protections) 
        ind=find(Blset.ions==Blset.protections(x));
        if isempty(ind)==0 p=p+1; protected(p)=ind; end
    end

    keeps=unique([keeps protected]);
    Blset.XL=Blset.XL(:,keeps);
    Blset.ions=Blset.ions(keeps);
    fileset.chrom_tic4=sum(XBL');
    fileset.chrom_tic3=sum(Blset.XL'); 
    qq_plot_blchrom(0); qq_plot_scale(103)
    qq_message(1,['|b|' num2str(ninion-length(Blset.ions)) ' ions removed, ' num2str(length(Blset.ions)) ' ions kept'])    
end
% Set win size
if an==15.1  
    h=findobj('Tag','CodaWinEdit'); str=get(h,'String'); val=str2double(str);
    if isnan(val)==0 && val>1 
        metset.baseline_codawin=val;       
    end
    set(h,'String',num2str(metset.baseline_codawin))
end
% Set threshold
if an==15.2  
    h=findobj('Tag','CodaThreshEdit'); str=get(h,'String'); val=str2double(str);
    if isnan(val)==0 && val<1 && val>0
        metset.baseline_codathresh=val;       
    end
    set(h,'String',num2str(metset.baseline_codathresh))
end      

% Filter
if an==16.1
    readfilter
end
if an==16.2
    ninion=length(Blset.ions);
    keepions=[]; p=0;
    
    for x=1:length(Blset.keepions) 
        ind=find(Blset.ions==Blset.keepions(x));
        if isempty(ind)==0 p=p+1; keepions(p)=ind; end
    end
    if isempty(keepions)==0 Blset.XL=Blset.XL(:,keepions); Blset.ions=Blset.ions(keepions); end   
    
    deleteions=[]; p=0;
    for x=1:length(Blset.deleteions) 
        ind=find(Blset.ions==Blset.deleteions(x));
        if isempty(ind)==0 p=p+1; deleteions(p)=ind; end
    end
    if isempty(deleteions)==0 Blset.XL(:,deleteions)=[]; Blset.ions(deleteions)=[]; end   
    fileset.chrom_tic4=sum(XBL');
    fileset.chrom_tic3=sum(Blset.XL'); 
    qq_plot_blchrom(0); qq_plot_scale(103)
    qq_message(1,['|b|' num2str(ninion-length(Blset.ions)) ' ions removed, ' num2str(length(Blset.ions)) ' ions kept'])    
end

% ---------------------- ACCEPT ------------------------
if an==97                                                                                                                                                                                                                                                             
   XBL=Blset.XL;  
   fileset.ions=Blset.ions;
   fileset.baseline_subtracted=1;
   if sum(size(XBL)==size(XR))==2
       if XBL==XR; fileset.baseline_subtracted=0; end
   end
   clearfields; clear Blset
   qq_closewin;            % Lukker
end  

% ---------------------- CLOSE ------------------------
if an==99
    clearfields; clear Blset
    qq_closewin;
end

% Keypress
if an==96
    kp=double(get(gcf,'CurrentCharacter'));
    if kp==28 | kp==29 qq_plot_scale(1.35); end %   
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                      %
%                        SUBFUNCTIONS                  %
%                                                      %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% ------------------- READFILTER -------------------
function readfilter
global metset locset Blset

%disp('--- readfilter ---')

h=findobj('Tag','FilterPop'); val=get(h,'Value'); str=get(h,'String'); selstr=str{val};

deleteions=[]; keepions=[]; protections=[];
n_delete=0; n_keep=0; n_protect=0;
iontype=0;

if val>1
    
    pathname=[locset.path_method,'\IONFILTER_' selstr '.csv'];

    fid = fopen(pathname,'r');
    while 1
        tline=fgetl(fid);
        if ~ischar(tline) break; end
        tval=str2double(tline);
        if isnan(tval)
            if isempty(regexpi(tline,'delete'))==0 iontype=1; end
            if isempty(regexpi(tline,'keep'))==0 iontype=2; end
            if isempty(regexpi(tline,'protect'))==0 iontype=3; end
        else
            if iontype==1 n_delete=n_delete+1; deleteions(n_delete)=tval; end
            if iontype==2 n_keep=n_keep+1; keepions(n_keep)=tval; end
            if iontype==3 n_protect=n_protect+1; protections(n_protect)=tval; end
        end    
    end
    fclose(fid);
end

Blset.deleteions=deleteions; 
Blset.keepions=keepions; 
Blset.protections=protections;

metset.baseline_filtername=selstr; 

% ------------------- GETFILTERS -------------------
function getfilters
global metset locset

pathname=[locset.path_method,'\IONFILTER_*.csv'];
DD=dir(pathname);
n=length(DD);
str{1}='-';
for x=1:n
    str{x+1}=DD(x).name(11:length(DD(x).name)-4);
end

h=findobj('Tag','FilterPop'); set(h,'String',str);

fno=strmatch(metset.baseline_filtername,str);
if isempty(fno)==0
    set(h,'Value',fno)
end


% ------------------- CLEARFIELDS -------------------
function clearfields
global fileset

if isfield(fileset,'chrom_tic3') fileset=rmfield(fileset,'chrom_tic3'); end
if isfield(fileset,'chrom_tic4') fileset=rmfield(fileset,'chrom_tic4'); end
if isfield(fileset,'baseline_thresh') fileset=rmfield(fileset,'baseline_thresh'); end
if isfield(fileset,'bl_zerovector') fileset=rmfield(fileset,'bl_zerovector'); end

% ------------------- SMOOTH -------------------
function nytic=smooth(tic,fdim)
% fdim er dimensjon p filter

% Smoothing
b=ones(1,fdim)*1/fdim;     % Vektor med filter, fdim siste pkt er vektet likt.
ticflip=(fliplr(tic));
sm1=filter(b,1,ticflip);
sm1=fliplr(sm1);
sm2=filter(b,1,tic);
nytic=(sm1/2)+(sm2/2);

% ---------------- VARVIN ------------------
function tic=varwin(X_in,winsize);

[dim,n]=size(X_in);
% VARIANSVINDU
if winsize/2==floor(winsize/2)  % hvis partall k med 1.
   winsize=winsize+1;
end
hint=floor(winsize/2);  
for i1=hint+1:dim-hint
   subX=X_in(i1-hint:i1+hint,:); sumvar(i1)=sum(var(subX));
end
sumvar(1:hint)=sumvar(hint+1); sumvar(dim-hint+1:dim)=sumvar(dim-hint); tic=sumvar;

% -------- SUBFUNCTION BLFINDTHRES ---------
function blfindthres
% Bestemmer threshold til gjennomsnittet+6*stdav til de metset.baseline_sens laveste % av TIC

global fileset metset
if isfield(metset,'baseline_sens')==0 metset.baseline_sens=10; end

divfactor=100/metset.baseline_sens;

dim=length(fileset.chrom_tic3(fileset.chrom_li:fileset.chrom_ri));
sTIC=sort(fileset.chrom_tic3(fileset.chrom_li:fileset.chrom_ri));
zcount=round(dim/divfactor);
sTIC=sTIC(1:zcount);
fileset.baseline_thresh=mean(sTIC)+6*std(sTIC); 


% -------- SUBFUNCTION BLZEROCOMP ---------
function blzerocomp
% Returnerer binr vektor med verdi 0 hvis under threshold
% og 1 hvis over threshold

global fileset

fileset.bl_zerovector(fileset.chrom_li:fileset.chrom_ri)=fileset.chrom_tic3(fileset.chrom_li:fileset.chrom_ri)<fileset.baseline_thresh;

%fileset.baseline_thresh % TEMP
%fileset.bl_zerovector % TEMP

% -------- SUBFUNCTION BLSPIKEFILTER ---------
function blspikefilter

% function zerovector=blspikefilter(zerovector);
%
% Fjerner spikes, fra zerovector
% 0 omgitt av minst to 1 eller 1 omgitt av minst to 0 fra binr vektor. 

global fileset

tempvect=fileset.bl_zerovector;

dim=length(fileset.bl_zerovector);
lx=fileset.chrom_li; if lx==1 lx=2; end
rx=fileset.chrom_ri; if rx==dim; rx=rx-1; end

for i=lx:rx
   tempvect(i)=round(mean(fileset.bl_zerovector(i-1:i+1)));
end

% Frste og siste aldri BL 
tempvect(dim)=0; tempvect(1)=0;
fileset.bl_zerovector=tempvect;


% -------- SUBFUNCTION BLBLSUBTRACT ----------
function BLS=blblsubtract(RAW)

% function BLS=blsubtract(RAW)
% Beregner baselinje
% BLS = Baselinjesubtraherte rdata
% RAW = rdata
% zerovector: Binr vektor som inneholder baselinjepunkter, 0: signal, 1: baselinje 

global fileset

dim=size(RAW);
RW=RAW; % RW = Rdata det arbeides med.

% FINNER BL START, SLUTT OG ANTALL BL
dzero=diff(fileset.bl_zerovector);

dzero=[0 dzero];

% "lukking" av baselinevinduer
% Sjekk om frste nonzero er neg og siste nonzero er pos.
% Sett frste og siste dzero til hhv -1 og 1
nonzero=find(dzero~=0);
nonzeroval=dzero(nonzero);
if nonzeroval(1) == -1
   dzero(1)=1;
end
dimnonzeroval=size(nonzeroval);dimnonzeroval=dimnonzeroval(2);
if nonzeroval(dimnonzeroval) == 1
   dzero(dim(1)) = -1;
end

blstart=find(dzero==1);
blslutt=find(dzero==-1);
blslutt=blslutt-1;
nbl=size(blstart);nbl=nbl(2);

% RESGRESJONER P BASELINJENE OG INTERPOLERING
% LEGG TIL CASE HVIS DET IKKE ER BASLINE VED SLUTT ELLER START AV KROM.

% BYGGER OPP REGRESJONSVEKTORER
np=0;                                   % Antall punkt i regresjonsvektoren

if blstart(1)>1                         % Test hvis start av chrom ikke er bl...
   np=np+1;
   xv(np)=1;          
   yv(np,:)=RW(blstart(1),:);           % ...sett den lik frste bl. 
end

for bln=1:nbl                           % Antall baselinjer
   
   if blslutt(bln)-blstart(bln)==0      % Dersom start og slutt i samme pkt
      np=np+1;                          % Legg til et punkt i regresjonsvektoren
      xv(np)=blstart(bln);              % Definerer et pkt i x-vektoren
      xxxtemp=RW(blstart(bln),:);
      yv(np,:)=xxxtemp;                 % Henter tilsv. Y-verdi fra RW
   end % if
   
   if blslutt(bln)-blstart(bln)==1      % Dersom to punkter
      np=np+1;                          % Legg til et punkt i regresjonsvektoren
      xv(np)=blstart(bln);              % Definerer et pkt i x-vektoren
      xxxtemp=0.5*RW(blstart(bln),:)+0.5*RW(blstart(bln),:);     % Snitt av start+slutt   
      yv(np,:)=xxxtemp;                 % Henter tilsv. verdi fra RW      
      np=np+1;                          % Legg til et punkt i regresjonsvektoren
      xv(np)=blslutt(bln);              % Definerer et pkt i x-vektoren
      xxxtemp=0.5*RW(blstart(bln),:)+0.5*RW(blstart(bln),:);     % Snitt av start+slutt
      yv(np,:)=xxxtemp;                 % Henter tilsv. verdi fra RW
   end % if

   
   if blslutt(bln)-blstart(bln)>1       % Dersom flere enn 2
      [first, last]=blfiltest(RW(blstart(bln):blslutt(bln),:),12);
      np=np+1;
      xv(np)=blstart(bln);
      yv(np,:)=first;   
      np=np+1;
      xv(np)=blslutt(bln);
      yv(np,:)=last;  
   end % if
   
end %for

if blslutt(nbl)<dim(1)                  % Hvis slutt av siste bl er lavere enn slutt av chrom...
   np=np+1;
   xv(np)=dim(1);         
   yv(np,:)=RW(blslutt(nbl),:);         % ...sett den lik siste bl 
end

% Interpolerer og beregner base
base=zeros(dim);
x=1:1:dim(1);
for i2=1:dim(2)
   y=(interp1(xv,yv(:,i2),x,'linear'))';
   BASE(:,i2)=y;
end

BLS=RW-BASE;     % SUBTRAHERER BASELINJEN 


% ----------- SUBFUNCTION blfiltest ------------
function [first,last]=blfiltest(BL, windim);

%function [first,last]=blfiltest=(BL);
% Returnerer vektorer med verdier for frste og siste
% baselinjepunkter berergnet fra BL ved hjelp av smoothing av 
% intil 5 frste eller 5 siste punkter.
% Benytteshvis antall BL-punkter er strre enn 3.
% BL er baselinje
% windim er vindusstrrelse
% !!!! Tilhrer funksjon 'blsubtract' !!!!

dim=size(BL);
n=dim(1); % n er antall baselinjepunkter

% Setter strrelse p vinduet
if n<windim*2
   fdim=ceil(n/2);           % Setter vinduet til halve matrisen
else
   fdim=windim;              % Setter vinduet til windim
end

b=ones(1,fdim)*1/fdim;     % Vektor med filter, fdim siste pkt er vektet likt.

% Beregner start
BLflip=(flipud(BL));
sm=filter(b,1,BLflip);
first=sm(n,:);
sim=mean(BLflip(1+n-fdim:n,:)); 
smm=mean(sm(1+n-fdim:n,:)); corr=sim-smm;
first=first+corr;

% Beregner slutt
sm=filter(b,1,BL);
last=sm(n,:);
sim=mean(BL(1+n-fdim:n,:)); 
smm=mean(sm(1+n-fdim:n,:)); corr=sim-smm;
last=last+corr;



%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset

if isfield(metset,'baseline_sens')==0 metset.baseline_sens=10; end
if isfield(metset,'baseline_winsize')==0 metset.baseline_winsize=5; end

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;% grid height

bo=bw/5;
x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='BlWin'; winpar{2}='Q: Baseline';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0; o=bw/2;
% RESET/CLOSE/ACCEPT
p=p+1;[ui{p,1:7}] = deal('Undo','Pushbutton',colors.reset,[x(4) y(20) bw bh*1.5],'qq_blcall(12)',3,'');
p=p+1;[ui{p,1:7}] = deal('Reset BL','Pushbutton',colors.reset,[x(5) y(20) bw bh*1.5],'qq_blcall(13)',3,'');

p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_blcall(99)',3,'');
p=p+1;[ui{p,1:7}] = deal('Accept','Pushbutton',colors.accept,[x(2) y(20) bw bh*1.5],'qq_blcall(97)',3,'');
% Manipulate TIC
p=p+1;[ui{p,1:7}] = deal('','Text',colors.btn{3},[x(1) y(13) x(6)-x(1) bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('TIC','Pushbutton',colors.btn{3},[x(1) y(13) bw bh],'qq_blcall(10.1)',2,'');
p=p+1;[ui{p,1:8}] = deal('Var. Win','Pushbutton',colors.btn{3},[x(2) y(13) bw bh],'qq_blcall(10.2)',2,'','-bm');
p=p+1;[ui{p,1:7}] = deal('Smooth','Pushbutton',colors.btn{3},[x(3) y(13) bw bh],'qq_blcall(10.4)',2,'');
p=p+1;[ui{p,1:8}] = deal('Win. Size: ','Text',colors.btn{3},[x(4) y(13) bw*2/3 eh],'',2,'Senstext','-r');
p=p+1;[ui{p,1:8}] = deal(num2str(metset.baseline_winsize),'Edit',colors.btn{3},[x(4)+bw*2/3 y(13) bw/3 eh],'qq_eval(''pi'')',2,'metset.baseline_winsize','-r');
% TRESHOLD
p=p+1;[ui{p,1:7}] = deal('','Text',colors.btn{3},[x(1) y(14) x(6)-x(1) bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Calc.Thresh.','Pushbutton',colors.btn{3},[x(1) y(14) bw bh],'qq_blcall(6.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('','Slider',colors.btn{3},[x(2) y(14) bw*2 bh],'qq_blcall(6.2)',2,'ThresholdSlider');
p=p+1;[ui{p,1:7}] = deal('','Edit',colors.btn{3},[x(4) y(14) bw*3/4 bh],'qq_blcall(6.3)',2,'ThresholdEdit');
p=p+1;[ui{p,1:7}] = deal('SM','Pushbutton',colors.btn{3},[x(5)-bw/4 y(14) bw/4 bh],'qq_blcall(6.4)',2,'');
p=p+1;[ui{p,1:8}] = deal('Sens.: ','Text',colors.btn{3},[x(5) y(14) bw*2/3 eh],'',2,'Senstext','-r');
p=p+1;[ui{p,1:8}] = deal(num2str(metset.baseline_sens),'Edit',colors.btn{3},[x(5)+bw*2/3 y(14) bw/3 eh],'qq_blcall(6.5)',2,'SensEdit','-r');
% ZEROLINE
p=p+1;[ui{p,1:8}] = deal('Calc Basel.','Pushbutton',colors.btn{3},[x(1) y(15) bw bh],'qq_blcall(7)',2,'','-bm');
p=p+1;[ui{p,1:8}] = deal('Spikefilter','Pushbutton',colors.btn{3},[x(2) y(15) bw bh],'qq_blcall(8)',2,'','-bm');
p=p+1;[ui{p,1:7}] = deal('Reset Vis.','Pushbutton',colors.btn{3},[x(3) y(15) bw bh],'qq_blcall(9)',2,'');
p=p+1;[ui{p,1:7}] = deal('Reset All','Pushbutton',colors.btn{3},[x(4) y(15) bw bh],'qq_blcall(9.1)',2,'');
p=p+1;[ui{p,1:8}] = deal('Subtr. Baseline','Pushbutton',colors.btn{1},[x(1) y(16) bw bh],'qq_blcall(11)',2,'','-bm');
% CODA
p=p+1;[ui{p,1:8}] = deal('CODA','Pushbutton',colors.btn{1},[x(1) y(17) bw bh],'qq_blcall(15)',2,'','-bm');
p=p+1;[ui{p,1:8}] = deal('Win size: ','Text',colors.bc,[x(2) y(17) bw*2/3 eh],'',2,'','-r');
p=p+1;[ui{p,1:8}] = deal(num2str(metset.baseline_codawin),'Edit',[1 1 1],[x(3)-bw/3 y(17) bw/3 eh],'qq_blcall(15.1)',2,'CodaWinEdit','-r');
p=p+1;[ui{p,1:8}] = deal('Thresh: ','Text',colors.bc,[x(3) y(17) bw*2/3 eh],'',2,'','-r');
p=p+1;[ui{p,1:8}] = deal(num2str(metset.baseline_codathresh),'Edit',[1 1 1],[x(4)-bw/3 y(17) bw/3 eh],'qq_blcall(15.2)',2,'CodaThreshEdit','-r');
% Filter
p=p+1;[ui{p,1:8}] = deal('Filter','Pushbutton',colors.btn{1},[x(1) y(18) bw bh],'qq_blcall(16.2)',2,'','-bm');
p=p+1;[ui{p,1:8}] = deal('-','PopupMenu',[1 1 1],[x(2) y(18) bw bh],'qq_blcall(16.1)',2,'FilterPop','-bm');
%p=p+1;[ui{p,1:8}] = deal('Active filter: None','Text',colors.bc,[x(4) y(18) bw bh],'',2,'','-bm');

updfcn='qq_blcall(100)';
h0=qq_drawwin(winpar,ui,updfcn);

h=findobj('Tag','ThresholdSlider'); set(h,'Value',15,'Max',100,'TooltipString','Adjust Threshold');
h=findobj('Tag','WindowSlider'); set(h,'Value',50,'Max',100,'SliderStep',[0.02 0.20]);







