function qq_checkspectra(inp)

global dirval D %X FCont  CA llabels lions Info tempset
global ions metset SPEC locset
%global XR XBL CL RE labels ions metset fileset cluvector detvector

% !!! Legg til file identifier
% Aktiveres nr 'CDF', 'Matlab' etc trykkes
% Persistent, Benyttes til  identifisere fil ved  load


if nargin<1 inp=0; end

FileEdit=findobj('Tag','FileEdit');
PathEdit=findobj('Tag','PathEdit');
DirList=findobj('Tag','DirList');
ContentsList=findobj('Tag','ContentsList');

qq_message(1,'');

% ------------------- FIRST CALL ---------------------------
if inp==0 
    openwin;
    if strmatch(get(gcf,'Tag'),'BatchWin')
        tempset.file_isdir=1;         
        setpath    
        D=readdir; D=sortdir(D); showdir(D); %(tempset.file_ext,metset.file_type);
        dirval=0;
    end
end

% -------------------- SET PATH ---------------------------
if inp==1
   tempset.file_filepath=get(gcbo,'String')
   cd(metset.file_exportpath);
   D=readdir; % (tempset.file_ext,metset.file_type);
   D=sortdir(D);
   showdir(D);
end
% Set path in method
if inp==1.1
    str=get(findobj('Tag','PathEdit'),'String');
    metset.file_qqrawpath=str;
end

% -------------------- DIRECTORY LISTE ---------------------
% Hyreklikk
if inp==2    % ButtonDownFcn (Hyreklikk)
   dirval=get(DirList,'Value');   
   if D{4,dirval}==1
      cd(D{1,dirval})
      D=readdir; %(tempset.file_ext,metset.file_type);
      D=sortdir(D);
      showdir(D);
      dirval=0;
   end
end

% Venstreklikk
if inp==2.5   % CallBack
   lastval=dirval;                % Forrige fil
   dirval=get(DirList,'Value'); 
   if D{4,dirval}==1
      tempset.file_isdir=1;
      qq_message(1,'Right click to change directory')
   end
   if D{4,dirval}==0
      tempset.file_isdir=0;
      tempset.file_filename=D{1,dirval};             % tempset.file_filename: Current file (persistent)
      if lastval~=dirval
         FCont=[]; 
      end
   end   
end

% -------------------- SEARCH STRING ---------------------------
if inp==4
    h=findobj('Tag','FileEdit'); str=get(h,'String');
    D=readdir; %(tempset.file_ext,metset.file_type); 
    D=sortdir(D); showdir(D);
end


% -------------------- DIRECTORY UP ---------------------------
if inp==6
   cd ..
   D=readdir; %(tempset.file_ext,metset.file_type); 
   D=sortdir(D); showdir(D);
end

% -------------------- SELECT FILES ---------------------------
if inp>7 & inp<8
    sh=findobj('Tag','SelectedList'); sstr=get(sh,'String'); sval=get(sh,'Value'); nsel=length(sstr);
    fh=findobj('Tag','DirList');  fstr=get(fh,'String'); fval=get(fh,'Value');
end
if inp==7.1    
    if D{4,fval}==1 qq_message(1,'|r|Right click to change directory'); 
    else
        if isempty(strmatch(D{1,fval},sstr)) sstr{nsel+1}=D{1,fval}; end
    end   
end
if inp==7.3 & nsel>0
    sstr(sval)=[]; nsel=nsel-1; if sval>nsel & nsel>0 set(sh,'Value',nsel); end
end
if inp==7.2
    [m,n]=size(fstr);
    for x=1:m
        if D{4,x}==0 
            if isempty(strmatch(D{1,x},sstr)) nsel=nsel+1; sstr{nsel}=D{1,x}; end    
        end
    end    
end
if inp==7.4 sstr=[]; set(sh,'Value',1); end
if inp>7 & inp<8 sstr=sort(sstr); set(sh,'String',sstr); end

% -------------------- SHOW CONTENTS ----------------------
if inp==8
    h=findobj('Tag','SelectedList')
    str=get(h,'String'); val=get(h,'Value'); selected=str{val};
    showcont(selected);
end

% ---------------------- GETSPECTRA ----------------------
if inp==9
    disp('-------- GET SPECTRA -----------')
    SPEC=getspectra
    SPEC=findcommon(SPEC);
end

% ---------------------- PCA-PLOTT ----------------------

if inp==10.2
    pca2(SPEC)
end
if inp==10.3
    pca3(SPEC)
end

% --------------- WINDOW UPDATE ----------------------

PathEdit=findobj('Tag','PathEdit');
set(PathEdit,'String',pwd);           % pwd er current working directory


% --------------- S U B F U N C T I O N S -------------

% -------------- FINDCOMMON --------------
function SPEC=findcommon(SPEC)
le=length(SPEC)

% Finner felles ioner
master=SPEC(1).ions;
for sno=2:le
    if isequal(master,SPEC(sno).ions)==0
        p=0; delind=[];
        for x=1:length(master) 
            if sum(master(x)==SPEC(sno).ions)==0; p=p+1; delind(p)=x; end
        end
        master(delind)=[];
    end
end

% Sjekker hvert spekter
for sno=1:le
    testions=SPEC(sno).ions;
    if isequal(master,testions)==0
        p=0; delind=[];
        for x=1:length(testions)
            if sum(testions(x)==master)==0; p=p+1; delind(p)=x; end
        end
        SPEC(sno).ions(delind)=[];
        SPEC(sno).abundance(delind)=[];
    end
end

% -------------- PCA2 --------------
function pca2(SPEC)

le=length(SPEC);
for sno=1:le
    II(sno,:)=SPEC(sno).abundance;
end

[U,S,V] = svds(II,2);
figure; hold on
for x=1:le
    cbf='';
    cmenu=uicontextmenu;
    ph=plot(U(x,1),U(x,2),'o','MarkerSize',5,'MarkerFaceColor',[0 0 1],'MarkerEdgeColor',[1 1 1],...
        'UserData',SPEC(x).filename,'UIContextMenu',cmenu);
    item1=uimenu(cmenu,'Label',SPEC(x).filename);
    %th=text(U(:,1),U(:,2),SPEC(x).filename)    
end
hold off
    
% -------------- PCA3 --------------
function pca3(SPEC)

le=length(SPEC);
for sno=1:le
    II(sno,:)=SPEC(sno).abundance;
end

[U,S,V] = svds(II,3);
figure; hold on
for x=1:le
    cbf='';
    cmenu=uicontextmenu;
    ph=plot3(U(x,1),U(x,2),U(x,3),'o','MarkerSize',5,'MarkerFaceColor',[0 0 1],'MarkerEdgeColor',[1 1 1],...
        'UserData',SPEC(x).filename,'UIContextMenu',cmenu);
    item1=uimenu(cmenu,'Label',SPEC(x).filename);
    %th=text(U(:,1),U(:,2),SPEC(x).filename)    
end
hold off



% -------------- GETSPECTRA --------------
function SPEC=getspectra

h=findobj('Tag','ContentsList'); str=get(h,'String'); val=get(h,'Value'); selcomp=str{val}
h=findobj('Tag','SelectedList'); files=get(h,'String');
nfiles=length(files);
for fno=1:nfiles
    filename=['SPEC_' files{fno} '.mat'];
    load(filename,'Spectra');
    le=length(Spectra); for x=1:le names{x}=Spectra(x).shortname; end
    pos=strmatch(selcomp,names);
    SPEC(fno).filename=Spectra(pos).filename;
    SPEC(fno).longname=Spectra(pos).longname;
    SPEC(fno).shortame=Spectra(pos).shortname;
    SPEC(fno).code=Spectra(pos).code;
    SPEC(fno).ions=Spectra(pos).ions;
    SPEC(fno).abundance=Spectra(pos).abundance;
end

% --------------- SHOWCONT --------------
function showcont(selected)

name=['SPEC_' selected '.mat'];
load(name,'Spectra');
le=length(Spectra); for x=1:le names{x}=Spectra(x).shortname; end
h=findobj('Tag','ContentsList'); set(h,'String',names);


% --------------- CHECKCORR -------------
function corr=checkcorr(ions1,S1,ions2,S2)

if isequal(ions1,ions2)==0
   p=0; delind=[];
   for x=1:length(ions1) 
       if sum(ions1(x)==ions2)==0; p=p+1; delind(p)=x; end
   end
   ions1(delind)=[]; S1(delind)=[];
   p=0; delind=[];
   for x=1:length(ions2) 
       if sum(ions2(x)==ions1)==0; p=p+1; delind(p)=x; end
   end
   ions2(delind)=[]; S2(delind)=[];   
end
corr = corrcoef(S1,S2)*100; corr=corr(1,2);


% -------------- SUBFUNCTION SETPATH --------------
function setpath
global metset

str=metset.file_exportpath; str2='*.mat';
PathEdit=findobj('Tag','PathEdit');
set(PathEdit,'String',str); cd(str)
FileEdit=findobj('Tag','FileEdit');
%set(FileEdit,'String',str2); 
cd(str);

% -------------- SUBFUNCTION SHOWDIR --------------
function showdir(D)

% LAGER OUTPUTARRAY
maxname=27;
dimD=size(D);nfiles=dimD(2);
for i1=1:nfiles
   name=(D{1,i1}); namesize=length(name); %namesize=namesize(2);
   if namesize>maxname
      namesize=maxname;
   end
   
   name=[name(1:namesize) blanks(maxname-namesize)];
   
   dato=(D{2,i1});
   
   storr=num2str(D{3,i1});
   if D{3,i1}>9999999
      storr=num2str(D{3,i1},'%-1.1e');
      storr(6)=[];
   end
   storrsize=size(storr);storrsize=storrsize(2);
   if storrsize>7
      storrsize=7;
   end
   storr=[blanks(7-storrsize) storr];
   
   if D{4,i1}==1, name(maxname-2:maxname)='DIR';
   end
   printdir(i1,:)=[name '  ' storr '  ' dato(1:17)];    
   
end

DirList=findobj('Tag','DirList');
set(DirList,'Value',1);
set(DirList,'String',printdir);


% -------------- SORTDIR -------------------
function DDS=sortdir(D)

% Returnerer cell array med sortert Directory
% Directories frst, deretter alfabetisk
% D m vre cell array: D=dir;D=struct2cell(D);

dimD=size(D);nfiles=dimD(2);
maxname=32; % Max antall tegn i filnavnet

% ALFABETISK SORTERING
% Lager matrise med filnavn 'FN'
for i1=1:nfiles
   name=(D{1,i1});
   name=lower(name); % Ungr case-sensitiv sortering
   namesize=size(name); namesize=namesize(2);
   if namesize>maxname
      namesize=maxname;
   end
   FN(i1,:)=[name(1:namesize) blanks(maxname-namesize)];
end
[sortv, ind]=sortrows(FN); % Finner indexer
DS(:,1:nfiles)=D(:,ind(:)); % Sortert Cell array DS

% SETTER DIRECTORIES VERST
for i1=1:nfiles
   dind(i1)=DS{4,i1}; % Siste celle i DS inneholder info om dir (1 eller 0)
end
dind=dind*-1; [sortv, ind]=sort(dind); % Indexer for sortering, "ind"
DDS(:,1:nfiles)=DS(:,ind(:)); % Returnerer cell array med dir verst, DDS


% -------------- SUBFUNCTION READDIR -------------------
function DE=readdir 
h=findobj('Tag','FileEdit'); str=get(h,'String');
%disp('---- READDIR -----')
dirstr=['SPEC_' str '.mat'];

D=dir(dirstr); type=cat(2,D.isdir);
for x=1:length(D) ind1=strfind(D(x).name,'.mat'); D(x).name=D(x).name(6:ind1-1); end % Fjerner identifier fra filnavn 
D=D(find(type==0)); dimD=size({D.name}); nfiles=dimD(2); 

DD=dir; type=cat(2,DD.isdir); 
DD=DD(find(type)); dimDD=size({DD.name}); ndirs=dimDD(2); 

if nfiles>0 DE=[DD; D]; end
if nfiles==0 DE=DD; end
DE=struct2cell(DE);

%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;% grid height

bo=bw/5;
x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='CheckSpecWin'; winpar{2}='Q: Checkspectra';

if isfield(metset,'peak_treshpct')==0 metset.peak_treshpct=25; end

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0; o=bw/2;
% CLOSE
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_closewin',3,'CloseBtn');
%p=p+1;[ui{p,1:7}] = deal('Run','Pushbutton',colors.accept,[x(1) y(20) bw bh*1.5],'qq_checkspectra(10)',3,'RunBtn');
% Path, lister, og file ext.
p=p+1;[ui{p,1:7}] = deal(' ','text',[1 1 1],[0 y(12) 1 bh],'',3,'');
p=p+1;[ui{p,1:7}] = deal('Path:','text',[1 1 1],[x(2)-bw*0.55 y(12)+eo bw/2 eh],'',3,'rjust');
p=p+1;[ui{p,1:7}] = deal(' ','edit',[1 1 1],[x(2) y(12)+eo bw*3 eh],'qq_checkspectra(1)',2,'PathEdit');
p=p+1;[ui{p,1:7}] = deal('SM','pushbutton',[1 1 1],[x(5)-bw/4 y(12)+eo bw/4 eh],'qq_checkspectra(1.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Searchstring:','text',[1 1 1],[x(6)-bw/2 y(12)+eo bw eh],'',3,'');
p=p+1;[ui{p,1:7}] = deal('*','edit',[1 1 1],[x(7)-bw/2 y(12)+eo bw*1.5 eh],'qq_checkspectra(4)',2,'FileEdit'); % Sjekk Call
% FilesList
p=p+1;[ui{p,1:7}] = deal('Searching...','listbox',[1 1 1],[x(1) y(11) bw*4 y(2)-y(12)+bh],'qq_checkspectra(2.5)',2,'DirList');
p=p+1;[ui{p,1:7}] = deal('','listbox',[1 1 1],[x(6)-bw/2 y(11) bw*1.5 y(2)-y(12)+bh],'qq_checkspectra(8)',2,'SelectedList');
p=p+1;[ui{p,1:7}] = deal('','listbox',[1 1 1],[x(8) y(11) bw*1.5 y(2)-y(12)+bh],'qq_checkspectra(8.1)',2,'ContentsList');
% Dir up
p=p+1;[ui{p,1:7}] = deal('Dir Up','Pushbutton',[1 1 1],[x(1) y(12) bw/2 bh],'qq_checkspectra(6)',2,'');
% Select files
p=p+1;[ui{p,1:7}] = deal('->','Pushbutton',colors.accept,[x(5) y(5) bw/2 bh],'qq_checkspectra(7.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('All','Pushbutton',colors.accept,[x(5) y(6) bw/2 bh],'qq_checkspectra(7.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('<-','Pushbutton',colors.reset,[x(5) y(7) bw/2 bh],'qq_checkspectra(7.3)',2,'');
p=p+1;[ui{p,1:7}] = deal('All','Pushbutton',colors.reset,[x(5) y(8) bw/2 bh],'qq_checkspectra(7.4)',2,'');
% Load
p=p+1;[ui{p,1:7}] = deal('Load spectra','Pushbutton',colors.btn{1},[x(1) y(13) bw bh],'qq_checkspectra(9)',2,'');
% Plot
p=p+1;[ui{p,1:7}] = deal('PCA2','Pushbutton',colors.btn{4},[x(1) y(14) bw bh],'qq_checkspectra(10.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('PCA3','Pushbutton',colors.btn{4},[x(1) y(15) bw bh],'qq_checkspectra(10.3)',2,'');

updfcn='qq_checkspectra(100)';
h0=qq_drawwin(winpar,ui,updfcn);
set(h0,'KeyPressFcn','qq_checkspectra(96)')

h=findobj('Tag','DirList'); set(h,'ButtonDownFcn','qq_checkspectra(2)','TooltipString','Right click to change directory') 
h=findobj('Tag','ContentsList'); set(h,'ButtonDownFcn','qq_checkspectra(3)','TooltipString','Right click to Load') 
h=findobj('Tag','rjust'); set(h,'HorizontalAlignment','right')


drawnow


















   



        


















   






   






