function qq_initialsettings

% function initialsettings
% Settings for:
% ....
% ....
% ....
% set in global vars metset og fileset

% h=findobj('Tag','StartWin'); close(h); % Lukker startwin

global metset fileset positions colors fonts locset

if locset.tracker==1 disp('--- qq_initialsettings ---'); end

% Suppress warnings
warning('off','MATLAB:UIW_DOSUNC'); % suppress waring of no UNC support in dos

%--------- LOCSET --------
% overrides foldersettings if locset.defaulfolders=1
if isfield(locset,'defaultfolders') && locset.defaultfolders==1
    locset.path_export=[locset.path_root '\export'];
    locset.path_qqraw=[locset.path_root '\rawdata'];
    locset.path_library=[locset.path_root '\libraries'];
    locset.path_method=[locset.path_root '\methods'];
    locset.path_results=[locset.path_root '\results'];
    locset.path_reports=[locset.path_root '\reports'];
end

% Sets fields if not already defined 
if ~isfield(locset,'path_export') locset.path_export=[locset.path_root '\export']; end  % Export of files, can be set in localsettings.csv
if ~isfield(locset,'path_qqraw') locset.path_qqraw=[locset.path_root '\rawdata']; end        % QQ-Rawdata
if ~isfield(locset,'path_library') locset.path_library=[locset.path_root '\libraries']; end % libraries
if ~isfield(locset,'path_method') locset.path_method=[locset.path_root '\methods']; end % Collection of methods
if ~isfield(locset,'path_results') locset.path_results=[locset.path_root '\results']; end % Folder for results file
if ~isfield(locset,'path_reports') locset.path_reports=[locset.path_root '\reports']; end % Folder for reports
locset.path_code=[locset.path_root '\code\' locset.version]; % Program code
if ~isfield(locset,'tracker') locset.tracker=0; end

%--------- METSET --------
metset.path_qqraw='';      % QQ-Rawdata
metset.path_export='';     % Exporterte filer fra dette prg.
metset.path_library='';    % Bibliotek
metset.path_method='';     % Metodesamling
metset.path_results='';    % Results
metset.path_reports='';    % Reports

metset.path_code='';       % Program
metset.path_matlab='';     % Matlabfiler                 
metset.path_prs='';        % Export fra Xtricator
metset.path_csv='';        % Export fra Chemstation (csv)
metset.path_agilent='';    % Chemstation
metset.path_cdf='';        % Net CDF

metset.global_spectrumtype='EI'; % Ionization mode
metset.global_spectrumtypes={'EI','CI+','CI-','ESI+','ESI-','APCI+','APCI-','DART','Other'};
metset.global_resol=1; % Mass resolution

metset.global_columns={'BPX-70','SP-2560','CP-Sil 88','PEG','100% Methyl','5% Phenyl','-'};
metset.global_selcol='BPX-70';  % Selected column
metset.global_editor='default'; % OBSOLETE? 'default','matlab','notepad' (qq_message) 
metset.global_class='FAME'; % Compound class
metset.global_saveas_v6=1;  % Save in Matlab v6.x format
metset.global_overwrite=1; % Overwrite files without warning (applies to some)
metset.global_makedir=0; % Automatically create directories 

metset.file_method=''; % Current method
metset.file_type='QQ-Rawdata'; % Type of data to load 

metset.load_ionthresh=0;     % Ion treshold in truncate
metset.load_dellow=0;       % delete x lowest ions in truncate functioon

metset.baseline_sens=10;    % Baseline sensitivity
metset.baseline_winsize=5;  % Smooth/varwin size
metset.baseline_plottype=1; % 1=TIC, 2=VarWin
metset.baseline_codawin=5;  % CODA windowsize
metset.baseline_codathresh=0.89;  % CODA windowsize
metset.baseline_filtername='-';  % Name of filter

metset.peak_leftbase=1.0;   % Peak contraction to percent of peak max
metset.peak_rightbase=1.0;  % Peak contraction to percent of peak max
metset.peak_minwhh=3.0;     % Minimum whh (in scans)
metset.peak_smoothwin=5;    % Smoothwindow
metset.peak_treshpct=25;    % Initial treshold (prosent)

metset.integrate_tresh=50;  % Min valley in percent at integration 
metset.integrate_blfit=0;   % Fits baseline to profile if 1
metset.integrate_fill=0;    % Show filled ares

metset.quant_unimod=1;      % Unimodality in AR/ALS
metset.quant_posC=1;        % Positive C in AR/ALS
metset.quant_posS=1;        % Positive S in AR/ALS
metset.quant_closure=1;     % Closure of C in AR/ALS
metset.quant_normS=1;       % Normalize S in AR/ALS
metset.quant_niter=50;      % Number of iterations in ALS/AR
metset.quant_stopcrit=10;    % Stop criterion in ALS/AR

metset.library_name='defaultlib'; % Bibliotek som editeres
metset.library_search={'defaultlib'}; % Bibliotek som det skes i
metset.library_minions=4;   % Min antall ioner som er felles mellom bibl. entry og testspektr.
metset.library_update=1;    % Sjekker register fortlpende mot nye entries
metset.library_showentr=20; % Antall spektra som vises
metset.library_riinterval=0.5; % Interval for retensjonsindex
metset.library_useri=0;     % Use retention time if 0, retention index if 1.
metset.library_rimatch=1;   % Anvendelse av RI; 1: ingen 2: interval, 3: gaussian
metset.library_colsearch=metset.global_columns{1}; % Kolonner som det skes p
metset.library_root=1;      % Brukes for  vekte opp svake ioner. 1=ingen vekting
metset.library_mf=1;   % matchfunction: mf=1 korrkoeff, mf2 explvar koeff.
metset.library_treshold=95;  % Treshold for identification

metset.results_rivect=[];   % Retensjonsindexvektor 
metset.results_rical=[];    % Data for beregning av retensjonsindexer
metset.results_homridiff=100;    % Homolg RI difference
metset.results_peakfit=1; % Bruker peakfit for  kalkulere RI, whh og asym
metset.results_kurt=1; % Kurtosis=1 for peakfit 
metset.results_sigma=6; % bruker 6 ganger s fom inputdata for  estimere toppen ved peakfit

metset.report_aopen=1; % Automatically opens reports
metset.report_txt=1; % Textreport
metset.report_dif=1; %Dif-report (excel import)
metset.report_spreadsheets={'Excel (xls)','Data Interchange Format (dif)'}; % Available report formats for spreadsheets
metset.report_spreadsheet={'Excel (xls)'}; % Selected reportformat

metset.batch_startrt=[]; % Start retensjonstid
metset.batch_endrt=[]; % Slutt retensjonstid


%--------- FILESET -------

fileset.file_type='All';   % Filtype som loades
fileset.file_filename='*.*';
fileset.file_ext='*.*';

fileset.global_filename='No file';

fileset.results_rivect=[];   % Retensjonsindexvektor 
fileset.results_rical=[];    % Data for beregning av retensjonsindexer
fileset.results_peaklabel=1; % Labels

%--------- POSITIONS ----------
%positions.window=[0 0 1 1];               % Posisjon til hovedvindu
positions.window=locset.windowpos;
%positions.window=[0.05 0.05 0.9 0.9];               % Posisjon til hovedvindu
positions.smallplot=[0.58 0.067 0.395 0.353]; % Posisjon for lite plott
positions.largeplot=[0.025 0.485 0.95 0.48];        % Posisjon for stort plott
positions.gl=0.045;                       % grid left
positions.gt=0.43;                        % grid top
positions.gw=0.1;                         % grid width
positions.gh=0.0465;                      % grid height
positions.bh=0.035;                       % button height
positions.bw=positions.gw;                % button width
positions.gt2=0.43+0.5;                        % grid top (grid 2, verste halvdel)
positions.gy2=positions.gt:-positions.gh:0.5;  % horisontalt grid (grid 2, verste halvdel)
positions.eh=positions.bh*0.8; % Edit hight
positions.normfont='Helvetica';

%---------- COLORS -------------
colors.bc=[0.5 0.5 0.7];
colors.reset=[1 0 0];
colors.accept=[0 1 0];
colors.close=[1 1 0.50];
colors.btn{1}=[1 0.5 0]; % orange, 
colors.btn{2}=[1 0.7 0.7]; % pink, LIBRARY
colors.btn{3}=[0.7 1 0.7]; % light green, RETENTION INDEX
colors.btn{4}=[0 1 1]; % cyan
colors.btn{5}=[0.75 0.75 0.75]; % grey
colors.btn{6}=[0.5 0.5 1]; % blue % REPORT
colors.btn{7}=[1 1 0.5]; % yellow % LOCK PEAKS

% ------------ FONTS ------------
fonts=[8 10 12 14 16];
set(0,'Units','Pixels'); screen=get(0,'ScreenSize'); % Collects screen size
if screen(3)<1000 fonts=[6 8 10 12 14]; end