function mdescr=qq_lib_descriptors(an,mdescr)
global metset locset

if locset.tracker disp('---- qq_lib_descriptors ----'); end

if nargin<2 mdescr=[]; end

if an==0; drawlist; end

if an==1; mdescr=readlist; end

if an==2; fillist(mdescr); end


%disp('END---- qq_lib_descriptors ----')

% ================ SUBFUNCTIONS ==================

% ---------------- FILLIST -------------------
function fillist(mdescr)
global metset
%disp('---- qq_lib_descriptors: fillist ----')

if isempty(mdescr)==0
% Molecular descriptors
    for p=1:length(metset.mdescr)
        h=findobj('Tag',['DescrField',num2str(p)]);
        fieldtype=metset.mdescr(p).fieldtype;
        varname=metset.mdescr(p).varname;
        val=mdescr.(varname);
        if strmatch(fieldtype,'Integer') set(h,'String',num2str(val)); end
        if strmatch(fieldtype,'Decimal') set(h,'String',num2str(val)); end
        if strmatch(fieldtype,'String') set(h,'String',val); end
        if strmatch(fieldtype,'Binary') set(h,'Value',val); end
        if strmatch(fieldtype,'Category') & isempty(val)==0
            str=get(h,'String'); setp=strmatch(val,str);        
            if isempty(setp) 
                str{length(str)+1}=val; setp=length(str); 
            else
                setp=setp(1);
            end
            set(h,'Value',setp,'String',str); 
        end
    end
else
    for p=1:length(metset.mdescr)
        h=findobj('Tag',['DescrField',num2str(p)]);
        fieldtype=metset.mdescr(p).fieldtype;
        varname=metset.mdescr(p).varname;
        %val=mdescr.(varname);
        if strmatch(fieldtype,'Integer') set(h,'String','NaN'); end
        if strmatch(fieldtype,'Decimal') set(h,'String','NaN'); end
        if strmatch(fieldtype,'String') set(h,'String',''); end
        if strmatch(fieldtype,'Binary') set(h,'Value',0); end
        if strmatch(fieldtype,'Category') set(h,'Value',1); end
    end
    
end


%disp('END---- qq_lib_descriptors: fillist ----')


% ---------------- READLIST -------------------
function mdescr=readlist
global metset locset

load([locset.path_library,'\class_',metset.global_class,'\Definitions.mat']);
n_descr=length(Definitions.mdescr);

for p=1:n_descr
    h=findobj('Tag',['DescrField',num2str(p)]);
    varname=Definitions.mdescr(p).varname;
    fieldtype=Definitions.mdescr(p).fieldtype;
    if strmatch(fieldtype,'Integer') mdescr.(varname)=round(str2double(get(h,'String'))); end
    if strmatch(fieldtype,'Decimal') mdescr.(varname)=str2double(get(h,'String')); end
    if strmatch(fieldtype,'String') mdescr.(varname)=get(h,'String'); end
    if strmatch(fieldtype,'Binary') mdescr.(varname)=get(h,'Value'); end
    if strmatch(fieldtype,'Category') str=get(h,'String'); mdescr.(varname)=str{get(h,'Value')}; end  
end


% ---------------- DRAWLIST -------------------
function drawlist
global metset positions colors locset

h0=gcf; % Current figure 
bw=positions.bw;
bh=positions.bh;
eh=positions.eh; %eo=(bh-eh)/2; % edit offset
gh=positions.gh;
x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

load([locset.path_library,'\class_',metset.global_class,'\Definitions.mat']);
n_descr=length(Definitions.mdescr);

vp=y(6);
for p=1:n_descr
    h1 = uicontrol('Parent',h0, ...
        'BackgroundColor',colors.bc, ...
	    'Position',[x(3) vp bw eh], ...
        'Style','Text',...
        'HorizontalAlignment','left',...
	    'Tag','',...
        'String',[Definitions.mdescr(p).text,':']);
    
    h1 = uicontrol('Parent',h0, ...
        'BackgroundColor',[1 1 1], ...
	    'Position',[x(4) vp bw eh], ...
        'Style','Edit',...
        'HorizontalAlignment','left',...
	    'Tag',['DescrField',num2str(p)],...
        'FontWeight','Normal',...
        'FontName','FixedWidth',...
        'String','');   
    if strmatch(Definitions.mdescr(p).fieldtype,'Category')    
        set(h1,'Style','PopupMenu')
        set(h1,'String',Definitions.mdescr(p).cat)
    end
    if strmatch(Definitions.mdescr(p).fieldtype,'Binary')    
        set(h1,'Style','Checkbox','BackgroundColor',colors.bc)
    end    
      
    vp=vp-gh;
end

