function qq_lib_jcampimport(inp)
 
global XR metset fileset jset locset Templib positions

% jset.D = Directory data, 
% jset.filename = Current File, 
% FCont = File contents (in matlab file), 
% jset.dirval = Position in dir-window, 
% jset.current_array=Current array (selected array in matlab file)
% jset.X = Loaded data
% jset.rt / jset.ions = local rt/ions (before accept)

if nargin<1
   inp=0;
end

qq_message(2)

FileEdit=findobj('Tag','FileEdit');
PathEdit=findobj('Tag','PathEdit');
DirList=findobj('Tag','DirList');
ContentsList=findobj('Tag','ContentsList');

% ------------------- FIRST CALL ---------------------------
if inp==0 
    if isfield(locset,'path_jcamp')==0 locset.path_jcamp=''; end
    openwin;
    if strmatch(get(gcf,'Tag'),'JCAMPimpotWin')
        Templib=[];
        jset.dironstart=cd;
        setpath        
        jset.D=readdir;
        jset.D=sortdir(jset.D);
        jset.dirval=0;
        showdir(jset.D);
        getlibdir
        librarylist
        %update
    end
    if isempty(locset.path_jcamp)
        qq_message(1,'|r|path_jcamp is not defined in localsettings.sdv')
    end
end

% -------------------- SET PATH ---------------------------
if inp==1
   checkpath; 
   jset.file_filepath=get(gcbo,'String');
   jset.D=readdir
   jset.D=sortdir(jset.D);
   showdir(jset.D);
   %update
end
% Set path in method

% -------------------- DIRECTORY LISTE ---------------------
% Hyreklikk
if inp==2    % ButtonDownFcn (Hyreklikk)
   jset.dirval=get(DirList,'Value');   
   if jset.D{4,jset.dirval}==1
      cd(jset.D{1,jset.dirval})
      jset.D=readdir;
      jset.D=sortdir(jset.D);
      showdir(jset.D);
      jset.dirval=0;
      update
   end
end
% Venstreklikk
if inp==2.5   % CallBack
   lastval=jset.dirval;                % Forrige fil
   jset.dirval=get(DirList,'Value'); 
   if jset.D{4,jset.dirval}==1
      jset.file_isdir=1;
      qq_message(1,'Right click to change directory');
  else
      qq_message(1,'');
   end
   if jset.D{4,jset.dirval}==0
      jset.file_isdir=0;
      jset.filename=jset.D{1,jset.dirval};             % jset.filename: Current file (persistent)
      set(FileEdit,'String',jset.filename)
   end   
   %update
end

% -------------------- DIRECTORY UP ---------------------------
if inp==6
   cd ..
   jset.D=readdir;
   jset.D=sortdir(jset.D);
   showdir(jset.D);
   set(PathEdit,'BackgroundColor',[1 1 1])
   %update
end

% -------------------- LOAD ------------------------------------
if inp==8 && jset.file_isdir==1 qq_message(1,'|r|Can''t load directory'); end
if inp==8 && jset.file_isdir==0
    Templib=jcampread([jset.currentdir '\' jset.filename]);
    if isempty(Templib)==0
        qq_message(1,['|b|' num2str(length(Templib)) ' spectra loaded']);
        h=findobj('Tag','SaveFileEdit'); set(h,'String',jset.filename(1:length(jset.filename)-length(jset.fileext)+1));
        contentslist(Templib)
    end
end

% -------------------- LIBRARYLIST ------------------------------------
if inp==9
    librarylist
end

% -------------------- CONTENTSLIST ------------------------------------
if inp==10
    h=findobj('Tag','ContentsList'); val=get(h,'Value');
    qq_plot_ms(0,Templib(val).ions,Templib(val).S,positions.largeplot); 
end

% -------------------- DELETE SEL. ------------------------------------
if inp==11
    h=findobj('Tag','ContentsList'); val=get(h,'Value'); 
    if isempty(Templib)==0
        Templib(val)=[];
        if val>length(Templib) val=length(Templib); end
        if val<1 val=1; end
        set(h,'Value',val); contentslist(Templib);
        if isempty(Templib)==0 qq_plot_ms(0,Templib(val).ions,Templib(val).S,positions.largeplot); end
    end       
end

% -------------------- SAVE ------------------------------------
if inp==12
    check=0;
    LibList=findobj('Tag','LibrariesList'); FnEdit=findobj('Tag','SaveFileEdit');
    fn=get(FnEdit,'String'); STRS=get(LibList,'String');
    if strmatch(fn,STRS)
        qq_message(1,['|r|' fn ' exists, select new name']); check=1;
    end
    if isempty(Templib)
        qq_message(1,['|r|Nothing to save']); check=1;
    end
    if check==0
        h=findobj('Tag','SavelistPop');
        strs=get(h,'String'); val=get(h,'Value'); path=strs{val}; 
        pathname=[path '\lib_' fn '.mat'];
        Library=Templib; 
        %save(pathname,'Library')
        qq_savefile(pathname,Library,'-o')
        librarylist
        qq_message(1,['|b|Library ' fn ' saved in ' path]);
    end    
end


% ------------------------ CLOSE --------------------------
if inp==99
   cd(jset.dironstart)
   clear jset
   qq_closewin;
end


% --------------- S U B F U N C T I O N S -------------

% -------------- Contentslist --------------
function contentslist(Library)

str{1}='Empty';
for x=1:length(Library)
    str{x}=Library(x).cmp_name;
end
h=findobj('Tag','ContentsList'); set(h,'String',str); 
    

% -------------- librarylist --------------
function librarylist

h=findobj('Tag','SavelistPop'); strs=get(h,'String'); val=get(h,'Value');
seldir=strs{val};

D=dir([seldir '\lib_*.mat']); namestr{1}='Empty';
for x=1:length(D)
    namestr{x}=D(x).name(5:length(D(x).name)-4);
end

h=findobj('Tag','LibrariesList'); set(h,'String',namestr)


% -------------- getlibdir --------------
function getlibdir
global locset metset

D=dir(locset.path_library);

str{1}=locset.path_library; p=1;
for x=1:length(D)
    if D(x).isdir && strcmp(D(x).name,'.')==0 && strcmp(D(x).name,'..')==0 
        p=p+1; str{p}=[locset.path_library '\' D(x).name];
    end
end
h=findobj('Tag','SavelistPop'); set(h,'String',str);


% -------------- JCAMPREAD --------------
function LIB=jcampread(pathname)
global positions
LIB=[];

STRS=textread(pathname,'%s','delimiter','\n');
startpoints=strmatch('##TITLE',STRS); nspec=length(startpoints);

if nspec>0

    endpoints=startpoints-1; endpoints=[endpoints; length(STRS)]; endpoints(1)=[];

    for x=1:nspec
        locSTRS=STRS(startpoints(x):endpoints(x));
        headerlines=strmatch('##',locSTRS);
        headerSTRS=locSTRS(headerlines);
        header=getheader(headerSTRS);
    
        fn=fieldnames(header);
        for y=1:length(fn)
            LIB(x).(fn{y})=header.(fn{y});
        end    
        specSTRS=locSTRS(max(headerlines)+1:length(locSTRS));
    
        [LIB(x).S,LIB(x).ions]=getspectrum(specSTRS);
        LIB(x).S=LIB(x).S*100/max(LIB(x).S); % Normalizing
    
        % Plotting  
        h=findobj('Tag','ShowSpecCheck'); showspec=get(h,'Value');
        if showspec
            qq_plot_ms(0,LIB(x).ions,LIB(x).S,positions.largeplot); drawnow
        end
    end
else
    qq_message(1,'|r|Not recognized as JCAMP-DX')
end

% ------------ getspectrum -------------
function [S,ions]=getspectrum(specSTRS)
S=[];ions=[];

for x=1:length(specSTRS)
    str=specSTRS{x};
    dstr=double(str);
    dlmpos=find(dstr==32); 
    numpos=find(dstr>=48 & dstr<=57 | dstr==46);
    startfirst=min(numpos); [ind]=find(dlmpos>startfirst); endfirst=dlmpos(min(ind)); 
    ions(x)=str2double(str(startfirst:endfirst));
    endlast=max(numpos); [ind]=find(dlmpos<endlast); startlast=dlmpos(max(ind));
    S(x)=str2double(str(startlast:endlast));
end

% ------------ getheader -------------
function header=getheader(headerSTRS)
header=[];

% NAME
pos=strmatch('##CAS NAME=',headerSTRS); 
if isempty(pos)==0 
    str=headerSTRS{pos}; header.cmp_name=str(length('##CAS NAME=')+1:length(str)); 
end
% Cas No
pos=strmatch('##CAS REGISTRY NO=',headerSTRS); 
if isempty(pos)==0 
    str=headerSTRS{pos}; header.cmp_casno=str(length('##CAS REGISTRY NO=')+1:length(str));
    str=headerSTRS{pos}; header.cmp_shortname=str(length('##CAS REGISTRY NO=')+1:length(str));
end
% MolWeight
pos=strmatch('##MW=',headerSTRS); 
if isempty(pos)==0 
    str=headerSTRS{pos}; header.molweight=str2double(str(length('##MW=')+1:length(str)));
    if header.molweight<=0 header.molweight=NaN; end
end
% Mol Formula
pos=strmatch('##MOLFORM=',headerSTRS); 
if isempty(pos)==0 
    str=headerSTRS{pos}; header.molform=str(length('##MOLFORM=')+1:length(str));
end
% Retention index
pos=strmatch('##$RETENTION INDEX=',headerSTRS); 
if isempty(pos)==0 
    str=headerSTRS{pos}; header.ri_calc=str2double(str(length('##$RETENTION INDEX=')+1:length(str)));
    if header.ri_calc<=0 header.ri_calc=NaN; end
end
% Mol Formula
pos=strmatch('##SAMPLE DESCRIPTION=',headerSTRS); 
if isempty(pos)==0 
    str=headerSTRS{pos}; header.comments=str(length('##SAMPLE DESCRIPTION=')+1:length(str));
end

if isfield(header,'cmp_code')==0 header.cmp_code='TEMP'; end
if isfield(header,'cmp_shortname')==0 header.cmp_shortname='-'; end
if isfield(header,'column')==0 header.column='-'; end

% -------------- SUBFUNCTION SETPATH --------------
function setpath
global metset jset locset

str=[locset.path_jcamp]; str2='*.dx'; 
PathEdit=findobj(gcf,'Tag','PathEdit'); set(PathEdit,'String',str); 
FileEdit=findobj('Tag','FileEdit'); set(FileEdit,'String',str2); 
jset.fileext=str2;

checkpath;

% -------------- SUBFUNCTION CHECKPATH --------------
function dircheck=checkpath
global metset jset locset

PathEdit=findobj(gcf,'Tag','PathEdit'); str=get(PathEdit,'String'); 
if isdir(str)
    dircheck=1; cd(str); 
    set(PathEdit,'BackGroundColor',[1 1 1]);
else
    dircheck=0; qq_message(1,['|r|' str ' does not exist']);
    set(PathEdit,'BackGroundColor',[1 1 0],'String',pwd);
end    

% -------------- SUBFUNCTION SHOWDIR --------------
function showdir(D)

% LAGER OUTPUTARRAY
maxname=27;
dimD=size(D);nfiles=dimD(2);
for i1=1:nfiles
   name=(D{1,i1});
   namesize=size(name); namesize=namesize(2);
   if namesize>maxname
      namesize=maxname;
   end
   name=[name(1:namesize) blanks(maxname-namesize)];
   
   dato=(D{2,i1});
   
   storr=num2str(D{3,i1});
   if D{3,i1}>9999999
      storr=num2str(D{3,i1},'%-1.1e');
      storr(6)=[];
   end
   storrsize=size(storr);storrsize=storrsize(2);
   if storrsize>7
      storrsize=7;
   end
   storr=[blanks(7-storrsize) storr];
   
   if D{4,i1}==1, name(maxname-2:maxname)='DIR';
   end
   printdir(i1,:)=[name '  ' storr '  ' dato(1:17)];    
   
end

DirList=findobj('Tag','DirList');
set(DirList,'Value',1);
set(DirList,'String',printdir);


% -------------- SORTDIR -------------------

function DDS=sortdir(D)

% Returnerer cell array med sortert Directory
% Directories frst, deretter alfabetisk
% D m vre cell array: D=dir;D=struct2cell(D);

dimD=size(D);nfiles=dimD(2);
maxname=32; % Max antall tegn i filnavnet

% ALFABETISK SORTERING
% Lager matrise med filnavn 'FN'
for i1=1:nfiles
   name=(D{1,i1});
   name=lower(name); % Ungr case-sensitiv sortering
   namesize=size(name); namesize=namesize(2);
   if namesize>maxname
      namesize=maxname;
   end
   FN(i1,:)=[name(1:namesize) blanks(maxname-namesize)];
end
[sortv, ind]=sortrows(FN); % Finner indexer
DS(:,1:nfiles)=D(:,ind(:)); % Sortert Cell array DS

% SETTER DIRECTORIES VERST
for i1=1:nfiles
   dind(i1)=DS{4,i1}; % Siste celle i DS inneholder info om dir (1 eller 0)
end
dind=dind*-1; [sortv, ind]=sort(dind); % Indexer for sortering, "ind"
DDS(:,1:nfiles)=DS(:,ind(:)); % Returnerer cell array med dir verst, DDS


% -------------- SUBFUNCTION READDIR -------------------
function DE=readdir
global jset

h=findobj('Tag','FileExtEdit'); dirstr=get(h,'String');
jset.currentdir=cd;
D=dir(dirstr); 
type=cat(2,D.isdir);
D=D(find(type==0)); dimD=size({D.name}); nfiles=dimD(2); 

DD=dir; type=cat(2,DD.isdir); 
DD=DD(find(type)); dimDD=size({DD.name}); ndirs=dimDD(2); 

if nfiles>0 DE=[DD; D]; end
if nfiles==0 DE=DD; end
DE=struct2cell(DE);


%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset locset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;% grid height

bo=bw/5;
x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='JCAMPimpotWin'; winpar{2}='Q: JCAMP import';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0; o=bw/2;
% CLOSE
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_lib_jcampimport(99)',3,'CloseBtn');
% Path, lister, og file ext.
p=p+1;[ui{p,1:7}] = deal(' ','text',[1 1 1],[0 y(12) 1 bh],'',3,'');
p=p+1;[ui{p,1:8}] = deal('Path:','text',[1 1 1],[x(2)-bw/9 y(12)+eo bw/2 eh],'',3,'','-l');
p=p+1;[ui{p,1:7}] = deal(locset.path_jcamp,'edit',[1 1 1],[x(2)+bw/3 y(12)+eo bw*4 eh],'qq_lib_jcampimport(1)',2,'PathEdit');
p=p+1;[ui{p,1:8}] = deal('Ext:','text',[1 1 1],[x(1) y(12)+eo bw/3 eh],'',3,'','-l');
p=p+1;[ui{p,1:8}] = deal('*.dx','edit',[1 1 1],[x(1)+bw/3 y(12)+eo bw*0.4 eh],'qq_lib_jcampimport(1)',2,'FileExtEdit','-c'); % Sjekk Call
p=p+1;[ui{p,1:7}] = deal('test','popupmenu',[1 1 1],[x(7)+bw/2 y(12)+eo bw*2.5 eh],'qq_lib_jcampimport(9)',2,'SavelistPop');

% FilesList
p=p+1;[ui{p,1:7}] = deal('Searching...','listbox',[1 1 1],[x(2)+bw/3 y(20) bw*4 y(13)-y(20)+bh],'qq_lib_jcampimport(2.5)',2,'DirList');
p=p+1;[ui{p,1:7}] = deal('Save as:','Text',colors.bc,[x(7)-bw/3 y(13) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Save New','Pushbutton',colors.btn{1},[x(6)+bw/3+bw*1/4 y(15) bw*3/4 bh],'qq_lib_jcampimport(12)',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(7)+bw/2 y(13) bw*2.5 eh],'',2,'SaveFileEdit');
p=p+1;[ui{p,1:7}] = deal('Libraries:','Text',colors.bc,[x(7)-bw/3 y(14) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','listbox',[1 1 1],[x(7)+bw/2 y(16) bw*2.5 y(14)-y(16)+bh],'',2,'LibrariesList');
p=p+1;[ui{p,1:7}] = deal('File contents:','Text',colors.bc,[x(7)-bw/3 y(17) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','listbox',[1 1 1],[x(7)+bw/2 y(20) bw*2.5 y(17)-y(20)+bh],'qq_lib_jcampimport(10)',2,'ContentsList');
p=p+1;[ui{p,1:7}] = deal('Delete Sel','Pushbutton',colors.reset,[x(6)+bw/3+bw*1/4 y(18) bw*3/4 bh],'qq_lib_jcampimport(11)',2,'');

% Dir up
p=p+1;[ui{p,1:8}] = deal('Dir Up','Pushbutton',colors.bc,[x(1) y(13) bw bh],'qq_lib_jcampimport(6)',2,'','-bm');
% Load
p=p+1;[ui{p,1:8}] = deal('Load','Pushbutton',colors.btn{1},[x(1) y(17) bw bh],'qq_lib_jcampimport(8)',2,'','-bm');
p=p+1;[ui{p,1:7}] = deal('Show spectra','Checkbox',colors.bc,[x(1) y(18) bw bh],'',2,'ShowSpecCheck');


updfcn='';
h0=qq_drawwin(winpar,ui,updfcn);

h=findobj('Tag','DirList'); set(h,'ButtonDownFcn','qq_lib_jcampimport(2)','TooltipString','Right click to change directory') 
h=findobj('Tag','ContentsList'); set(h,'ButtonDownFcn','qq_lib_jcampimport(3)','TooltipString','Right click to Load') 
%h=findobj('Tag','rjust'); set(h,'HorizontalAlignment','right')

drawnow

