function qq_lib_miner(an)
% function qq_addlib

global fileset metset locset
global LIB c_ind n_lib REG SUBLIB %c_lib ind  n_rep % ind=vektor med matchende indexer, c_ind=gjeldende index
%persistent LIB selected

qq_message(2)

%disp('----- ADDLIB -----')
%metset % TEMP

% pner vindu
if an==0; 
    LIB=[]; ind=[]; n_entr=0; c_ind=0; c_lib=0;
    openwin; 
    findlibs
end

% Select Libraries 
if an==1.1; addlib; end
if an==1.2; rmlib; end
if an==1.3; strlib; end
if an==1.4; addall; end
if an>1 & an<2 h=findobj('Tag','ActLibList'); n_lib=length(get(h,'String')); end

% Search/Generate register
if an==2.1 & n_lib>0
    c_lib=1; c_ind=1; n_rep=0;
    h=findobj('Tag','ActLibList');str=get(h,'String');
    for x=1:length(str)
        [TLIB]=openlib(str{x}); nt=length(TLIB);
        if x==1 & nt>0 LIB=TLIB; end
        if x>1 & nt>0 nl=length(LIB); LIB(nl+1:nl+nt)=TLIB(1:nt); end
    end
    for x=1:length(LIB) LIB(x).pos_currentlib=x; end
    REG=findentries(LIB); REG=sortreg(REG); showreg(REG)
    txt=findobj('Tag','SelInfoTxt'); set(txt,'String',' ')
end

% Select entries
if an==3.1
    SUBLIB=[]; ps=REG(1).p_stdev;
    contentslist=findobj('Tag','ContentsList'); 
    val=get(contentslist,'Value');
    for x=1:length(val)
        cmp_code=REG(val(x)).cmp_code;
        TLIB=listentries(LIB,cmp_code,ps); nt=length(TLIB);
        if x==1 & nt>0 SUBLIB=TLIB; end
        if x>1 & nt>0 nl=length(SUBLIB); SUBLIB(nl+1:nl+nt)=TLIB(1:nt); end
    end
    showsublib(SUBLIB);   
    txt=findobj('Tag','SelInfoTxt'); set(txt,'String',' ')
end

% Select compound
if an==4.1
    %disp('--- Selected compound ----')
    h=findobj('Tag','DetailsList'); val=get(h,'Value');
    str{1}=['Code: ' SUBLIB(val).cmp_code];
    str{2}=['Short: ' SUBLIB(val).cmp_shortname];
    str{3}=['Name: ' SUBLIB(val).cmp_name];
    str{4}=['Library: ' SUBLIB(val).libname '  ' 'Entry: ' num2str(SUBLIB(val).pos_origlib)];
    str{6}=['Filename: ' SUBLIB(val).file_name];
    str{7}=['Rt: ' num2str(SUBLIB(val).rt) '  ' 'RI: ' num2str(SUBLIB(val).ri_calc)];
    str{9}=['Source/comments: ' SUBLIB(val).comments];
    txt=findobj('Tag','SelInfoTxt'); set(txt,'String',str)
end

% Delete Entry
if an==5.1
    %disp('---- Delete Entry ----')
    h=findobj('Tag','DetailsList'); val=get(h,'Value');
    delentry=SUBLIB(val).pos_currentlib;
    LIB(delentry)=[];
    for x=1:length(LIB) LIB(x).pos_currentlib=x; end
    REG=findentries(LIB); REG=sortreg(REG); showreg(REG)
    txt=findobj('Tag','SelInfoTxt'); set(txt,'String',' ')
    qq_lib_miner(3.1)
end
if an==5.2
    disp('---- Delete Group ----')
end
if an==5.3
    %disp('---- Showspectra ----')
    for x=1:length(SUBLIB)
        spec(x).ions=SUBLIB(x).ions;
        spec(x).S=SUBLIB(x).S;
        spec(x).name=SUBLIB(x).file_name;
    end
    qq_spectra(1,spec);
end

% RI-Maps
if an==6.1
    h=findobj('Tag','SortCheck'); set(h,'Value',1);
    REG=sortreg(REG); showreg(REG); SUBLIB=[]; showsublib(SUBLIB);
    qq_ri_maps(0)
end

% Sort
if an==7.1
    REG=sortreg(REG); showreg(REG);
    SUBLIB=[]; showsublib(SUBLIB);
end


% ----------- UPDATE ----------
%c_ind
%ind
%if c_ind>0 & length(ind)>0 & c_ind<=length(ind)
%    EntrInfo(LIB(ind(c_ind)),c_ind,ind);
%end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                            S U B F U N C T I O N S
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% ------------------- SORTREG ---------------------
function REG=sortreg(REG)

h=findobj('Tag','SortCheck'); val=get(h,'Value');
if val==1
    [d,ind]=sort(cat(1,REG(:).meanri)); 
    REG=REG(ind);
else
    [d,ind]=sortrows(strvcat(REG.cmp_code));
    REG=REG(ind);
end

% ------------------- POOLED STDEV ---------------------
function ps=pstdev(REG)
ps=[];

stdev=cat(1,REG(:).stdev);
n_entr=cat(1,REG(:).n_entr);

NaNs=find(isnan(stdev));
stdev(NaNs)=[]; 
n_entr(NaNs)=[];
num=sum((n_entr-1).*(stdev.^2));
denum=sum(n_entr)-length(n_entr);
ps=(num/denum)^0.5;

% ------------------- LISTENTRIES ---------------------
function SUBLIB=listentries(LIB,cmp_code,ps)
p=0;
for x=1:length(LIB)
    if strcmp(cmp_code,LIB(x).cmp_code);
        p=p+1; SUBLIB(p)=LIB(x);
    end
end

%Test for outliers
h=findobj('Tag','TreshEdit'); val=str2double(get(h,'String'))
if isnan(val) val=2.57; set(h,'String','2.57'); end
ri=cat(1,SUBLIB(:).ri_calc); meanri=mean(ri); 
[SUBLIB(:).outlier]=deal(0);
for x=1:length(SUBLIB)
    if abs(SUBLIB(x).ri_calc-meanri)>val*ps SUBLIB(x).outlier=1; end
end


% ------------------- SHOWSUBLIB ---------------------
function showsublib(SUBLIB)
list=findobj('Tag','DetailsList');
str='';
for x=1:length(SUBLIB)
    numstr=num2str(x); numstr=[numstr blanks(5-length(numstr))]; 
    codestr=SUBLIB(x).cmp_code; codestr=[codestr blanks(10-length(codestr))]; 
    filestr=num2str(SUBLIB(x).file_name); filestr=[filestr blanks(20-length(filestr))]; 
    libstr=num2str(SUBLIB(x).libname); libstr=[libstr blanks(20-length(libstr))]; 
    if SUBLIB(x).outlier==1 outlier='*'; else outlier=' '; end 
    ri=SUBLIB(x).ri_calc;  
    ristr=num2str(ri,'%05.4f'); ristr=[ristr blanks(10-length(ristr))];
    str{x}=[numstr(1:5) codestr(1:7) ' ' outlier ' ' filestr(1:16) ' '  libstr(1:10) ' '  ristr(1:8)];   
end

set(list,'String',str); set(list,'Value',1); qq_copylist(0,list)


% ------------------- SHOWREG ---------------------
function showreg(REG)

clist=findobj('Tag','ContentsList');

for x=1:length(REG)
    numstr=num2str(x); numstr=[numstr blanks(5-length(numstr))]; 
    codestr=REG(x).cmp_code; codestr=[codestr blanks(8-length(codestr))]; 
    nstr=num2str(REG(x).n_entr); nstr=[nstr blanks(10-length(nstr))]; 
    shortstr=num2str(REG(x).cmp_shortname); shortstr=[shortstr blanks(20-length(shortstr))]; 
    ristr=num2str(REG(x).meanri,'%05.4f'); ristr=[ristr blanks(10-length(ristr))];
    stdevstr=''; if isnan(REG(x).stdev)==0  stdevstr=num2str(REG(x).stdev,'%05.4f'); end
    stdevstr=[stdevstr blanks(10-length(stdevstr))];    
    if REG(x).outliers==1 outl='*'; else outl=' '; end
    str{x}=[numstr(1:5) codestr(1:7) ' ' outl ' ' nstr(1:4) ' ' shortstr(1:17) ' ' ristr(1:8) ' ' stdevstr(1:6)];   
end

set(clist,'String',str); qq_copylist(0,clist)
if get(clist,'Value')>length(REG) set(clist,'Value',length(REG)); end


% ------------------- FINDENTRIES ---------------------
function Register=findentries(Library)
%disp('---- findentries ----')

Library % TEMP

% Lager tomt register
Register(1).cmp_code=[];
Register(1).ri_calc=[];
Register(1).ri_def=[];
Register(1).n_entr=0;
Register(1).cmp_shortname=[];
Register(1).cmp_name=[];
n_reg=1;

% Sjekker innhold mot register
for i2=1:length(Library)   
    found=0;
    for i3=1:n_reg
        if strcmp(Register(i3).cmp_code,Library(i2).cmp_code);
            Register(i3).n_entr=Register(i3).n_entr+1; found=1;
            Register(i3).ri_calc=[Register(i3).ri_calc Library(i2).ri_calc]; 
        end
    end
    
    if found==0; n_reg=n_reg+1;
        Register(n_reg).cmp_code=Library(i2).cmp_code;
        Register(n_reg).cmp_shortname=Library(i2).cmp_shortname;
        Register(n_reg).cmp_name=Library(i2).cmp_name;
        Register(n_reg).n_entr=1;
        Register(n_reg).reg_entry=(n_reg-1);
        Register(n_reg).ri_calc=Library(i2).ri_calc;
        Register(n_reg).ri_def=Library(i2).ri_def;
    end
end

Register(1)=[]; n_reg=n_reg-1;
% Beregner standardavvik
for x=1:n_reg
    Register(x).meanri=mean(Register(x).ri_calc);
    Register(x).stdev=NaN; 
    if length(Register(x).ri_calc)>1 Register(x).stdev=sqrt(sum((Register(x).ri_calc-Register(x).meanri).^2)/(length(Register(x).ri_calc)-1)); end
end
% Pooled
ps=pstdev(Register);
[Register(:).p_stdev]=deal(ps);

% Test for outliers
h=findobj('Tag','TreshEdit'); val=str2double(get(h,'String'))
if isnan(val) val=2.57; set(h,'String','2.57'); end
[Register(:).outliers]=deal(0);
for x=1:length(Register)
    residuals=abs(Register(x).ri_calc-Register(x).meanri);
    if max(residuals)>val*ps Register(x).outliers=1; end
end
    
% SORTERER ETTER KODE
[b,index]=sortrows(strvcat(Register.cmp_code)); 
Register(:)=Register(index);   

% Info
str{1}=['Number of compounds: ' num2str(length(Register))];
str{2}=['Number of libr. entries: ' num2str(length(Library))];
str{3}=['Pooled RI std.dev.: ' num2str(ps)];
h=findobj('Tag','GenInfoTxt'); set(h,'String',str);
    


% ------------------- FINDLIBS ---------------------
function findlibs
global metset locset

filename=[locset.path_library,'\class_',metset.global_class,'\lib_*'];
D=dir([filename,'.mat']);
DD=struct2cell(D);
[m,n_libs]=size(DD);

for x=1:n_libs LibNames{x}=DD{1,x}(5:length(DD{1,x})-4); end
h=findobj('Tag','AvaLibList'); set(h,'String',LibNames);


% ------------------- ADDLIB ---------------------
function addlib

h=findobj('Tag','AvaLibList'); AvaStr=get(h,'String'); AvaPos=get(h,'Value'); nAva=length(AvaStr);
SelLib=AvaStr{AvaPos};
if AvaPos<nAva; set(h,'Value',AvaPos+1); end

h=findobj('Tag','ActLibList'); ActStr=get(h,'String'); nAct=length(ActStr); strm=strmatch(SelLib,ActStr,'exact');
if isempty(strm) ActStr{nAct+1}=SelLib; set(h,'String',ActStr,'Value',nAct+1); end


% ------------------- ADDALL ---------------------
function addall

h=findobj('Tag','AvaLibList'); AvaStr=get(h,'String');
h=findobj('Tag','ActLibList'); set(h,'String',AvaStr);


% ------------------- RMLIB ---------------------
function rmlib

h=findobj('Tag','ActLibList'); ActStr=get(h,'String'); 
ActPos=get(h,'Value'); nAct=length(ActStr);
if nAct>0 
    ActStr(ActPos)=[]; nAct=nAct-1; 
    if ActPos>nAct; set(h,'Value',nAct); end 
    set(h,'String',ActStr); 
end


% ------------------- STRLIB ---------------------
function strlib

h=findobj('Tag','LibStrEdit'); LibStr=get(h,'String');
if isempty(LibStr)
    qq_message(1,'|r|No String')
else
    h=findobj('Tag','AvaLibList'); AvaStr=get(h,'String');
    matchpos=strmatch(LibStr,AvaStr);
    ActStr=AvaStr(matchpos);
    h=findobj('Tag','ActLibList');
    if isempty(ActStr)==0 set(h,'String',ActStr,'Value',1); else qq_message(1,'|r|No Match'); end
end


% ------------------- OPENLIB ---------------------
function [LIB]=openlib(libname)
global metset locset

filename=[locset.path_library,'\class_',metset.global_class,'\LIB_',libname,'.mat'];
load(filename,'Library');
LIB=Library;

[LIB.libname]=deal(libname);
for x=1:length(LIB) LIB(x).pos_origlib=x; end



%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset fileset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;

x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='LibMinerWin'; winpar{2}='Q:Lib.Miner';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0;
% RESET/CLOSE/ACCEPT
%p=p+1;[ui{p,1:7}] = deal('Discard','Pushbutton',colors.reset,[x(1) y(20) bw bh*1.5],'qq_addlib(8)',3,'');
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_closewin',3,'');
%p=p+1;[ui{p,1:7}] = deal('Accept','Pushbutton',colors.accept,[x(2) y(20) bw bh*1.5],'qq_addlib(0)',3,'');


% FRAME
oo=1; fh=10; ho=0*bw;
p=p+1;[ui{p,1:7}] = deal('','Frame',colors.bc,[x(1)+ho-bw/3 y(oo+fh) bw*5 y(1)-y(fh+2)],'',3,'');
p=p+1;[ui{p,1:7}] = deal('Libraries:','Text',colors.bc,[x(1)+ho y(oo) bw*3 bh],'',4,'');
p=p+1;[ui{p,1:7}] = deal('Searchstr:','Text',colors.bc,[x(2)+ho+bw*0.6 y(oo) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(3)+ho+bw/2 y(oo) bw*2 eh],'',2,'LibStrEdit');
p=p+1;[ui{p,1:7}] = deal('','Listbox',[1 1 1],[x(1)+ho y(oo+9) bw*2 gh*8.6],'',2,'AvaLibList');
p=p+1;[ui{p,1:7}] = deal('','Listbox',[1 1 1],[x(3)+ho+bw/2 y(oo+9) bw*2 gh*8.6],'',2,'ActLibList');
p=p+1;[ui{p,1:7}] = deal('Add ->','Pushbutton',colors.accept,[x(1)+ho+bw*2 y(oo+3) bw/2 bh*1],'qq_lib_miner(1.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Del <-','Pushbutton',colors.reset,[x(1)+ho+bw*2 y(oo+4) bw/2 bh*1],'qq_lib_miner(1.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('String','Pushbutton',colors.accept,[x(1)+ho+bw*2 y(oo+5) bw/2 bh*1],'qq_lib_miner(1.3)',2,'');
p=p+1;[ui{p,1:7}] = deal('All','Pushbutton',colors.accept,[x(1)+ho+bw*2 y(oo+6) bw/2 bh*1],'qq_lib_miner(1.4)',2,'');

% LIBRARY CONTENTS
oo=1; fh=19; ho=5.5*bw; 
p=p+1;[ui{p,1:7}] = deal('','Frame',colors.bc,[x(1)+ho-bw/3 y(oo+fh) bw*4 y(1)-y(fh+2)],'',3,'');
p=p+1;[ui{p,1:7}] = deal('Contents:','Text',colors.bc,[x(1)+ho y(oo) bw*3 bh],'',4,'');
p=p+1;[ui{p,1:7}] = deal('','Listbox',[1 1 1],[x(1)+ho y(oo+12) bw*3.5 gh*11.6],'qq_lib_miner(3.1)',2,'ContentsList');
p=p+1;[ui{p,1:7}] = deal('','Listbox',[1 1 1],[x(1)+ho y(oo+18) bw*3.5 gh*5.6],'qq_lib_miner(4.1)',2,'DetailsList');
p=p+1;[ui{p,1:7}] = deal('Del. Entry','Pushbutton',colors.reset,[x(1)+ho y(20) bw bh],'qq_lib_miner(5.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Del. Group','Pushbutton',colors.reset,[x(2)+ho y(20) bw bh],'qq_lib_miner(5.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('Show Spectra','Pushbutton',colors.btn{5},[x(3)+ho y(20) bw bh],'qq_lib_miner(5.3)',2,'');
p=p+1;[ui{p,1:7}] = deal('Sort by RI','Checkbox',colors.bc,[x(3)+ho+bw/2 y(oo) bw bh],'qq_lib_miner(7.1)',2,'SortCheck');

%Info-frame
oo=13; fh=7; ho=1.5*bw;
p=p+1;[ui{p,1:7}] = deal('','Frame',colors.bc,[x(1)+ho-bw/3 y(oo+fh) bw*3.5 y(1)-y(fh+2)],'',3,'');
p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[x(1)+ho y(oo+1)-gh*0.5 bw*3 gh*2.1],'',2,'GenInfoTxt');
p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[x(1)+ho y(oo+6)-gh*0.9 bw*3 gh*5.4],'',2,'SelInfoTxt');

% Actions
p=p+1;[ui{p,1:7}] = deal('Read and Calc','Pushbutton',colors.accept,[x(1) y(13) bw bh],'qq_lib_miner(2.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Outl tresh','Text',colors.bc,[x(1) y(14) bw*2/3 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('2.57','Edit',[1 1 1],[x(1)+bw*2/3 y(14) bw/3 eh],'',2,'TreshEdit');
p=p+1;[ui{p,1:7}] = deal('RI Maps','Pushbutton',colors.btn{1},[x(1) y(16) bw bh],'qq_lib_miner(6.1)',2,'');


%p=p+1;[ui{p,1:7}] = deal('Srch/Repl','Pushbutton',colors.accept,[x(2) y(vp) bw bh],'qq_lib_miner(2.2)',2,'');
%p=p+1;[ui{p,1:7}] = deal('Repl. Entr.','Pushbutton',colors.accept,[x(1)+ho y(vp+1) bw bh],'qq_lib_miner(3.1)',2,'');
%p=p+1;[ui{p,1:7}] = deal('Repl All','Pushbutton',colors.accept,[x(2)+ho y(vp+1) bw bh],'qq_lib_miner(3.2)',2,'');
%p=p+1;[ui{p,1:7}] = deal('Skip Entr.','Pushbutton',colors.reset,[x(3)+ho y(vp+1) bw bh],'qq_lib_miner(3.9)',2,'');
%p=p+1;[ui{p,1:7}] = deal('Skip Libr.','Pushbutton',colors.reset,[x(3) y(vp) bw bh],'qq_lib_miner(3.3)',2,'');


updfcn='';
h0=qq_drawwin(winpar,ui,updfcn); 

contentslist=findobj('Tag','ContentsList'); set(contentslist,'Max',2); 

drawnow






