function qq_libmanager(an)

global metset locset
global all_libs n_all Library n_entries % GJR PERSISTENT

qq_message(2);

if an==0   
    openwin;
    [all_libs,n_all]=getall;
    h=findobj('Tag','LibsList');
    set(h,'String',all_libs)
end

if an==2
    h=findobj('Tag','LibsList');
    val=get(h,'Value');
    h=findobj('Tag','LibraryEdit2');
    metset.library_name=all_libs{val};
    set(h,'String',metset.library_name)
end

% EXPORT
if an==3.1
    [n_entries,Library]=getlib;
    matlabexport(Library,n_entries) 
end
if an==3.2
    [n_entries,Library]=getlib;
    asciiexport(Library,n_entries) 
end
if an==3.3
    [n_entries,Library]=getlib;
    jcampexport(Library,n_entries) 
end

% RadioButtons
if an==3.5
    h=findobj('Tag','SampleNameRadio');
    set(h,'Value',0);
    set(gcbo,'Value',1);
end

if an==100
    updwindow
end

    
%--------------------------------------------------------------------------
%--------                  SUBFUNCTIONS
%--------------------------------------------------------------------------

%--------------------------MATLABEXPORT------------------------------------
function matlabexport(Library,n_entries)

global metset fonts locset

tic; qq_message(1,['|b|Achieving raw data']);
[X,allions]=prepmatrix(Library,n_entries);
qq_message(1,['|b|Achieving molecular descr']);

h=findobj('Tag','SampleNameRadio');
nameval=get(h,'Value');
h=findobj('Tag','IncludeCheck');
includeval=get(h,'Value');

h=findobj('Tag','SampleNameRadio'); nameval=get(h,'Value');le=length(metset.mdescr);incl=[];
for x=1:le
    h=findobj('Tag',['mdescr_' metset.mdescr(x).varname]);
    if get(h,'Value')==1; incl=[incl x]; end
end

% Variables
str1=[]; str=[]; leincl=length(incl);
for x=1:leincl
    str{x}=metset.mdescr(incl(x)).text;
    varname{x}=metset.mdescr(incl(x)).varname;
end
if isempty(str)==0; str=strvcat(str{:}); end
Variables=num2str(allions'); if isempty(Variables)==0 Variables=strvcat(str,Variables); end

% Objects    
if nameval{1}==1 Objects=strvcat(Library.cmp_code); end
if nameval{2}==1 Objects=strvcat(Library.cmp_shortname); end

nlib=length(Library); XM=[];
for x=1:nlib
    for y=1:leincl
        t=Library(x).mdescr.(varname{y}); if isnumeric(t)==0; t=NaN; end
        XM(x,y)=t;
    end
end

if isempty(XM)==0 X=cat(2,XM,X); end

qq_message(1,['|b|Saving']);
%save([locset.path_library,'\LIB_MAT_EXP.mat'],'X','Variables','Objects');
qq_savefile([locset.path_library,'\LIB_MAT_EXP.mat'],X,Variables,Objects,'-o');
mins=floor(toc/60); remsec=(toc-mins*60); qq_message(1,['|b|Elapsed: ' num2str(mins) ':' num2str(round(remsec))]) 

mess{1}=['Data saved in: ',locset.path_export,'\LIB_MAT_EXP.mat'] ;
mess{2}=['Data in "X".'];
mess{3}=['Variables in "Variables" (Vertical string array).'];
mess{4}=['Spectra names in "Objects" (Vertical String array).'];
MessageTxt=findobj('Tag','LibmanMessage');
set(MessageTxt,'FontSize',fonts(2),'String',mess);


%---------------------------ASCIIEXPORT------------------------------------
function asciiexport(Library,n_entries)

global metset fonts locset

h=findobj('Tag','SampleNameRadio'); nameval=get(h,'Value');le=length(metset.mdescr);incl=[];
for x=1:le
    h=findobj('Tag',['mdescr_' metset.mdescr(x).varname]);
    if get(h,'Value')==1; incl=[incl x]; end
end

qq_message(1,['|b|Preparing file']); tic;
[X,allions]=prepmatrix(Library,n_entries);

fh=fopen([locset.path_export '\' metset.path_export '\LIB_ASC_EXP.txt'],'w');

% Variabler: Mol_descr
str1=[]; leincl=length(incl);
for x=1:leincl
    txt=['"' metset.mdescr(incl(x)).text '",'];
    str1=[str1,txt]; 
    varname{x}=metset.mdescr(incl(x)).varname;
end

% Variabler: Ions
n_ions=length(allions);
for x=1:n_ions
    str1=[str1,'"',num2str(allions(x)),'"'];
    if x<n_ions str1=[str1,',']; else str1=[str1,'\n']; end
end
fprintf(fh,str1);

% Data
for x=1:n_entries 
    qq_message(1,['|b|Exporting ' num2str(x)]);
    if nameval{1}==1; str1=(['"',Library(x).cmp_code,'"']); end
    if nameval{2}==1; str1=(['"',Library(x).cmp_shortname,'"']); end
    
    % Molecular descriptors
    for y=1:leincl
        val=Library(x).mdescr.(varname{y}); 
        if isnumeric(val) val=num2str(val); end
        str1=[str1 ',' val]; 
    end
    
    % Spektra
    for x2=1:n_ions
        if isnan(X(x,x2)) str1=[str1,',m']; else str1=[str1,',',num2str(X(x,x2))]; end
        if x2==n_ions str1=[str1,'\n']; end
    end
    fprintf(fh,str1);
end

fclose(fh);

mess{1}=['Data saved as: ',locset.path_export,'\',metset.path_export,'\LIB_ASC_EXP.txt'];
mess{2}='Import using ASCII-import (Wide block)';
mess{3}='First row: column names, First column: row names';
mess{4}='Name qualifier: double quote. Item delimitters: comma';
MessageTxt=findobj('Tag','LibmanMessage');
set(MessageTxt,'FontSize',fonts(2),'String',mess);

% OPEN FILE
qq_message(6,[locset.path_export,'\',metset.path_exporth,'\LIB_ASC_EXP.txt'])

mins=floor(toc/60); remsec=(toc-mins*60); qq_message(1,['|b|Elapsed: ' num2str(mins) ':' num2str(round(remsec))]) 


%---------------------------JCAMPREAD (TEMP)------------------------------------
function jcampread(Library,n_entries)
global metset locset
% TEMP %TEMP %TEMP

openstr=[locset.path_export,'\',metset.path_export,'\LIB_JCAMP_EXP.dx']
fh=fopen(openstr,'r')
a=fread(fh,60);
b=char(a);
c=num2str(a);
[b,blanks(length(c))',c]
fclose(fh);


%---------------------------JCAMPEXPORT------------------------------------
function jcampexport(Library,n_entries)
global metset fonts locset
%disp('---- JCAMP EXPORT ----')

cr='\r\n'; % Carriage return 

h=findobj('Tag','SampleNameRadio'); nameval=get(h,'Value');le=length(metset.mdescr);incl=[];
for x=1:le
    h=findobj('Tag',['mdescr_' metset.mdescr(x).varname]);
    if get(h,'Value')==1; incl=[incl x]; end
end

qq_message(1,['|b|Preparing file']); tic;
[X,allions]=prepmatrix(Library,n_entries);

fh=fopen([locset.path_export,'\',metset.path_export,'\JCAMP_' metset.library_name '.dx'],'w');

% Data
%Library
%metset
for x=1:n_entries 
    qq_message(1,['|b|Exporting ' num2str(x)]);
    mw=9999; molform='';
    
    xdat=Library(x).ions;
    ydat=Library(x).S;
    npoints=length(xdat);
    descr=[ 'Datafile: ' Library(x).file_name ' / ' ...
            'Rt: ' num2str(Library(x).rt) ' / '...
            'Column: ' Library(x).column ' / '...
            'Notes: ' Library(x).comments ' / '...
            'Exp.Libr: ' metset.library_name ' / '...
            'Class: ' metset.global_class ' / '...
            'Single/Extr: ' Library(x).single];
    
    %Class Alkylphenols
    if strcmp(metset.global_class,'Phenols')
        nC=13; nO=2; nH=5; nF=5; % HI-derivater, Usubst. Fenol
        %nC=6; nO=1; nH=6; nF=0; % Fenol Fri
        if isnan(Library(x).mdescr.tsubst)==0;
            nC=nC+Library(x).mdescr.tsubst;
            nH=nH+Library(x).mdescr.tsubst*2;
            molform=['C' num2str(nC) 'O' num2str(nO) 'H' num2str(nH)];
            if nF>0 molform=[molform 'F' num2str(nF)]; end
            mw=nC*12.01+nO*16.00+nH*1.01+nF*19.00;
        end       
    end
    
    % Class FAME
    %metset.global_class
    if strcmp(metset.global_class,'FAME') | strcmp(metset.global_class,'NEWFAME')  
        if strcmp(Library(x).mdescr.mtype,'Normal') & sum(isnan([Library(x).mdescr.n_carb Library(x).mdescr.n_dbb]))==0
            nC=Library(x).mdescr.n_carb+1; nO=2; nH=(nC*2)-(Library(x).mdescr.n_dbb*2); 
            mw=nC*12.01+nO*16.00+nH*1.01; 
            molform=['C' num2str(nC) 'O' num2str(nO) 'H' num2str(nH)];            
        end
    end
    
    fprintf(fh,['##TITLE=Library Entry ' num2str(x) ' in ' metset.library_name cr]);
    fprintf(fh,['##JCAMPDX=Revision 4.10' cr]);
    fprintf(fh,['##DATA TYPE=MASS SPECTRUM' cr]);
    fprintf(fh,['##SAMPLE DESCRIPTION= ' descr cr]);
    fprintf(fh,['##NAMES=' Library(x).cmp_code cr]);
    fprintf(fh,['##CAS NAME=' Library(x).cmp_shortname ' $$ ' Library(x).cmp_name ' $$ ' Library(x).cmp_code cr]);
    fprintf(fh,['##MOLFORM=' molform cr]);
    fprintf(fh,['##CAS REGISTRY NO=000000-00-0' cr]);
    fprintf(fh,['##MP=' cr]);
    fprintf(fh,['##BP=' cr]);
    fprintf(fh,['##MW= ' num2str(mw) cr]);
    fprintf(fh,['##$RETENTION INDEX=' num2str(Library(x).ri_calc) cr]);
    fprintf(fh,['##$CONDENSED SPECTRUM=NO' cr]);
    fprintf(fh,['##NPOINTS= ' num2str(npoints) cr]);
    fprintf(fh,['##XYDATA=(XY..XY)' cr]);
    for x=1:npoints; fprintf(fh,['    ' num2str(xdat(x)) '    ' num2str(ydat(x)) cr]); end
    
end

fclose(fh);
mess{1}='Library exported to:';
mess{2}=[locset.path_export,'\',metset.path_export,'\JCAMP_' metset.library_name '.dx'];
mess{3}='Import into Chemstation using Parametric Retrieval - Read JCAMP';
MessageTxt=findobj('Tag','LibmanMessage');
set(MessageTxt,'FontSize',fonts(2),'String',mess);

% OPEN FILE
qq_message(6,[locset.path_export,'\',metset.path_export,'\JCAMP_' metset.library_name '.dx'])

mins=floor(toc/60); remsec=(toc-mins*60); qq_message(1,['|b|Elapsed: ' num2str(mins) ':' num2str(round(remsec))]) 

%jcampread

% --------- SUBFUNCTION: GETALL ------------------------------------------
function [all_libs,n_all]=getall
global metset locset
% Henter filnavn
filename=[locset.path_library,'\class_',metset.global_class,'\lib_*'];
D=dir([filename,'.mat']);
DD=struct2cell(D);
[m,n_all]=size(DD);
for x=1:n_all
    all_libs(x)=DD(1,x);
    all_libs{x}(1:4)=[];
    ind=findstr(all_libs{x},'.mat');
    all_libs{x}(ind:ind+3)=[];
end
LibsList=findobj('Tag','LibsList');
set(LibsList,'String',all_libs)

% --------- SUBFUNCTION: PREPMATRIX ------------------------------------------

function [valmat,allions]=prepmatrix(Library,n_entries)

allions=[];
for i1=1:n_entries
    a=length(Library(i1).ions);
    for i2=1:a
        b=find(Library(i1).ions(i2)==allions); 
        if isempty(b) 
            allions=[allions Library(i1).ions(i2)]; 
        end
    end
end
allions=sort(allions);

n=length(allions);
valmat=repmat(NaN,n_entries,n);
for i1=1:n_entries
    for i2=1:n
        a=find(allions(i2)==Library(i1).ions);
        if isempty(a)==0 valmat(i1,i2)=Library(i1).S(a); end
    end
end


% ------------------ FUNCTION: GETLIB -----------------------------
function [n_entries,Library]=getlib

global metset locset

filename=[locset.path_library,'\class_',metset.global_class,'\lib_',metset.library_name];

load(filename,'Library');
d=struct2cell(Library);
[m,n_entries]=size(d);


% ------------------ FUNCTION: UPDWINDOW -----------------------------
function updwindow
global metset colors

% Finner parametre
h0=findobj('Tag','LibmanagerWin'); % Vindu
ht=findobj('Tag','IncTxt'); % Overskrift
opos=get(ht,'Position'); % Posisjon p overskrift
fonts=get(ht,'FontSize');
vd=opos(4); % Vertikal diff=eh
hdel=findobj('UserData','MD_Check'); 
delete(hdel); % sletter gamle 

% Nye checkbokser
[m,ndescr]=size(metset.mdescr);
for ii=1:ndescr
    tag_str=['mdescr_' metset.mdescr(ii).varname];
    txt_str=metset.mdescr(ii).text;
    pos=opos-[0 vd*ii 0 0];
    
    h1 = uicontrol('Parent',h0, ...
           'String',txt_str, ...   
           'Style','Checkbox', ...
	       'BackgroundColor',colors.bc, ...
           'Position',pos, ...	
           'FontSize',fonts, ...
           'Tag',tag_str,...
           'UserData','MD_Check');
end

%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset locset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;

x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='LibmanagerWin'; winpar{2}='Q: Libr. Manager';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0;
% RESET/CLOSE/ACCEPT
%p=p+1;[ui{p,1:7}] = deal('Discard','Pushbutton',colors.reset,[x(1) y(20) bw bh*1.5],'',3,'');
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_closewin',3,'');
p=p+1;[ui{p,1:7}] = deal('Transformlibs','Pushbutton',colors.reset,[x(9) y(20) bw bh],'qq_transformlibs',2,'Transformlibsbutton');
%p=p+1;[ui{p,1:7}] = deal('Accept','Pushbutton',colors.accept,[x(2) y(20) bw bh*1.5],'',3,'');
% --------- FRAME-1 --------- 
yp=14; fw=bw*2.9;
p=p+1;[ui{p,1:7}] = deal('','Frame',colors.bc,[x(1)-bw/5 y(yp)+bh*0.7 fw y(1)-y(yp)+eh/2],'',3,'');
p=p+1;[ui{p,1:7}] = deal('Functions','Text',colors.bc,[x(1) y(1)-bh*0.2 bw*2 bh],'',4,'');
% Functions
p=p+1;[ui{p,1:7}] = deal('Move Spectra','Pushbutton',colors.btn{3},[x(1) y(2) bw*1.5 bh],'qq_libmover(0)',2,'');
p=p+1;[ui{p,1:7}] = deal('Sublibrary','Pushbutton',colors.btn{3},[x(1) y(3) bw*1.5 bh],'qq_libsub(0)',2,'');
p=p+1;[ui{p,1:7}] = deal('Searchparameters','Pushbutton',colors.btn{3},[x(1) y(4) bw*1.5 bh],'qq_libset(1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Edit Libr.','Pushbutton',colors.btn{3},[x(1) y(5) bw*1.5 bh],'qq_editlib(1)',2,'');
%p=p+1;[ui{p,1:7}] = deal('Regression','Pushbutton',colors.btn{3},[x(1) y(6) bw*1.5 bh],'qq_libreg(0)',2,'');
p=p+1;[ui{p,1:7}] = deal('Replace','Pushbutton',colors.btn{3},[x(1) y(7) bw*1.5 bh],'qq_lib_replace(0)',2,'');
p=p+1;[ui{p,1:7}] = deal('Miner','Pushbutton',colors.btn{3},[x(1) y(8) bw*1.5 bh],'qq_lib_miner(0)',2,'');
p=p+1;[ui{p,1:7}] = deal('JCAMP import','Pushbutton',colors.btn{3},[x(1) y(10) bw*1.5 bh],'qq_lib_jcampimport(0)',2,'');
% --------- FRAME-2 --------- 
o=0.3;
p=p+1;[ui{p,1:7}] = deal('','Frame',colors.bc,[x(1)-bw/5+o y(yp)+bh*0.7 fw y(1)-y(yp)+eh/2],'',3,'');
p=p+1;[ui{p,1:7}] = deal('Select libr.','Text',colors.bc,[x(1)+o y(1)-bh*0.2 bw*2 bh],'',4,'');
% Liblist
p=p+1;[ui{p,1:7}] = deal('','Listbox',[1 1 1],[x(1)+o y(10)-bh*0.2 bw*2 y(1)-y(10)],'qq_libmanager(2)',2,'LibsList');
p=p+1;[ui{p,1:7}] = deal('Selected (Edit Libr)','Text',colors.bc,[x(1)+o y(11) bw*2 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(metset.library_name,'Edit',[1 1 1],[x(1)+o y(12) bw*2 bh],'',2,'LibraryEdit2');
% --------- FRAME-3 ----------
o=0.6;
p=p+1;[ui{p,1:7}] = deal('','Frame',colors.bc,[x(1)-bw/5+o y(yp)+bh*0.7 fw y(1)-y(yp)+eh/2],'',3,'');
p=p+1;[ui{p,1:7}] = deal('Export','Text',colors.bc,[x(1)+o y(1)-bh*0.2 bw*2 bh],'',4,'');
% Export
p=p+1;[ui{p,1:7}] = deal('Matlab Exp.','Pushbutton',colors.btn{3},[x(1)+o y(2) bw*1.5 bh],'qq_libmanager(3.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('ASCII Exp.','Pushbutton',colors.btn{3},[x(1)+o y(3) bw*1.5 bh],'qq_libmanager(3.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('JCAMP Exp.','Pushbutton',colors.btn{3},[x(1)+o y(4) bw*1.5 bh],'qq_libmanager(3.3)',2,'');

% Names
p=p+1;[ui{p,1:7}] = deal('Sample Names:','Text',colors.bc,[x(1)+o y(5) bw*1.5 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Shortname','Radiobutton',colors.bc,[x(1)+o y(5)-eh bw*1.5 eh],'qq_libmanager(3.5)',2,'SampleNameRadio');
p=p+1;[ui{p,1:7}] = deal('Reg. Code','Radiobutton',colors.bc,[x(1)+o y(5)-2*eh bw*1.5 eh],'qq_libmanager(3.5)',2,'SampleNameRadio');
% Include
p=p+1;[ui{p,1:7}] = deal('Include:','Text',colors.bc,[x(1)+o y(7) bw*1.5 eh],'',2,'IncTxt');

% --------- Infobox --------- 
p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[x(1) y(18) bw*5 bh*4],'',2,'LibmanMessage');

updfcn='qq_libmanager(100)';
h0=qq_drawwin(winpar,ui,updfcn); 
set(h0,'KeyPressFcn','qq_libmanager(96)')

h=findobj('Tag','SampleNameRadio'); h=findobj(h,'String','Shortname'); set(h,'Value',1);
h=findobj('Tag','IncludeCheck'); set(h,'Value',0); 
h=findobj('Tag','LibsList'); set(h,'ButtonDownFcn','qq_libmanager(2)','Value',1);

if locset.tracker==0
    h=findobj(gcf,'Tag','Transformlibsbutton'); set(h,'Enable','off')
end

drawnow
updwindow









