function qq_load_agilent(an)

%persistent %X %llabels %lions %pathinfo %Info
% D = Directory data, 
% X = Loaded data
% llabels / lions = local labels/ions (before accept)

global XR labels ions metset fileset loadset locset

qq_message(2)

if nargin<1
   an=0;
end

if an==0
    openwin
    pathsearch;
    loadset.pathinfo=getfiles;
    loadset.X=[]; loadset.rt=[]; loadset.ions=[];
end

if an==1.1  
    pathsearch;
    loadset.pathinfo=getfiles;
end

% Get Toggles
%if an==2.1
%    toggles=findobj('Tag','GetToggle'); set(toggles,'Value',0); set(gcbo,'Value',1); 
%    if strmatch(get(gcbo,'String'),'All ->'); metset.file_showall=1; else metset.file_showall=0; end
%    loadset.pathinfo=getfiles;
%end

% Callback fra Dirlist
if an==2.3 
    loadset.pathinfo=getfiles;
end

% Load
if an==3.1
    h=findobj('Tag','ContentsList'); val=get(h,'value');
    pathname=[loadset.pathinfo(val).path '\' loadset.pathinfo(val).name '.D\DATA.MS'];
    fid=fopen(pathname,'r');
    [loadset.X,loadset.rt,loadset.ions,loadset.Info]=qq_readms(fid);
    fclose(fid);
    loadset.Info.File_Name=loadset.pathinfo(val).name; loadset.Info.Source='MS Chemstation';
    [loadset.X,loadset.rt,loadset.ions,loadset.Info]=truncate(loadset.X,loadset.rt,loadset.ions,loadset.Info); 
    qq_load_plots(loadset.X,loadset.rt,loadset.ions,loadset.Info,1);
end

% Export
if an==3.2
    h=findobj('Tag','ContentsList'); val=get(h,'value');
    %export(loadset.pathinfo(val),metset.file_exportpath);
    export(loadset.pathinfo(val),[locset.path_qqraw '\' metset.path_qqraw ]);
end
if an==3.3
    %exportall(loadset.pathinfo,metset.file_exportpath);
    exportall(loadset.pathinfo,[locset.path_qqraw '\' metset.path_qqraw ]);
end

% Plots
if an==4.1 & isempty(loadset.X)==0 qq_load_plots(loadset.X,loadset.rt,loadset.ions,loadset.Info,1); end
if an==4.2 & isempty(loadset.X)==0 qq_load_plots(loadset.X,loadset.rt,loadset.ions,loadset.Info,2); end

% ----- ACCEPT ----
if an==97
   dim=size(loadset.X);
   if dim(2)>0   
      initialize(loadset.X,loadset.rt,loadset.ions,loadset.Info)
      clear loadset
      qq_closewin; 
   else
      qq_message(1,'|r|No data'); 
   end
end

% ----- CLOSE ----
if an==99
    clear loadset
    qq_closewin
end


%======================================== SUBFUNCTIONS ========================================

% --------------- TRUNCATE -------------------------------
function [X,llabels,lions,Info]=truncate(X,llabels,lions,Info)
global metset

str=['|b|loaded: ' num2str(length(llabels)) ' scans, ' num2str(length(lions)) ' ions'];

% Remove n lowest ions (max value)
nremoved=0;
maxv=max(X); 
%LowEdit=findobj('Tag','LowEdit');
%nlow=str2double(get(LowEdit,'String'));
nlow=metset.load_dellow;
if nlow>=length(maxv); nlow=length(maxv)-1; end
[dummy,ind]=sort(maxv); delvect=ind(1:nlow); 
X(:,delvect)=[]; lions(delvect)=[]; nremoved=nremoved+length(delvect);

% Remove ions with max below treshold
maxv=max(X);
%TreshEdit=findobj('Tag','TreshEdit');
%tresh=str2double(get(TreshEdit,'String'));
tresh=metset.load_iontresh;
%if isnan(tresh)==1 tresh=0; end
delvect=find(maxv<tresh); 
if length(delvect)==length(maxv); tresh=max(maxv); delvect=find(maxv<tresh); end
X(:,delvect)=[]; lions(delvect)=[]; nremoved=nremoved+length(delvect);

if nremoved>0 str=[str ',  ' num2str(nremoved) ' ions truncated'];  end
qq_message(1,[str,'.']);
    

% -------------- SUBFUNCTION EXPORTALL -------------------
function exportall(pathinfo,exportpath)
global colors

winpar={'M-Win','Batch export',[0.1 0.5 0.8 0.4]};
p=0; p=p+1; [ui{p,1:7}] = deal('','listbox',[1 1 1],[0.05 0.1 0.2 0.7],'',2,'RemList');
p=p+1; [ui{p,1:7}] = deal('Remaining','Text',colors.bc,[0.05 0.8 0.2 0.1],'',2,'');
p=p+1; [ui{p,1:7}] = deal('','listbox',[1 1 1],[0.3 0.1 0.2 0.7],'',2,'ConvList');
p=p+1; [ui{p,1:7}] = deal('Converted','Text',colors.bc,[0.3 0.8 0.2 0.1],'',2,'');
p=p+1; [ui{p,1:7}] = deal('','Text',colors.bc,[0.55 0.4 0.3 0.5],'',3,'ConvInfo');
level='';
h0=qq_drawwin(winpar,ui,level);

RemList=findobj(h0,'Tag','RemList'); ConvList=findobj(h0,'Tag','ConvList'); ConvInfo=findobj(h0,'Tag','ConvInfo');

n=length(pathinfo);
dirname=['\QQ-Raw-' datestr(now,1)];
a=dir([exportpath '\' dirname]); if isempty(a) mkdir(exportpath,dirname); end

starttime=now;
for x=1:n   
    RemStr=strvcat(pathinfo(x:n).name); set(RemList,'String',RemStr);
    IStr{1}=['Now Converting: ' pathinfo(x).name]; 
    IStr{2}=[num2str(x-1) ' Converted, ' num2str(n-x+1) ' Remaining']; IStr{3}=['------------------------------------------------']; 
    ConvStr=strvcat(pathinfo(1:x-1).name); set(ConvList,'String',ConvStr);
    set(ConvInfo,'String',IStr);
    
    export(pathinfo(x),[exportpath '\' dirname]);
    
    elapsed=now-starttime; IStr{4}=['Elapsed time: ' datestr(elapsed,13)]; 
    per_conv=elapsed/x;
    n_rem=n-x;
    remtime=per_conv*n_rem;
    IStr{5}=['Est rem. time: ' datestr(remtime,13)];
    IStr{6}=['Est. end time: ' datestr(now+remtime,13)];  
    set(ConvInfo,'String',IStr); 
end

qq_message(1,['|b|Data exported to separate directory: ' exportpath dirname])
close(h0);

% -------------- SUBFUNCTION EXPORT -------------------
function export(pathinfo,exportpath)

% Get data 
pathname=[pathinfo.path '\' pathinfo.name '.D\DATA.MS'];
fid=fopen(pathname,'r'); qq_message(1,['|b|Reading: ' pathinfo.name]); drawnow
[XR,labels,ions,Info]=qq_readms(fid);
Info.File_Name=pathinfo.name; Info.Source='MS Chemstation'; 
fclose(fid);
[XR,labels,ions,Info]=truncate(XR,labels,ions,Info); 

qq_message(1,['|b|Exporting: ' pathinfo.name]); drawnow
fname=['QQ_RAW_' pathinfo.name,'.mat'];
pname=[exportpath,'\',fname];

Objects=num2str(labels','%11.4f');
[m,n]=size(Objects); bl=repmat(' ',m,32-n); Objects=[Objects bl];

Variables=num2str(ions','%11.4f');
[m,n]=size(Variables); bl=repmat(' ',m,32-n); Variables=[Variables bl];

%save(pname,'XR','Objects','Variables','Info'); 
qq_savefile(pname,XR,Objects,Variables,Info,'-o -s')

qq_message(1,['|b|Saved as: ',fname,' in: ',exportpath])

% --------------- GETFILES -------------
function pathinfo=getfiles
global metset

pathinfo(1).name=''; pathinfo(1)=[];

dirlist=findobj('Tag','DirList'); val=get(dirlist,'Value');
%if metset.file_showall==1
    %pathlist=get(dirlist,'String');
    %else
    str=get(dirlist,'String'); pathlist=str(val);
    %end
    
searchstr=(get(findobj('Tag','SearchEdit'),'String'));
p=0;
for x=1:length(pathlist)
    DD=dir([pathlist{x} '\' searchstr '.D']); le=length(DD);
    for y=1:le
        p=p+1; names{p}=DD(y).name(1:length(DD(y).name)-2); filepath{p}=pathlist{x};  
    end
end

ind=[]; if exist('names') [dummy,ind]=sortrows(strvcat(names)); end
for x=1:length(ind)
    pathinfo(x).name=names{ind(x)};
    pathinfo(x).path=filepath{ind(x)};
end

h=findobj('Tag','ContentsList'); 
set(h,'String',strvcat(pathinfo.name),'Value',1); 

% --------------- PATHSEARCH -------------
% Scanner path og subdirectories, sjekker om directories inneholder
% chemstation dirs.
function pathsearch
global metset

h=findobj('Tag','SearchPathEdit'); pathstr=get(h,'String');
h=findobj('Tag','SearchEdit'); searchstr=get(h,'String');

searchcont=0; if isempty(strmatch(searchstr,'')) searchcont=1; searchstr=[searchstr '.D']; end

listlength=1; current=0; 
scanlist{1}=pathstr; 
dirlist{1}='';
DD=dir(pathstr); if isempty(DD) qq_message(1,'|r|Not a directory'); current=1; end
% SCAN
while current<listlength
    current=current+1;
    DD=dir(scanlist{current});
    isdir=find(cat(2,DD.isdir));
    q=0;
    for x=1:length(isdir)
        add=1; name=DD(x).name;
        
        % Directories som ikke skal sjekkes
        if strmatch(name,'.'); add=0; end
        if strmatch(name,'..'); add=0; end
        le=length(name); 
        if le>1 & strmatch(name(le-1:le),'.D') add=0; end % Chemstation data directories
        if le>3 & strmatch(name(le-3:le),'.LOG') add=0; end % Log directories
        if le>3 & strmatch(name(le-3:le),'.LNK') add=0; end % Links
        
        if add==1 
            q=q+1;     
            listname=strrep([scanlist{current} '\' name],'/','\'); listname=strrep(listname,'\\','\');
            scanlist{q+listlength}=listname; 
        end
    end
    listlength=length(scanlist);
end % while

% Constrain
tom=[];
if searchcont==1
    for x=1:listlength
        dirstr=[scanlist{x} '\' searchstr];
        cont=dir(dirstr);
        tom(x)=isempty(cont);
    end
end
scanlist(find(tom))=[]; listlength=length(scanlist); 

% Sort
[A,ind]=sortrows(strvcat(scanlist)); 
for x=1:listlength
    dirlist{x}=scanlist{ind(x)};
end

h=findobj('Tag','DirList'); 
if isempty(dirlist) set(h,'String','Empty''Value',1); else set(h,'String',dirlist,'Value',1); end

%if metset.file_showall==1; getfiles; end


% -------------- INITIALIZE -------------------
function initialize(X,llabels,lions,Info)

global RE CL XR XBL fileset %labels ions

fn=fieldnames(fileset); fileset=rmfield(fileset,fn);

fileset.global_filename=Info.File_Name;
fileset.file_type='Agilent Chemstation';

%fileset.bl_subtracted=0; % 1 hvis baselinjesubtrahert
%fileset.peak_lockvector=[]; % lst omrde
%fileset.quant_areas=0;        % Number of quantified areas
%fileset.global_currentcl=0;   % Current cluster
%fileset.global_nuclusters=0;  % Number of clusters
%fileset.global_nuquant=0;     % Number of quantified clusters
%fileset.results_npeaks=0;     % Number of peaks in results

XR=X; XBL=X; CL=[]; RE=[];

fileset.rt=llabels;
fileset.ions=lions;
fileset.info=Info;




%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset locset

if isfield(metset,'load_iontresh')==0 metset.load_iontresh=0; end
if isfield(metset,'load_dellow')==0 metset.load_dellow=0; end

searchpath=[locset.path_agilent '\' metset.path_agilent];

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;% grid height

bo=bw/5;
x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='LoadAgilent'; winpar{2}='Q: MS Chemstation Import';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0; o=bw/2;
% CLOSE
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_load_agilent(99)',3,'CloseBtn');
p=p+1;[ui{p,1:8}] = deal('Accept','Pushbutton',colors.accept,[x(1) y(19)+bh/2 bw bh*1.5],'qq_load_agilent(97)',3,'AcceptBtn','-bm');
% Path, lister, og file ext.
p=p+1;[ui{p,1:7}] = deal('','text',[1 1 1],[0 y(12) 1 bh],'',3,'');
p=p+1;[ui{p,1:7}] = deal('Search Path:','text',[1 1 1],[x(1) y(12)+eo bw*2 eh],'',3,'');
p=p+1;[ui{p,1:7}] = deal(searchpath,'edit',[1 1 1],[x(2)+bo y(12)+eo bw*5-bo eh],'qq_load_agilent(1.1)',2,'SearchPathEdit');
p=p+1;[ui{p,1:7}] = deal('  For:','text',[1 1 1],[x(7) y(12)+eo bw eh],'',3,'');
p=p+1;[ui{p,1:7}] = deal('*','edit',[1 1 1],[x(8)-bw/2 y(12)+eo bw*1.5 eh],'qq_load_agilent(1.1)',2,'SearchEdit'); % Sjekk Call

% FilesList
p=p+1;[ui{p,1:7}] = deal('Searching...','listbox',[1 1 1],[x(2)+bo y(20) bw*5-bo y(2)-y(9)+bh],'qq_load_agilent(2.3)',2,'DirList');
p=p+1;[ui{p,1:7}] = deal('','listbox',[1 1 1],[x(8)-bw/2 y(20) bw*1.5 y(2)-y(9)+bh],'',2,'ContentsList');
% Get
%p=p+1;[ui{p,1:7}] = deal('All ->','Togglebutton',colors.accept,[x(7) y(14) bw/2 bh],'qq_load_agilent(2.1)',2,'GetToggle');
%p=p+1;[ui{p,1:7}] = deal('Sel.->','Togglebutton',colors.accept,[x(7) y(15) bw/2 bh],'qq_load_agilent(2.1)',2,'GetToggle');
% Load
p=p+1;[ui{p,1:8}] = deal('Load','Pushbutton',colors.btn{1},[x(9) y(14) bw bh],'qq_load_agilent(3.1)',2,'','-bm');
p=p+1;[ui{p,1:8}] = deal('Export','Pushbutton',colors.btn{6},[x(9) y(15) bw bh],'qq_load_agilent(3.2)',2,'','-bm');
p=p+1;[ui{p,1:8}] = deal('Export All','Pushbutton',colors.btn{6},[x(9) y(16) bw bh],'qq_load_agilent(3.3)',2,'','-bm');

% Treshold
p=p+1;[ui{p,1:7}] = deal('Ion tresh.','Text',colors.bc,[x(9)+bw*1/4 y(17)-eh*0.7 bw bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(metset.load_iontresh,'Edit',[1 1 1],[x(9)+bw*1/4 y(18) bw*3/4 eh],'qq_eval(''pn0'')',2,'metset.load_iontresh');
p=p+1;[ui{p,1:7}] = deal('Del. Lowest','Text',colors.bc,[x(9)+bw*1/4 y(19)-eh*0.7 bw bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(metset.load_dellow,'Edit',[1 1 1],[x(9)+bw*1/4 y(20) bw*3/4 eh],'qq_eval(''pn0'')',2,'metset.load_dellow');

% Search Buttons
p=p+1;[ui{p,1:7}] = deal('Show TIC','Pushbutton',colors.bc,[x(1) y(13) bw bh],'qq_load_agilent(4.1)',2,''); 
p=p+1;[ui{p,1:7}] = deal('Show Ions','Pushbutton',colors.bc,[x(1) y(14) bw bh],'qq_load_agilent(4.2)',2,''); 

updfcn='';
h0=qq_drawwin(winpar,ui,updfcn);

drawnow
    
















   



        


















   






   






