function qq_loadcall(inp)
 
global XR metset fileset loadset locset

% loadset.D = Directory data, 
% loadset.filename = Current File, 
% FCont = File contents (in matlab file), 
% loadset.dirval = Position in dir-window, 
% loadset.current_array=Current array (selected array in matlab file)
% loadset.X = Loaded data
% loadset.rt / loadset.ions = local rt/ions (before accept)

if nargin<1
   inp=0;
end

qq_message(2)

FileEdit=findobj('Tag','FileEdit');
PathEdit=findobj('Tag','PathEdit');
DirList=findobj('Tag','DirList');
ContentsList=findobj('Tag','ContentsList');

% ------------------- FIRST CALL ---------------------------
if inp==0 
    openwin;
    if strmatch(get(gcf,'Tag'),'LoadWin')
        loadset.filename='*.*';
        if isfield(metset,'file_type')==0 metset.file_type='QQ-Rawdata'; end  
        loadset.dironstart=cd;
        setpath        
        loadset.D=readdir(loadset.fileext,metset.file_type);
        loadset.D=sortdir(loadset.D);
        loadset.FCont=[];
        loadset.X=[];
        loadset.dirval=0;
        showdir(loadset.D);
        update
    end
end

% -------------------- SET PATH ---------------------------
if inp==1
   checkpath; 
   loadset.file_filepath=get(gcbo,'String');
   loadset.D=readdir(loadset.fileext,metset.file_type);
   loadset.D=sortdir(loadset.D);
   showdir(loadset.D);
   update
end
% Set path in method
tv=0;
if inp==1.1
    checkpath; str=get(findobj('Tag','PathEdit'),'String');
    if metset.file_type(1)=='Q' 
        locstr=locset.path_qqraw;
        if strmatch(locstr,str)==1 metset.path_qqraw=str(length(locstr)+2:length(str)); tv=1; end
    end
    if metset.file_type(1)=='C' 
        locstr=locset.path_csv;
        if strmatch(locstr,str)==1 metset.path_csv=str(length(locstr)+2:length(str)); tv=1; end
    end
    if metset.file_type(1)=='X' 
        locstr=locset.path_prs;
        if strmatch(locstr,str)==1 metset.path_prs=str(length(locstr)+2:length(str)); tv=1; end
    end
    if metset.file_type(1)=='M' || metset.file_type(1)=='A' 
        locstr=locset.path_matlab;
        if strmatch(locstr,str)==1 metset.path_matlab=str(length(locstr)+2:length(str)); tv=1; end
    end
    if tv==1 qq_message(1,'|b|Path updated in method'); else qq_message(1,'|r|Path does not match local settings'); end
end

% -------------------- DIRECTORY LISTE ---------------------
% Hyreklikk
if inp==2    % ButtonDownFcn (Hyreklikk)
   loadset.dirval=get(DirList,'Value');   
   if loadset.D{4,loadset.dirval}==1
      cd(loadset.D{1,loadset.dirval})
      loadset.D=readdir(loadset.fileext,metset.file_type);
      loadset.D=sortdir(loadset.D);
      showdir(loadset.D);
      loadset.dirval=0;
      update
   end
end
% Venstreklikk
if inp==2.5   % CallBack
   lastval=loadset.dirval;                % Forrige fil
   loadset.dirval=get(DirList,'Value'); 
   if loadset.D{4,loadset.dirval}==1
      loadset.file_isdir=1;
      qq_message(1,'Right click to change directory');
  else
      qq_message(1,'');
   end
   if loadset.D{4,loadset.dirval}==0
      loadset.file_isdir=0;
      loadset.filename=loadset.D{1,loadset.dirval};             % loadset.filename: Current file (persistent)
      set(FileEdit,'String',loadset.filename)
      % Sletter FCont hvis ny fil valgt
      if lastval~=loadset.dirval
         loadset.FCont=[]; 
      end
   end   
   update
end

% -------------------- DIRECTORY UP ---------------------------
if inp==6
   cd ..
   loadset.D=readdir(loadset.fileext,metset.file_type);
   loadset.D=sortdir(loadset.D);
   showdir(loadset.D);
   set(PathEdit,'BackgroundColor',[1 1 1])
   update
end

% -------------------- LOAD ------------------------------------
% Check for errors
if inp==8 loaded=0; end
if inp==8 && loadset.dirval==0 qq_message(1,'|r|No file selected'); inp=-1; end
if inp==8 & metset.file_type(1)=='A' qq_message(1,'Select file type'); inp=-1; end
if inp==8 && loadset.file_isdir==1 qq_message(1,'|r|Can''t load directory'); inp=-1; end
% PRS-load
if inp==8 & metset.file_type(1)=='X' & loadset.file_isdir==0
    Info.File_Name='-'; loadset.Info=Info; loadset.Info.Source='PRS Extricator';
    [loadset.X, loadset.rt, loadset.ions]=prsload(loadset.filename);
    [loadset.X, loadset.rt, loadset.ions]=truncate(loadset.X, loadset.rt, loadset.ions);
    p=find(loadset.filename=='.'); loadset.Info.File_Name=loadset.filename(1:p-1);
    loaded=1;
end
% QQ-load
if inp==8 & metset.file_type(1)=='Q' & loadset.file_isdir==0
    Info.File_Name='-'; loadset.Info=Info;
    [loadset.X, loadset.rt, loadset.ions, loadset.Info]=qqload(loadset.filename);
    [loadset.X, loadset.rt, loadset.ions]=truncate(loadset.X, loadset.rt, loadset.ions);
    p=find(loadset.filename=='.'); loadset.Info.File_Name=loadset.filename(8:p-1);
    loaded=1;
end
% Matlab-load
if inp==8 & metset.file_type(1)=='M' & loadset.file_isdir==0
    qq_message(1,'|b|Read contents and right-click on variable');
end
% Agilent CSV
if inp==8 & metset.file_type(1)=='C' & loadset.file_isdir==0
    Info.File_Name='-'; loadset.Info=Info; loadset.Info.Source='CSV Import';
    [loadset.X, loadset.rt, loadset.ions, st]=csvload(loadset.filename);
    [loadset.X, loadset.rt, loadset.ions]=truncate(loadset.X, loadset.rt, loadset.ions);
    p=find(loadset.filename=='.'); loadset.Info.File_Name=loadset.filename(1:p-1);
    loaded=1;
end

if inp==8 & loaded==1;
    % Convert scale
    min2sec=get(findobj('Tag','MinSecCheck'),'Value');
    if min2sec loadset.rt=loadset.rt*60; end
    sec2min=get(findobj('Tag','SecMinCheck'),'Value');
    if sec2min loadset.rt=loadset.rt/60; end
    
    [m,n]=size(loadset.X); 
    timerange=loadset.rt(m)-loadset.rt(1); scans_min=m/timerange;
    txt=['|b|' int2str(m) ' scans, ' int2str(n) ' ions, ' num2str(loadset.rt(1)) ' to ' num2str(loadset.rt(m)) ' min,  ' num2str(scans_min) ' scans/timeunit'];  
    qq_message(1,txt); 
    qq_load_plots(loadset.X,loadset.rt,loadset.ions,loadset.Info,1);
end

% -------------------- READ MATLAB CONTENTS --------------------
if inp==7 
   val=get(DirList,'Value');
   loadset.filename=loadset.D{1,val}; % Curent file
   loadset.filename=lower(loadset.filename);
   matmatch=findstr(loadset.filename,'.mat'); % Sjekker om filnavn matcher '.mat'
   if isempty(matmatch)==0
      loadset.FCont=load(loadset.filename);
      ContentsList=findobj('Tag','ContentsList');
      set(ContentsList,'String',fieldnames(loadset.FCont),'Enable','on')
      qq_message(1,'|b|Right-click on variable to read'); %   
   else
      qq_message(1,'|r|Not a matlab file'); %    
   end   
end

% -------------------- MATLAB CONTENTS LIST --------------------
if inp==3.5   % Callback
   if isempty(loadset.FCont)
      qq_message(1,'|r|Empty'); 
   else
      FCell=struct2cell(loadset.FCont); % Konverterer til cell array  
      val=get(ContentsList,'Value');
      loadset.current_array=FCell{val};
      if isnumeric(loadset.current_array)
         qq_message(1,'Right click to read'); 
      else
         qq_message(1,'|r|Not readable');
      end
   end
end
if inp==3    % Hyreklikk
   if isempty(loadset.FCont)==0
      FCell=struct2cell(loadset.FCont);  % Konverterer til cell array   
      val=get(ContentsList,'Value');
      loadset.current_array=FCell{val};
      if isnumeric(loadset.current_array)
         loadset.X=loadset.current_array;
         dim=size(loadset.X);
         loadset.rt=1:dim(1);
         loadset.ions=1:dim(2);
         [loadset.X,loadset.rt,loadset.ions]=truncate(loadset.X,loadset.rt,loadset.ions);
         Info.File_Name='-'; loadset.Info=Info;
         p=find(loadset.filename=='.'); loadset.Info.File_Name=loadset.filename(1:p-1);
         loadset.Info.Source='Matlab Import';
         qq_load_plots(loadset.X,loadset.rt,loadset.ions,loadset.Info,1)         
      end
   end
end


% ----------------------- TRANSPOSE -----------------------
if inp==11
   dim=size(loadset.X);
   if dim(2)>1  
      loadset.X=loadset.X';
      dim=size(loadset.X);
      loadset.rt=1:dim(1);
      loadset.ions=1:dim(2);
      qq_load_plots(loadset.X,loadset.rt,loadset.ions,loadset.Info,2) 
   end   
end

% ---------------------- FILE TYPES -----------------------

% All files
if inp > 12 & inp < 13
    set(findobj('Tag','MinSecCheck'),'Value',0)
    set(findobj('Tag','SecMinCheck'),'Value',0)
end
if inp==12.1
   metset.file_type='All'; loadset.fileext='*.*';
end
% Matlab
if inp==12.2
   metset.file_type='Matlab'; loadset.fileext='*.mat';
   qq_message(1,'Press "Mat file Contents" to read, Right click on variable to load')
end
if inp==12.3
   metset.file_type='Xtricator Exp'; loadset.fileext='*.mat';
   set(findobj('Tag','SecMinCheck'),'Value',1)
end
if inp==12.4
   metset.file_type='Chemstation csv'; loadset.fileext='*.csv';
end
if inp==12.5
   metset.file_type='QQ-Rawdata'; loadset.fileext='*.mat';
end
if inp > 12 & inp < 13
   setpath    
   loadset.D=readdir(loadset.fileext,metset.file_type);
   loadset.D=sortdir(loadset.D);
   showdir(loadset.D);
   loadset.filename=loadset.fileext;
   loadset.FCont=[];
   update
end

% -------------------- PLOT DATA -------------------
% TIC
if inp==14
   dim=size(loadset.X);
   if dim(2)>0      
       loadset.Info.dummy=[];
      qq_load_plots(loadset.X,loadset.rt,loadset.ions,loadset.Info,1);
   else
      qq_message(1,'|r|No data'); 
   end
end
% Plot
if inp==9
   dim=size(loadset.X);
   if dim(2)>0    
       loadset.Info.dummy=[];
      qq_load_plots(loadset.X,loadset.rt,loadset.ions,loadset.Info,2);
   else
      qq_message(1,'|r|No data'); 
   end
end

% ------------------------ ACCEPT -------------------------
if inp==97
   dim=size(loadset.X);
   if dim(2)>0  
       loadset.Info.File_Type=metset.file_type;
       initialize(loadset.X,loadset.rt,loadset.ions,loadset.Info)
       cd(loadset.dironstart)
       clear loadset    
       qq_closewin;
   else
      qq_message(1,'|r|No data'); 
   end
end

% ------------------------ CLOSE --------------------------
if inp==99
   cd(loadset.dironstart)
   clear loadset
   qq_closewin;
end


% --------------- S U B F U N C T I O N S -------------

% -------------- SUBFUNCTION UPDATE --------------
function update
global metset loadset

PathEdit=findobj('Tag','PathEdit'); set(PathEdit,'String',pwd); % pwd er current working directory

FileTypeEdit=findobj('Tag','FileTypeEdit'); set(FileTypeEdit,'String',metset.file_type);

if isfield(loadset,'filename')==0; loadset.filename='*.*'; end
FileEdit=findobj('Tag','FileEdit');  set(FileEdit,'String',loadset.filename);

ContentsList=findobj('Tag','ContentsList');
if isempty(loadset.FCont); 
   set(ContentsList,'String','','Value',1,'Enable','off') % Set inaktiv
end


% -------------- SUBFUNCTION SETPATH --------------
function setpath
global metset loadset locset

str2='*.*';
if metset.file_type(1)=='Q' str=[locset.path_qqraw '\' metset.path_qqraw]; str2='*.mat'; end
if metset.file_type(1)=='C' str=[locset.path_csv '\' metset.path_csv]; str2='*.csv'; end
if metset.file_type(1)=='X' str=[locset.path_prs '\' metset.path_prs]; str2='*.mat'; end
if metset.file_type(1)=='M' str=[locset.path_matlab '\' metset.path_matlab]; str2='*.mat'; end
if metset.file_type(1)=='A' str=[locset.path_matlab '\' metset.path_matlab]; str2='*.*'; end   
PathEdit=findobj(gcf,'Tag','PathEdit'); set(PathEdit,'String',str); 
FileEdit=findobj('Tag','FileEdit'); set(FileEdit,'String',str2); loadset.fileext=str2;

checkpath;

% -------------- SUBFUNCTION CHECKPATH --------------
function dircheck=checkpath
global metset loadset locset

PathEdit=findobj(gcf,'Tag','PathEdit'); str=get(PathEdit,'String'); 
if isdir(str)
    dircheck=1; cd(str); 
    set(PathEdit,'BackGroundColor',[1 1 1]);
else
    dircheck=0; qq_message(1,['|r|' str ' does not exist']);
    set(PathEdit,'BackGroundColor',[1 1 0],'String',pwd);
end    


% -------------- SUBFUNCTION SHOWDIR --------------
function showdir(D)

% LAGER OUTPUTARRAY
maxname=27;
dimD=size(D);nfiles=dimD(2);
for i1=1:nfiles
   name=(D{1,i1});
   namesize=size(name); namesize=namesize(2);
   if namesize>maxname
      namesize=maxname;
   end
   name=[name(1:namesize) blanks(maxname-namesize)];
   
   dato=(D{2,i1});
   
   storr=num2str(D{3,i1});
   if D{3,i1}>9999999
      storr=num2str(D{3,i1},'%-1.1e');
      storr(6)=[];
   end
   storrsize=size(storr);storrsize=storrsize(2);
   if storrsize>7
      storrsize=7;
   end
   storr=[blanks(7-storrsize) storr];
   
   if D{4,i1}==1, name(maxname-2:maxname)='DIR';
   end
   printdir(i1,:)=[name '  ' storr '  ' dato(1:17)];    
   
end

DirList=findobj('Tag','DirList');
set(DirList,'Value',1);
set(DirList,'String',printdir);


% -------------- SORTDIR -------------------

function DDS=sortdir(D)

% Returnerer cell array med sortert Directory
% Directories frst, deretter alfabetisk
% D m vre cell array: D=dir;D=struct2cell(D);

dimD=size(D);nfiles=dimD(2);
maxname=32; % Max antall tegn i filnavnet

% ALFABETISK SORTERING
% Lager matrise med filnavn 'FN'
for i1=1:nfiles
   name=(D{1,i1});
   name=lower(name); % Ungr case-sensitiv sortering
   namesize=size(name); namesize=namesize(2);
   if namesize>maxname
      namesize=maxname;
   end
   FN(i1,:)=[name(1:namesize) blanks(maxname-namesize)];
end
[sortv, ind]=sortrows(FN); % Finner indexer
DS(:,1:nfiles)=D(:,ind(:)); % Sortert Cell array DS

% SETTER DIRECTORIES VERST
for i1=1:nfiles
   dind(i1)=DS{4,i1}; % Siste celle i DS inneholder info om dir (1 eller 0)
end
dind=dind*-1; [sortv, ind]=sort(dind); % Indexer for sortering, "ind"
DDS(:,1:nfiles)=DS(:,ind(:)); % Returnerer cell array med dir verst, DDS


% -------------- SUBFUNCTION READDIR -------------------
function DE=readdir(dirstr,filetype)

D=dir(dirstr); type=cat(2,D.isdir);
D=D(find(type==0)); dimD=size({D.name}); nfiles=dimD(2); 

if filetype(1)=='X' D=prsfilter(D); end % PRS-filter her
if filetype(1)=='Q' D=qqfilter(D); end % QQ-filter her

DD=dir; type=cat(2,DD.isdir); 
DD=DD(find(type)); dimDD=size({DD.name}); ndirs=dimDD(2); 

if nfiles>0 DE=[DD; D]; end
if nfiles==0 DE=DD; end
DE=struct2cell(DE);

% -------------- SUBFUNCTION TRUNCATE -------------------
function [X, rt, ions]=truncate(X, rt, ions)
% Fjerner tomme ioner eller retensjonstider
null=find (sum(X)==0);
X(:,null)=[];
ions(null)=[];
null=find (sum(X')==0);
X(null,:)=[];
rt(null)=[];

% -------------- SUBFUNCTION PRSFILTER -------------------
function D=prsfilter(D)

dim=size({D.name});nfiles=dim(2); isprs=[];
for i1=1: nfiles
    filename=D(i1).name;
    S=load(filename);
    % Test 1: Objects & variables finnes
    if isfield(S,'Objects') & isfield(S,'Variables')
        names=fieldnames(S); firstname=names(1); firstname=firstname{1};
        X=S.(firstname); Objects=S.Objects; Variables=S.Variables;
        % Test 2 strrelse p objekter
        dimX=size(X); dimO=size(Objects); dimV=size(Variables);
        if dimX(1)==dimO(1) & dimX(2)==dimV(1), isprs(i1)=1;
        else isprs(i1)=0; end
    else
        isprs(i1)=0;    
    end
    isprs(i1);      
end
% Krymping
prsp=find(isprs==1); D=D(prsp);

% -------------- SUBFUNCTION QQFILTER -------------------
function D=qqfilter(D)

nfiles=length(D); isqq=[];
for i1=1: nfiles    
    isqq(i1)=strncmp(D(i1).name,'QQ_RAW_',7);
end
% Krymping
qqp=find(isqq==1); D=D(qqp);

% -------------- SUBFUNCTION PRSLOAD -------------------
function [X, rt, ions]=prsload(filename)

X=[];rt=[];ions=[];
S=load(filename);
names=fieldnames(S); firstname=names(1); firstname=firstname{1};
X=S.(firstname);
dim=size(X); n_obj=dim(1); n_ions=dim(2);
Objstr=S.Objects; 
for i1=1:n_obj   
 rt(i1)=str2double(Objstr(i1,:));
end
Varstr=S.Variables;
for i1=1:n_ions   
 ions(i1)=str2double(Varstr(i1,:));
end

% -------------- SUBFUNCTION QQLOAD -------------------
function [X,rt,ions,Info]=qqload(filename)

X=[];rt=[];ions=[]; Info.dummy=[]; Info=rmfield(Info,'dummy'); 
S=load(filename); 
names=fieldnames(S); firstname=names(1); firstname=firstname{1};
if isfield(S,'XR'); X=S.XR; end
if isfield(S,'XBL'); X=S.XBL; end
if isfield(S,'Info'); Info=S.Info; end

dim=size(X); n_obj=dim(1); n_ions=dim(2);
Objstr=S.Objects; 
for i1=1:n_obj   
 rt(i1)=str2double(Objstr(i1,:));
end
Varstr=S.Variables;
for i1=1:n_ions   
 ions(i1)=str2double(Varstr(i1,:));
end


% -------------- SUBFUNCTION MATLOAD -------------------
function [X, rt, ions]=matload(filename)
X=[];rt=[];ions=[];
S=load(filename);
names=fieldnames(S);
n_arrays=size(names);n_arrays=n_arrays(1);
p=0;
for i1=1:n_arrays   
    arrname=names{i1};
    X=S.(arrname);
    dim(i1)=0;
    if isnumeric(X)
        st=size(X);dim(i1)=st(1)*st(2);
    end
end
p=find(dim==max(dim));
arrname=names{p};
X=S.(arrname);
[a,b]=size(X); rt=1:a; ions=1:b;

% -------------- SUBFUNCTION CSVLOAD -------------------
function [X, rt, ions, stat]=csvload(filename)

% importerer TIC & SIM kromatogrammer eksportert fra
% HP-Chemstation G1701BA (B.01.00) 
% Det er en bug i export-rutinen til Agilent som gjr at det noen ganger mangler et linjeskift. 
% Vedlagte rutine leser begge formatene.

%global loadset

X=[];rt=[];ions=[];stat=0;

chemex=textread(filename,'%s','delimiter','\n'); % Henter data som teksfil

[m,n]=size(chemex);

% TEST FOR SCAN-DATA  % Finner ioner og posisjon i chemex
p=0; ions=[];
for i1=1:m; 
    startpos=strfind(chemex{i1,1},'"Ion '); % finner text "Ion 
    if isempty(startpos)==0
        p=p+1; matchline(p)=i1; % Cellenummer i chemex som inneholer ioner 
        searchstr=chemex{i1,1}; [d,length]=size(searchstr); % Linje med text "Ion
        endpos=min(strfind(searchstr(startpos:length),'(')); endpos=endpos+startpos; % Frste '(' etter "Ion  
        ions(p)=str2double(searchstr(startpos+5:endpos-2)); % Tall mellom "Ion og neste '('
    end
end
% Antall ions/scans / Oppdaterer status
[d,n_ions]=size(ions); 
if n_ions==1; stat=2; end  % Behandle som TIC
if n_ions>1; stat=1; end   % SIM-data

% LESER SIM-DATA
if stat==1 % Dersom SIM-data
    n_scans=matchline(2)-matchline(1)-1;
    Xdata=dlmread(filename,',',matchline(1),1);  
    for i1=1:n_ions
        start(i1)=matchline(i1)-matchline(1)+1; X(:,i1)=Xdata(start(i1):start(i1)+n_scans-1);
    end  
    % Finner Labels
    for i1=matchline(1)+1:matchline(2)-1;
        delpos=strfind(chemex{i1,1},','); rt(i1-matchline(1))=str2double(chemex{i1,1}(1:delpos));
    end  
end

% TEST FOR TIC-DATA
if stat==0 % Dersom hverken stat eller sim
    i1=1;
    while i1<=m
       startpos=strfind(chemex{i1,1},'"TIC: '); % finner text "TIC: 
       if isempty(startpos)==0; matchline=i1; i1=m+1; stat=2; end
       i1=i1+1;
   end
end
% Leser TIC med DLM-resd   
if stat==2;
    Xdata=dlmread(filename,',',matchline,1);
    X(:,1)=Xdata; [n_scans,d]=size(X);
    % Labels
    for i1=1:n_scans
        delpos=strfind(chemex{i1+matchline,1},',');
        rt(i1)=str2double(chemex{i1+matchline,1}(1:delpos));
    end  
    if isempty(ions), ions(1)=1; end
end

% Finner filnavn
%str=chemex{matchline(1),1};
%pos1=strfind(str,':'); pos1=max(pos1); 
%pos2=strfind(str,'.'); pos2=max(pos2);
%loadset.global_filename=str(pos1+2:pos2-1);

% -------------------- INITIALIZE -------------------------
function initialize(X,loc_rt,loc_ions,Info)
global RE CL XR XBL fileset loadset %rt ions

fn=fieldnames(fileset); fileset=rmfield(fileset,fn);

fileset.global_filename=Info.File_Name;
fileset.file_type=Info.File_Type;

XR=X; XBL=X; CL=[]; RE=[];
fileset.rt=loc_rt;
fileset.ions=loc_ions;
fileset.info=Info;


%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;% grid height

bo=bw/5;
x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='LoadWin'; winpar{2}='Q: Load';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0; o=bw/2;
% CLOSE
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_loadcall(99)',3,'CloseBtn');
p=p+1;[ui{p,1:8}] = deal('Accept','Pushbutton',colors.accept,[x(2)+bo y(20) bw bh*1.5],'qq_loadcall(97)',3,'AcceptBtn','-bm');
% Path, lister, og file ext.
p=p+1;[ui{p,1:7}] = deal(' ','text',[1 1 1],[0 y(12) 1 bh],'',3,'');
p=p+1;[ui{p,1:7}] = deal('Path:','text',[1 1 1],[x(1)-bw*0.03 y(12)+eo bw/2 eh],'',3,'rjust');
p=p+1;[ui{p,1:7}] = deal(' ','edit',[1 1 1],[x(1)+bw/2 y(12)+eo bw*3 eh],'qq_loadcall(1)',2,'PathEdit');
p=p+1;[ui{p,1:7}] = deal('SM','pushbutton',[1 1 1],[x(4)+bw*0.5 y(12)+eo bw/4 eh],'qq_loadcall(1.1)',2,'');

p=p+1;[ui{p,1:7}] = deal('File:','text',[1 1 1],[x(5)-bw/5 y(12)+eo bw/2 eh],'',3,'rjust');
p=p+1;[ui{p,1:7}] = deal('*.*','edit',[1 1 1],[x(5)+bw/3 y(12)+eo bw+bw/3 eh],'qq_loadcall(4)',2,'FileEdit'); % Sjekk Call
p=p+1;[ui{p,1:7}] = deal('Type:','text',[1 1 1],[x(7)-bw/3 y(12)+eo bw/1.65 eh],'',3,'rjust');
p=p+1;[ui{p,1:7}] = deal('*.*','edit',[1 1 1],[x(7)+bw/3 y(12)+eo bw eh],'qq_loadcall(4)',2,'FileTypeEdit'); % Sjekk Call
p=p+1;[ui{p,1:7}] = deal('Mat File Contents:','text',[1 1 1],[x(8)+bw/2 y(12)+eo bw*3 eh],'',3,'');
% FilesList
p=p+1;[ui{p,1:7}] = deal('Searching...','listbox',[1 1 1],[x(3)+bw/3 y(20) bw*5 y(2)-y(9)+bh],'qq_loadcall(2.5)',2,'DirList');
p=p+1;[ui{p,1:7}] = deal('','listbox',[1 1 1],[x(8)+bw/2 y(20) bw*1.5 y(2)-y(9)+bh],'qq_loadcall(3.5)',2,'ContentsList');
% Dir up
p=p+1;[ui{p,1:8}] = deal('Dir Up','Pushbutton',colors.bc,[x(2)+bo y(13) bw bh],'qq_loadcall(6)',2,'','-bm');
% Contents
p=p+1;[ui{p,1:7}] = deal('MAT file cont.','Pushbutton',colors.btn{1},[x(2)+bo y(17) bw bh],'qq_loadcall(7)',2,'');
% Load
p=p+1;[ui{p,1:8}] = deal('Load','Pushbutton',colors.btn{1},[x(1) y(17) bw bh],'qq_loadcall(8)',2,'','-bm');

% Convert scale
p=p+1;[ui{p,1:8}] = deal('Convert min->sec','Checkbox',colors.bc,[x(1) y(18) bw*1.5 bh],'',2,'MinSecCheck','');
p=p+1;[ui{p,1:8}] = deal('Convert sec->min','Checkbox',colors.bc,[x(1) y(19)+bh/2 bw*1.5 bh],'',2,'SecMinCheck','');

% Plot
p=p+1;[ui{p,1:7}] = deal('Show ions','Pushbutton',colors.bc,[x(2)+bo y(14) bw bh],'qq_loadcall(9)',2,''); 
p=p+1;[ui{p,1:7}] = deal('Show TIC','Pushbutton',colors.bc,[x(2)+bo y(14)-bh bw bh],'qq_loadcall(14)',2,''); 
p=p+1;[ui{p,1:8}] = deal('Transpose','Pushbutton',colors.bc,[x(2)+bo y(14)-bh*2 bw bh],'qq_loadcall(11)',2,'','-bm'); 
% Filetype Buttons
p=p+1;[ui{p,1:8}] = deal('All Files','Pushbutton',colors.bc,[x(1) y(13) bw bh],'qq_loadcall(12.1)',2,'','-bm'); 
p=p+1;[ui{p,1:8}] = deal('Matlab','Pushbutton',colors.bc,[x(1) y(13)-bh bw bh],'qq_loadcall(12.2)',2,'','-bm'); 
p=p+1;[ui{p,1:8}] = deal('Xtricator','Pushbutton',colors.bc,[x(1) y(13)-bh*2 bw bh],'qq_loadcall(12.3)',2,'','-bm');
p=p+1;[ui{p,1:8}] = deal('Chemst.CSV','Pushbutton',colors.bc,[x(1) y(13)-bh*3 bw bh],'qq_loadcall(12.4)',2,'','-bm');
p=p+1;[ui{p,1:8}] = deal('QQ-Rawdata','Pushbutton',colors.bc,[x(1) y(13)-bh*4 bw bh],'qq_loadcall(12.5)',2,'','-bm'); 

updfcn='';
h0=qq_drawwin(winpar,ui,updfcn);

h=findobj('Tag','DirList'); set(h,'ButtonDownFcn','qq_loadcall(2)','TooltipString','Right click to change directory') 
h=findobj('Tag','ContentsList'); set(h,'ButtonDownFcn','qq_loadcall(3)','TooltipString','Right click to Load') 
h=findobj('Tag','rjust'); set(h,'HorizontalAlignment','right')

if strcmp(metset.file_type,'Xtricator Exp') h=findobj('Tag','SecMinCheck'); set(h,'Value',1); end

drawnow



