function qq_maincall(call)
% function maincall(call)
% Funksjon koblet til hovedvinduet


global XBL XR fileset metset CL RE fonts locset
%global status

if nargin<1 call=0; end

qq_message(2); % Blanker ut meldinger
   
% NEW WIN
if call==0;  
    clear global XBL XR RE CL fileset
    qq_initialsettings
    initialize
    openwin
    % Leser def. method  
    fname=[locset.path_method '\' metset.path_method '\met_' locset.defaultmethod]; 
    try
        load(fname);
        tempmet.dummy=[]; fn=fieldnames(tempmet); n=length(fn);
        for x=1:n metset.(fn{x})=tempmet.(fn{x}); end  
        qq_message(1,['|b|Q Version: ' locset.version '  -  Method: ' metset.file_method '  -  Root Folder: ' locset.path_root])
    catch
        qq_message(1,'|r|Could not load default  method')
    end 
end

% Change file name:
if call==1.1
    fileset.global_filename=get(gcbo,'String');
end

% RESET BASELINE
if call==3 & isempty(XR)==0 
    %XBL=XR; 
    qq_blcall(2);
    qq_plot_mainchrom(1); qq_plot_scale(100); 
end
%if call==3 & isempty(XR)==1 qq_message(1,'|r|No data'); end


% ------------------- LOAD/SAVE/EXPORT ---------------

% Export spectra
if call==86 exportspectra; end
% Export data 
if call==87 export; end
% Export template
if call==85 exporttemplate; end
% Tempsave
if call==89
    if isempty(XR)==0
        Info.savedby='ChromBox Q'; Info.version=locset.version; Info.date=date; Info.clockvector=clock; Info.matlabversion=version;
        %save([locset.path_root, '\qq_tempsave'],'CL','XBL','XR','RE','fileset','metset','Info') %Old
        qq_savefile([locset.path_root, '\qq_tempsave'],CL,XBL,XR,RE,fileset,metset,Info,'-o')
    else
        qq_message(1,'|r|No data saved')
    end
end
% Resume
if call==88
    oldmet=metset;
    load([locset.path_root, '\qq_tempsave'],'CL','XBL','XR','RE','fileset','metset'); checkmet(oldmet);
    % Filnavn & Tic
    if isfield(fileset,'file_filename') fnam=fileset.global_filename; else fnam='no file'; end
    h=findobj('Tag','CurrentFileEdit'); set(h,'String',fnam);
    qq_plot_mainchrom(0); qq_plot_scale(100); updinfo 
end
% Save results
if call ==8.1
    if strcmp(fileset.global_filename,'No file')
        qq_message(1,'|r|No file to save')
    else        
        fnam=[locset.path_results '\' metset.path_results '\res_' fileset.global_filename];
        Info.savedby='ChromBox Q'; Info.version=locset.version; Info.date=date; Info.clockvector=clock; Info.matlabversion=version;
        %save(fnam,'CL','XBL','XR','RE','fileset','metset','Info'); % old
        %qq_message(1,['|b|Results saved in: ',fnam]); % Old
        qq_savefile(fnam,CL,XBL,XR,RE,fileset,metset,Info)
    end
end

% Load results
if call ==8.2
    oldmet=metset;
    
    h=findobj('Tag','FileBoxEdit'); files=get(h,'String'); val=get(h,'Value'); 
    if isempty(files)==0 nam=files{val}; else nam=''; end
    
    fnam=[locset.path_results '\' metset.path_results '\res_',nam,'.mat'];
    D=dir(fnam);
    [a,b]=size(D);
    if a==1
        h=findobj('Tag','IncludeMethodCheck');
        if get(h,'value')==1
            load(fnam,'CL','XBL','XR','RE','fileset','metset'); checkmet(oldmet); % Loader metset
        else
            load(fnam,'CL','XBL','XR','RE','fileset'); % Loader ikke metset
        end
        % Check for old formats (11-01 or earlier)
        if isfield(fileset,'rt')==0 
            load(fnam,'labels'); fileset.rt=labels; % for old formats
            load(fnam,'ions'); fileset.ions=ions;  % for old formats
            load(fnam,'cluvector'); fileset.cluvector=cluvector; %for old formats
        end
        lre=length(RE);
        if isfield(RE,'compound_code') [RE(1:lre).cmp_shortname]=deal(RE(1:lre).compound_code); RE=rmfield(RE,'compound_code'); end
        if isfield(RE,'compound_name') [RE(1:lre).cmp_name]=deal(RE(1:lre).compound_name); RE=rmfield(RE,'compound_name'); end
        if isfield(RE,'cas_nr') [RE(1:lre).cmp_code]=deal(RE(1:lre).cas_nr); RE=rmfield(RE,'cas_nr'); end       
        fileset.global_filename=nam;
        qq_plot_mainchrom(0); qq_plot_scale(100); updinfo
    else 
        qq_message(1,'|r|No such results file');
    end
end
% List files
if call==8.3
    getfiles
end

% ---------- UPDATE ----------   

% Nye data
if call==100
    if isempty(fileset.rt)==0 qq_plot_mainchrom(0); qq_plot_scale(100); end  % Plotter rdata
    updinfo
end

% Keypress
if call==96
    kp=double(get(gcf,'CurrentCharacter'));
    if isfield(fileset,'rt') & (kp==28 | kp==29) qq_plot_scale(1.35); end    
end

% -------- CLOSE/EXIT ---------
% Quit
if call==99 % Quit
    quitfunction
end
if call==99.1 % Exit
    h=get(gcf,'Children'); delete(h); delete(gcf);  
end
if call==99.2 % Exit Matlab
    h=get(gcf,'Children'); delete(h); delete(gcf); exit 
end
if call==99.3
    fn=fieldnames(metset); n=length(fn);
    pathname=[locset.path_method '\' metset.path_method '\met_' metset.file_method '.mat']; 
    for x=1:n tempmet.(fn{x})=metset.(fn{x}); end
    %save(pathname,'tempmet'); % old
    qq_savefile(pathname,tempmet,'-o')
end


% -------------------------------------------------------------------------
% ----------------- S U B F U N C T I O N S -------------------------------
% -------------------------------------------------------------------------

% -------- ------ SUBFUNCTION QUITFUNCTION -------------------
function quitfunction
global colors positions

winpos=positions.window;

h=findobj('Tag','QuitWin');
if isempty(h)
    %winpar={'QuitWin','Quit',[0.1 0.5 0.3 0.4]};
    winpar={'QuitWin','Quit',[winpos(1) winpos(2) winpos(3)*0.25 winpos(4)*0.4]};
    p=1; [ui{p,1:7}] = deal('Return to Q','Pushbutton',colors.close,[0.1 0.1 0.5 0.1],'close(gcf)',2,'');
    p=p+1; [ui{p,1:7}] = deal('Quit Matlab','Pushbutton',colors.reset,[0.1 0.25 0.5 0.1],'close(gcf); qq_maincall(99.2)',2,'');
    p=p+1; [ui{p,1:7}] = deal('Quit Q','Pushbutton',colors.reset,[0.1 0.4 0.5 0.1],'close(gcf); qq_maincall(99.1)',2,'');
    p=p+1; [ui{p,1:7}] = deal('Save and quit Matlab','Pushbutton',colors.accept,[0.1 0.55 0.5 0.1],'close(gcf); qq_maincall(89); qq_maincall(99.2)',2,'');
    p=p+1; [ui{p,1:7}] = deal('Save and quit Q','Pushbutton',colors.accept,[0.1 0.7 0.5 0.1],'close(gcf); qq_maincall(89); qq_maincall(99.1)',2,'');
    p=p+1; [ui{p,1:7}] = deal('Save Method','Pushbutton',colors.btn{3},[0.1 0.85 0.5 0.1],'qq_maincall(99.3)',2,'');
    h0=qq_drawwin(winpar,ui,''); 
    set(h0,'WindowStyle','modal');
end

% -------- ------ SUBFUNCTION GETFILES -------------------
function getfiles
global fileset metset locset

searchstring=get(findobj('Tag','SearchStringEdit'),'String');
searchstring=[locset.path_results '\' metset.path_results '\res_' searchstring '.mat'];

DD=dir(searchstring);
for x=1:length(DD)
    nam=DD(x).name; ind1=strfind(nam,'.mat'); str{x}=nam(5:ind1-1);
end
if length(DD)==0 str=''; end
h=findobj('Tag','FileBoxEdit'); set(h,'String',str); set(h,'Value',1);


% -------------- SUBFUNCTION CHECKMET -------------------
% Legger over felt som ikke er i lastet metode (sikrer kompatibilitet med
% gamle data)
function checkmet(oldmet)
global metset

fnam=fieldnames(oldmet); le=length(fnam);
for x=1:le
    if isfield(metset,fnam{x})==0 metset.(fnam{x})=oldmet.(fnam{x}); end
end
    

% -------------- SUBFUNCTION UPDINFO -------------------
function updinfo
global fileset

h=findobj('Tag','CurrentFileEdit');
if isfield(fileset,'global_filename') set(h,'String',fileset.global_filename); else set(h,'String','No file'); end
%h=findobj('Tag','FileTypeEdit');
%if isfield(fileset,'file_type') set(h,'String',fileset.file_type); else set(h,'String','Unknown'); end


% -------------- SUBFUNCTION EXPORTTEMPLATE -------------------
function exporttemplate
global RE metset fileset locset

fnam=[locset.path_export '\' metset.path_export '\TEMPLATE_' fileset.global_filename '.mat'];
TPL=RE;
%save(fnam,'RE','fileset'); % old
qq_savefile(fnam,RE,fileset)

% -------------- SUBFUNCTION EXPORTSPECTRA -------------------
function exportspectra
global RE metset fileset locset

% Eksport Matlab-fil
nspec=length(RE);
if nspec>0
    for x=1:nspec
        Spectra(x).filename=fileset.global_filename;
        Spectra(x).rt=RE(x).rt;
        Spectra(x).ri=RE(x).ri_calc;
        Spectra(x).longname=RE(x).cmp_name;
        Spectra(x).shortname=RE(x).cmp_shortname;
        Spectra(x).code=RE(x).cmp_code;
        Spectra(x).ions=fileset.ions;
        Spectra(x).abundance=RE(x).S;
        if RE(x).peaksincl==1 Spectra(x).purepeak=1; else Spectra(x).purepeak=0; end
    end

    fname=['SPEC_' fileset.global_filename,'.mat']; 
    pname=[locset.path_export '\' metset.path_export '\' fname];
    %save(pname,'Spectra'); Old
    qq_savefile(pname,Spectra,'-o')

    % Eksport CSV-fil
    p=1; ionstr='';
    for y=1:length(fileset.ions)
        ionstr=[ionstr ',"' num2str(fileset.ions(y)) '"'];
        %ionstr=[ionstr ',' num2str(ions(y)) ''];
    end
    expstr{p}=ionstr;
    
    for x=1:nspec
        p=p+1;
        cid=[Spectra(x).code '-' Spectra(x).filename(length(Spectra(x).filename)-4:length(Spectra(x).filename))];
        abstr='';
        for y=1:length(Spectra(x).abundance)
            abstr=[abstr ',' num2str(Spectra(x).abundance(y))];
        end
        expstr{p}=['"' cid '"' abstr];
    end

    % Write to file
    p=0; fh=-1;
    while fh==-1
        p=p+1;filename=['SPEC_',fileset.global_filename,'_']; filename=[filename,num2str(p)];
        fh=fopen([locset.path_export '\' metset.path_export '\' filename '.csv'],'w');
    end

    for x=1:nspec
        fprintf(fh,[expstr{x},'\n']);
    end

    fclose(fh);

    qq_message(1,['|b|Spectra saved as: ' filename '.csv and ' filename '.mat in: ' locset.path_export '\' metset.path_export])
else
    qq_message(1,'|r|No spectra found, check Results') 
end
    


% -------------- SUBFUNCTION EXPORT -------------------
function export
global fileset metset XR XBL locset

fname=['QQ_RAW_' fileset.global_filename,'.mat']; 
pname=[locset.path_export '\' metset.path_export '\' fname];

Objects=num2str(fileset.rt','%11.4f');
[m,n]=size(Objects); bl=repmat(' ',m,32-n); Objects=[Objects bl];

Variables=num2str(fileset.ions','%11.4f');
[m,n]=size(Variables); bl=repmat(' ',m,32-n); Variables=[Variables bl];

h=findobj('Tag','ExportXblCheck'); 
if get(h,'Value')==1 
    %save(pname,'XBL','Objects','Variables') % old
    qq_savefile(pname,XBL,Objects,Variables)
else
    %save(pname,'XR','Objects','Variables'); % old
    qq_savefile(pname,XR,Objects,Variables); 
end

qq_message(1,['|b|Saved as: ' fname ' in: ' locset.path_export '\' metset.path_export])

% -------------- INITIALIZE -------------------
function initialize

global fileset RE CL 

fileset.bl_subtracted=0; % 1 hvis baselinjesubtrahert
fileset.peak_lockvector=[]; % lst omrde
fileset.quant_areas=0;        % Number of quantified areas
fileset.global_currentcl=0;   % Current cluster
fileset.global_nuclusters=0;  % Number of clusters
fileset.global_nuquant=0;     % Number of quantified clusters
fileset.results_npeaks=0;     % Number of peaks in results
fileset.rt=[];                % Retention times

CL=[];
RE=[];

%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;% grid height
o1=bw*3+bw/2; % Offset for gruppe 2

bo=bw/5;
x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='MainWin'; winpar{2}='Q: Main';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0; o=bw/2;
% CLOSE
p=p+1;[ui{p,1:7}] = deal('Quit','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_maincall(99)',3,'');
% LOAD
p=p+1;[ui{p,1:7}] = deal('Load','Pushbutton',colors.btn{1},[x(1) y(13) bw bh],'qq_loadcall(0)',2,'FButton');
p=p+1;[ui{p,1:7}] = deal('Load Chemst.','Pushbutton',colors.btn{1},[x(2) y(13) bw bh],'qq_load_agilent(0)',2,'FButton');
p=p+1;[ui{p,1:7}] = deal('Load Net CDF','Pushbutton',colors.btn{1},[x(3) y(13) bw bh],'qq_load_cdf(0)',2,'FButton');
% BASELINE
p=p+1;[ui{p,1:7}] = deal('Baseline','Pushbutton',colors.btn{1},[x(1) y(14) bw bh],'qq_blcall(0)',2,'FButton');
p=p+1;[ui{p,1:8}] = deal('Auto Basel.','Pushbutton',colors.btn{1},[x(2) y(14) bw bh],'qq_blcall(1)',2,'FButton','-bm');
p=p+1;[ui{p,1:7}] = deal('Reset Basel.','Pushbutton',colors.btn{1},[x(3) y(14) bw bh],'qq_maincall(3)',2,'FButton');
% PEAKS
p=p+1;[ui{p,1:7}] = deal('Detect','Pushbutton',colors.btn{1},[x(1) y(15) bw bh],'qq_peakcall(0)',2,'FButton');
% QUANT
p=p+1;[ui{p,1:7}] = deal('Quantify','Pushbutton',colors.btn{1},[x(1) y(16) bw bh],'qq_quantcall2(0)',2,'FButton');

% RESULTS
p=p+1;[ui{p,1:7}] = deal('Results','Pushbutton',colors.btn{1},[x(1) y(17) bw bh],'qq_resultscall(0)',2,'FButton');
% BATCH
%p=p+1;[ui{p,1:7}] = deal('Batch','Pushbutton',colors.btn{5},[x(1) y(18) bw bh],'qq_maincall(8)',2,'FButton');
%p=p+1;[ui{p,1:7}] = deal('Check Spectr','Pushbutton',colors.btn{5},[x(2) y(18) bw bh],'qq_checkspectra(0)',2,'FButton');
% LIBRARY
p=p+1;[ui{p,1:7}] = deal('Libr. Manager','Pushbutton',colors.btn{5},[x(2) y(18) bw bh],'qq_libmanager(0)',2,'');
% 2D-FARI
%p=p+1;[ui{p,1:7}] = deal('2D-FARI','Pushbutton',colors.btn{5},[x(4) y(18) bw bh],'qq_2dfari(0)',2,'');
% ADDONS
p=p+1;[ui{p,1:7}] = deal('Extensions','Pushbutton',colors.btn{5},[x(1) y(18) bw bh],'qq_extcall(0)',2,'');


%  SAVE/LOAD/EXPORT/TEMPSAVE/RESUME
hp=8;
p=p+1;[ui{p,1:8}] = deal('Save Results','Pushbutton',colors.btn{6},[x(hp) y(13) bw bh],'qq_maincall(8.1)',2,'','-bm');
p=p+1;[ui{p,1:8}] = deal('Load Results','Pushbutton',colors.btn{6},[x(hp) y(14) bw bh],'qq_maincall(8.2)',2,'','-bm');
p=p+1;[ui{p,1:7}] = deal('Incl method','Checkbox',colors.bc,[x(hp+1)+bw/6 y(14) bw*2 bh],'',2,'IncludeMethodCheck');
p=p+1;[ui{p,1:8}] = deal('Tempsave','Pushbutton',colors.btn{6},[x(hp) y(15) bw bh],'qq_maincall(89)',2,'','-bm');
p=p+1;[ui{p,1:8}] = deal('Resume','Pushbutton',colors.btn{6},[x(hp) y(16) bw bh],'qq_maincall(88)',2,'','-bm');
p=p+1;[ui{p,1:7}] = deal('Bl. Subtr.','Checkbox',colors.bc,[x(hp+1)+bw/6 y(18) bw bh],'',2,'ExportXblCheck');
p=p+1;[ui{p,1:8}] = deal('Export Data','Pushbutton',colors.btn{6},[x(hp) y(18) bw bh],'qq_maincall(87)',2,'','-bm');
p=p+1;[ui{p,1:8}] = deal('Export Spectra','Pushbutton',colors.btn{6},[x(hp) y(19) bw bh],'qq_maincall(86)',2,'','-bm');
p=p+1;[ui{p,1:8}] = deal('Export Template','Pushbutton',colors.btn{6},[x(hp) y(20) bw bh],'qq_maincall(85)',2,'','-bm');
% FILE INFO
hp=6;
p=p+1;[ui{p,1:8}] = deal('Current file:','Text',colors.bc,[x(hp-1) y(13) bw*2 eh],'',2,'','-l -fh -fvp');
p=p+1;[ui{p,1:8}] = deal('No File','Edit',[1 1 1],[x(hp) y(13) bw*1.5 eh],'qq_maincall(1.1)',3,'CurrentFileEdit','-l -fh -fvp');
p=p+1;[ui{p,1:8}] = deal('Search string:','Text',colors.bc,[x(hp-1) y(14) bw eh],'',2,'','-l -fh -fvp');
p=p+1;[ui{p,1:8}] = deal('','Edit',[1 1 1],[x(hp) y(14) bw*1.5 eh],'qq_maincall(8.3)',3,'SearchStringEdit','-l -fh -fvp');
p=p+1;[ui{p,1:7}] = deal('','Listbox',[1 1 1],[x(hp) y(20) bw*1.5 bh*6.9+eh],'',3,'FileBoxEdit');

updfcn='qq_maincall(100)'; 
h0=qq_drawwin(winpar,ui,updfcn);
set(h0,'KeyPressFcn','qq_maincall(96)')
set(h0,'CloseRequestFcn','qq_maincall(99)')

%h=findobj('Tag','MainWin'); set(h,'ButtonDownFcn','qq_maincall(100)') 

%---------------- AXES ----------------
%h = axes('Position',[0 0.5 1 0.5],'Tag','Largeplot');















   



        












