function qq_nistsearch(Searchinfo)

% SEARCHINFO:
%    Searchinfo(1).peaknumber=fileset.results_selpeak;
%    Searchinfo(1).filename=fileset.global_filename;
%    Searchinfo(1).scannumber=RE(fileset.results_selpeak).maxp;
%    Searchinfo(1).rt=RE(fileset.results_selpeak).rt;
%    Searchinfo(1).ri=RE(fileset.results_selpeak).ri_calc;
%    Searchinfo(1).ions=fileset.ions;
%    Searchinfo(1).abundance=RE(fileset.results_selpeak).S;
%    Searchinfo(1).nistpath=locset.path_nist;
%    Searchinfo(1).exportpath=locset.path_export;

%disp('---- qq_nistsearch ----')

%Searchinfo

err=0;
% get content in autoimp.msd
pathname=[Searchinfo.nistpath '\autoimp.msd'];
fh=fopen(pathname,'r');
tline=['dummy']; filespecpath='';
if fh==-1
    qq_message(1,'|r|Could not open autoimp.msd. Check NIST searchpath');
    err=1;    
else
    while ischar(tline)
        tline=fgetl(fh);
        if ~isempty(tline) && ischar(tline)
            filespecpath=tline;
        end   
    end
    fclose(fh);
end
 
% Write filespecpath
if err==0  
    exportspec=[Searchinfo.exportpath '\nistexport.msp'];
    fh=fopen(filespecpath,'w');    
    if fh==-1
       qq_message(1,'|r|Could not write filespec.fil. Check that target specified in autoimp.msd is [a valid path]\filespec.fil');
       err=1;         
    else
        fprintf(fh,'%s',[exportspec ' OVERWRITE']);
        fclose(fh);  
    end 
end
%dosfunction=['notepad.exe ' filespecpath];
%dos(dosfunction)

% Create file with export to nist
p=1; str{p}=['NAME:' Searchinfo.filename ', Scan number: ' num2str(Searchinfo.scannumber) ', Rt: ' num2str(Searchinfo.rt)];
if isfield(Searchinfo,'ri') && ~isempty(Searchinfo.ri) && ~isnan(Searchinfo.ri)
    p=p+1; str{p}=['COMMENTS: Calc. retention index: ' num2str(Searchinfo.ri)];
end
%p=p+1; str{p}=['FORMULA:'];
%p=p+1; str{p}=['MWT:'];
%p=p+1; str{p}=['CAS:'];
p=p+1; str{p}=['Num Peaks:' num2str(length(Searchinfo.ions))];
for x=1:length(Searchinfo.ions)
    p=p+1; str{p}=[num2str(Searchinfo.ions(x)) '   ' num2str(Searchinfo.abundance(x))];
end

if err==0
    linefeed=char([13 10]);
    fh=fopen(exportspec,'w');
    if fh==-1
        qq_message(1,'|r|Could not write resultsfile. Check Chrombox exportpath');
        err=1;  
    else
        for x=1:length(str)
        fprintf(fh,'%s',[str{x} linefeed]);
        end               
        fclose(fh);    
    end      
end
%dosfunction=['notepad.exe ' exportspec ];
%dos(dosfunction)

if err==0
    dosfunction=[Searchinfo.nistpath '\nistms$.exe /instrument'];
    status=dos(dosfunction);
    if status~=0
        qq_message(1,'|r|Could not perform search');
    end
end
    








