function [center,lwhh,rwhh,height,bloffset,kurtosis]=qq_normfit(xax,C)

% Tilpasser normalfordeling (uavhengig h og v bredde) og flat baselinje til
% xax og C.
%
% center=peak max
% lwhh=Bredde ved halve hyden (venstre)
% rwhh=Bredde ved halve hyden (hyre)
% height=Hyde p topp (fra baselinje til max)
% bloffset=Baselinjeniv
% kurtosis: kurtosis-factor, 1=normal 

%disp('---- qq_normfit2 ----')

% Analyze in-data
minc=min(C); maxc=max(C); 
height=maxc-minc;hh=(height/2)+minc; above=find(C>hh);
if min(above)<2
    lxp=min(xax);
else
    li=[min(above)-1 min(above)]; lx=xax(li); ly=C(li);
    dxdy=(lx(2)-lx(1))/(ly(2)-ly(1)); dh=hh-ly(1); lxp=lx(1)+(dh*dxdy);
end
if max(above)>length(xax)-1
    rxp=max(xax);
else
    ri=[max(above) max(above)+1]; rx=xax(ri); ry=C(ri);
    dxdy=(rx(2)-rx(1))/(ry(2)-ry(1)); dh=hh-ry(1); rxp=rx(1)+(dh*dxdy);
end
ii=find(C==maxc); ii=ii(1); 
rt_val=xax([ii-1 ii ii+1]); % Startestimater RT
scandist=(max(xax)-min(xax))/(length(xax)-1); % Avstand mellom scan
lw=xax(ii)-lxp; lw_val=([lw-scandist lw lw+scandist]); % Startestimater venstre bredde 
rw=rxp-xax(ii); rw_val=([rw-scandist rw rw+scandist]); % Startestimater hyre bredde
kf_val=[0.8 1 1.2]; % Startestimater, kurtosis

[DM,center]=desmat2(4);

startint=[scandist scandist scandist 0.2];

cval=0.5; % Constrain

% Beregner TM
rt_int=(max(rt_val)-min(rt_val))/2; rt_mean=rt_val(2); TM(:,1)=DM(:,1)*rt_int; TM(:,1)=TM(:,1)+rt_mean;
lw_int=(max(lw_val)-min(lw_val))/2; lw_mean=lw_val(2); TM(:,2)=DM(:,2)*lw_int; TM(:,2)=TM(:,2)+lw_mean;
rw_int=(max(rw_val)-min(rw_val))/2; rw_mean=rw_val(2); TM(:,3)=DM(:,3)*rw_int; TM(:,3)=TM(:,3)+rw_mean;
kf_int=(max(kf_val)-min(kf_val))/2; kf_mean=kf_val(2); TM(:,4)=DM(:,4)*kf_int; TM(:,4)=TM(:,4)+kf_mean;


konvergens=0; x=0;
while konvergens==0
x=x+1;
    %disp(['---- x = ' num2str(x) ' ----']);
    [m,n]=size(TM);
    for p=1:m
        C_est=hpeak(xax,TM(p,1),TM(p,2),TM(p,3),TM(p,4)); % Estimerer C
        err(p)=testest(C,C_est); % Tester estimatet
    end
    minerr(x)=min(err); minind=find(err==minerr(x)); % Finner minimum

    if minind==center
        %disp('---senterpkt---')
        % Constrain
        rt_int=(max(rt_val)-min(rt_val))/2; rt_mean=rt_val(2); rt_int=rt_int*cval; rt_val=[rt_mean-rt_int rt_mean rt_mean+rt_int];
        lw_int=(max(lw_val)-min(lw_val))/2; lw_mean=lw_val(2); lw_int=lw_int*cval; lw_val=[lw_mean-lw_int lw_mean lw_mean+lw_int];
        rw_int=(max(rw_val)-min(rw_val))/2; rw_mean=rw_val(2); rw_int=rw_int*cval; rw_val=[rw_mean-rw_int rw_mean rw_mean+rw_int];    
        kf_int=(max(kf_val)-min(kf_val))/2; kf_mean=kf_val(2); kf_int=kf_int*cval; kf_val=[kf_mean-kf_int kf_mean kf_mean+kf_int];    

    else
        %disp('---ikke senterpkt---')
        % Flytt
        bestcal=TM(minind,:);
        rt_int=(max(rt_val)-min(rt_val))/2; rt_mean=bestcal(1); rt_val=[rt_mean-rt_int rt_mean rt_mean+rt_int]; 
        lw_int=(max(lw_val)-min(lw_val))/2; lw_mean=bestcal(2); lw_val=[lw_mean-lw_int lw_mean lw_mean+lw_int];
        rw_int=(max(rw_val)-min(rw_val))/2; rw_mean=bestcal(3); rw_val=[rw_mean-rw_int rw_mean rw_mean+rw_int];
        kf_int=(max(kf_val)-min(kf_val))/2; kf_mean=bestcal(4); kf_val=[kf_mean-kf_int kf_mean kf_mean+kf_int];
        
    end
    
    % Beregner ny TM
    rt_int=(max(rt_val)-min(rt_val))/2; rt_mean=rt_val(2); TM(:,1)=DM(:,1)*rt_int; TM(:,1)=TM(:,1)+rt_mean;
    lw_int=(max(lw_val)-min(lw_val))/2; lw_mean=lw_val(2); TM(:,2)=DM(:,2)*lw_int; TM(:,2)=TM(:,2)+lw_mean;
    rw_int=(max(rw_val)-min(rw_val))/2; rw_mean=rw_val(2); TM(:,3)=DM(:,3)*rw_int; TM(:,3)=TM(:,3)+rw_mean;
    kf_int=(max(kf_val)-min(kf_val))/2; kf_mean=kf_val(2); TM(:,4)=DM(:,4)*kf_int; TM(:,4)=TM(:,4)+kf_mean;

    % Konvergenstest
    intervals=[rt_int lw_int rw_int kf_int];
    dint=100*intervals./startint;
    if max(dint) <0.1 konvergens=1; end % intervaller <1% av startintervaller
    if x>100 konvergens=1; end % Max antall    
end

%disp(['Normfit2, konvergens: ' num2str(x) ' iterasjoner'])

% BESTEMMER VERDIER
center=bestcal(1);
lwhh=bestcal(2);
rwhh=bestcal(3);
kurtosis=bestcal(4);
C_est=hpeak(xax,bestcal(1),bestcal(2),bestcal(3),bestcal(4));
X=[C_est; ones(1,length(C))]; % Estimat av toppen + baselinje
b=C/X; % Kalkuler regresjonskoeffisienter
height=b(1);
bloffset=b(2);

%disp('end ---- qq_normfit2 ----')


% ------------------------------------------------
% ----------------- SUBFUNCTIONS -----------------
% ------------------------------------------------

% ---------------- DESMAT2 ------------------
function [D,center]=desmat2(nd)

segm=[-1; 0; 1];
for x=1:nd
    nyv=[repmat(-1,3^(x-1),1); repmat(0,3^(x-1),1); repmat(1,3^(x-1),1)];
    if x==1 D=nyv; else D=[D;D;D]; D=[nyv D]; end
end
[m,n]=size(D); center=ceil(m/2);


% ---------------- TESTEST ------------------
function e=testest(C,C_est)

X=[C_est; ones(1,length(C))]; % Estimat av toppen + baselinje
b=C/X; % Kalkuler regresjonskoeffisienter
y_est=b*X; % ny y kalkulert fra b og X
e=y_est-C; e=e.^2; e=sum(e); % Error


% ---------------- HPEAK ------------------
function yval = hpeak (scanpos, position, lwidth, rwidth, kurtosis)
%global metset

li=find(scanpos<=position); lowpos=scanpos(li);
ri=find(scanpos>position); highpos=scanpos(ri);

kf=kurtosis*2; % Kutosis=1 gir kf=2: Normalfordelingskurve

s=lwidth*(2/2.35482); % Se 3.3.07.4 i [02-520]
%s=lwidth/(2*log(2))^0.5;
lyval = exp(-((position-lowpos).^kf)/(2*s^kf));
s=rwidth*(2/2.35482);
%s=rwidth/(2*log(2))^0.5;
hyval = exp(-((highpos-position).^kf)/(2*s^kf));

yval=[lyval hyval];









