function qq_peakprop(an)

global RE fileset metset locset %labels 

upd=0;

if an==1
    openwin
    upd=1;
end

if an>2 & an<3
    RtRadio=findobj('Tag','RtRadio');
    RiRadio=findobj('Tag','RiRadio');
    if an==2.1 set(RtRadio,'Value',0); set(RiRadio,'Value',1); end
    if an==2.2 set(RtRadio,'Value',1); set(RiRadio,'Value',0); end
    upd=1;
end

if an==3.1 & fileset.results_selpeak>1 fileset.results_selpeak=fileset.results_selpeak-1; upd=1; end
if an==3.2 & fileset.results_selpeak<fileset.results_npeaks fileset.results_selpeak=fileset.results_selpeak+1; upd=1; end

% Upd. Homolog RI
if an==4.0
    upd=1;
end

if an==5
    h=findobj('Tag','PP_PeakfitCheck'); metset.results_peakfit=get(h,'Value'); 
    h=findobj('Tag','PeakfitCheck'); set(h,'Value',metset.results_peakfit); % oppdaterer resultswin
    h=findobj('Tag','PP_KurtosisCheck'); metset.results_kurt=get(h,'Value'); 
    h=findobj('Tag','KurtosisCheck'); set(h,'Value',metset.results_kurt); % oppdaterer resultswin
    h=findobj('Tag','PP_SigmaEdit'); hstr=get(h,'String'); val=str2double(hstr); if isnan(val) val=4; set(h,'str','4'); end; if val<4 val=4; set(h,'str','4'); end
    metset.results_sigma=val; h=findobj('Tag','SigmaEdit'); set(h,'String',num2str(metset.results_sigma)); % oppdaterer resultswin
    %metset.results_peakfit % TEMP
    peakplot; selupd; 
    if metset.results_peakfit==1 fitpeak; end
end

% Keypress
if an==99
    kp=double(get(gcf,'CurrentCharacter'));
    if kp==31 | kp==28 qq_peakprop(3.1); end    
    if kp==30 | kp==29 qq_peakprop(3.2); end
end

if upd==1;
    h=findobj('Tag','FitPeakInfo'); set(h,'String','');    
    peakplot; selupd; if metset.results_peakfit==1 fitpeak; end
end


%======================================== SUBFUNCTIONS ========================================

% ----------- FITPEAK ------------
function fitpeak
global RE fileset metset

%disp('--- qq_peakprop/fitpeak ---')

% Henter x og y-vektor
sel=fileset.results_selpeak;
startp=RE(sel).startp;
endp=RE(sel).endp;
C=RE(sel).C';

% Constrain til antall sigma
h=findobj('Tag','RtRadio'); 
if get(h,'Value')==1; xvect=fileset.rt(startp:endp); else xvect=fileset.results_rivect(startp:endp); end
h=findobj('Tag','RtRadio'); if get(h,'Value')==1; rt=fileset.rt(RE(sel).maxp); else rt=fileset.results_rivect(RE(sel).maxp); end
[whh,lxp,rxp,hheight]=whhcalc(xvect,C);
lw=rt-lxp; rw=rxp-rt; elp=rt-lw*metset.results_sigma/2.355; erp=rt+rw*metset.results_sigma/2.355; ind=find(xvect>elp & xvect<erp);

% Beregner
xvect=xvect(ind); C=C(ind);
if metset.results_kurt==1
    [center,lwhh,rwhh,height,bloffset]=qq_normfit(xvect,C); 
    kurtosis=1;
else
    [center,lwhh,rwhh,height,bloffset,kurtosis]=qq_normfit2(xvect,C);
end

% ---- Plotter C ----
nyax=linspace(min(xvect),max(xvect),1000);
C_smooth=hpeak(nyax,center,lwhh,rwhh,kurtosis);
hold on; 
h=plot(nyax,(C_smooth*height)+bloffset,'r','LineWidth',2); if kurtosis==1; set(h,'Color','g'); end
line([min(xvect) max(xvect)],[bloffset bloffset],'Color',[0 1 0],'LineWidth',2)
hold off;

% Tekst
str{1}='Calculated by Normfit:'
str{2}=['Rt / RI: ' num2str(center,'%1.3f')];
str{3}=['Whh: ' num2str(lwhh+rwhh,'%1.4f') ' (LWhh: ' num2str(lwhh,'%1.4f') ', RWhh: ' num2str(rwhh,'%1.4f') ')'];
str{4}=['Asymmetry factor: ' num2str(rwhh/lwhh,'%1.4f') ',   Kurtosis: ' num2str(kurtosis,'%1.4f') ];
str{5}='';
metset.results_homridiff=str2double(get(findobj('Tag','HomRiEdit'),'String'));
h=findobj('Tag','RiRadio');
if isfield(RE(fileset.results_selpeak),'ri_calc') & get(h,'Value')==1
    pwri=RE(fileset.results_selpeak).ri_calc;
    SN=(metset.results_homridiff/((lwhh+rwhh)*2))-1;
    str{5}=['Est. Separation number (SN): ',num2str(SN)];
end
h=findobj('Tag','FitPeakInfo1'); set(h,'Str',str);

% Beregning av whh her:
[whh,lxp,rxp,hheight,maxp,asf]=whhcalc(xvect,C);
% Tekst
str{1}='Calculated by Whhcalc:'
str{2}=['Rt / RI: ' num2str(center,'%1.3f')];
str{3}=['Whh: ' num2str(whh,'%1.4f') ' (LWhh: ' num2str(maxp-lxp,'%1.4f') ', RWhh: ' num2str(rxp-maxp,'%1.4f') ')'];
str{4}=['Asymmetry factor: ' num2str(asf,'%1.4f')];
str{5}='';

metset.results_homridiff=str2double(get(findobj('Tag','HomRiEdit'),'String'));
h=findobj('Tag','RiRadio');
if isfield(RE(fileset.results_selpeak),'ri_calc') & get(h,'Value')==1
    pwri=RE(fileset.results_selpeak).ri_calc;
    SN=(metset.results_homridiff/((whh)*2))-1;
    str{5}=['Est. Separation number (SN): ',num2str(SN)];
end
h=findobj('Tag','FitPeakInfo2'); set(h,'Str',str);


%disp('END--- qq_peakprop/fitpeak ---')

% ----------- SELUPD -------------
function selupd
global fileset metset RE

% Peakinfo
str='';
if fileset.results_selpeak>0
    str{1}=['Peak: ',num2str(fileset.results_selpeak)];
    str{2}=['Area: ',num2str(RE(fileset.results_selpeak).area)];
    str{3}=['Area pct: ',num2str(RE(fileset.results_selpeak).areapct)];
    str{4}=['Raw Rt: ',num2str(fileset.rt(RE(fileset.results_selpeak).maxp))];
    str{5}=['RI: ',num2str(RE(fileset.results_selpeak).ri_calc)];     
    if RE(fileset.results_selpeak).identified==1
         str{6}=['Name: ',RE(fileset.results_selpeak).cmp_name];
         str{7}=['Short name: ',RE(fileset.results_selpeak).cmp_shortname];
         str{8}=['Reg Code: ',RE(fileset.results_selpeak).cmp_code];
    end
end

h=findobj('Tag','Peakinfotxt'); set(h,'String',str);
h=findobj('Tag','PnTxt'); set(h,'String',num2str(fileset.results_selpeak));


% ------------------- addinfo ---------------------
function addinfo(whh)
global RE fileset metset

str='';
metset.results_homridiff=str2double(get(findobj('Tag','HomRiEdit'),'String'));
h=findobj('Tag','RiRadio');
%RE(fileset.results_selpeak).ri_calc
if isfield(RE(fileset.results_selpeak),'ri_calc') & get(h,'Value')==1
    pwri=RE(fileset.results_selpeak).ri_calc;
    SN=(metset.results_homridiff/(whh*2))-1;
    str{1}=['Est. Separation number (SN): ',num2str(SN)];
end
h=findobj('Tag','AddInfo'); set(h,'String',str);


% ------------------- peakplot ---------------------
function peakplot
global RE fileset

sel=fileset.results_selpeak; 
startp=RE(sel).startp;
endp=RE(sel).endp;
C=RE(sel).C';

h=findobj('Tag','PP-Plot'); child=get(h,'Children'); delete(child); set(gcf,'CurrentAxes',h);

h=findobj('Tag','RtRadio');
if get(h,'Value')==1; 
    xvect=fileset.rt(startp:endp);
else
    xvect=fileset.results_rivect(startp:endp);
end

[whh,lxp,rxp,hheight,maxp]=whhcalc(xvect,C);

hold on
plot(xvect,C,'o-')
line([lxp rxp],[hheight hheight],'Color',[1 0 0]);
text((rxp+lxp)*0.5,hheight*1.1,['Whh: ' num2str(whh,'%1.4f')],'FontWeight','bold','HorizontalAlignment','center'); 
text(0.03,0.9,'','units','normalized','fontweight','bold','verticalalignment','top','Tag','Peakinfotxt'); 
line([min(xvect) max(xvect)],[min(C) min(C)],'LineStyle','--','Color',[1 0 0]);

hold off
xlim([min(xvect) max(xvect)]); yrange=max(C)-min(C); ylim([min(C)-yrange/50 max(C)+yrange/50]);

addinfo(whh);
qq_copyfigure

% ------------------- whhcalc ---------------------
function [whh,lxp,rxp,hheight,maxp,asf]=whhcalc(xvect,C)

% whh: Bredde ved halve hyde
% lxp/rxp: x-verdier for hh-linje
% hheight: Halve hyden
% maxp: maxpkt
% asf: asymmetrifaktor

% Beregner maxpkt
mi=find(C==max(C)); mi=mi(1); maxp=xvect(mi); 

% Beregning av whh
%minc=min(C); 
%maxc=max(C); 
%height=maxc-minc;
%hheight=(height/2)+minc; 
%above=find(C>hheight);
%li=[min(above)-1 min(above)]; lx=xvect(li); ly=C(li);
%dxdy=(lx(2)-lx(1))/(ly(2)-ly(1)); dh=hheight-ly(1); lxp=lx(1)+(dh*dxdy);
%ri=[max(above) max(above)+1]; rx=xvect(ri); ry=C(ri);
%dxdy=(rx(2)-rx(1))/(ry(2)-ry(1)); dh=hheight-ry(1); rxp=rx(1)+(dh*dxdy);
%whh=rxp-lxp; 

% Beregning av whh
minc=min(C); 
maxc=max(C); 
height=maxc-minc;
hheight=(height/2)+minc; 
above=find(C>hheight);
if min(above)<2
    lxp=min(xvect);
else
    li=[min(above)-1 min(above)]; lx=xvect(li); ly=C(li);
    dxdy=(lx(2)-lx(1))/(ly(2)-ly(1)); dh=hheight-ly(1); lxp=lx(1)+(dh*dxdy);
end
if max(above)>length(xvect)-1
    rxp=max(xvect);
else
    ri=[max(above) max(above)+1]; rx=xvect(ri); ry=C(ri);
    dxdy=(rx(2)-rx(1))/(ry(2)-ry(1)); dh=hheight-ry(1); rxp=rx(1)+(dh*dxdy);
end
whh=rxp-lxp; 

% Beregning av asym
as_height=(height/10)+minc;
above=find(C>as_height);

li=[min(above)-1 min(above)]; 
if min(li)>0 
   lx=xvect(li); ly=C(li); dxdy=(lx(2)-lx(1))/(ly(2)-ly(1)); dh=as_height-ly(1); as_lxp=lx(1)+(dh*dxdy);
else
    as_lxp=xvect(1);
end

ri=[max(above) max(above)+1]; 
if min(ri)<length(C)
   rx=xvect(ri); ry=C(ri); dxdy=(rx(2)-rx(1))/(ry(2)-ry(1)); dh=as_height-ry(1); as_rxp=rx(1)+(dh*dxdy);
else
   as_rxp=xvect(length(xvect));
end

lw=maxp-as_lxp; rw=as_rxp-maxp;
asf=rw/lw; 

% ---------------- HPEAK ------------------
function yval = hpeak (scanpos, position, lwidth, rwidth, kurtosis)
%global metset

li=find(scanpos<=position); lowpos=scanpos(li);
ri=find(scanpos>position); highpos=scanpos(ri);

kf=kurtosis*2; % Kutosis=1 gir kf=2: Normalfordelingskurve

s=lwidth*(2/2.35482); % Se 3.3.07.4 i [02-520]
%s=lwidth/(2*log(2))^0.5;
lyval = exp(-((position-lowpos).^kf)/(2*s^kf));
s=rwidth*(2/2.35482);
%s=rwidth/(2*log(2))^0.5;
hyval = exp(-((highpos-position).^kf)/(2*s^kf));

yval=[lyval hyval];


%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
o=bw/5;
%gh=positions.gh;% grid height

x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='PeakPropWin'; winpar{2}='Peak Properties';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0;
% RESTET/CLOSE/ACCEPT
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'close(gcbf)',3,'CloseBtn');
% Scale Radio
p=p+1;[ui{p,1:7}] = deal('Scale: ','text',colors.bc,[x(3)+bw*0.4 y(12) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Ret. Time','RadioButton',colors.bc,[x(4) y(12) bw bh],'qq_peakprop(2.2)',2,'RtRadio');
p=p+1;[ui{p,1:7}] = deal('Ret. Index','RadioButton',colors.bc,[x(5) y(12) bw bh],'qq_peakprop(2.1)',2,'RiRadio');
% Sel Peak
p=p+1;[ui{p,1:7}] = deal('Peak No:','Text',colors.bc,[x(1) y(12) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('<','Pushbutton',colors.bc,[x(2) y(12) bw/3 bh],'qq_peakprop(3.1)',4,'');
p=p+1;[ui{p,1:7}] = deal('>','Pushbutton',colors.bc,[x(2)+bw*2/3 y(12) bw/3 bh],'qq_peakprop(3.2)',4,'');
p=p+1;[ui{p,1:7}] = deal('','text',colors.bc,[x(2)+bw/3 y(12) bw/3 bh],'',4,'PnTxt');
% Additional Info
p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[x(1) y(16) bw*3 y(12)-y(15)],'',2,'AddInfo');
p=p+1;[ui{p,1:7}] = deal('Homolog RI dist.','Text',colors.bc,[x(6)+bw*0.3 y(12) bw*1.5 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('100','Edit',[1 1 1],[x(7)+bw/2 y(12) bw/2 eh],'qq_peakprop(4)',2,'HomRiEdit');
% Fit Peak
p=p+1;[ui{p,1:7}] = deal('Fit peak','Checkbox',colors.bc,[x(1) y(15) bw eh],'qq_peakprop(5)',2,'PP_PeakfitCheck');
p=p+1;[ui{p,1:7}] = deal('Use','Text',colors.bc,[x(2) y(15) bw/3 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(num2str(metset.results_sigma),'Edit',[1 1 1],[x(2)+bw/3 y(15) bw/4 eh],'qq_peakprop(5)',2,'PP_SigmaEdit');
p=p+1;[ui{p,1:7}] = deal('Sigma','Text',colors.bc,[x(2)+2/3*bw y(15) bw/3 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Normal kurtosis','Checkbox',colors.bc,[x(3)+bw/2 y(15) bw eh],'qq_peakprop(5)',2,'PP_KurtosisCheck');

p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[x(1) y(18) bw*3 y(12)-y(15)],'',2,'FitPeakInfo1');
p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[x(4) y(18) bw*3 y(12)-y(15)],'',2,'FitPeakInfo2');

updfcn='qq_peakprop(100)';
h0=qq_drawwin(winpar,ui,updfcn);
set(h0,'KeyPressFcn','qq_peakprop(99)')

%axes('Position',[x(1) y(10) x(10)-x(1) y(1)-y(10)],'Tag','PP-Plot')
axes('Position',positions.largeplot,'Tag','PP-Plot')
h=findobj('Tag','RtRadio'); set(h,'Value',1)
h=findobj('Tag','PnTxt'); set(h,'HorizontalAlignment','Center')
h=findobj('Tag','PP_PeakfitCheck'); set(h,'Value',metset.results_peakfit);
h=findobj('Tag','PP_KurtosisCheck'); set(h,'Value',metset.results_kurt);

if isfield(metset,'results_homridiff')
    h=findobj('Tag','HomRiEdit'); set(h,'String',num2str(metset.results_homridiff));
end
    
