function qq_plot_blchrom(an)

% function qq_plot_mainchrom(an)
% Plots TIC in mainwindow
% an==0: Autoselect plot (depends on available data)

%disp('----- qq_plot_blchrom -----')

% SJEKK FOR PLOTSCALE
h=findobj(gcf,'Tag','Plotcontrol'); if isempty(h) qq_plot_scale; end

if nargin<1 an=0; end
if an==0 an=1; end 

if an==1 blplot; end

% -------------- SUBFUNCTION BLPLOT -------------------
function blplot

global fileset positions metset colors

%switch metset.global_plotscale
%    case 1; fileset.chrom_plotlab=fileset.rt;
%    case 2; fileset.chrom_plotlab=fileset.results_rivect;
%    case 3; fileset.chrom_plotlab=1:length(fileset.rt)
%end

dim=length(fileset.chrom_tic3); 
maxy=max(max(fileset.chrom_tic3),max(fileset.chrom_tic4));
miny=min(min(fileset.chrom_tic3),min(fileset.chrom_tic4));
yrange=maxy-miny; maxy=maxy+yrange*0.05; miny=miny-yrange*0.05;
minx=min(fileset.chrom_plotlab);
maxx=max(fileset.chrom_plotlab);

zeroplot=subplot('position',positions.largeplot);
plot(0)% rensker omrdet
hold on

zwl=length(fileset.bl_zerovector);
if zwl>0
   zwh=bar(fileset.chrom_plotlab,fileset.bl_zerovector*maxy,1,'g');
   set(zwh,'LineStyle','none','FaceColor',colors.btn{3})
end

plot(fileset.chrom_plotlab, fileset.chrom_tic3,'-','linewidth',1,'color',[0 0 1]); hold on
plot(fileset.chrom_plotlab, fileset.chrom_tic4,'--','linewidth',1,'color',[1 0 0]); hold on
if isfield(fileset,'baseline_thresh')==0 fileset.baseline_thresh=min(fileset.chrom_tic3(fileset.chrom_li:fileset.chrom_ri)); end
trl=line([minx maxx],[fileset.baseline_thresh fileset.baseline_thresh],'color',[0 0.5 0],'Tag','thresholdline','LineWidth',2);

set(gca,'Tag','Mainchrom','UserData','Baseline Chromatogram')

text(0.02,0.95,'Current chromatogram','Units','Normalized','Color',[1 0 0])
text(0.02,0.90,'Modified chromatogram','Units','Normalized','Color',[0 0 1])
text(0.02,0.85,'Threshold','Units','Normalized','Color',[0 0.5 0])

hold off
qq_copyfigure


