function qq_plot_ms(an,ions,yval,position)
global positions metset

if nargin>2 [m,n]=size(ions); if m>n ions=ions'; end; end
if nargin>2 [m,n]=size(yval); if m>n ions=yval'; end; end
if nargin<4 position=positions.smallplot; end

if an==0 && length(ions)==length(yval)
    barspec(ions,yval,position); 
    rcmenu;
end

if an==1; 
    numericout
end

if an==2;
    searchspectrum
end



% ==================================================================
% ===================       SUBFUNCTIONS        ====================
% ==================================================================

function searchspectrum
global metset locset

bh=findobj(gca,'Tag','SpecBars'); searchions=mean(get(bh,'Xdata')); yv=get(bh,'Ydata'); searchS=yv(4,:);

search_libs=metset.library_search;
[m,n_libs]=size(search_libs);
n_entries=0; 
for x=1:n_libs
    filename=[locset.path_library,'\class_',metset.global_class,'\lib_',search_libs{x}];
    load(filename,'Library');
    d=struct2cell(Library); [m,n]=size(d); 
    [Library.library_name]=deal(search_libs{x});
    % Legger til entrynr
    a=1:n; a=num2cell(a); a=cell2struct(a,'libentry',1); [Library(:).lib_entrynr]=deal(a(:).libentry);
    % Catenation
    CatLibrary(n_entries+1:n_entries+n)=Library(1:n);
end

n_entries=length(Library);
for i1=1:n_entries
        
    if length(Library(i1).ions) >= metset.library_minions 

        test_remn=[]; % ioner i test-spektrum ikke funnet i lib-spektrum 
        lib_remn=[];  % ioner i lib-spektrum ikke funnet i test-spektrum 
        n_match=length(searchions); % antall ioner testet
    
        if isequal(searchions, Library(i1).ions) 
            testv=searchS; libv=Library(i1).S; 
        else 
            test_remn=searchions; lib_remn=Library(i1).ions; p=0; testv=[]; libv=[];
            for i2=1:length(searchions)
                ind=find(Library(i1).ions==searchions(i2));
                if isempty(ind)==0
                    p=p+1; testv(p)=searchS(i2); libv(p)=Library(i1).S(ind);
                    test_remn(i2)=0; lib_remn(ind)=0;
                end
            end
            test_remn; a=find(test_remn==0); test_remn(a)=[]; % ioner i test-spektrum ikke funnet i lib-spektrum 
            n_match=n_match-length(test_remn);                % antall ioner testet
            lib_remn; a=find(lib_remn==0); lib_remn(a)=[];    % ioner i lib-spektrum ikke funnet i test-spektrum 
        end
        
        if metset.library_root>1
            testv(find(testv<0))=0; testv=testv.^(1/metset.library_root); %testv=testv*(100/max(testv));
            libv(find(libv<0))=0; libv=libv.^(1/metset.library_root); %libv=libv*(100/max(libv));
        end
            
        % Beregner match
        if metset.library_mf==1; 
            m=corrcoef(libv,testv); m=m(2,1); % Korrelasjonskoeffisient
        else 
            testv=testv/sum(testv); libv=libv/sum(libv); % normaliserer
            m=(var(testv)-var(libv-testv))/var(testv); % forkl. var koeff.
        end
        m=(m+1)*0.5; m=m*100; 
        
        match(i1,1)=m; % Total match, max=100
        if n_match<metset.library_minions; match(i1)=0; end
        match(i1,2)=(i1);              % entry nr
        match(i1,3)=length(test_remn); % antall ioner i test-spekter ikke testet
        match(i1,4)=length(lib_remn);  % antall ioner i bibl-spekter ikke testet
        match(i1,5)=length(testv);  % Number of ions tested
        
    end % if length(library(i1).ions>metset.library_minions
end % for-slyfe

% SORTERER TRUNKERER, fjerner alle med match=0
if isempty(match)==0
    a=find(match(:,1)==0); match(a,:)=[]; 
    [sortv, ind]=sort(match(:,1)); ind=flipud(ind); SMatch(:,:)=match(ind,:); % Sorter etter correl.coeff.
end
[n_hits,n]=size(SMatch); n_hits=min(n_hits,metset.library_showentr); 
SMatch=SMatch(1:n_hits,:); % 

% Creates output
[m,n]=size(SMatch);
for x=1:m
    entrynr=SMatch(x,2);
    p=1; if isempty(Library(entrynr).cmp_code)==0  str{x,p}=[Library(entrynr).cmp_code,blanks(4)]; else str{x,p}='-'; end
    p=2; if isempty(Library(entrynr).cmp_shortname)==0 str{x,p}=[Library(entrynr).cmp_shortname,blanks(4)]; else str{x,p}='-'; end
    p=3; if isempty(Library(entrynr).cmp_name)==0 str{x,p}=([Library(entrynr).cmp_name,blanks(4)]); else str{x,p}='-'; end
    p=4; str{x,p}=[num2str(SMatch(x,1)),blanks(4)]; 
    p=5; str{x,p}=[num2str(SMatch(x,5)),blanks(6)];
end
titlestr={'Code','Short','Name','Match','N.ions'}; 

printstr=[]; alltitle=[];
for x=1:p
    strx=strvcat(str(:,x)); 
    printstr=[printstr,strx];
    [a,len]=size(strx); % len=lengde p streng
    titlestr{x}=[titlestr{x},blanks(len-length(titlestr{x}))];titlestr{x}=[titlestr{x}(1:len-1),' '];
    alltitle=[alltitle,titlestr{x}];
end
% Separator
[o,p]=size(printstr); sepstr=repmat('-',1,p);

% Print to file
fh=fopen([locset.path_reports '\' metset.path_reports '\QQ_Spectrumsearch.txt'],'w');
fprintf(fh,[alltitle,char([13 10])]);
fprintf(fh,[sepstr,char([13 10])]);
for x=1:m
    fprintf(fh,[printstr(x,:),char([13 10])]);
end
fprintf(fh,[sepstr,char([13 10])]);
fprintf(fh,['Search is based on spectrum only',char([13 10])]);
fclose(fh);
% Open file
qq_message(6,[locset.path_reports '\' metset.path_reports '\QQ_Spectrumsearch.txt']);


% ------------------- numericout ------------------
function numericout
global metset locset

bh=findobj(gca,'Tag','SpecBars');
xv=mean(get(bh,'Xdata'));
yv=get(bh,'Ydata'); yv=yv(4,:);

p=1; str{p}='[m/z]; [Abundance]';
for x=1:length(yv)
    p=p+1;
    str{p}=[num2str(xv(x)) '; ' num2str(yv(x))];
end

fh=fopen([locset.path_reports '\' metset.path_reports '\QQ_Numericspectrum.txt'],'w');

for x=1:length(str)
    fprintf(fh,[str{x},char([13 10])]);
end

fclose(fh); qq_message(6,[locset.path_reports '\' metset.path_reports '\QQ_Numericspectrum.txt']);

    
% ------------------- rcmenu ------------------
function rcmenu

mh=get(gca,'UiContextMenu');
item2 = uimenu(mh, 'Label', 'Numeric output', 'Callback', 'qq_plot_ms(1)','Separator','on');
item3 = uimenu(mh, 'Label', 'Search Library', 'Callback', 'qq_plot_ms(2)');


% ------------------- SCALE ------------------
function scale

% Set axes
bh=findobj(gcf,'Tag','SpecBars'); plh=findobj(gcf,'Tag','MassSpec');
for x=1:length(plh)
    minx(x)=min(min(get(bh(x),'XData'))); maxx(x)=max(max(get(bh(x),'XData')));
    miny(x)=min(min(get(bh(x),'YData'))); maxy(x)=max(max(get(bh(x),'YData')));
end
minx=min(minx); maxx=max(maxx); miny=min(miny); maxy=max(maxy);

yrange=maxy-miny; xrange=maxx-minx; set(plh,'YLim',[miny maxy+yrange/20])
xrange=maxx-minx; set(plh,'XLim',[minx-xrange/50 maxx+xrange/50])

% Yscale
for x=1:length(plh)
    set(plh(x),'YAxisLocation','right','YTickLabel','');
    yp=get(plh(x),'Ytick')'; xp=repmat(maxx,1,length(yp))';
    xp=xp(find((yp)~=0)); yp=yp(find((yp)~=0)); % removes 0
    th=text(xp,yp,num2str(yp),'HorizontalAlignment','right','VerticalAlignment','middle'); 
end


% ------------------- BARSPEC ------------------
function barspec(ions,yval,position)
global metset

plh=subplot('position',position); delete(get(plh,'Children')); set(plh,'Tag','MassSpec');   

if isfield(metset,'global_resol')==0; metset.global_resol=1; end
o=metset.global_resol/2.5;

nuller=repmat(0,length(yval),1);
A=[ions(:)-o ions(:)+o ions(:)+o ions(:)-o]';
B=[nuller'; nuller'; yval; yval];    
bh=patch(A, B, [0 0 0.5],'Tag','SpecBars','EdgeColor','none');

% TEXT
% Finds ions that are largest among wz nearest neighbours
if length(yval)>100
    wz=round(length(yval)/20);
    for x=1:(length(yval)-wz+1)
        locy=yval(x:x+wz-1); [maxv,lind]=max(locy); 
        if (lind>1 & lind <wz) ind(x)=lind+x-1; end
    end
    ind(find(ind==0))=[];  unind=unique(ind);    
else
    unind=1:length(yval);
end
% treshold value 
tresh=1; unind=unind(find(yval(unind)>tresh));
% Text
th=text(ions(unind),yval(unind),num2str(ions(unind)')); 
set(th,'HorizontalAlignment','center','VerticalAlignment','bottom')
    
scale

qq_copyfigure

%get(plh)
    
    


    