function qq_plot_peakchrom(an)

% function qq_plot_peakchrom(an)
% Plots TIC in peaknwindow
% an==0: Autoselect plot (depends on available data)
global locset

if locset.tracker==1 disp(['---- qq_plot_peakchrom ---- ' num2str(an)]); end

% SJEKK FOR PLOTSCALE
h=findobj(gcf,'Tag','Plotcontrol'); if isempty(h) qq_plot_scale; end

if nargin<1 an=0; end
if an==0 an=1; end 

if an==1 peakplot; qq_plot_scale(100); end


% ---------------- PEAKPLOT ------------------
function peakplot
global fileset CL positions

menuh=uicontextmenu; set(menuh,'Tag','PlotMenu');
uimenu(menuh,'Label','Manual split','CallBack','qq_peakcall(17.2)')
uimenu(menuh,'Label','Move borders','CallBack','qq_peakcall(17.3)')
uimenu(menuh,'Label','Lock','CallBack','qq_peakcall(8.4)')
uimenu(menuh,'Label','Unlock','CallBack','qq_peakcall(8.5)')
uimenu(menuh,'Label','Delete','CallBack','qq_peakcall(17)')
uimenu(menuh,'Label','Autosplit','CallBack','qq_peakcall(17.1)')

dim=size(fileset.chrom_tic2); dim=dim(2);
maxy=max(fileset.chrom_tic2)+(max(fileset.chrom_tic2)-min(fileset.chrom_tic2))*0.05;
miny=min(fileset.chrom_tic2)-(max(fileset.chrom_tic2)-min(fileset.chrom_tic2))*0.01; 
minx=min(fileset.chrom_plotlab);
maxx=max(fileset.chrom_plotlab);

%zeroplot=subplot('position',[0 0.5 1 0.5]);
zeroplot=subplot('position',positions.largeplot);
plot(0)% rensker omrdet
hold on

npeaks=length(CL);
if npeaks>0 % 
   for i1=1:npeaks
      rectvect=[fileset.chrom_plotlab(CL(i1).startp) miny fileset.chrom_plotlab(CL(i1).endp)-fileset.chrom_plotlab(CL(i1).startp) maxy*1.05];
      h=rectangle('position',rectvect,...
         'LineWidth',1,...
         'EdgeColor',[0 0 0],...
         'FaceColor',[0.5 1 1],...
         'Tag','PeakRect',...
         'ButtonDownFcn','qq_peakcall(16.3)',...
         'UserData',i1,...
         'UiContextMenu',menuh);
      if CL(i1).locked==1 & CL(i1).quantified==0, set(h,'FaceColor',[1 1 0.5]); end % Locked
      if CL(i1).locked==1 & CL(i1).quantified==1, set(h,'FaceColor',[0 1 0]); end % Loccked & Quant.
      if CL(i1).locked==0 & CL(i1).quantified==1, set(h,'FaceColor',[0.75 0.75 1]); end % Quant
   end   
end

menuh=uicontextmenu; set(menuh,'Tag','PlotMenu');
uimenu(menuh,'Label','Select split position','CallBack','qq_peakcall(17.2)')
%if stat>0 % Dersom fileset.chrom_tic2 eksisterer
   plot(fileset.chrom_plotlab, fileset.chrom_tic2,'-','linewidth',1,'color',[0 0 1],'UiContextMenu',menuh)
%end

treshold=str2double(get(findobj('Tag','TresholdEdit'),'String')); if isnan(treshold) treshold=0; end
trl=line([minx maxx], [treshold treshold],'color','r','Tag','tresholdline','LineWidth',2);

% PEAKNUMBERS
for i1=1:npeaks, 
    peaknumber(i1)={num2str(i1)};  xpos(i1)=fileset.chrom_plotlab(CL(i1).maxp); 
end
if npeaks>1
   ypos=ones(1,npeaks);ypos=ypos*maxy*0.95;
   pnh=text(xpos,ypos,peaknumber,'HorizontalAlignment','center','FontSize',10,'FontWeight','bold','Tag','PnrTxt');
end

% RANK
p=0; xpos=[];
for i1=1:npeaks, 
    if CL(i1).rank>0, p=p+1; rang(p)={num2str(CL(i1).rank)}; xpos(p)=fileset.chrom_plotlab(CL(i1).maxp); end 
end
if p>0;
   ypos=ones(1,p);ypos=ypos*maxy*0.9;
   pnr=text(xpos,ypos,rang,'HorizontalAlignment','center','FontSize',10,'FontWeight','bold','Color',[1 0 0],'Tag','RankMark');
end
hold off

%scale; yscale;
set(gca,'Tag','Mainchrom','UserData','Find peaks Chromatogram')
qq_copyfigure
% Set slider
sp=fileset.chrom_cent/length(fileset.chrom_plotlab); sh=findobj(gcf,'Tag','Plotslider'); set(sh,'Value',sp*100);