function qq_plot_quant
global positions metset quantset locset

if locset.tracker==1 disp(['---- qq_plot_quant ---- ']); end

C_vol=quantset.C_vol;
blpos=quantset.blpos;
for i = 1:length(quantset.areas)
   peaklab{i}=[num2str(quantset.percent(i),3) ' %'];
end

[le,n_peaks]=size(C_vol);

% MENU FOR PROFILES
menuh=uicontextmenu; set(menuh,'Tag','PlotMenu');
uimenu(menuh,'Label','Select split position','CallBack','qq_quantcall2(30.1)')
uimenu(menuh,'Label','Delete profile','CallBack','qq_quantcall2(30.2)')

% Fargekart(inntil ni topper)
farger(1:3,1:3)=eye(3);farger(4:6,1:3)=ones(3)*0.75-eye(3)*0.75; farger(7:12,1:3)=farger(1:6,1:3)*0.75;
% verste plott, kromatogrammer
iplh=subplot('position',positions.largeplot); h=plot(0); % Renser eksisterende plot

%totmax=max(max(C_vol)); totmin=min(min(C_vol));
%voffset=(totmax-totmin)*0.02; 
%hoffset=(max(quantset.labels)-min(quantset.labels))/100;
%axis([min(quantset.labels)-hoffset max(quantset.labels)+hoffset totmin-voffset totmax+5*voffset])
%lh=line([min(quantset.labels)-hoffset max(quantset.labels)+hoffset],[0 0],'LineStyle','-','Color',[0.2 0.2 0.2],'LineWidth',1);

% Peak Labels
for p = 1:n_peaks
    [maxc,mapos]=max(C_vol(:,p));
    text(quantset.labels(mapos),maxc,peaklab(p),'fontweight','bold',...
        'horizontalalignment','center','VerticalAlignment','Bottom','FontSize',12)
end

hold on

% PLOTT INTEGRATION
for p=1:n_peaks 
    Cv=C_vol(:,p)';
    blp=blpos(p,:);
    
    % FILL
    if isfield(metset,'integrate_fill')==1 & metset.integrate_fill==1
        h=findobj('Tag','QuantWin'); set(h,'Renderer','OpenGL');
        px=[quantset.labels(blp(1)) quantset.labels(blp(1):blp(2)) quantset.labels(blp(2))];
        py=[blp(3) Cv(blp(1):blp(2)) blp(4)];
        h=patch(px,py,'y'); 
        set(h,'FaceColor',farger(p,:)); set(h,'FaceAlpha',0.3) 
    end
   
    a=blp(1):blp(2);  % X-verdier
    b=C_vol(blp(1):blp(2),p); %Y-verdier
   
    plot(quantset.labels(1:le),Cv,'linewidth',0.5,'color',farger(p,:),'Tag','cp') % Tegner totalprofil  
    plot(quantset.labels(a),b,'linewidth',2, 'color',farger(p,:),'Tag','cp')  % Tegner integrert profil
   
    % Tegner baselinje
    line([quantset.labels(blp(1)) quantset.labels(blp(2))], [blp(3), blp(4)],'color',farger(p,:),'linestyle','--','linewidth',2)
    line([quantset.labels(blp(1)) quantset.labels(blp(1))], [blp(3) Cv(blp(1))],'color',farger(p,:),'linestyle','-','linewidth',2,'Tag','cp')
    line([quantset.labels(blp(2)) quantset.labels(blp(2))], [blp(4) Cv(blp(2))],'color',farger(p,:),'linestyle','-','linewidth',2,'Tag','cp')
    % Right Click
    h=findobj('Tag','cp');
    set(h,'ButtonDownFcn',' set(gcbo,''Tag'',''CprofC'') ');
    set(h,'UiContextMenu',menuh); set(h,'UserData',p); set(h,'Tag','Cprof')     
end

% MENU FOR HANDLES
    menuh2=uicontextmenu; set(menuh,'Tag','HandleMenu');
    uimenu(menuh2,'Label','Move','CallBack','qq_quantcall2(40)')
    uimenu(menuh2,'Label','Fit to zero','CallBack','qq_quantcall2(41)')   
    uimenu(menuh2,'Label','Fit to profile','CallBack','qq_quantcall2(42)')
    
for p=1:n_peaks
    % Baseline Handles
    blp=blpos(p,:);
    lh=plot(quantset.labels(blp(1)),blp(3),'o','MarkerSize',10,'MarkerEdgeColor',farger(p,:),'MarkerFaceColor',farger(p,:),...
        'UserData',-p,'Tag','BaselineHandle','ButtonDownFcn','set(gcbo,''Tag'',''SelBaselineHandle'')','UiContextMenu',menuh2);
    rh=plot(quantset.labels(blp(2)),blp(4),'o','MarkerSize',10,'MarkerEdgeColor',farger(p,:),'MarkerFaceColor',farger(p,:),...
        'UserData',p,'Tag','BaselineHandle','ButtonDownFcn','set(gcbo,''Tag'',''SelBaselineHandle'')','UiContextMenu',menuh2);
end

%blmin=min(blpos(:,3));

totmax=max(max(C_vol)); totmin=min([min(min(C_vol)) min(blpos(:,3)) min(blpos(:,4))]);
voffset=(totmax-totmin)*0.02; 
hoffset=(max(quantset.labels)-min(quantset.labels))/100;
axis([min(quantset.labels)-hoffset max(quantset.labels)+hoffset totmin-voffset totmax+5*voffset])
lh=line([min(quantset.labels)-hoffset max(quantset.labels)+hoffset],[0 0],'LineStyle','-','Color',[0.2 0.2 0.2],'LineWidth',1);

hold off
qq_copyfigure