function qq_quantcall2(an)
% function qq_quantcall2(an)
%
% Global variables:
%   - XBL: Baselinjesubtraherte data
%   - CL: Clusters
%   - fileset: file settings
%   - metset: method settings

% GLOBAL AND PERSISTENT VARIABLES:
global XBL CL fileset metset locset % general global variables
global quantset % For Quantcall
% X: Rawdata, C: Resolved chromatograms, S: resolved spectra, XUT: Untransformed X 

qq_message(2); % Blanks messageline

%[quantset.C_vol quantset.C_int]% TEMP

% --------------- OPENS WINDOW -------------------
if an==0 
    if length(CL)>0
        if fileset.global_currentcl==0 fileset.global_currentcl=1; end % Check that fileset.global_currentcl>0
        quantset.estimate='S';
        openwin;  
        if fileset.global_currentcl==0, fileset.global_currentcl=1; end %   Cluster number
        newpeak;   % Resets for new peak
        rankupdate;
        quantset.smallplot=1; % Chromatogram in small window
        smallplot; largeplot; % updates
    else
        qq_message(1,'|r|Nothing to quantify; peaks/Clusters not defined')
    end
end

% --------------- TRANSFORMATIONS -------------------
if an==11.1 quantset.X=qq_transform(quantset.XUT,1); quantset.transform='A'; end
if an==11.2 quantset.X=qq_transform(quantset.XUT,2); quantset.transform='B'; end
if an==11.3 quantset.X=qq_transform(quantset.XUT,3); quantset.transform='C'; end
if an==11.4 quantset.X=qq_transform(quantset.XUT,4); quantset.transform='D'; end
if an==11.5 quantset.X=qq_transform(quantset.XUT,5); quantset.transform='E'; end
if an==11.8 quantset.X=qq_transform(quantset.XUT,8); quantset.transform='F'; end
if an==11.9 quantset.X=qq_transform(quantset.XUT,9); quantset.transform='G'; end
if an==11.6 quantset.X=quantset.XUT; quantset.transform='U'; end
if an==11.7 quantset.X=qq_transform(quantset.X,6); quantset.transform='N'; end
if an>11.0 & an<12.0 quantset.resolved=0; 
    quantset.quantified=0; quantset.C=[]; quantset.S=[]; quantset.C_vol=[]; quantset.largeplot=2; largeplot; smallplot; rankupdate
end

% -------------- ESTIMATE C/S -------------------

if an>12.0 & an<13 & CL(fileset.global_currentcl).rank<1
    qq_message(1,'|r|Rank not set')
end

% ESTIMATE C/S
if an==12.3 & CL(fileset.global_currentcl).rank>0
    estinit(quantset.X,CL(fileset.global_currentcl).rank);
    quantset.resolved=0; quantset.quantified=0; quantset.C=[]; quantset.S=[]; quantset.C_vol=[];
end

% Calc S/C
if an==12.4 & CL(fileset.global_currentcl).rank>0
     rank=CL(fileset.global_currentcl).rank;
    if isempty(quantset.ipure)
        estinit(quantset.X,CL(fileset.global_currentcl).rank);
    end
    
    if quantset.estimate=='S';
        %disp('--- quantset.estimate==S ---')
        quantset.S=quantset.X(quantset.ipure,:);      
        sumS=sum(quantset.S'); 
        for x=1:rank, quantset.S(x,:)=quantset.S(x,:)/sumS(x); end; % Normalise sum of S to 1
        quantset.C=quantset.X/quantset.S; 
        cvol; autobaseline; integrate
    end
    
    if quantset.estimate=='C';
        quantset.C=quantset.X(:,quantset.ipure); % initial estimate of C
        quantset.S=(quantset.X'/quantset.C')';
        sumS=sum(quantset.S'); for x=1:rank, quantset.S(x,:)=quantset.S(x,:)/sumS(x); end; 
        quantset.C=quantset.X/quantset.S;
        cvol; autobaseline; integrate;
    end
    quantset.largeplot=3; quantset.resolved=1; largeplot; resplot;
end

% CS-Radio
if an==12.5 
    h=findobj('Tag','CS-Radio'); set(h,'Value',0); set(gco,'Value',1); 
    if get(gco,'String')=='C'; quantset.estimate='C'; end
    if get(gco,'String')=='S'; quantset.estimate='S'; end
    quantset.ipure=[];
    smallplot
end

% -------------------- REFINE -------------------
if an>13.0 & an<14.0 & quantset.resolved==0;
    qq_message(1,'|r|No solution to refine')
end
% ALS
if an==13.1 & quantset.resolved>0
    [m,rank]=size(quantset.C); 
    %[quantset.C,quantset.S] = qq_als(quantset.X,quantset.C,CL(fileset.global_currentcl).rank); 
    [quantset.C,quantset.S] = qq_als(quantset.X,quantset.C,rank); 
    cvol; autobaseline; integrate;
    largeplot; resplot;
end

% ---------------- SINGLE PEAK -------------------
if an==14.1
    quantset.C=(sum(quantset.X'))'; % C = total ion current, 
    quantset.S=(quantset.X'/quantset.C')'; % S estimated from C 
    cvol; autobaseline; integrate;
    quantset.estimates=1; quantset.resolved=1; quantset.largeplot=3; largeplot; resplot
    % Autoaccept
    h=findobj('Tag','AcceptSingleCheck'); val=get(h,'Value'); 
    if val==1 an=99; end
end

% ----------------- ALL SINGLE -------------------
if an==14.2
    for x=1:fileset.global_nuclusters; 
        fileset.global_currentcl=x; qq_quantcall2(14.1); drawnow; 
    end
end

% ----------- CALL FROM BATCHCALL, ALL SINGLE ----------
if an==14.3
    for x=1:fileset.global_nuclusters 
        [quantset.X, quantset.labels, quantset.ions]=getquantset.X(x);
        quantset.C=(sum(quantset.X'))'; quantset.S=(quantset.X'/quantset.C')'; 
        cvol; autobaseline; integrate;
        quantset.estimates=1; quantset.resolved=1; 
        qq_plot_quant; 
        [d,n_analytes]=size(quantset.C);
        CL(x).quantified=1;
        CL(x).locked=1;     
        CL(x).inresults=0;    
        CL(x).n_analytes=n_analytes;
        CL(x).C=quantset.C;
        CL(x).S=normmax(quantset.S);
        CL(x).areas=quantset.areas;      
        fileset.global_nuquant=x;
    end
end

% ---------------------- SET RANK -------------------
% estimate
if an==15.1, 
    CL(fileset.global_currentcl).rank=qq_rang(quantset.X,0);
end
% decrease
if an==15.2 & CL(fileset.global_currentcl).rank>0, CL(fileset.global_currentcl).rank= CL(fileset.global_currentcl).rank-1; end
% Increase
if an==15.3 & CL(fileset.global_currentcl).rank<min(size(quantset.X)), CL(fileset.global_currentcl).rank= CL(fileset.global_currentcl).rank+1; end  
% update
if an>15.0 & an<15.9
    if CL(fileset.global_currentcl).rank>0, tekst=num2str(CL(fileset.global_currentcl).rank); else, tekst=' '; end
    h=findobj('Tag','RankTxt'); set(h,'String',tekst);  smallplot;
end

% ---------------------- SELECT PEAK -------------------
if an==18.1 & fileset.global_currentcl>1, fileset.global_currentcl=fileset.global_currentcl-1; end
if an==18.2 & fileset.global_currentcl<fileset.global_nuclusters, fileset.global_currentcl=fileset.global_currentcl+1; end
if an==18.3
    h=findobj('Tag','PnTxt'); str=get(h,'String'); pn=str2double(str);
    if isnan(pn) pn=fileset.global_currentcl; end
    if pn > fileset.global_nuclusters pn=fileset.global_nuclusters; end; if pn<1 pn=1; end
    fileset.global_currentcl=pn;  
end
if an>=18.1 & an<18.4 
    newpeak; largeplot; smallplot; rankupdate
end

% -------------------- LARGEPLOT ------------------
if an==16.1, quantset.largeplot=1; largeplot; end 
if an==16.2, quantset.largeplot=2; largeplot; end 
if an==16.3 & quantset.resolved>0, quantset.largeplot=3; largeplot; end 
if an==16.4 & quantset.resolved>0, quantset.largeplot=4; largeplot; end 

% -------------------- SMALLPLOT -----------------
if an>17.0 & an<18.0 
    h=findobj('Tag','Plotradio'); set(h,'Value',0); set(gcbo,'Value',1)
    if an==17.1, quantset.smallplot=1; smallplot; end
    if an==17.2, quantset.smallplot=2; smallplot; end
    if an==17.3, quantset.smallplot=3; smallplot; end
    if an==17.4, quantset.smallplot=4; smallplot; end
    if an==17.5, quantset.smallplot=5; smallplot; end
end

% --------------- PEAKWINDOW --------------------
if an==20.4
    qq_peakcall(0);
end

% ------------------ EXPORT DATA ----------------
if an==20.9
    export(quantset.X)
end

% --------------- SPLIT profile ----------------
if an==30.1
    [xp,yp]=ginput(1); % posisjon
    h=findobj('Tag','CprofC'); nr=get(h,'UserData'); % nr=profile to split,
    lower=find(quantset.labels<xp); splitp=max(lower);
    [m,n]=size(quantset.C); % n=number of peaks
    quantset.C(splitp:m,n+1)=quantset.C(splitp:m,nr);
    quantset.C(splitp:m,nr)=0; 
    quantset.S(n+1,:)=quantset.S(nr,:); 
    cvol; autobaseline; integrate;
    CL(fileset.global_currentcl).rank=CL(fileset.global_currentcl).rank+1;
    h=findobj('Tag','RankTxt'); set(h,'String',num2str(CL(fileset.global_currentcl).rank))
    largeplot; resplot
end

% ------------- DELETE profile -----------------
if an==30.2
    [m,n]=size(quantset.C);
    if n>1; h=findobj('Tag','CprofC'); 
        nr=get(h,'UserData'); quantset.C(:,nr)=[]; quantset.S(nr,:)=[]; quantset.C_vol(:,nr)=[]; quantset.C_int(:,nr)=[];
        quantset.blpos(nr,:)=[]; quantset.areas(nr)=[]; quantset.height(nr)=[]; quantset.percent(nr)=[];
    else 
        qq_message(1,'|r|Last Peak');
    end
    largeplot; resplot
end

% ------------- MOVE BASELINE -----------------
if an==40
    movebaseline; integrate; qq_plot_quant
end
if an==41
    handle_id=get(gco,'Userdata');
    if handle_id<0 handle_id=handle_id*-1; quantset.blpos(handle_id,3)=0; else quantset.blpos(handle_id,4)=0; end
    integrate; qq_plot_quant
end
if an==42
    handle_id=get(gco,'Userdata');
    if handle_id<0
        handle_id=handle_id*-1; quantset.blpos(handle_id,3)=quantset.C_vol(quantset.blpos(handle_id,1),handle_id);
    else
        quantset.blpos(handle_id,4)=quantset.C_vol(quantset.blpos(handle_id,2),handle_id);       
    end
    integrate; qq_plot_quant;
end

% --------------- GET STORED -------------------
if an==95
    % Imports data from CL, used for re-integration
    if isfield(CL,'C_vol') && isempty(CL(fileset.global_currentcl).C_vol)==0
        npeaks=CL(fileset.global_currentcl).n_analytes;
        quantset.rank=CL(fileset.global_currentcl).rank;
        quantset.C=CL(fileset.global_currentcl).C;
        for x=1:npeaks
            quantset.S(x,:)=CL(fileset.global_currentcl).S(x,:)/sum(CL(fileset.global_currentcl).S(x,:));
        end
        quantset.C_vol=CL(fileset.global_currentcl).C_vol;
        quantset.C_int=CL(fileset.global_currentcl).C_int;
        quantset.blpos=CL(fileset.global_currentcl).blpos;
        quantset.areas=CL(fileset.global_currentcl).areas;
        quantset.resolved=1;
        integrate; qq_plot_quant; smallplot;
    else
        qq_message(1,'|r|Sufficient info not stored')
    end    
end


% --------------- KEY PRESS -------------------
if an==96
    kp=double(get(gcf,'CurrentCharacter'));
    if kp==28  qq_quantcall2(18.1); end    
    if kp==29  qq_quantcall2(18.2); end
    if kp==30  qq_quantcall2(15.3); end
    if kp==31  qq_quantcall2(15.2); end
end

% -------------------- RESET ---------------------
if an==97; 
    CL(fileset.global_currentcl).quantified=0;
    CL(fileset.global_currentcl).inresults=0;
    CL(fileset.global_currentcl).n_analytes=[];
    CL(fileset.global_currentcl).areas=[];
    CL(fileset.global_currentcl).C=[];
    CL(fileset.global_currentcl).S=[];
    CL(fileset.global_currentcl).C_vol=[];
    CL(fileset.global_currentcl).C_int=[];
    CL(fileset.global_currentcl).blpos=[];    
    fileset.global_nuquant=sum(cat(1,CL(:).quantified)); % Number of quantified clusters
    quantset.quantified=0; quantset.resolved=0;   
    newpeak; largeplot; smallplot;
end 

% -------------------- CLOSE --------------------
if an==98 
    qq_closewin; clear quantset;
end

% ------------------- ACCEPT ---------------------
if an==99   
    if quantset.quantified==0 | quantset.resolved==0; qq_message(1,'|r|Not quantified'); end    
    
    % Updates areas
    if quantset.quantified==1 & quantset.resolved==1;
        [d,n_analytes]=size(quantset.C);
        % Recalculates S from quantset.XUT if transform A to D was used
        if strmatch(quantset.transform,{'A','B','C','D','N'}) S_untr=(quantset.XUT'/quantset.C')'; else S_untr=quantset.S; end
        %SUT=realspectra(quantset.XUT,quantset.C);
        CL(fileset.global_currentcl).quantified=1;
        CL(fileset.global_currentcl).locked=1;     
        CL(fileset.global_currentcl).inresults=0;    
        CL(fileset.global_currentcl).n_analytes=n_analytes;
        CL(fileset.global_currentcl).C=quantset.C;
        CL(fileset.global_currentcl).S=normmax(S_untr); 
        CL(fileset.global_currentcl).areas=quantset.areas; 
        
        CL(fileset.global_currentcl).C_vol=quantset.C_vol;  
        CL(fileset.global_currentcl).C_int=quantset.C_int;  
        CL(fileset.global_currentcl).blpos=quantset.blpos;
        
        fileset.global_nuquant=sum(cat(1,CL(:).quantified)); % Number of quantified clusters
        
        % Get next peak if caller is maincall 
        CallWinTag=get(gcf,'UserData'); 
        if strcmp(CallWinTag,'MainWin') & fileset.global_currentcl<fileset.global_nuclusters; 
            fileset.global_currentcl=fileset.global_currentcl+1; newpeak; largeplot; smallplot; rankupdate
        end
        % Returns to peakcall if caller is peakcall
        if strcmp(CallWinTag,'PeakWin')
            qq_closewin; clear quantset;
        end 
    end       
end

% --------------- UPDATE WINDOW -------------------
if an==100 
    newpeak; smallplot; largeplot
end

%quantset

% ----------------------------------------------------------------------------------------
%
%                                 S U B F U N C T I O N S
%
% ----------------------------------------------------------------------------------------

%--------------- RANKUPDATE ------------------

function rankupdate
global CL quantset fileset

if get(findobj('Tag','RankCheck'),'Value')
    CL(fileset.global_currentcl).rank=qq_rang(quantset.X,0);
    quantset.rank=CL(fileset.global_currentcl).rank;
end
if CL(fileset.global_currentcl).rank>0, tekst=num2str(CL(fileset.global_currentcl).rank); else, tekst=' '; end
set(findobj('Tag','RankTxt'),'String',tekst);  


%--------------- MOVEBASELINE ------------------
function movebaseline
global metset quantset

handle_id=get(gco,'Userdata');

qq_message(1,'|b|Select new position')
[x,y] = ginput(1);

minind=max(find(quantset.labels<x)); if isempty(minind) minind=1; end
maxind=min(find(quantset.labels>=x)); if isempty(maxind) maxind=length(quantset.labels); end
minval=quantset.labels(minind);
maxval=quantset.labels(maxind);
if x-minval>maxval-x
    ind=maxind;
else
    ind=minind;
end

if handle_id<0 % Left handle
    handle_id=handle_id*-1;
    quantset.blpos(handle_id,1)=ind;
    quantset.blpos(handle_id,3)=y;
else
    quantset.blpos(handle_id,2)=ind;
    quantset.blpos(handle_id,4)=y;
end

%if metset.integrate_blfit==0; quantset.blpos(:,3)=0; quantset.blpos(:,4)=0; end 

qq_message(2)


%--------------- AUTOBASELINE ------------------
function autobaseline
global metset quantset

C_vol=quantset.C_vol;

if isfield(metset,'integrate_tresh'); tresh=metset.integrate_tresh; else tresh=50; end
if isfield(metset,'integrate_blfit'); blfit=metset.integrate_blfit; else blfit=0; end

[n_scans, n_peaks]=size(C_vol);

for ii=1:n_peaks
    
    sumCi(ii)=sum(C_vol(:,ii));
    if sumCi(ii) <= 0 qq_message(1,'|r|Problem: Negative or empty peak'); end
    
    [maxCi(ii) maxpos]=max(C_vol(:,ii)); maxposCi(ii)=maxpos(1);
    
    % Beregner treshold
    treshold(ii)=max(C_vol(:,ii))*(tresh/100); % Treshold % av max hyde
    
    lmin=1; % lmin: lokale minima under treshold tv for max
    for jj=maxposCi(ii):-1:2
        if C_vol(jj-1,ii) >= C_vol(jj,ii) & C_vol(jj,ii) < treshold(ii)
            lmin=[lmin jj];
        end
    end
    start(ii)=max(lmin);
    
    rmin=n_scans; % rmin: lokale minima under treshold th for max
    for jj=maxposCi(ii):n_scans-1
        if C_vol(jj+1,ii) >= C_vol(jj,ii) & C_vol(jj,ii) < treshold(ii)
            rmin=[rmin jj];
        end
    end
    slutt(ii)=min(rmin);
    
    if blfit==1
        starty(ii)=C_vol(start(ii),ii); 
        slutty(ii)=C_vol(slutt(ii),ii); 
    else
        starty(ii)=0;
        slutty(ii)=0;
    end
 
end

quantset.blpos=[start' slutt' starty' slutty'];


%------------ INTEGRATE --------------
function integrate
global metset quantset

C_vol=quantset.C_vol; blpos=quantset.blpos;

%%%% INTEGRERER OG PLOTTER %%%%%

dim=size(C_vol);     
for i1 = 1:dim(2)
   [maxc(i1),mapos(i1)]=max(C_vol(:,i1)) ; 
   if maxc(i1)==0; qq_message(1,'|r|Problem: Negative or empty peak'); end
end

%- BEREGNER BASELINJE OG DIFFERANSER -
baseline=zeros(dim(1),dim(2)); % Matrise som inneholder baselinje
diff=zeros(dim(1),dim(2));     % Matrise som inneholder baselinjekorrigerte kromatogrammer
for i=1:dim(2)
   % Beregner funksjon for baselinje
   startx=blpos(i,1); sluttx=blpos(i,2);
   starty=blpos(i,3); slutty=blpos(i,4);
   
   a=(slutty-starty)/(sluttx-startx); b=starty;
   
   % Beregner baselinje og differanse
   for j=startx:sluttx
       if metset.integrate_blfit==1
          baseline(j,i)=(a*(j-startx))+b;
      end
      diff(j,i)=C_vol(j,i)-baseline(j,i);
   end
   height(i)=diff(mapos(i),i);
end

quantset.C_int=diff;

% Integrerer og beregner arealer
areas=trapz(diff); % Beregner areal ved  integrere differanse mellom totprofil og baselinje

for i = 1:dim(2)
   percent(i)=100*areas(i)/(sum(areas));   % Beregner arealprosenter
end

quantset.areas=areas;
quantset.height=height;
quantset.percent=percent;
quantset.quantified=1;

% --------------- CVOL -----------------
function cvol
global quantset
% Calculates chromatographic profile from the 'volume' of C*S.

S=quantset.S; C=quantset.C;

dim=size(C);     
C_vol=zeros(dim(1),dim(2)); 
for i1 = 1:dim(2)
   x=C(:,i1)*S(i1,:);
   C_vol(:,i1)=sum(x')';   
end

quantset.C_vol=C_vol;


% --------------- NORMMAX -----------------
function S=normmax(S)

f=max(S,[],2); fm=diag(100./f); S=fm*S; % Sets max=100


% -------------- NEWPEAK -------------------
function newpeak
global fileset quantset CL XBL

%names=fieldnames(quantset); for x=1:length(names); quantset=rmfield(quantset,names{x}); end

startp=CL(fileset.global_currentcl).startp; endp=CL(fileset.global_currentcl).endp;

quantset.estimate='S';
quantset.ions=fileset.ions;
quantset.X=XBL(startp:endp,:);
quantset.XUT=quantset.X; 
quantset.labels=fileset.rt(startp:endp);
quantset.rank=CL(fileset.global_currentcl).rank;
quantset.transform='U';
quantset.estimates=0;   
quantset.resolved=0;
quantset.quantified=0;
quantset.ipure=[];
quantset.largeplot=2;
quantset.C=[]; 
quantset.S=[];  
quantset.C_vol=[]; % Quantitative profile
quantset.C_int=[]; % Integrated profile
quantset.blpos=[]; % Baseline
quantset.areas=[];
quantset.height=[];
quantset.percent=[];

set(findobj('Tag','PnTxt'),'String',num2str(fileset.global_currentcl)); 
if CL(fileset.global_currentcl).rank>0, tekst=num2str(CL(fileset.global_currentcl).rank); else, tekst=' '; end
h=findobj('Tag','RankTxt'); set(h,'String',tekst);  


% -------------- LARGEPLOT -------------------
function largeplot
global fileset quantset CL

if quantset.largeplot==1; plottic(quantset.X); end
if quantset.largeplot==2; plotions(quantset.X); end
if quantset.largeplot==3; qq_plot_quant; end

if quantset.largeplot==4; 
    if strmatch(quantset.transform,{'A','B','C','D','N'}) S_plot=(quantset.XUT'/quantset.C')'; else S_plot=quantset.S; end
    S_plot=(normmax(S_plot)); [n_spectra,n_ions]=size(S_plot);
    for i1=n_spectra:-1:1
        px=(i1-1)/n_spectra; pw=1/n_spectra; qq_plot_ms(0,quantset.ions,S_plot(i1,:),[px 0.5 pw 0.5]);
    end   
end

if quantset.largeplot>=1 && quantset.largeplot<=3  
    if CL(fileset.global_currentcl).quantified==1
        str='Quantified'; bc=[0 1 0];
    else
        str='Not Quantified'; bc=[1 1 0];
    end
    text(0.025,0.90,str,'Units','Normalized','FontWeight','Bold','BackgroundColor',bc,'FontSize',12);
end


% -------------- smallplot -------------------
function smallplot
global fileset quantset CL

if isfield(quantset,'smallplot')==0 quantset.smallplot=1; end
if quantset.smallplot==1; fullview(fileset.global_currentcl);end
if quantset.smallplot==2; qq_rang(quantset.X,1);end
if quantset.smallplot==3 & quantset.estimate=='S' qq_borgen2(quantset.X',CL(fileset.global_currentcl).rank,1,quantset.labels); end
if quantset.smallplot==3 & quantset.estimate=='C' qq_borgen2(quantset.X,CL(fileset.global_currentcl).rank,1,quantset.ions); end
if quantset.smallplot==4; lpgplot(quantset.X); end
if quantset.smallplot==5; resplot; end


% -------------- estinit -------------------
function estinit(X,rank)
global fileset metset quantset

h=findobj('Tag','CS-Radio'); h=findobj(h,'Value',1); 
if get(h,'String')=='C'; [ipure] = qq_borgen2(X,rank,0,quantset.ions); quantset.estimate='C'; end
if get(h,'String')=='S'; [ipure] = qq_borgen2(X',rank,0,quantset.labels); quantset.estimate='S'; end 
quantset.ipure=ipure; plotions(X); quantset.estimates=1;      


% -------------- PLOTTIC -------------------
function plottic(X)
global fileset quantset positions

subplot('position',positions.largeplot)
tic=sum(X'); plot(quantset.labels,tic);
[m,n]=size(tic); maxtic=max(tic); mintic=min(tic); minx=1;maxx=n;miny=mintic;maxy=maxtic*1.05; 
axis ([quantset.labels(minx) quantset.labels(maxx) miny maxy]); set(gca,'Tag','TicPlot')
qq_copyfigure


% -------------- PLOTIONS -------------------
function plotions(X)
global fileset quantset positions

subplot('position',positions.largeplot); h=plot(quantset.labels,X,'Tag','Trace');
dim=size(X); minx=1;maxx=dim(1);miny=0;maxy=max(max(X)); voffs=maxy*0.05;
hoffs=(quantset.labels(maxx)-quantset.labels(minx))/100;
axis ([quantset.labels(minx)-hoffs quantset.labels(maxx)+hoffs miny maxy+voffs])

% Adds Tag and trace number
traceh=findobj('Tag','Trace'); traceh=flipud(traceh); 
for z=1:length(traceh); set(traceh(z),'UserData',z); end

% Writes ions
[yp,xp]=max(X); % x og y pos for ion maxima
xp=xp(1,:); % Truncates if >1 maximum.
yp=yp(1,:); 
txt=strvcat(num2str(quantset.ions(:))); h=text(quantset.labels(xp),yp+voffs/2,txt);
set(h,'HorizontalAlignment','center','FontSize',10,'FontWeight','bold','Tag','IonsPlot')

if isfield(quantset,'ipure') && isempty(quantset.ipure)==0
    if quantset.estimate=='C'
        ipure=quantset.ipure;
        h=findobj('Tag','Trace'); for x=1:length(ipure) h2=findobj(h,'UserData',ipure(x)); set(h2,'LineWidth',3); end
    end
    if quantset.estimate=='S'
        ipure=quantset.ipure;
        for x=1:length(ipure) line([quantset.labels(ipure(x)) quantset.labels(ipure(x))],[miny maxy+voffs]); end
    end
end
qq_copyfigure


% -------------- SUBFUNCTION LPGPLOT -------------------
function lpgplot(X)
global fileset quantset positions CL

dh=findobj('Position',positions.smallplot); delete(dh)
h=axes('Position',positions.smallplot,'Tag','LPG');

[U S V]=svds(X,2); T=U*S;

if abs(min(T(:,1)))>abs(max(T(:,1))) T(:,1)=T(:,1)*-1; end 
plot(T(:,1),T(:,2));

[ipure]=qq_borgen2(X',CL(fileset.global_currentcl).rank,0); % Reneste topper
v1=(T(ipure,1)); v2=(T(ipure,2)); 
hold on; plot(v1,v2,'or','MarkerFaceColor','r'); hold off
o=diff(xlim)/15;
for x=1:length(ipure); o=-o; text(v1(x)+o,v2(x),num2str(quantset.labels(ipure(x))),'HorizontalAlignment','Center'); end

qq_copyfigure


% -------------- SUBFUNCTION RESPLOT -------------------
function resplot
global positions quantset

h=findobj('Tag','Plotradio','String','TIC+Res'); ison=get(h,'Value');

if ison
    dh=findobj('Position',positions.smallplot); delete(dh)
    h=axes('Position',positions.smallplot,'Tag','RES');

    tic=sum(quantset.X'); tic2=[]; restic=[];
    plot(quantset.labels,tic,'LineWidth',2)
    if isempty(quantset.C)==0
        tic2=sum((quantset.C*quantset.S)'); 
        restic=tic2-tic;
        hold on
        plot(quantset.labels,tic2,'--g','Linewidth',2)
        plot(quantset.labels,restic,'r','LineWidth',2)
        hold off
    end
    
    xlim([min(quantset.labels) max(quantset.labels)])
    line(xlim,[0 0],'Color',[0 0 0],'LineStyle','--')
    
    miny=min([tic tic2 restic]); maxy=max([tic tic2 restic]); dy=(maxy-miny)/20;
    ylim([miny-dy maxy+dy])
    
    qq_copyfigure
end


% -------------- SUBFUNCTION FULLVIEW -------------------
function fullview(clunr)

global XBL CL fileset positions

tic=sum(XBL'); subplot('position',positions.smallplot); plot(0);
dim=size(tic); minx=1;maxx=dim(2);miny=0;maxy=max(tic);

% Rectangles
for i1=1:fileset.global_nuclusters
    x=fileset.rt(CL(i1).startp); y=miny; w=fileset.rt(CL(i1).endp)-fileset.rt(CL(i1).startp); h=maxy-miny; 
    rh=rectangle('position',[x y w h],'FaceColor',[0.5 1 1],'LineStyle','none');    
    if (CL(i1).locked==1 & CL(i1).quantified==0), set(rh,'FaceColor',[1 1 0.5]); end % Locked
    if CL(i1).locked==1 & CL(i1).quantified==1, set(rh,'FaceColor',[0 1 0]); end % Loccked & Quant.
    if CL(i1).locked==0 & CL(i1).quantified==1, set(rh,'FaceColor',[0.75 0.75 1]); end % Quant
end
x=fileset.rt(CL(clunr).startp); y=miny; w=fileset.rt(CL(clunr).endp)-fileset.rt(CL(clunr).startp); h=maxy-miny; 
rectangle('position',[x y w h],'FaceColor',[1 0 0.5],'LineStyle','none');
% Tic
hold on; h=plot(fileset.rt,tic); set(h,'LineWidth',1); axis ([fileset.rt(minx) fileset.rt(maxx) miny maxy]); hold off
qq_copyfigure


% -------------- SUBFUNCTION EXPORT -------------------
function export(X)
global fileset metset quantset locset

fname=[fileset.global_filename,'_',num2str(fileset.global_currentcl),'_',quantset.transform,'.mat'];
pname=[locset.path_export '\' metset.path_export '\',fname];
% filnavn="filnavn_cluster nr_transformasjon"
Objects=num2str(quantset.labels','%11.4f'); % konverterer quantset.labels (retensjonstider) til text
[m,n]=size(Objects); bl=repmat(' ',m,32-n); Objects=[Objects bl]; 
% Legger til blanke slik at format blir m * 32
Variables=num2str(quantset.ions','%11.4f'); % konverterer ions til tekst
[m,n]=size(Variables); bl=repmat(' ',m,32-n); Variables=[Variables bl]; 
% Legger til blanke slik at format blir m * 32
SX=X; save(pname,'SX','Objects','Variables')
qq_message(1,['|b|Saved as: ' fname,' in: ' locset.path_export '\' metset.path_export])



%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset fonts

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
o=bw/5;
%gh=positions.gh;% grid height

x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='QuantWin'; winpar{2}='Q: Quantify';

if isfield(metset,'quant_niter')==0 metset.quant_niter=50; end 
if isfield(metset,'quant_stopcrit')==0 metset.quant_stopcrit=1; end

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0;
% RESTET/CLOSE/ACCEPT
p=p+1;[ui{p,1:7}] = deal('Reset','Pushbutton',colors.reset,[x(1) y(20) bw bh*1.5],'qq_quantcall2(97)',3,'');
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(2) y(20) bw bh*1.5],'qq_quantcall2(98)',3,'');
p=p+1;[ui{p,1:7}] = deal('Accept','Pushbutton',colors.accept,[x(3) y(20) bw bh*1.5],'qq_quantcall2(99)',3,'');
% PLOTBAR
p=p+1;[ui{p,1:7}] = deal('TIC','Pushbutton',colors.bc,[x(1) y(12) bw bh],'qq_quantcall2(16.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Show ions','Pushbutton',colors.bc,[x(2) y(12) bw bh],'qq_quantcall2(16.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('Resolved C','Pushbutton',colors.bc,[x(3) y(12) bw bh],'qq_quantcall2(16.3)',2,'');
p=p+1;[ui{p,1:7}] = deal('Resolved S','Pushbutton',colors.bc,[x(4) y(12) bw bh],'qq_quantcall2(16.4)',2,'');
% PLOT-2
p=p+1;[ui{p,1:7}] = deal('Full view','Radiobutton',colors.bc,[x(5)+o y(12) bw*0.9 bh],'qq_quantcall2(17.1)',2,'Plotradio');
p=p+1;[ui{p,1:7}] = deal('Rank plot','Radiobutton',colors.bc,[x(5)+o y(13) bw*0.9 bh],'qq_quantcall2(17.2)',2,'Plotradio');
p=p+1;[ui{p,1:7}] = deal('Borgen plot','Radiobutton',colors.bc,[x(5)+o y(14) bw*0.9 bh],'qq_quantcall2(17.3)',2,'Plotradio');
p=p+1;[ui{p,1:7}] = deal('LPG','Radiobutton',colors.bc,[x(5)+o y(15) bw*0.9 bh],'qq_quantcall2(17.4)',2,'Plotradio');
p=p+1;[ui{p,1:7}] = deal('TIC+Res','Radiobutton',colors.bc,[x(5)+o y(16) bw*0.9 bh],'qq_quantcall2(17.5)',2,'Plotradio');

% TRANSFORMS
f=9/3;
p=p+1;[ui{p,1:7}] = deal('Transform: ','text',colors.bc,[x(1) y(14) bw bh],'',3,'cent');
p=p+1;[ui{p,1:7}] = deal('A','Pushbutton',colors.bc,[x(2)+0*(bw/f) y(14) bw/f bh],'qq_quantcall2(11.1)',3,'');
p=p+1;[ui{p,1:7}] = deal('B','Pushbutton',colors.bc,[x(2)+1*(bw/f) y(14) bw/f bh],'qq_quantcall2(11.2)',3,'');
p=p+1;[ui{p,1:7}] = deal('C','Pushbutton',colors.bc,[x(2)+2*(bw/f) y(14) bw/f bh],'qq_quantcall2(11.3)',3,'');
p=p+1;[ui{p,1:7}] = deal('D','Pushbutton',colors.bc,[x(2)+3*(bw/f) y(14) bw/f bh],'qq_quantcall2(11.4)',3,'');
p=p+1;[ui{p,1:7}] = deal('E','Pushbutton',colors.bc,[x(2)+4*(bw/f) y(14) bw/f bh],'qq_quantcall2(11.5)',3,'');
p=p+1;[ui{p,1:7}] = deal('F','Pushbutton',colors.bc,[x(2)+5*(bw/f) y(14) bw/f bh],'qq_quantcall2(11.8)',3,'');
%p=p+1;[ui{p,1:7}] = deal('G','Pushbutton',colors.bc,[x(2)+6*(bw/f) y(14) bw/f bh],'qq_quantcall2(11.8)',3,''); 
p=p+1;[ui{p,1:7}] = deal('RA','Pushbutton',colors.bc,[x(2)+6*(bw/f) y(14) bw/f bh],'qq_quantcall2(11.9)',3,'');
p=p+1;[ui{p,1:7}] = deal('No','Pushbutton',colors.bc,[x(2)+7*(bw/f) y(14) bw/f bh],'qq_quantcall2(11.7)',3,'');
p=p+1;[ui{p,1:7}] = deal('Re','Pushbutton',colors.bc,[x(2)+8*(bw/f) y(14) bw/f bh],'qq_quantcall2(11.6)',2,'');

% INITIAL ESTIMATES & RESOLUTION
%p=p+1;[ui{p,1:7}] = deal('','Text',colors.btn{4},[x(1) y(15) bw*4 bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Init. Est.','Pushbutton',colors.btn{4},[x(1) y(15) bw bh],'qq_quantcall2(12.3)',2,'');
p=p+1;[ui{p,1:7}] = deal('S','Radiobutton',colors.bc,[x(2)+bw/10 y(15) bw/3 bh],'qq_quantcall2(12.5)',2,'CS-Radio');
p=p+1;[ui{p,1:7}] = deal('C','Radiobutton',colors.bc,[x(2)+bw/2 y(15) bw/3 bh],'qq_quantcall2(12.5)',2,'CS-Radio');
p=p+1;[ui{p,1:7}] = deal('Calc C/S','Pushbutton',colors.btn{4},[x(3) y(15) bw bh],'qq_quantcall2(12.4)',2,'');
p=p+1;[ui{p,1:7}] = deal('Get Stored','Pushbutton',colors.btn{5},[x(4) y(15) bw bh],'qq_quantcall2(95)',2,'');


%p=p+1;[ui{p,1:7}] = deal('','Text',colors.btn{4},[x(1) y(16) bw*4 bh],'',2,'');
p=p+1;[ui{p,1:8}] = deal('AR/ALS','Pushbutton',colors.btn{4},[x(1) y(16) bw bh],'qq_quantcall2(13.1)',2,'','-bm');
p=p+1;[ui{p,1:7}] = deal('N.Iter: ','text',colors.bc,[x(2) y(16) bw-bw/3-bw/10 eh],'',2,'niteredit');
p=p+1;[ui{p,1:8}] = deal(num2str(metset.quant_niter),'edit',[1 1 1],[x(3)-bw/3-bw/10 y(16) bw/3 bh],'qq_eval(''pi'')',2,'metset.quant_niter','-c');
p=p+1;[ui{p,1:7}] = deal('Stopcrit: ','text',colors.bc,[x(3) y(16) bw-bw/3-bw/10 eh],'',2,'stopcritedit');
p=p+1;[ui{p,1:8}] = deal(num2str(metset.quant_stopcrit),'edit',[1 1 1],[x(4)-bw/3-bw/10 y(16) bw/3 bh],'qq_eval(''pi'')',2,'metset.quant_stopcrit','-c');

p=p+1;[ui{p,1:7}] = deal('','Text',colors.btn{4},[x(1) y(17) bw*4 bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Pos C','Checkbox',colors.btn{4},[x(1) y(17) bw*3/4 bh],'qq_eval(''ch'')',2,'metset.quant_posC');
p=p+1;[ui{p,1:7}] = deal('Pos S','Checkbox',colors.btn{4},[x(1)+bw*3/4 y(17) bw*3/4 bh],'qq_eval(''ch'')',2,'metset.quant_posS');
p=p+1;[ui{p,1:7}] = deal('Unimod','Checkbox',colors.btn{4},[x(1)+bw*6/4 y(17) bw*3/4 bh],'qq_eval(''ch'')',2,'metset.quant_unimod');
p=p+1;[ui{p,1:7}] = deal('Closure','Checkbox',colors.btn{4},[x(1)+bw*9/4 y(17) bw*3/4 bh],'qq_eval(''ch'')',2,'metset.quant_closure');
p=p+1;[ui{p,1:7}] = deal('Norm S','Checkbox',colors.btn{4},[x(1)+bw*12/4 y(17) bw*3/4 bh],'qq_eval(''ch'')',2,'metset.quant_normS');
%p=p+1;[ui{p,1:7}] = deal('Gentle A','Pushbutton',colors.bc,[x(2) y(15) bw bh],'qq_quantcall2(13.2)',2,'');
%p=p+1;[ui{p,1:7}] = deal('Gentle B','Pushbutton',colors.bc,[x(3) y(15) bw bh],'qq_quantcall2(13.3)',2,'');

% QUANTIFY
p=p+1;[ui{p,1:7}] = deal('Single Peak','Pushbutton',colors.accept,[x(1) y(18) bw bh],'qq_quantcall2(14.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Accept single','Checkbox',colors.bc,[x(2)+bw/5 y(18) bw*2 bh*0.9],'',2,'AcceptSingleCheck');
p=p+1;[ui{p,1:7}] = deal('All single','Pushbutton',colors.accept,[x(4)+o y(18) bw-o bh],'qq_quantcall2(14.2)',2,'');
% SELECT PEAK
p=p+1;[ui{p,1:7}] = deal('<','Pushbutton',colors.bc,[x(2) y(13) bw/3 bh],'qq_quantcall2(18.1)',4,'');
p=p+1;[ui{p,1:7}] = deal('>','Pushbutton',colors.bc,[x(2)+bw*2/3 y(13) bw/3 bh],'qq_quantcall2(18.2)',4,'');
p=p+1;[ui{p,1:7}] = deal('','edit',[1 1 1],[x(2)+bw/3 y(13) bw/3 bh],'qq_quantcall2(18.3)',3,'PnTxt');
p=p+1;[ui{p,1:7}] = deal('Peak:','text',colors.bc,[x(1) y(13) bw bh],'',3,'cent');
% RANK LINE
p=p+1;[ui{p,1:7}] = deal('<','Pushbutton',colors.btn{1},[x(4) y(13) bw/3 bh],'qq_quantcall2(15.2)',4,'');
p=p+1;[ui{p,1:7}] = deal('>','Pushbutton',colors.btn{1},[x(4)+bw*2/3 y(13) bw/3 bh],'qq_quantcall2(15.3)',4,'');
p=p+1;[ui{p,1:7}] = deal('','text',colors.btn{1},[x(4)+bw/3 y(13) bw/3 bh],'',3,'RankTxt');
p=p+1;[ui{p,1:7}] = deal('Est. Rank','Pushbutton',colors.btn{1},[x(3) y(13) bw*3/4 bh],'qq_quantcall2(15.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('','Text',colors.btn{1},[x(3)+3*bw/4 y(13) bw/4 bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Checkbox',colors.btn{1},[x(3)+bw*0.82 y(13) bw*0.18 bh],'',2,'RankCheck');
% DUMP
p=p+1;[ui{p,1:7}] = deal('Export Data','Pushbutton',colors.btn{5},[x(4)+o y(20) bw-o bh],'qq_quantcall2(20.9)',2,'');
p=p+1;[ui{p,1:7}] = deal('Peakwindow','Pushbutton',colors.btn{5},[x(4)+o y(19) bw-o bh],'qq_quantcall2(20.4)',2,'');

updfcn='qq_quantcall2(100)';
h0=qq_drawwin(winpar,ui,updfcn);

set(h0,'KeyPressFcn','qq_quantcall2(96)')

h=findobj('Tag','Plotradio'); set(h,'Value',0); h=findobj(h,'String','Full view'); set(h,'Value',1)
h=findobj('Tag','AcceptSingleCheck'); set(h,'Value',1)
h=findobj('Tag','PnTxt'); set(h,'HorizontalAlignment','center','FontWeight','bold','FontName',positions.normfont,'FontSize',fonts(3));
h=findobj('Tag','cent'); set(h,'HorizontalAlignment','center');
h=findobj('Tag','RankTxt'); set(h,'HorizontalAlignment','center');  
h=findobj('Tag','CS-Radio'); set(h,'Value',0); set(h(2),'Value',1);

if isfield(metset,'quant_unimod')==0; metset.quant_unimod=1; end 
h=findobj(h0,'Tag','metset.quant_unimod'); set(h,'Value',metset.quant_unimod);
if isfield(metset,'quant_posC')==0; metset.quant_posC=1; end 
h=findobj(h0,'Tag','metset.quant_posC'); set(h,'Value',metset.quant_posC);
if isfield(metset,'quant_posS')==0; metset.quant_posS=1; end 
h=findobj(h0,'Tag','metset.quant_posS'); set(h,'Value',metset.quant_posS);
if isfield(metset,'quant_closure')==0; metset.quant_closure=1; end 
h=findobj(h0,'Tag','metset.quant_closure'); set(h,'Value',metset.quant_closure);
if isfield(metset,'quant_normS')==0; metset.quant_normS=1; end 
h=findobj(h0,'Tag','metset.quant_normS'); set(h,'Value',metset.quant_normS);

h=findobj('Tag','niteredit'); set(h,'HorizontalAlignment','right')
h=findobj('Tag','stopcritedit'); set(h,'HorizontalAlignment','right')

h=findobj('Tag','RankCheck'); set(h,'Value',1)