function K=qq_rang(X,plotrank);

global positions

% function [K]=rank(X);
% Rang-estimat og rangplott
% plotrank=1: Plotter egenverdier og grenser

dim=size(X);
n=min(dim); % Bestemmer minste rader/kolonner


[U,S,V]=svd(X,0); n=min(size(S)); S=S(1:n,1:n);
% Trbbel med kompatibilitet mellom versjoner, kan derfor ikke bruke
% 'economy'-parameter.

res=100;

for i=1:n
   rav(i)=100*S(i,i)/trace(S);  % Forklart var
   res=res-rav(i); 
   resvar(i)=res;
end

% Teller antall med eigenverdi strre enn 5% av tracen
test(1)=0;
for i=1:n
   if rav(i)>5     
      test(1)=test(1)+1;
   end
end

% Teller antall eigenverdi strre enn 2% av neste relativt til tracen.
test(2)=0;
for i=1:n-1
   if rav(i)-rav(i+1)>2
        test(2)=test(2)+1;
   end
end

% Teller grense for nr rest av akkumulerte egenverdier er under 10%
test(3)=0;

for i=1:n
   if resvar(i) > 10
      test(3)=test(3)+1;
   end
end
test(3)=test(3)+1;

K=median(test); % Setter K lik median verdien av de tre testene
n=max(test)+1;

%%%%% PLOTTER %%%%

if plotrank==1
   
   maxy=1.10*rav(1); maxx=n+0.6; miny=0; minx=0.3;
   
   subplot('position',positions.smallplot)
   plot(0);
   axis([minx maxx miny maxy]);
   
   hold on
   bar(rav(1:n));
   bar(rav(1:K),'r');
   hold off
   
   for i=1:n
      text(i,rav(i)+maxy/30,[num2str(rav(i),3) '%'],'fontweight','bold','horizontalalignment','center');
   end
   
   line([test(1)+0.5 test(1)+0.5],[miny maxy],'linewidth',2,'color','b');
   text(test(1)+0.5,maxy*0.8,'T1','fontweight','bold','fontsize',16,'color','b')
   
   line([test(2)+0.5 test(2)+0.5],[miny maxy],'linewidth',2,'color','r');
   text(test(2)+0.5,maxy*0.7,'T2','fontweight','bold','fontsize',16,'color','r')

   line([test(3)+0.5 test(3)+0.5],[miny maxy],'linewidth',2,'color','g');
   text(test(3)+0.5,maxy*0.6,'T3','fontweight','bold','fontsize',16,'color','g')
   
end


   
