function qq_register(an)

global metset locset
persistent Register n_reg cond_reg n_cond registerclass

if locset.tracker disp(['--- qq_register --- ' num2str(an)]); end

% Load register hvis tomt
if isempty(Register) || strcmp(registerclass,metset.global_class)==0
    [Register,n_reg,registerclass]=getregister;
end

% Nytt register
if an==1 
    [Register,n_reg,registerclass]=makeregister;
    %save([locset.path_library,'\class_',metset.global_class,'\Register'],'Register','n_reg');
    qq_savefile([locset.path_library,'\class_',metset.global_class,'\Register'],Register,n_reg,'-o');
    report(Register,n_reg);   
end

% SEARCH
if an==2
    LIB=searchparameters;
    [cond_reg,n_cond]=search(LIB,Register,n_reg); 
    write_reg(cond_reg,n_cond)
end

% SELECT
if an==3
    write_entry(cond_reg); 
end

% SELECT
if an==4
    blank_entry
end

% ADD ENTRY
if an==5
    LIB=searchparameters;       
    [cond_reg,n_cond]=search(LIB,Register,n_reg);
    if n_cond>0
        ind=cond_reg(1).reg_entry;
        Register(ind).n_entr=Register(ind).n_entr+1;
    else
        n_reg=n_reg+1;
        Register(n_reg).cmp_name=LIB.cmp_name;
        Register(n_reg).cmp_shortname=LIB.cmp_shortname;
        Register(n_reg).cmp_code=LIB.cmp_code;
        Register(n_reg).mdescr=LIB.mdescr;
        Register(n_reg).n_entr=1;    
        Register(n_reg).reg_entry=n_reg;   
    end  
    %save([locset.path_library,'\class_',metset.global_class,'\Register'],'Register','n_reg')
    qq_savefile([locset.path_library,'\class_',metset.global_class,'\Register'],Register,n_reg,'-o -s')
end

% Skriv hele register 
if an==6
    %[Register,n_reg,registerclass]=getregister;
    write_reg(Register,n_reg)   
end

% Search for compound
if an==7
    RegisterList=findobj('Tag','RegisterList'); 
    entry=get(RegisterList,'Value');
    searchentry=Register(entry);
    searchcompound(searchentry);
end

% Get Code
if an==8
    getcode(Register)   
end




%--------------------------------------------------------------------------
%-------------------------- S U B F U N C T I O N S -----------------------
%--------------------------------------------------------------------------

% --------- SUBFUNCTION: getregister -----------------------------------
function [Register,n_reg,registerclass]=getregister
global locset metset

%disp('--- LOAD REGISTER ---')
filename=[locset.path_library,'\class_',metset.global_class,'\Register'];
D=dir([filename,'.mat']);
DD=struct2cell(D);[m,regs]=size(DD);
if regs>0 
    load([locset.path_library,'\class_',metset.global_class,'\Register'],'Register','n_reg')
    registerclass=metset.global_class;
else
    qq_message(1,'|r|Register not found')
    Register=[]; n_reg=0;
    %[Register,n_reg]=makeregister; save([locset.path_library,'\class_',metset.global_class,'\Register'],'Register','n_reg')
end



% --------- SUBFUNCTION: GETCODE -----------------------------------
function getcode(Register)

n=length(Register);
for x=1:n
    cmp_code=Register(x).cmp_code; le=length(cmp_code);
    pos=strfind(cmp_code,'-');
    if le-pos>0
        nu(x)=str2num(cmp_code(pos+1:le));
    end  
end
maxnu=max(nu); nextnu=maxnu+1;
qq_message(1,['|b|Next available code: ' num2str(nextnu)]);
h=findobj('Tag','CasNrEdit'); set(h,'String',['-',num2str(nextnu)]);


% --------- SUBFUNCTION: WRITE ENTRY --------------------------------
function write_entry(cond_reg)
global metset

if isempty(cond_reg)
    qq_message(1,'|r|Not found in register'); 
else
    RegisterList=findobj('Tag','RegisterList'); entry_nr=get(RegisterList,'Value'); 
    CompoundNameEdit=findobj('Tag','CompoundNameEdit'); set(CompoundNameEdit,'String',cond_reg(entry_nr).cmp_name);
    CompoundCodeEdit=findobj('Tag','CompoundCodeEdit'); set(CompoundCodeEdit,'String',cond_reg(entry_nr).cmp_shortname);
    CasNrEdit=findobj('Tag','CasNrEdit'); set(CasNrEdit,'String',cond_reg(entry_nr).cmp_code);
    qq_lib_descriptors(2,cond_reg(entry_nr).mdescr)
end


% --------- SUBFUNCTION: BLANK_ENTRY ------------------------------------------
function blank_entry

RegisterList=findobj('Tag','RegisterList'); entry_nr=get(RegisterList,'Value');

CompoundNameEdit=findobj('Tag','CompoundNameEdit'); set(CompoundNameEdit,'String','');
CompoundCodeEdit=findobj('Tag','CompoundCodeEdit'); set(CompoundCodeEdit,'String','');
CasNrEdit=findobj('Tag','CasNrEdit'); set(CasNrEdit,'String','');
CarbonsEdit=findobj('Tag','CarbonsEdit'); set(CarbonsEdit,'String','');
DbbEdit=findobj('Tag','DbbEdit'); set(DbbEdit,'String','');

% --------- SUBFUNCTION: SEARCHPARAMETERS ----------------------------------------
function LIB=searchparameters

CompoundNameEdit=findobj('Tag','CompoundNameEdit'); LIB.cmp_name=get(CompoundNameEdit,'String');
CompoundCodeEdit=findobj('Tag','CompoundCodeEdit'); LIB.cmp_shortname=get(CompoundCodeEdit,'String');
CasNrEdit=findobj('Tag','CasNrEdit'); LIB.cmp_code=get(CasNrEdit,'String');  
LIB.mdescr=qq_lib_descriptors(1);
%CarbonsEdit=findobj('Tag','CarbonsEdit'); LIB.carbons=round(str2double(get(CarbonsEdit,'String')));  
%DbbEdit=findobj('Tag','DbbEdit'); LIB.dbb=round(str2double(get(DbbEdit,'String')));  

% --------- SUBFUNCTION: WRITE_REG -----------------------------------------------
function write_reg(cond_reg,n_cond)

RegisterList=findobj('Tag','RegisterList');
set(RegisterList,'Value',1)

for j=1:n_cond
    Str1=cond_reg(j).cmp_name; Str1=[Str1,blanks(55)]; Str1=Str1(1:55);
    Str2=cond_reg(j).cmp_shortname; Str2=[Str2,blanks(15)];Str2=Str2(1:13);
    Str3=cond_reg(j).cmp_code; Str3=[Str3,blanks(9)];Str3=Str3(1:9);
    ReM{j}=[Str3,' ',Str2,' ',Str1];
end

if n_cond>0; set(RegisterList,'String',ReM); end
if n_cond==0; set(RegisterList,'String',' '); end


% --------- SUBFUNCTION: SEARCH ------------------------------------------------------------------
function [cond_reg,n_cond]=search(LIB,Register,n_reg);

%disp('--- qq_register: SEARCH ---')

cond_reg=Register;
n_cond=n_reg;

% Search by short name
%disp('--- Search by short name ---')
if isempty(LIB.cmp_shortname)~=1
    matchv = strmatch(LIB.cmp_shortname,strvcat(cond_reg.cmp_shortname));
    cond_reg=cond_reg(matchv);
    n_cond=length(matchv);
end

% Search by name
%disp('--- Search by name ---')
if isempty(LIB.cmp_name)~=1
    matchv = strmatch(LIB.cmp_name,strvcat(cond_reg.cmp_name)); 
    cond_reg=cond_reg(matchv);
    n_cond=length(matchv);
end

% Search by code
%disp('--- Search by code ---')
if isempty(LIB.cmp_code)~=1
    matchv = strmatch(LIB.cmp_code,strvcat(cond_reg.cmp_code)); 
    cond_reg=cond_reg(matchv);
    n_cond=length(matchv);
end

% SORTERER ETTER KODE
[b,index]=sortrows(strvcat(cond_reg.cmp_code)); index=flipud(index);
cond_reg(:)=cond_reg(index);

%disp('END --- qq_register: SEARCH ---')


%--------- MAKEREGISTER ------------
function [Register,n_reg,registerclass]=makeregister;
global metset locset

% Henter filnavn
filename=[locset.path_library,'\class_',metset.global_class,'\lib_*'];
D=dir([filename,'.mat']);
DD=struct2cell(D);[m,n_libs]=size(DD);

% Lager tomt register
Register(1).cmp_name=[];
Register(1).cmp_shortname=[];
Register(1).cmp_code=[];
Register(1).mdescr=[];
Register(1).n_entr=0;
n_reg=1;

% Loader Libraries
for i1=1:n_libs
    filename=[locset.path_library,'\class_',metset.global_class,'\',DD{1,i1}];
    load(filename,'Library');
    d=struct2cell(Library);
    [m,n_entries]=size(d);
    
    isdescr=isfield(Library,'mdescr');
    
    % Sjekker innhold mot register
    for i2=1:n_entries    
        found=0;
        for i3=1:n_reg
            k(1)=strcmp(Register(i3).cmp_name,Library(i2).cmp_name);
            k(2)=strcmp(Register(i3).cmp_shortname,Library(i2).cmp_shortname);
            k(3)=strcmp(Register(i3).cmp_code,Library(i2).cmp_code);
            if isdescr
                k(4)=isequalwithequalnans(Register(i3).mdescr,Library(i2).mdescr);
            else
                k(4)=1;
            end           
            %k(5)=isequalwithequalnans(Register(i3).dbb,Library(i2).dbb);
            if sum(k)==4
                Register(i3).n_entr=Register(i3).n_entr+1; found=1;
            end
        end
        
        if found==0; n_reg=n_reg+1;
            Register(n_reg).cmp_name=Library(i2).cmp_name;
            Register(n_reg).cmp_shortname=Library(i2).cmp_shortname;
            Register(n_reg).cmp_code=Library(i2).cmp_code;
            if isdescr
                Register(n_reg).mdescr=Library(i2).mdescr;
            end
            Register(n_reg).n_entr=1;
            Register(n_reg).reg_entry=(n_reg-1);
        end
    end

end

Register(1)=[]; n_reg=n_reg-1;

% SORTERER ETTER KODE
[b,index]=sortrows(strvcat(Register.cmp_code)); index=flipud(index);
Register(:)=Register(index);

registerclass=metset.global_class;


% ----------------------- SCREENDUMP ------------------
function screendump(Register,n_reg)
ReM=reportlist(Register,n_reg);
cat(1,ReM{:})

% --------------------- REPORTLIST ------------------
function ReM=reportlist(Register,n_reg)
global metset

cw=[40 15 8 8]; % kolonnebredder 
le=length(metset.mdescr); if le>5 cw(4)=5; end % Constrain
% Liste
for j=1:n_reg
    str=Register(j).cmp_code; str=[str,blanks(cw(3))]; str=str(1:cw(3)); totstr=[str];
    str=Register(j).cmp_shortname; str=[str,blanks(cw(2))]; str=str(1:cw(2)); totstr=[totstr '  ' str];
    str=Register(j).cmp_name; str=[str,blanks(cw(1))]; str=str(1:cw(1)); totstr=[totstr '  ' str];
    if isfield(Register,'mdescr') && isempty(Register(j).mdescr)==0
        felt=fieldnames(Register(j).mdescr); n_descr=length(felt);
        for k=1:n_descr
            str=Register(j).mdescr.(felt{k}); if isnumeric(str); str=num2str(str); end
            str=[str,blanks(cw(4))]; str=str(1:cw(4)); totstr=[totstr '  ' str];  
        end
    end
    str=num2str(Register(j).n_entr); str=[str,blanks(cw(3))]; str=str(1:cw(3)); totstr=[totstr '  ' str];
    ReM{j+2}=totstr;
end
% Heading
str='Code'; str=[str,blanks(cw(3))]; str=str(1:cw(3)); totstr=[str];
str='Short'; str=[str,blanks(cw(2))]; str=str(1:cw(2)); totstr=[totstr '  ' str];
str='Name'; str=[str,blanks(cw(1))]; str=str(1:cw(1)); totstr=[totstr '  ' str];
for k=1:length(metset.mdescr)
    str=metset.mdescr(k).text; str=[str,blanks(cw(4))]; str=str(1:cw(4)); totstr=[totstr '  ' str];    
end
str='N'; str=[str,blanks(cw(3))]; str=str(1:cw(3)); totstr=[totstr '  ' str]; ReM{1}=totstr; % Heading
le=length(totstr); ReM{2}=repmat('-',1,le); % Separator

% --------------------- REPORT ------------------
function report(Register,n_reg)
global metset locset

ReM=reportlist(Register,n_reg);
[m,n]=size(ReM); % n=antall linjer
fh=fopen([locset.path_library,'\class_',metset.global_class,'\Register_rep.txt'],'w');

for x=1:n
    fprintf(fh,[ReM{x},char([13 10])]); 
end

fclose(fh);
%qq_message(6,[locset.path_library,'\class_',metset.global_class,'\Register_rep.txt'])

try
    winopen([locset.path_library,'\class_',metset.global_class,'\Register_rep.txt']);
catch
    qq_message(1,'|r|Error: Could not open file')
end

%if isfield(locset,'editor') && strcmp(locset.editor,'notepad')
%   a=dos(['notepad ' locset.path_library,'\class_',metset.global_class,'\Register_rep.txt &']);
%else
%   a=dos([locset.path_library,'\class_',metset.global_class,'\Register_rep.txt']);
%end

% ----------------------- searchcompound ------------------
function searchcompound(searchentry)
global metset locset

% Henter filnavn
filename=[locset.path_library,'\class_',metset.global_class,'\lib_*'];
D=dir([filename,'.mat']);
DD=struct2cell(D);
[m,n_libs]=size(DD);

hits.libname=[]; hits.column=[]; hits.n=0; p=0; % Antall hits
for i1=1:n_libs
    filename=[locset.path_library,'\class_',metset.global_class,'\',DD{1,i1}];
    load(filename,'Library');
    d=struct2cell(Library);
    [m,n_entries]=size(d);
    libname=DD{1,i1}; libname=libname(5:length(libname)-4);
    for i2=1:n_entries
        if strcmp(Library(i2).cmp_name,searchentry.cmp_name)==1 & ...
           strcmp(Library(i2).cmp_shortname,searchentry.cmp_shortname)==1 & ...
           strcmp(Library(i2).cmp_code,searchentry.cmp_code)==1 
           p=length(cat(2,hits.n));
           if p==0 p=p+1; hits(p).libname=libname; hits(p).column=Library(i2).column; hits(p).n=1; end
           for i3=1:p
               found=0;
               if strcmp(hits(i3).libname,libname)==1 & strcmp(hits(i3).column,Library(i2).column)==1 
                   hits(i3).n=hits(i3).n+1;
                   found=1;
               end % if
           end % for i3
           if found==0;
               p=p+1; 
               hits(p).libname=libname; 
               hits(p).column=Library(i2).column; 
               hits(p).n=1;
           end % if
        end % if strcmp
    end % for i2
end % for i1

p=length(cat(2,hits.n));
writestr{1}='Library           Column            n-hits';
writestr{2}='-----------------------------------------------';
for i1=2:p
    Str1=hits(i1).libname; Str1=[Str1,blanks(18)]; Str1=Str1(1:18);
    Str2=hits(i1).column; Str2=[Str2,blanks(18)]; Str2=Str2(1:18);
    Str3=num2str(hits(i1).n); Str3=[Str3,blanks(10)]; Str3=Str3(1:10);
    writestr{i1+1}=[Str1,Str2,Str3];
end

RegisterList=findobj('Tag','RegisterList');
set(RegisterList,'Value',1,'String',writestr)



    




