function qq_report_dif(Reportstruct)
global locset metset

linefeed=char([13 10]);

% ------------- Opens file -------------
Reportstruct(1).pathname=[Reportstruct(1).pathname];
fh=fopen([Reportstruct(1).pathname '.dif'],'w');

if fh==-1; 
    cc_message(1,'|r|Warning, could not write to file, file may be open or output folder may not exist'); 
else

    [n_cols,n_rows]=size(Reportstruct.cells);
    fprintf(fh,['TABLE',linefeed]);
    fprintf(fh,['0,1',linefeed]);
    fprintf(fh,['"EXCEL"',linefeed]);
    fprintf(fh,['VECTORS',linefeed]);
    fprintf(fh,['0,' num2str(n_rows) linefeed]);
    fprintf(fh,['""',linefeed]);
    fprintf(fh,['TUPLES',linefeed]);
    fprintf(fh,['0,' num2str(n_cols) linefeed]);
    fprintf(fh,['""',linefeed]);
    fprintf(fh,['DATA',linefeed]);
    fprintf(fh,['0,0',linefeed]);
    fprintf(fh,['""',linefeed]);

    % Header
    for x=1:length(Reportstruct.header)
        fprintf(fh,['-1,0',linefeed]);
        fprintf(fh,['BOT',linefeed]);
        str1=['1,0']; fprintf(fh,[str1,linefeed]);
        str2=['"' Reportstruct.header{x} '"']; fprintf(fh,[str2,linefeed]);
    end
    
    % Column headers
    fprintf(fh,['-1,0',linefeed]);
    fprintf(fh,['BOT',linefeed]);
    for cn=1:n_cols
        str1=['1,0']; fprintf(fh,[str1,linefeed]);
        str2=['" ' Reportstruct.columntitle{cn} '"']; fprintf(fh,[str2,linefeed]);
    end

    % Main body
    for rn=1:n_rows
        fprintf(fh,['-1,0',linefeed]);
        fprintf(fh,['BOT',linefeed]);
        for cn=1:n_cols
            if strcmp(Reportstruct.format{cn},'str')
                str1=['1,0']; fprintf(fh,[str1,linefeed]);
                str2=['" ' Reportstruct.cells{cn,rn} '"']; fprintf(fh,[str2,linefeed]);
            else
                str1=['0,' num2str(Reportstruct.cells{cn,rn},Reportstruct.format{cn})]; fprintf(fh,[str1,linefeed]);
                str2=['v']; fprintf(fh,[str2,linefeed]);
            end
        end
    end

    % Footer
    for x=1:length(Reportstruct.footer)
        fprintf(fh,['-1,0',linefeed]);
        fprintf(fh,['BOT',linefeed]);
        str1=['1,0']; fprintf(fh,[str1,linefeed]);
        str2=['"' Reportstruct.footer{x} '"']; fprintf(fh,[str2,linefeed]);
    end

    % End of file
    fprintf(fh,['-1,0',linefeed]);
    fprintf(fh,['EOD']);

    fclose(fh);

    if isfield(Reportstruct,'displaymessage') && Reportstruct.displaymessage==1;
        qq_message(1,['|b|Report saved as ' Reportstruct.pathname '.dif'])
    end
    
    if isfield(Reportstruct,'autoopen') && Reportstruct.autoopen==1;
        %a=dos([Reportstruct.pathname '.dif']);
        %if a>0 qq_message(1,'|r|Could not open file'); end
        try
            winopen([Reportstruct.pathname '.dif'])
        catch
            qq_message(1,'|r|Could not open file');
        end
    end
    


end % if fh==-1












