function qq_resultscall(an)

global XBL fileset metset CL RE positions locset

%persistent plotupd winupd showspec     % Parametre for plot

qq_message(2); % Blank

if an==0;
    if isempty(CL)==0 && sum(cat(1,CL.quantified))>0
        openwin; 
        getpeaks; % Legger topper i RE
        quanttest
        deletedtest
        metset.results_peaklabel=1; 
        metset.results_scale=1;
        if isfield(fileset,'results_selpeak')==0 fileset.results_selpeak=0; end
        if fileset.results_selpeak>length(RE) fileset.results_selpeak=0; end
        qq_plot_results(0); qq_plot_scale(100);  
        if fileset.results_selpeak>0
            qq_plot_ms(0,fileset.ions,RE(fileset.results_selpeak).S,positions.smallplot); 
        end         
    else
        qq_message(1,'|r|No peaks quantified')
    end
end

% ---------------------- SELECT PEAK -------------------

if an==16.1 && fileset.results_selpeak>1 fileset.results_selpeak=fileset.results_selpeak-1; end
if an==16.2 && fileset.results_selpeak<fileset.results_npeaks fileset.results_selpeak=fileset.results_selpeak+1; end
if an==16.3 fileset.results_selpeak=get(gco,'UserData'); end
% Oppdaterer vindu
if an>16.0 && an<17.0 && fileset.results_selpeak>0; 
    qq_plot_ms(0,fileset.ions,RE(fileset.results_selpeak).S,positions.smallplot); qq_plot_results(2); %selupd; 
end
if an>16.0 && an<17.0 && fileset.results_selpeak>0
    cp=round(((RE(fileset.results_selpeak).startp+RE(fileset.results_selpeak).endp))/2);
    range=fileset.chrom_ri-fileset.chrom_li; 
    fileset.chrom_li=floor(cp-(range/2)); fileset.chrom_ri=fileset.chrom_li+range;
    if fileset.chrom_li<1; fileset.chrom_li=1; fileset.chrom_ri=fileset.chrom_li+range; end 
    if fileset.chrom_ri>length(fileset.rt); fileset.chrom_ri=length(fileset.rt); fileset.chrom_li=fileset.chrom_ri-range; end
    qq_plot_scale(100);   
end

% ---------------------- DELETE -------------------------
if an==7 && fileset.results_selpeak>0 
    if RE(fileset.results_selpeak).clu_nr==0
        RE(fileset.results_selpeak)=[];
        fileset.results_npeaks=fileset.results_npeaks-1;
        if fileset.results_selpeak>fileset.results_npeaks fileset.results_selpeak=fileset.results_selpeak-1; end
        %qq_chrom(6.1);
        qq_plot_results(0); qq_plot_scale(100); %selupd; peaklabels; 
        spectrum(RE,fileset.ions) 
    else
        qq_message(1,'|r|Not allowed - edit in peak-window or quant-window')
    end
end

% ----------------------- LABELS -----------------------
if an>17.0 && an<18.0 
    h=findobj('Tag','Labelradio'); set(h,'Value',0); set(gcbo,'Value',1)
    if an==17.1, metset.results_peaklabel=1; end
    if an==17.2, metset.results_peaklabel=2; end
    if an==17.3, metset.results_peaklabel=3; end
    if an==17.4, metset.results_peaklabel=4; end
    qq_plot_results(3)
end

% ----------------------- SHOWCAL-CHECK -----------------------
if an==19.1 
    %qq_chrom(6.1); selupd; peaklabels; 
    qq_plot_results(0); qq_plot_scale(100);
end

% ---------------------- LIBRARY -------------------
% Add to library
if an==5.1 
    if ~isempty(fileset.results_selpeak) && fileset.results_selpeak>0
        qq_addlib(1,fileset.results_selpeak);
    else
        qq_message(1,'|r|No peak selected')
    end
end
% Search Library
if an==5.2
    if ~isempty(fileset.results_selpeak) && fileset.results_selpeak>0
        qq_lib_search(1,fileset.results_selpeak);
    else
        qq_message(1,'|r|No peak selected')
    end
end
% Edit Library
if an==5.3 
    qq_editlib(1);
end
% Search all
if an==5.4
    qq_lib_search(10); 
    %qq_chrom(6.1); selupd; peaklabels
    qq_plot_results(0); qq_plot_scale(100);
end
% Tentative
if an==5.5
    tentwin
end
if an==5.6
    tentaccept
end

% ---------------------- RETENTION INDEX -------------------

% Calculate RI
if an==6.1 
    if isfield(fileset,'results_rical')
        qq_retindex(3); % Updates RI vector
        qq_retindex(1); % Updates peaks
    else
        qq_message(1,'|r|No calibration in memory')
    end
end
% Calibrate
if an==6.2 qq_retindex(2); end 
% SAVE
if an==6.4 qq_retindex(4); end   
% LOAD
if an==6.5 qq_retindex(5); end  
% LOAD
if an==6.6 qq_retindex(6); end  
% DELETE
if an==6.7 qq_retindex(7); end  
% EDIT
if an==6.8 qq_retindex_edit(1); end
% UPDATE PLOT
if an>6 && an<7 h=findobj('Tag','CalibrCheck'); 
    set(h,'value',1); 
    %qq_chrom(6.1); selupd; peaklabels; 
    qq_plot_results(0); qq_plot_scale(100);
end

%  REPORT 
if an==7.1; report; end
% Peak Properties

if an==7.2 
    if fileset.results_selpeak>0 qq_peakprop(1); else qq_message(1,'|r|Select peak'); end
end

% Calculate Rt
if an>8.0 && an<8.9
    h=findobj('Tag','PeakfitCheck'); metset.results_peakfit=get(h,'Value');
    h=findobj('Tag','KurtosisCheck'); metset.results_kurt=get(h,'Value');
    h=findobj('Tag','SigmaEdit'); hstr=get(h,'String'); val=str2double(hstr); if isnan(val) val=4; set(h,'str','4'); end; if val<4 val=4; set(h,'str','4'); end
end
if an==8.1 && fileset.results_selpeak>0
    rtcalc(fileset.results_selpeak); qq_plot_results(2); qq_plot_results(3); %selupd; peaklabels;     
end
if an==8.2
    for x=1:fileset.results_npeaks rtcalc(x); end; qq_plot_results(2); qq_plot_results(3); %selupd; peaklabels; 
end

% NIST SEARCH
if an==9.0 
    if ~isempty(fileset.results_selpeak) && fileset.results_selpeak>0
        Searchinfo(1).peaknumber=fileset.results_selpeak;
        Searchinfo(1).filename=fileset.global_filename;
        Searchinfo(1).scannumber=RE(fileset.results_selpeak).maxp;
        Searchinfo(1).rt=RE(fileset.results_selpeak).rt;
        Searchinfo(1).ri=RE(fileset.results_selpeak).ri_calc;
        Searchinfo(1).ions=fileset.ions;
        Searchinfo(1).abundance=RE(fileset.results_selpeak).S;
        Searchinfo(1).nistpath=locset.path_nist;
        Searchinfo(1).exportpath=locset.path_export;
        qq_nistsearch(Searchinfo)
    else
        qq_message(1,'|r|No peak selected')
    end
end

% Calls fra batchcall
if an==100
    %disp('----- resultscall/batchcall -------')   
    getpeaks; % Legger topper i RE
    quanttest
    deletedtest
    fileset.results_selpeak=0; metset.results_peaklabel=1; metset.results_scale=1; 
    % Plotter
end

% Keypress
if an==98
    kp=double(get(gcf,'CurrentCharacter'));
    if kp==31  qq_resultscall(16.1); end    
    if kp==30  qq_resultscall(16.2); end
    %if kp==28 | kp==29 qq_chrom(1.35); end %
    if ~isempty(kp) && (kp==28 || kp==29) qq_plot_scale(1.35); end %
end


% RETUR FRA BIBLIOTEK / UPDATE
if an==99 && isempty(RE)==0
    %disp('--- qq_resultscall an==99 (UPDATE) ---')
    %qq_chrom(6.1); selupd; peaklabels; 
    qq_plot_results(0); qq_plot_scale(100);
    if fileset.results_selpeak>0 qq_plot_ms(0,fileset.ions,RE(fileset.results_selpeak).S,positions.smallplot); end
end


% ----------------- ----------- -----------------
% ----------------- SUFUNCTIONS ----------------- 
% ----------------- ----------- -----------------

% -------------- RTCALC ---------------
% Bestemmer Rt ved kurvetilpasning eller Max C
% MERK FORSKJELL I WHH MELLOM KALKULASJONER HER OG I QQ_PEAKPROM SOM
% SKYLDES AT BASELINGE BEREGNES FOTSKJELLIG.
function rtcalc(peakno)
global RE fileset metset

xvect=fileset.rt(RE(peakno).startp:RE(peakno).endp); C=RE(peakno).C; 
[whh,lxp,rxp,hheight,rt,asf]=whhcalc(xvect,C); RE(peakno).peakparameters='RAW';

if metset.results_peakfit==1
    lw=rt-lxp; rw=rxp-rt; elp=rt-lw*metset.results_sigma/2.355; erp=rt+rw*metset.results_sigma/2.355; ind=find(xvect>elp & xvect<erp);
    xvect=xvect(ind); C=C(ind)';
    if metset.results_kurt==1
        [rt,lwhh,rwhh,height,bloffset]=qq_normfit(xvect,C);  
    else
        [rt,lwhh,rwhh,height,bloffset,kurtosis]=qq_normfit2(xvect,C);
    end 
    whh=lwhh+rwhh; asf=rwhh/lwhh; RE(peakno).peakparameters='PEAKFIT';   
end
RE(peakno).rt=rt;
RE(peakno).whh=whh;
RE(peakno).asf=asf;


% ------------------- whhcalc ---------------------
function [whh,lxp,rxp,hheight,maxp,asf]=whhcalc(xvect,C)

% whh: Bredde ved halve hyde
% lxp/rxp: x-verdier for hh-linje
% hheight: Halve hyden
% maxp: maxpkt
% asf: asymmetrifaktor

% Beregner maxpkt
mi=find(C==max(C)); mi=mi(1); maxp=xvect(mi); 

% Beregning av whh
minc=min(C); 
maxc=max(C); 
height=maxc-minc;
hheight=(height/2)+minc; 
above=find(C>hheight);
if min(above)<2
    lxp=min(xvect);
else
    li=[min(above)-1 min(above)]; lx=xvect(li); ly=C(li);
    dxdy=(lx(2)-lx(1))/(ly(2)-ly(1)); dh=hheight-ly(1); lxp=lx(1)+(dh*dxdy);
end
if max(above)>length(xvect)-1
    rxp=max(xvect);
else
    ri=[max(above) max(above)+1]; 
    rx=xvect(ri); ry=C(ri);
    dxdy=(rx(2)-rx(1))/(ry(2)-ry(1)); dh=hheight-ry(1); rxp=rx(1)+(dh*dxdy);
end
whh=rxp-lxp; 

% Beregning av asym
as_height=(height/10)+minc; above=find(C>as_height);
li=[min(above)-1 min(above)]; 
if min(li)>0 
   lx=xvect(li); ly=C(li); dxdy=(lx(2)-lx(1))/(ly(2)-ly(1)); dh=as_height-ly(1); as_lxp=lx(1)+(dh*dxdy);
else
    as_lxp=xvect(1);
end
ri=[max(above) max(above)+1]; 
if min(ri)<length(C)
   rx=xvect(ri); ry=C(ri); dxdy=(rx(2)-rx(1))/(ry(2)-ry(1)); dh=as_height-ry(1); as_rxp=rx(1)+(dh*dxdy);
else
   as_rxp=xvect(length(xvect));
end
lw=maxp-as_lxp; rw=as_rxp-maxp; asf=rw/lw; 

% ---------------- TENTWIN -------------------
function tentwin
global colors positions fileset RE

%disp('---- tentwin ----')

hf=3; % Height factor
wf=2; % Width factor
bw=positions.bw*wf;
bh=positions.bh*hf;
eh=positions.eh*hf; eo=(bh-eh)/2; % edit offset
gh=positions.gh*hf;
x=positions.gl*wf:positions.gw*wf:1; % horisontalt grid
y=positions.gt*wf:-positions.gh*hf:0; % vertikalt grid

peakno=fileset.results_selpeak;
winpar={'M-Win','Tentative Identification',[0.1 0.6 1/wf 1/hf]};
p=0; 
% NAME
p=p+1;[ui{p,1:7}] = deal('Name:','Text',colors.bc,[x(1) y(2) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(RE(peakno).cmp_name,'Edit',[1 1 1],[x(2) y(2) bw*3 eh],'',2,'CompoundNameEdit');
% Short Name
p=p+1;[ui{p,1:7}] = deal('Short name:','Text',colors.bc,[x(1) y(3) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(RE(peakno).cmp_shortname,'Edit',[1 1 1],[x(2) y(3) bw*3 eh],'',2,'CompoundCodeEdit');
% Code
p=p+1;[ui{p,1:7}] = deal('Reg. code:','Text',colors.bc,[x(1) y(4) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(RE(peakno).cmp_code,'Edit',[1 1 1],[x(2) y(4) bw eh],'',2,'CasNrEdit');
% Ri def
p=p+1;[ui{p,1:7}] = deal('RI (def):','Text',colors.bc,[x(3)+bw/6 y(4) bw eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal(num2str(RE(peakno).ri_def),'Edit',[1 1 1],[x(4) y(4) bw eh],'',2,'RiEdit');
% Close/Accept
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(7) bw bh*1.5],'close(gcbf)',3,'');
p=p+1;[ui{p,1:7}] = deal('Accept','Pushbutton',colors.accept,[x(2) y(7) bw bh*1.5],'qq_resultscall(5.6)',3,'');

level='';
h0=qq_drawwin(winpar,ui,level);

% ------------ TENTACCEPT --------------
function tentaccept
global fileset metset RE

peakno=fileset.results_selpeak;
RE(peakno).cmp_name=get(findobj('Tag','CompoundNameEdit'),'String');
RE(peakno).cmp_shortname=get(findobj('Tag','CompoundCodeEdit'),'String');
RE(peakno).cmp_code=get(findobj('Tag','CasNrEdit'),'String');
RE(peakno).ri_def=str2double(get(findobj('Tag','RiEdit'),'String'));
if isempty(RE(peakno).cmp_code) RE(peakno).cmp_code='TENT'; end
RE(peakno).identified=1;
close(gcbf); qq_resultscall(99);


% ---------------- GETPEAKS --------------
function getpeaks
global fileset CL RE
%disp('---- GETPEAKS ----')

% Oppdaterer antall topper
if isempty(RE)==0; fileset.results_npeaks=length(cat(1,RE.maxp));
else fileset.results_npeaks=0;
end

% Sjekker for Rt fra peakfit
%h=findobj('Tag','PeakfitCheck'); fit_rt=get(h,'Value');

% Oppdaterer clusternummer
for i1=1:fileset.results_npeaks
    RE(i1).clu_nr=fileset.cluvector(RE(i1).maxp);
end

for i1=1:fileset.global_nuclusters
    if CL(i1).inresults==0 % Dersom clusteren ikke er lest inn i Results
        
        %Slett eksisterende topper fra samme cluster
        if isempty(RE)==0
            reclusters=cat(2,RE.clu_nr);
            delvect=find(reclusters==i1);
            RE(delvect)=[];
            fileset.results_npeaks=fileset.results_npeaks-length(delvect);
        end
        
        % Konverterer CL til RE
        for i2=1:CL(i1).n_analytes
            fileset.results_npeaks=fileset.results_npeaks+1; 
            %fileset.results_npeaks% TEMP
            CL(i1).inresults=1;           % Cluster lest i results
            RE(fileset.results_npeaks).area = CL(i1).areas(i2);
            RE(fileset.results_npeaks).C = CL(i1).C(:,i2);
            RE(fileset.results_npeaks).S = CL(i1).S(i2,:);
            RE(fileset.results_npeaks).startp = CL(i1).startp;
            RE(fileset.results_npeaks).endp=CL(i1).endp;
            [maxv,maxp]=max(RE(fileset.results_npeaks).C); maxp=maxp+RE(fileset.results_npeaks).startp-1; 
            RE(fileset.results_npeaks).maxp=maxp;
            % RE(fileset.results_npeaks).maxp=CL(i1).maxp; % Settes nyaktig i 'plotresults'
            RE(fileset.results_npeaks).clu_nr=CL(i1).nr;
            RE(fileset.results_npeaks).peaksincl=CL(i1).n_analytes;
            RE(fileset.results_npeaks).identified=0;
            RE(fileset.results_npeaks).cmp_name=' ';
            RE(fileset.results_npeaks).cmp_shortname=' ';
            RE(fileset.results_npeaks).cmp_code=' ';
            RE(fileset.results_npeaks).ri_def=[];
            RE(fileset.results_npeaks).ri_calc=[];
            rtcalc(fileset.results_npeaks);
        end   
    end
end

% Sjekker for manglende Rt i RE (Gammelt format)
if isfield(RE,'rt')==0
    for pn=1:length(RE)
        rtcalc(pn);
    end
end

% Beregner prosent
areas=cat(2,RE(:).area); totarea=sum(areas);
for p=1:fileset.results_npeaks
    RE(p).areapct = RE(p).area*100/totarea;
end   

% Sorterer
[b,index]=sort(cat(1,RE.maxp));
RE(:)=RE(index);



% -------------- DELETED TEST ---------------
function deletedtest

global CL RE fileset

% Oppdaterer clusternummer
for i1=1:fileset.results_npeaks
    RE(i1).clu_nr=fileset.cluvector(RE(i1).maxp);
end
% Test for topper som ikke tilhrer noen cluster
if length(find(cat(2,RE.clu_nr)==0))>0
    qq_message(1,'|r|Peaks from deleted clusters')
end

% -------------- QUANTTEST ---------------
function quanttest

global CL

notquant=find(cat(2,(CL.quantified))==0);
if isempty(notquant)==0;
    q_str=' ';
    for x=1:length(notquant)
        q_str=[q_str num2str(notquant(x)) ', '];
    end
    qq_message(1,['|r|Warning: Clusters' q_str 'not quantified'])
end

% ----------------- REPORT2 -------------------
function report
global RE fileset metset locset

fileset.results_reportfields=[1 1 1 1 1 1 1 1]; % [Rt, ECL, CasNr, ShortName, Name, Area, AreaPct, whh]
if sum(cat(2,RE.ri_calc))==0 fileset.results_reportfields(2)=0; end 
if sum(cat(2,RE.identified))==0 fileset.results_reportfields(3:5)=0; end 

REP=RE;
% Fill inn blanks
for x=1:length(REP)
    if isempty(REP(x).cmp_code); REP(x).cmp_code='-'; end
    if isempty(REP(x).cmp_shortname); REP(x).cmp_shortname='-'; end
    if isempty(REP(x).cmp_name); REP(x).cmp_name='-'; end
end

% Sorts
h=findobj('Tag','SortPopup'); val=get(h,'Value'); if isempty(val) val=1; end
if val==1 [a,index]=sort(cat(2,REP.rt)); end % sort by rt
if val==2 [a,index]=sortrows(strvcat(REP.cmp_code)); end % sort by code
if val==3 [a,index]=sortrows(strvcat(REP.cmp_shortname)); end % sort by shortname
if val==4 [a,index]=sortrows(strvcat(REP.cmp_name)); end % sort by name
if val==5 [a,index]=sort(cat(2,REP.area)); index=fliplr(index); end % sort by area
REP=REP(index);

for x=1:fileset.results_npeaks
    p=0;
    if fileset.results_reportfields(1)==1
        p=p+1; Reportstruct.columntitle{p}='Rt'; Reportstruct.format{p}='%8.4f'; Reportstruct.cells{p,x}=REP(x).rt;
    end    
    if fileset.results_reportfields(2)==1
        p=p+1; Reportstruct.columntitle{p}='Retind'; Reportstruct.format{p}='%8.4f'; Reportstruct.cells{p,x}=REP(x).ri_calc;
    end
    if fileset.results_reportfields(3)==1
        %code=REP(x).cmp_code; if isempty(code) code='-'; end 
        p=p+1; Reportstruct.columntitle{p}='Code'; Reportstruct.format{p}='str'; Reportstruct.cells{p,x}=REP(x).cmp_code;
    end
    if fileset.results_reportfields(4)==1
        %shortname=REP(x).cmp_shortname; if isempty(shortname) shortname='-'; end 
        p=p+1; Reportstruct.columntitle{p}='Short'; Reportstruct.format{p}='str'; Reportstruct.cells{p,x}=REP(x).cmp_shortname;
    end    
    if fileset.results_reportfields(5)==1
        %name=REP(x).cmp_name; if isempty(name) name='-'; end
        p=p+1; Reportstruct.columntitle{p}='Name'; Reportstruct.format{p}='str'; Reportstruct.cells{p,x}=REP(x).cmp_name;
    end  
    if fileset.results_reportfields(6)==1
        p=p+1; Reportstruct.columntitle{p}='Area'; Reportstruct.format{p}='%10.0f'; Reportstruct.cells{p,x}=REP(x).area;
    end  
    if fileset.results_reportfields(7)==1
        p=p+1; Reportstruct.columntitle{p}='A pct'; Reportstruct.format{p}='%10.4f'; Reportstruct.cells{p,x}=REP(x).areapct;
    end  
    if fileset.results_reportfields(8)==1
        p=p+1; Reportstruct.columntitle{p}='Whh'; Reportstruct.format{p}='%10.4f'; Reportstruct.cells{p,x}=REP(x).whh;
        p=p+1; Reportstruct.columntitle{p}='Asym'; Reportstruct.format{p}='%10.2f'; Reportstruct.cells{p,x}=REP(x).asf;        
    end  
    p=p+1; str=''; 
    if isfield(REP,'peakparameters') & strmatch(REP(x).peakparameters,'PEAKFIT') str=[str 'PF ']; end
    if REP(x).peaksincl>1 str=[str 'D ']; end
    if REP(x).identified==0 str=[str 'I ']; end
    Reportstruct.columntitle{p}='Notes';
    Reportstruct.format{p}='str';
    Reportstruct.cells{p,x}=str;    
end

Reportstruct.header{1}=['Results for file: ',fileset.global_filename];
Reportstruct.header{2}=[num2str(fileset.results_npeaks),' peaks found in ',num2str(fileset.global_nuclusters),' clusters.'];
Reportstruct.footer{1}='Notes: PF-Peak parameters by function, D-Deconvoluted, I-Not identified';

Reportstruct.pathname=[locset.path_reports '\' metset.path_reports '\RESULTS_',fileset.global_filename];
Reportstruct.displaymessage=1;
Reportstruct.autoopen=metset.report_aopen;
 
rf=0;
if metset.report_txt 
    qq_report_txt(Reportstruct); rf=1; 
end
if metset.report_dif 
    if strcmp(metset.report_spreadsheet,'Data Interchange Format (dif)')
        qq_report_dif(Reportstruct); rf=1; 
    end
    if strcmp(metset.report_spreadsheet,'Excel (xls)')
        qq_report_xls(Reportstruct); rf=1; 
    end
    
end
if rf==0; qq_message(1,'|r|Select report type'); end

%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
o=bw/5;
%gh=positions.gh;% grid height

x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='ResultsWin'; winpar{2}='Q: Results';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0;
% RESET/CLOSE/ACCEPT
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_closewin',3,'');
% SELECT PEAK
p=p+1;[ui{p,1:7}] = deal('Select peak','Pushbutton',colors.bc,[x(1) y(13) bw bh],'qq_resultscall(16)',2,'');
p=p+1;[ui{p,1:7}] = deal('<','Pushbutton',colors.bc,[x(2) y(13) bw/3 bh],'qq_resultscall(16.1)',4,'');
p=p+1;[ui{p,1:7}] = deal('>','Pushbutton',colors.bc,[x(2)+bw*2/3 y(13) bw/3 bh],'qq_resultscall(16.2)',4,'');
p=p+1;[ui{p,1:7}] = deal('','text',colors.bc,[x(2)+bw/3 y(13) bw/3 bh],'',4,'PnTxt');
% DELETE
p=p+1;[ui{p,1:7}] = deal('Delete','Pushbutton',colors.reset,[x(3) y(13) bw bh],'qq_resultscall(7)',2,'');
% PEAKFIT
p=p+1;[ui{p,1:7}] = deal('Rt by peakfit','Checkbox',colors.bc,[x(1) y(14) bw*2 bh*0.9],'qq_resultscall(8.3)',2,'PeakfitCheck');
p=p+1;[ui{p,1:7}] = deal('Kurt=1','Checkbox',colors.bc,[x(2) y(14) bw*2 bh*0.9],'qq_resultscall(8.3)',2,'KurtosisCheck');
p=p+1;[ui{p,1:7}] = deal('Use','Text',colors.bc,[x(2)+bw*0.7 y(14) bw/3 eh],'',2,'');
p=p+1;[ui{p,1:8}] = deal('4','Edit',[1 1 1],[x(2)+0.95*bw y(14) bw/5 eh],'qq_resultscall(8.3)',2,'SigmaEdit','-c');
p=p+1;[ui{p,1:7}] = deal('Sigma','Text',colors.bc,[x(3)+bw*0.2 y(14) bw/3 eh],'',2,'');
p=p+1;[ui{p,1:8}] = deal('Recalc all','Pushbutton',colors.bc,[x(4)+bw*1/3 y(14) bw*2/3 bh],'qq_resultscall(8.2)',2,'','-bm');
p=p+1;[ui{p,1:7}] = deal('Recalc sel','Pushbutton',colors.bc,[x(3)+bw*2/3 y(14) bw*2/3 bh],'qq_resultscall(8.1)',2,'');

% LIBRARY
p=p+1;[ui{p,1:7}] = deal('Search lib.','Pushbutton',colors.btn{2},[x(1) y(15) bw*4/6 bh],'qq_resultscall(5.2)',2,'');
p=p+1;[ui{p,1:8}] = deal('Search All','Pushbutton',colors.btn{2},[x(1)+bw*4/6 y(15) bw*4/6 bh],'qq_resultscall(5.4)',2,'','-bm');
p=p+1;[ui{p,1:7}] = deal('Add to lib.','Pushbutton',colors.btn{2},[x(1)+bw*8/6 y(15) bw*4/6 bh],'qq_resultscall(5.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Tentative','Pushbutton',colors.btn{2},[x(1)+bw*12/6 y(15) bw*4/6 bh],'qq_resultscall(5.5)',2,'');
p=p+1;[ui{p,1:7}] = deal('Edit lib.','Pushbutton',colors.btn{2},[x(1)+bw*16/6 y(15) bw*4/6 bh],'qq_resultscall(5.3)',2,'');
p=p+1;[ui{p,1:7}] = deal('Settings','Pushbutton',colors.btn{2},[x(1)+bw*20/6 y(15) bw*4/6 bh],'qq_libset(1)',2,'');

% RETENTION INDICES
p=p+1;[ui{p,1:8}] = deal('Calc. RI','Pushbutton',colors.btn{3},[x(1) y(16) bw*4/7 bh],'qq_resultscall(6.1)',2,'','-bm');
p=p+1;[ui{p,1:7}] = deal('Calibr.','Pushbutton',colors.btn{3},[x(1)+bw*4/7 y(16) bw*4/7 bh],'qq_resultscall(6.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('Store','Pushbutton',colors.btn{3},[x(1)+bw*8/7 y(16) bw*4/7 bh],'qq_resultscall(6.4)',2,'');
p=p+1;[ui{p,1:7}] = deal('Get','Pushbutton',colors.btn{3},[x(1)+bw*12/7 y(16) bw*4/7 bh],'qq_resultscall(6.5)',2,'');
p=p+1;[ui{p,1:7}] = deal('Next','Pushbutton',colors.btn{3},[x(1)+bw*16/7 y(16) bw*4/7 bh],'qq_resultscall(6.6)',2,'');
p=p+1;[ui{p,1:7}] = deal('Delete','Pushbutton',colors.btn{3},[x(1)+bw*20/7 y(16) bw*4/7 bh],'qq_resultscall(6.7)',2,'');
p=p+1;[ui{p,1:7}] = deal('Edit','Pushbutton',colors.btn{3},[x(1)+bw*24/7 y(16) bw*4/7 bh],'qq_retindex_edit(1)',2,'');
p=p+1;[ui{p,1:7}] = deal('','Text',colors.btn{3},[x(1) y(17) bw*4 bh],'',2,'');
p=p+1;[ui{p,1:8}] = deal('Regr. type:  ','Text',colors.btn{3},[x(1)+bw*12/5 y(17) bw*4/5 eh],'',2,'','-r');
txt={'M-Regr.','V&K-Regr.'};
p=p+1;[ui{p,1:7}] = deal(txt,'Popupmenu',[1 1 1],[x(1)+bw*16/5 y(17) bw*4/5 bh],'',2,'RegrPopup');

% REPORT
p=p+1;[ui{p,1:7}] = deal('','Text',colors.btn{6},[x(1) y(18) bw*4 bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Report','Pushbutton',colors.btn{6},[x(1) y(18) bw bh],'qq_resultscall(7.1)',2,'');
p=p+1;[ui{p,1:8}] = deal('Sort by:  ','Text',colors.btn{6},[x(1)+bw*12/5 y(18) bw*4/5 eh],'',2,'','-r');
txt={'Rt','Code','Short','Name','Area'};
%po=bw/10;
p=p+1;[ui{p,1:7}] = deal(txt,'Popupmenu',[1 1 1],[x(1)+bw*16/5 y(18) bw*4/5 bh],'',2,'SortPopup');
p=p+1;[ui{p,1:7}] = deal('TXT','Checkbox',colors.btn{6},[x(2)+o y(18) bw/2 bh],'qq_eval(''ch'')',2,'metset.report_txt');
p=p+1;[ui{p,1:7}] = deal('Excel','Checkbox',colors.btn{6},[x(2)+bw/2+o y(18) bw/2 bh],'qq_eval(''ch'')',2,'metset.report_dif');
p=p+1;[ui{p,1:7}] = deal('Open','Checkbox',colors.btn{6},[x(3)+o y(18) bw/2 bh],'qq_eval(''ch'')',2,'metset.report_aopen');

% LABELS
yp=13; q=0.8;
p=p+1;[ui{p,1:7}] = deal('Labels','text',colors.bc,[x(5)+o y(yp) bw bh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('Ret. Time','RadioButton',colors.bc,[x(5)+o y(yp)-q*bh*1 bw bh],'qq_resultscall(17.1)',2,'Labelradio');
p=p+1;[ui{p,1:7}] = deal('Ret. Index','RadioButton',colors.bc,[x(5)+o y(yp)-q*bh*2 bw bh],'qq_resultscall(17.2)',2,'Labelradio');
p=p+1;[ui{p,1:7}] = deal('Areas','RadioButton',colors.bc,[x(5)+o y(yp)-q*bh*3 bw bh],'qq_resultscall(17.3)',2,'Labelradio');
p=p+1;[ui{p,1:7}] = deal('Area pct.','RadioButton',colors.bc,[x(5)+o y(yp)-q*bh*4 bw bh],'qq_resultscall(17.4)',2,'Labelradio');
p=p+1;[ui{p,1:7}] = deal('Show calibr.peaks','Checkbox',colors.bc,[x(5)+o y(yp)-q*bh*6 bw bh],'qq_resultscall(19.1)',2,'CalibrCheck');
% SERACH NIST
p=p+1;[ui{p,1:7}] = deal('NIST','Pushbutton',colors.btn{5},[x(2)+o y(19) bw*0.75 bh],'qq_resultscall(9)',2,'');
% PEAK PROPERTIES
p=p+1;[ui{p,1:7}] = deal('Peak prop.','Pushbutton',colors.btn{5},[x(4)+o y(19) bw*0.75 bh],'qq_resultscall(7.2)',2,'');
% Regplot
p=p+1;[ui{p,1:7}] = deal('Reg.Plot','Pushbutton',colors.btn{5},[x(3)+o y(19) bw*0.75 bh],'qq_retindex(999)',2,'');

updfcn='qq_resultscall(99)';
h0=qq_drawwin(winpar,ui,updfcn);
set(h0,'KeyPressFcn','qq_resultscall(98)');

%h=findobj('Tag','Scaleradio'); set(h,'Value',0); h=findobj(h,'String','Ret. Time');set(h,'Value',1) 
%h=findobj('Tag','Labelradio'); set(h,'Value',0); h=findobj(h,'String','Ret. Time');set(h,'Value',1) 
h=findobj('Tag','CalibrCheck'); set(h,'Value',0)
h=findobj('Tag','WindowSlider'); set(h,'Value',50,'Max',100,'SliderStep',[0.02 0.20]);
h=findobj('Tag','PnTxt'); set(h,'HorizontalAlignment','center');
h=findobj('Tag','PeakfitCheck'); set(h,'Value',metset.results_peakfit); 
h=findobj('Tag','KurtosisCheck'); set(h,'Value',metset.results_kurt); 
h=findobj('Tag','SigmaEdit'); set(h,'String',num2str(metset.results_sigma)); 

h=findobj('Tag','metset.report_aopen'); set(h,'Value',1); 
h=findobj('Tag','metset.report_txt'); set(h,'Value',1);
h=findobj('Tag','metset.report_dif'); set(h,'Value',1);














