function qq_retindex(an)

global RE fileset metset locset
persistent ind_vect ridef_vect

%disp('--------- NB! Sjekk at Rt for bde kalibrering og regresjon er oppdatert med RE.rt ---------')

if locset.tracker==1 disp(['--- qq_retindex ---' num2str(an)]); end

% Calculate RI
if an==1 && isfield(fileset,'results_rivect')
    %disp('---- Calculate RI ----')
    if length(fileset.results_rivect)==length(fileset.rt)
        ri_calc
    else
        qq_message('Regression not valid - Update')
    end
    ri_plot
end

% Calibrate
if an==2
    ri_calib
end

% Upd regression 
if an==3
    %disp('---- Update regression ----')
    [a,b]=size(fileset.results_rical); 
    if b>2
        val=get(findobj('Tag','RegrPopup'),'Value');
        if val==1 fileset.results_rivect=ri_regression(fileset.rt); end  
        if val==2 fileset.results_rivect=ri_regression2(fileset.rt); end
        
    else
        qq_message(1,'|r|Not enough regression points')
    end
    ri_plot
end

% Save: Transfer from file to method
if an==4 && isfield(fileset,'results_rical')
    fileset.results_calfile=fileset.global_filename;
    if isfield(metset,'results_ridata') [m,n]=size(metset.results_ridata); else m=0; end
    metset.results_ridata{m+1,1}=fileset.results_rical; 
    metset.results_ridata{m+1,2}=fileset.results_calfile; 
    metset.results_ridata{m+1,3}=length(fileset.rt);  % lengde p rt-vektor (gjenkjenning)
    metset.results_ridata{m+1,4}=fileset.rt(length(fileset.rt)); % Siste retensjonstid (gjenkjenning)
    metset.results_currentcalibr=m+1;
    qq_message('Regression transferred to method'); 
    ri_plot
end
if an==4 && ~isfield(fileset,'results_rical')
    qq_message(1,'|r|No calibration to transfer to method')
end

% Load: Transfer from method from file
if an==5 && isfield(metset,'results_ridata') 
    sortregressions
    fileset.results_rical=metset.results_ridata{1,1};
    fileset.results_calfile=metset.results_ridata{1,2};
    metset.results_currentcalibr=1;
    ri_plot
    qq_message('Regression from method'); 
end
if an==5 && isfield(metset,'results_ridata')==0; qq_message(1,'|r|No calibrations in method file'); end 


if an==6 && isfield(metset,'results_ridata')
    [m,n]=size(metset.results_ridata);
    if metset.results_currentcalibr==m 
        metset.results_currentcalibr=1; 
    else 
        metset.results_currentcalibr=metset.results_currentcalibr+1; 
    end
    fileset.results_rical=metset.results_ridata{metset.results_currentcalibr,1};
    fileset.results_calfile=metset.results_ridata{metset.results_currentcalibr,2};
    ri_plot
end
if an==6 && ~isfield(metset,'results_ridata')
    qq_message(1,'|r|No calibration data in method')
end

% DELETE
if an==7 && isfield(metset,'results_currentcalibr') && metset.results_currentcalibr>0 && isfield(metset,'results_ridata')
    metset.results_ridata(metset.results_currentcalibr,:)=[];
    metset.results_currentcalibr=metset.results_currentcalibr-1;
    ri_plot
end
if an==7 && ~isfield(metset,'results_currentcalibr') 
    qq_message(1,'|r|No data to delete')
end
if an==7 && isfield(metset,'results_currentcalibr') && metset.results_currentcalibr==0
    qq_message(1,'|r|Calibration not selected')
end

% DUMP REGR PLOTS
if an==999
    ri_plot_all
end

% -------------------------------------------------------------------------
% ----------------------------- SUBFUNCTIONS ------------------------------
% -------------------------------------------------------------------------

% ------------------------------- SORT REGRESSIONS -----------------------

function sortregressions
global metset fileset

% Sorterer etter rt for siste scan
ridata=metset.results_ridata;
endrt=cat(1,ridata{:,4}); diffendrt=abs(endrt-fileset.rt(length(fileset.rt)));
[d,ind]=sort(diffendrt);
[m,n]=size(ridata);
for x=1:m
    metset.results_ridata(x,:)=ridata(ind(x),:);
end

% ------------------------------- RI PLOTT -------------------------------
function ri_plot

global fileset metset positions

% PLOTTER
subplot('position',positions.smallplot); plot(0);
hold on
if isempty(fileset.results_rical)==0
    plot(fileset.results_rical(1,:),fileset.results_rical(2,:),'or')
end
if isfield(fileset,'results_rivect')
    a=length(fileset.rt); b=length(fileset.results_rivect); vl=min(a,b);
    plot(fileset.rt(1:vl),fileset.results_rivect(1:vl))
end

%--------- setter akser ---------
if isempty(fileset.results_rical)==0
    maxx=max(max(fileset.rt),max(fileset.results_rical(1,:)));
    minx=min(min(fileset.rt),min(fileset.results_rical(1,:)));

    maxy=max(fileset.results_rical(2,:));
    if isfield(fileset,'results_rivect') maxy=max(max(fileset.results_rivect),max(fileset.results_rical(2,:))); end
    if isempty(maxy) maxy=max(fileset.results_rical(2,:)); end

    miny=min(fileset.results_rical(2,:));
    if isfield(fileset,'results_rivect') miny=min(min(fileset.results_rivect), min(fileset.results_rical(2,:))); end
    if isempty(miny) miny=min(fileset.results_rical(2,:)); end

    axis([minx maxx miny maxy])
    % axis tight
    text(0.05,0.93,'Retention Index','units','normalized','fontweight','bold','horizontalalignment','left')
    text(0.95,0.05,'Time','units','normalized','fontweight','bold','horizontalalignment','right')
    if isfield(fileset,'results_calfile')==0; fileset.results_calfile='----'; end
    if ~isfield(metset,'results_currentcalibr') metset.results_currentcalibr=0; end
    text(0.05,0.85,['Calibr. file ' num2str(metset.results_currentcalibr) ': ' fileset.results_calfile], ...
        'units','normalized','fontweight','bold','horizontalalignment','left','Interpreter','none')
    if metset.results_currentcalibr>0 & length(fileset.rt)~=metset.results_ridata{metset.results_currentcalibr,3} 
        text(0.05,0.75,['Different number of scans: ' num2str(length(fileset.rt)-metset.results_ridata{metset.results_currentcalibr,3})], ...
            'units','normalized','fontweight','bold','horizontalalignment','left')
        qq_message(1,'|r|Warning: Different number of scans in calibration and sample')
    end
    hold off
end




% ------------------------------- RI PLOTT_ALL -------------------------------
function ri_plot_all

global fileset metset colors

% DUMPER ALLE REGRESJONER TIL NY FIGUR

if isfield(fileset,'results_rivect') rivect_old=fileset.results_rivect; end
if isfield(fileset,'results_rical') rical_old=fileset.results_rical; end

figure('Color',colors.bc);
hold on
    
[m,n]=size(metset.results_ridata);
for x=1:m 
    fileset.results_rical=metset.results_ridata{x,1};
    
    %ri_regression
    
    ridef_vect=fileset.results_rical(2,:); % Retensjonsindekser (standarder)
    ind_vect=fileset.results_rical(1,:);   % Retensjonstider (standarder)
    p=length(ind_vect);
    
    % interval fra start til 2. pkt
    % andre ordens interpolering p de tre frste pkt
    
    times=[]; retindex=[];

    newpol=polyfit(ind_vect(1:3),ridef_vect(1:3),2);
    loctimes=linspace(ind_vect(1),ind_vect(2));
    rivect1=(newpol(1)*(loctimes).^2)+(newpol(2)*(loctimes))+newpol(3);
    times=[times loctimes]; retindex=[retindex rivect1];

    % Mellom-interval
    % lokal andre-ordens interpolering over tre punkter
    for k=2:p-2
        
        loctimes=linspace(ind_vect(k),ind_vect(k+1));
        
        lastpol=newpol;
        rivect1=(lastpol(1)*(loctimes).^2)+(lastpol(2)*(loctimes))+lastpol(3);
        
        newpol=polyfit(ind_vect(k:k+2),ridef_vect(k:k+2),2);
        rivect2=(newpol(1)*(loctimes).^2)+(newpol(2)*(loctimes))+newpol(3);
        
        weights1=linspace(0,1); weights2=1-weights1;
        rivect3=rivect1.*weights1+rivect2.*weights2;
        
        times=[times loctimes]; retindex=[retindex rivect3];

    end
    
    % siste intervall til slutt:
    % lokal andre ordens over tre siste punkter
    loctimes=linspace(ind_vect(p-1),ind_vect(p));
    rivect1=(newpol(1)*(loctimes).^2)+(newpol(2)*(loctimes))+newpol(3);
    times=[times loctimes]; retindex=[retindex rivect1];
    plot(times,retindex,'Color',[0 0 0])
    plot(fileset.results_rical(1,:),fileset.results_rical(2,:),'o','MarkerSize',6,'MarkerFaceColor',[0 0 0],'MarkerEdgeColor',[1 1 1]);

    
end
    
axis tight
text(0.05,0.95,'ECL','units','normalized','fontweight','bold','horizontalalignment','left')
text(0.99,0.05,'Retention time (min)','units','normalized','fontweight','bold','horizontalalignment','right')

hold off

% Restore
if exist('rivect_old') fileset.results_rivect=rivect_old; end 
if exist('rical_old') fileset.results_rical=rical_old; end

% ------------------ RI_CALIB -----------------------
function ri_calib
global RE fileset metset

% Finner data for mettede fettsyrer
p=0;
for i1=1:fileset.results_npeaks
    if isnan(RE(i1).ri_def)==0
        p=p+1;
        % ind_vect(p)=RE(i1).maxp;
        rt_vect(p)=RE(i1).rt;
        ridef_vect(p)=RE(i1).ri_def;
    end
end
if p==0
    qq_message(1,'|r|No calibration peaks')
    fileset.results_rical=[];
else
    fileset.results_rical=[rt_vect; ridef_vect];
    metset.results_currentcalibr=0;
    fileset.results_calfile=fileset.global_filename;
    ri_plot    
end

% ------------------- RI_REGRESSION (Ny 28.10.05) --------------------------
function rivect=ri_regression(labels)
global fileset RE

% ------------------- BEREGN ind_vect OG ridef_vect -----------------
ridef_vect=fileset.results_rical(2,:);
rtdef_vect=fileset.results_rical(1,:);
p=length(ridef_vect);
for i1=1:p
    a=min(find(labels >= fileset.results_rical(1,i1))); 
    if isempty(a)==0 ind_vect(i1)=a; end
end
if length(ind_vect)<p; p=length(ind_vect); end %

% -------- BEREGNER ECL-vektor ----------
% interval fra start til 2. pkt
% andre ordens interpolering p de tre frste pkt

newpol=polyfit(rtdef_vect(1:3),ridef_vect(1:3),2);
locrt=labels(1:ind_vect(2));
rivect(1:ind_vect(2))=(newpol(1)*(locrt).^2)+(newpol(2)*(locrt))+newpol(3);

% Mellom-interval
% lokal andre-ordens interpolering over tre punkter
for k=2:p-2
    lastpol=newpol;
    
    locrt=labels(ind_vect(k):ind_vect(k+1));
    rivect1=(lastpol(1)*(locrt).^2)+(lastpol(2)*(locrt))+lastpol(3);
    
    newpol=polyfit(rtdef_vect(k:k+2),ridef_vect(k:k+2),2);
    rivect2=(newpol(1)*(locrt).^2)+(newpol(2)*(locrt))+newpol(3);
    
    %WEIGHTS: wl=min(locrt); wh=max(locrt); wd=wh-wl; %ww=locrt-wl; weights1=ww/wd;
    weights2=(locrt-min(locrt))/(max(locrt)-min(locrt)); 
    weights1=1-weights2;
   
    rivect3=rivect1.*weights1+rivect2.*weights2;  
    rivect(ind_vect(k):ind_vect(k+1))=rivect3;
end

% siste intervall til slutt: Lokal andre ordens over tre siste punkter
slutt=length(labels);
locrt=labels(ind_vect(p-2):slutt);
rivect(ind_vect(p-2):slutt)=(newpol(1)*(locrt).^2)+(newpol(2)*(locrt))+newpol(3);

%fileset.results_rivect=rivect;


% ------------------- RI_REGRESSION2 (Ny 28.10.05) --------------------------
% Regresjon etter van den Dool & Kratz
function rivect=ri_regression2(labels)
global fileset RE

% ------------------- BEREGN ind_vect OG ridef_vect -----------------
ridef_vect=fileset.results_rical(2,:);
rtdef_vect=fileset.results_rical(1,:);
p=length(ridef_vect);
for i1=1:p
    a=min(find(labels >= fileset.results_rical(1,i1))); 
    if isempty(a)==0 ind_vect(i1)=a; end
end
if length(ind_vect)<p; p=length(ind_vect); end %

% Start
newpol=polyfit(rtdef_vect(1:2),ridef_vect(1:2),1);
%disp('--- Startintervall ---')
locrt=labels(1:ind_vect(2));
rivect(1:ind_vect(2))=(newpol(1)*(locrt))+newpol(2);
% Mellom-interval
for k=2:p-1
    %disp('--- Mellomintervall ---')
    locrt=labels(ind_vect(k):ind_vect(k+1));
    newpol=polyfit(rtdef_vect(k:k+1),ridef_vect(k:k+1),1);
    rivect(ind_vect(k):ind_vect(k+1))=(newpol(1)*(locrt))+newpol(2);
end
% Slutt
slutt=length(labels);
%disp('--- Sluttintervall ---')
locrt=labels(ind_vect(p-1):slutt);
rivect(ind_vect(k):slutt)=(newpol(1)*(locrt))+newpol(2);

%fileset.results_rivect=rivect;

% PLOTTING
%figure
%plot(labels(1:length(rivect)),rivect)
%hold on
%plot(rtdef_vect,ridef_vect,'or')
%hold off
%figure



% ------------------------ RI_CALC ------------------------------
function ri_calc

global fileset RE

for i1=1:fileset.results_npeaks
    ind1=max(find(fileset.rt<=RE(i1).rt));
    ind2=min(find(fileset.rt>=RE(i1).rt));

    if ind1==ind2
        RE(i1).ri_calc=fileset.results_rivect(ind1);
    else
        xv=[fileset.rt(ind1) fileset.rt(ind2)];
        yv=[fileset.results_rivect(ind1) fileset.results_rivect(ind2)];
        RE(i1).ri_calc=interp1(xv,yv,RE(i1).rt);
    end
    
end

%fileset



