function qq_ri_maps(an)
% function qq_addlib

global fileset metset locset
global REG  %c_lib ind  n_rep % ind=vektor med matchende indexer, c_ind=gjeldende index
%persistent LIB selected

qq_message(2)

% pner vindu
if an==0; 
    openwin; 
    zoomline
    %[d,ind]=sort(cat(1,REG(:).meanri)); REG=REG(ind);
    drawmap
end



% -------------- ZOOM ------------
if an>1 & an<2
    indices=(cat(2,REG(:).meanri)); lowbound=min(indices); upbound=max(indices); range=upbound-lowbound;
    set(gcf,'CurrentAxes',findobj(gcf,'Tag','RI-Map'))
    lims=xlim; li=lims(1); ri=lims(2); cp=(ri+li)/2; range=ri-li;
end
% Zoom in
if an==1.1 
    li=cp-(range/4); ri=cp+(range/4); 
end
% Zoom out
if an==1.2 
    li=cp-(range); ri=cp+(range); 
end  
% Slider
if an==1.3 
    slide=gcbo; cp=get(slide,'Value');
    li=cp-range/2; ri=cp+range/2;
end
if an==1.4
    h=findobj('Tag','LowxEdit'); li=str2double(get(h,'String'));
    h=findobj('Tag','HighxEdit'); ri=str2double(get(h,'String'));
end
% Oppdaterer
if an>1 & an<2
    % Oppdaterer li/ri og range
    if li<lowbound li=lowbound; end; if ri>upbound; ri=upbound; end
    if ri>li xlim([li ri]); end
    range=ri-li; 
    % Oppdaterer slider:    
    slide=findobj('Tag','Plotslider'); 
    set(slide,'Max',upbound,'Min',lowbound,'Value',cp,'SliderStep',[range/(upbound-lowbound) (range/(upbound-lowbound))/10])
    % Setter xlim 
    xlim([li ri])
    % Oppdaterer Edit 
    h=findobj('Tag','LowxEdit'); set(h,'String',num2str(li));
    h=findobj('Tag','HighxEdit'); set(h,'String',num2str(ri));
end

% Draw
if an==2.1
    drawmap
end

% Update Colors
if an==3.1
    %colorcodes(REG)
    %colorcodes2(REG)
    drawmap
end

% Save
if an==4.1
    h=findobj('Tag','MapnameEdit'); fn=get(h,'String');
    filestr=[locset.path_library '\class_' metset.global_class '\ri_map_' fn];
    Info.savedby='Q'; Info.version=locset.version; Info.date=date; Info.clockvector=clock; Info.matlabversion=version;
    save(filestr,'REG','Info');
    qq_message(1,['|b|Map saved as: ' filestr])
end
if an==4.2
    qq_message(1,'|r|Not implemented')
end



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                            S U B F U N C T I O N S
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% -------------- SUBFUNCTION DRAWMAP -------------------
function drawmap
global positions REG

colorcodes2
boldthresh=str2double(get(findobj('Tag','BoldEdit'),'String'));
h=findobj('Tag','RI-Map'); if isempty(h)==0 delete(h); end % Sletter gamle plott

pos=positions.largeplot; pos(2)=0.30; pos(4)=1-pos(2);

axes('Position',pos,'Tag','RI-Map')

textlevel(1)=2.8; textlevel(2)=1.8; textlevel(3)=2.3; textlevel(4)=1.3; tlc=0; 

for x=1:length(REG)
    if REG(x).n_entr>=boldthresh lw=2; else lw=1; end
    meanri=REG(x).meanri; 
    stdev=REG(x).p_stdev; % Dersom pooled stdv
    lowri=meanri-3*stdev; highri=meanri+3*stdev; xax=linspace(lowri,highri,50); % Lager x-akse
    yax=hpeak(xax,meanri,stdev);
    
    h=plot(xax,yax,'Color',REG(x).color,'LineWidth',lw,'Tag','rimap_peak','UserData',x); hold on;    
    
    tlc=tlc+1; if tlc>4; tlc=1; end
    str{1}=REG(x).cmp_code; str{2}=REG(x).cmp_shortname; str{3}=num2str(REG(x).meanri); str{4}=['(' num2str(REG(x).n_entr) ')'];
    th=text(meanri,textlevel(tlc),str,'HorizontalAlignment','Center','Color',REG(x).color,'Tag','rimap_text','UserData',x);
    
    lo=0.22; line([meanri meanri],[1 textlevel(tlc)-lo],'LineStyle',':','Color',REG(x).color,'Tag','rimap_line','UserData',x)
          
end
hold off

set(gca,'Tag','RI-Map')

ylim([0 3.1]); qq_copyfigure

% Setter sliderverdier
lims=xlim; lowbound=lims(1); upbound=lims(2); cp=(upbound+lowbound)/2; 
slide=findobj('Tag','Plotslider'); set(slide,'Max',upbound,'Min',lowbound,'Value',cp,'SliderStep',[0 0])
% Oppdaterer Edit 
h=findobj('Tag','LowxEdit'); set(h,'String',num2str(lowbound));
h=findobj('Tag','HighxEdit'); set(h,'String',num2str(upbound));


% ---------------- COLORCODES2 ------------------
function colorcodes2
global REG

for x=1:length(REG)
    codes{x}=REG(x).cmp_code;
end

ce=findobj('Tag','ColorEdit'); cf=findobj('Tag','ColorFrame');

[REG.color]=deal([0 0 0]);
for x=1:length(ce)
    cstr=get(ce(x),'String');
    colorvect=get(cf(x),'BackgroundColor');
    if isempty(cstr)==0
        mind=strmatch(cstr,codes)
        if isempty(mind)==0
            [REG(mind).color]=deal(colorvect);
        end        
    end
end



% ---------------- COLORCODES ------------------
%function [colorcell,codecell]=colorcodes
%function colorcodes(REG)%
%
%ncols=7; 
%str=get(findobj('Tag','BoldEdit'),'String'); boldtresh=str2double(str);
%
%for x=1:length(REG) regcodes{x}=REG(x).cmp_code; end
%
%h=findobj('Tag','rimap_peak'); set(h,'Color',[0 0 0],'LineWidth',1)
%h=findobj('Tag','rimap_text'); set(h,'Color',[0 0 0],'FontWeight','Normal')
%h=findobj('Tag','rimap_line'); set(h,'Color',[0 0 0],'LineWidth',1)
%
%for x=1:ncols
%    frstr=['ColorFrame' num2str(x)]; edstr=['ColorEdit' num2str(x)]; 
%    h=findobj('Tag',frstr); color=get(h,'Backgroundcolor');
%    h=findobj('Tag',edstr); code=get(h,'String');
%    
%    if isempty(code)==0
%        match=strmatch(code,regcodes);
%        for y=1:length(match)
%            h=findobj('Tag','rimap_peak','UserData',match(y));
%            set(h,'Color',color)
%            h=findobj('Tag','rimap_text','UserData',match(y));
%            set(h,'Color',color)
%            h=findobj('Tag','rimap_line','UserData',match(y));
%            set(h,'Color',color)            
%        end
%    end   
%end

%n_entr=cat(1,REG(:).n_entr); above=find(n_entr >= boldtresh);
%for x=1:length(above)
%    h=findobj('Tag','rimap_peak','UserData',above(x)); set(h,'LineWidth',2)
%    h=findobj('Tag','rimap_line','UserData',above(x)); set(h,'LineWidth',2)    
%    h=findobj('Tag','rimap_text','UserData',above(x)); set(h,'FontWeight','Bold')
%end


% ---------------- HPEAK ------------------
function yval = hpeak (scanpos, position, s)
%global metset

li=find(scanpos<=position); lowpos=scanpos(li);
ri=find(scanpos>position); highpos=scanpos(ri);

lyval = exp(-((position-lowpos).^2)/(2*s^2));
hyval = exp(-((highpos-position).^2)/(2*s^2));

yval=[lyval hyval];

% -------------- SUBFUNCTION ZOOMLINE -------------------
function zoomline

global fonts positions colors

bw=positions.bw;
bh=positions.bh;
eh=positions.eh;
x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid
o=bh-eh;
h0=gcf;

% ZOOMLINE
h=findobj(gcf,'Tag','Plotcontrol'); hp=17;
if isempty(h)
    uicontrol('Parent',h0,'Callback','qq_ri_maps(1.1)','Position',[x(1) y(hp)+o bw/2 eh],'String','+','Tag','Plotcontrol','FontSize',fonts(5));
    uicontrol('Parent',h0,'Callback','qq_ri_maps(1.2)','Position',[x(1)+bw/2 y(hp)+o bw/2 eh],'String','-','Tag','Plotcontrol','FontSize',fonts(5));
    uicontrol('Parent',h0,'Callback','qq_ri_maps(1.3)','Max',100,'SliderStep',[0.02 0.20],'Position',[x(2) y(hp)+o bw*2 eh], ...
    	'Style','slider','Tag','Plotslider','Value',50.0);
    uicontrol('Parent',h0,'Callback','qq_ri_maps(1.4)','Position',[x(4)+bw/2 y(hp)+o bw*0.45 eh], ...
    	'Style','Edit','Tag','LowxEdit','Value',0,'String','','BackgroundColor',[1 1 1]);
    uicontrol('Parent',h0,'Callback','qq_ri_maps(1.4)','Position',[x(5) y(hp)+o bw*0.45 eh], ...
    	'Style','Edit','Tag','HighxEdit','Value',0,'String','','BackgroundColor',[1 1 1]);
end


%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset fileset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;

x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='RIMapsWin'; winpar{2}='Q:Retention Maps';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0;
% RESET/CLOSE/ACCEPT
%p=p+1;[ui{p,1:7}] = deal('Discard','Pushbutton',colors.reset,[x(1) y(20) bw bh*1.5],'qq_addlib(8)',3,'');
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_closewin',3,'');
%p=p+1;[ui{p,1:7}] = deal('Accept','Pushbutton',colors.accept,[x(2) y(20) bw bh*1.5],'qq_addlib(0)',3,'');

p=p+1;[ui{p,1:7}] = deal('Redraw','Pushbutton',colors.accept,[x(2) y(20) bw bh*1.5],'qq_ri_maps(2.1)',2,'');

hp=20;
p=p+1;[ui{p,1:7}] = deal('Save Map','Pushbutton',colors.btn{6},[x(4) y(hp) bw bh],'qq_ri_maps(4.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(5) y(hp) bw*1.5 bh],'',3,'MapnameEdit');

p=p+1;[ui{p,1:7}] = deal('Load Map','Pushbutton',colors.btn{6},[x(7) y(hp) bw bh],'qq_ri_maps(4.2)',2,'');
p=p+1;[ui{p,1:7}] = deal(' ','PopupMenu',[1 1 1],[x(8) y(hp) bw*1.5 bh],'',3,'');

%hp=18;
%p=p+1;[ui{p,1:7}] = deal('','Frame',[0 0 1],[x(3) y(hp) bw*0.8 bh],'',3,'ColorFrame1');
%p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(3)+bw*0.2 y(hp)+((bh-eh)/2) bw*0.4 eh],'qq_ri_maps(3.1)',3,'ColorEdit1');
%p=p+1;[ui{p,1:7}] = deal('','Frame',[1 0 0],[x(4) y(hp) bw*0.8 bh],'',3,'ColorFrame2');
%p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(4)+bw*0.2 y(hp)+((bh-eh)/2) bw*0.4 eh],'qq_ri_maps(3.1)',3,'ColorEdit2');
%p=p+1;[ui{p,1:7}] = deal('','Frame',[0 0.6 0],[x(5) y(hp) bw*0.8 bh],'',3,'ColorFrame3');
%p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(5)+bw*0.2 y(hp)+((bh-eh)/2) bw*0.4 eh],'qq_ri_maps(3.1)',3,'ColorEdit3');
%p=p+1;[ui{p,1:7}] = deal('','Frame',[0.5 0 0.5],[x(6) y(hp) bw*0.8 bh],'',3,'ColorFrame4');
%p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(6)+bw*0.2 y(hp)+((bh-eh)/2) bw*0.4 eh],'qq_ri_maps(3.1)',3,'ColorEdit4');
%p=p+1;[ui{p,1:7}] = deal('','Frame',[0.5 0.5 0],[x(7) y(hp) bw*0.8 bh],'',3,'ColorFrame5');
%p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(7)+bw*0.2 y(hp)+((bh-eh)/2) bw*0.4 eh],'qq_ri_maps(3.1)',3,'ColorEdit5');
%p=p+1;[ui{p,1:7}] = deal('','Frame',[0 0.5 0.5],[x(8) y(hp) bw*0.8 bh],'',3,'ColorFrame6');
%p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(8)+bw*0.2 y(hp)+((bh-eh)/2) bw*0.4 eh],'qq_ri_maps(3.1)',3,'ColorEdit6');
%p=p+1;[ui{p,1:7}] = deal('','Frame',[0.4 0.4 0.4],[x(9) y(hp) bw*0.8 bh],'',3,'ColorFrame7');
%p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(9)+bw*0.2 y(hp)+((bh-eh)/2) bw*0.4 eh],'qq_ri_maps(3.1)',3,'ColorEdit7');
%p=p+1;[ui{p,1:7}] = deal('Bold thresh.','Text',colors.bc,[x(1) y(hp)+((bh-eh)/2) bw*0.75 eh],'',2,'');
%p=p+1;[ui{p,1:7}] = deal('5','Edit',[1 1 1],[x(1)+bw*0.75 y(hp)+((bh-eh)/2) bw*0.25 eh],'qq_ri_maps(3.1)',2,'BoldEdit');
%p=p+1;[ui{p,1:7}] = deal('Colorcodes:','Text',colors.bc,[x(2)+bw/4 y(hp)+((bh-eh)/2) bw*0.75 eh],'',2,'');

hp=18;
p=p+1;[ui{p,1:7}] = deal('','Frame',[1 0 0],[x(3) y(hp) bw*0.8 bh],'',3,'ColorFrame');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(3)+bw*0.2 y(hp)+((bh-eh)/2) bw*0.4 eh],'qq_ri_maps(3.1)',3,'ColorEdit');
p=p+1;[ui{p,1:7}] = deal('','Frame',[0 0 1],[x(4) y(hp) bw*0.8 bh],'',3,'ColorFrame');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(4)+bw*0.2 y(hp)+((bh-eh)/2) bw*0.4 eh],'qq_ri_maps(3.1)',3,'ColorEdit');
p=p+1;[ui{p,1:7}] = deal('','Frame',[0 0.6 0],[x(5) y(hp) bw*0.8 bh],'',3,'ColorFrame');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(5)+bw*0.2 y(hp)+((bh-eh)/2) bw*0.4 eh],'qq_ri_maps(3.1)',3,'ColorEdit');
p=p+1;[ui{p,1:7}] = deal('','Frame',[0.5 0 0.5],[x(6) y(hp) bw*0.8 bh],'',3,'ColorFrame');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(6)+bw*0.2 y(hp)+((bh-eh)/2) bw*0.4 eh],'qq_ri_maps(3.1)',3,'ColorEdit');
p=p+1;[ui{p,1:7}] = deal('','Frame',[0.5 0.5 0],[x(7) y(hp) bw*0.8 bh],'',3,'ColorFrame');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(7)+bw*0.2 y(hp)+((bh-eh)/2) bw*0.4 eh],'qq_ri_maps(3.1)',3,'ColorEdit');
p=p+1;[ui{p,1:7}] = deal('','Frame',[0 0.5 0.5],[x(8) y(hp) bw*0.8 bh],'',3,'ColorFrame');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(8)+bw*0.2 y(hp)+((bh-eh)/2) bw*0.4 eh],'qq_ri_maps(3.1)',3,'ColorEdit');
p=p+1;[ui{p,1:7}] = deal('','Frame',[0.4 0.4 0.4],[x(9) y(hp) bw*0.8 bh],'',3,'ColorFrame');
p=p+1;[ui{p,1:7}] = deal('','Edit',[1 1 1],[x(9)+bw*0.2 y(hp)+((bh-eh)/2) bw*0.4 eh],'qq_ri_maps(3.1)',3,'ColorEdit');
p=p+1;[ui{p,1:7}] = deal('Bold thresh.','Text',colors.bc,[x(1) y(hp)+((bh-eh)/2) bw*0.75 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('5','Edit',[1 1 1],[x(1)+bw*0.75 y(hp)+((bh-eh)/2) bw*0.25 eh],'qq_ri_maps(3.1)',2,'BoldEdit');
p=p+1;[ui{p,1:7}] = deal('Colorcodes:','Text',colors.bc,[x(2)+bw/4 y(hp)+((bh-eh)/2) bw*0.75 eh],'',2,'');

updfcn='';
h0=qq_drawwin(winpar,ui,updfcn); 

drawnow








