function qq_setlocset(Savesettings)

fileext='';
fh=fopen([Savesettings.path_root '\qq_localsettings.csv'],'r');
if fh~=-1
    fileext='csv'; fclose(fh); 
else
    fh=fopen([Savesettings.path_root '\qq_localsettings.sdv'],'r'); % old type settings
    if fh ~=-1 fileext='sdv'; fclose(fh); end
end
clockv=clock;
datestr=[num2str(clockv(1)) '_' num2str(clockv(2)) '_' num2str(clockv(3)) '_' num2str(clockv(4)) '_' num2str(clockv(5)) '_' num2str(round(clockv(6)))];
oldfn=[Savesettings.path_root '\qq_localsettings.' fileext];
newfn=[Savesettings.path_export '\qq_localsettings_' datestr '.bak'];

if isempty(fileext)
    qq_message(1,'|r|Error: Could not backup old settings, new settings not saved')
else

    % Backups old file
    fh=fopen(oldfn,'r');
    tline=1; p=0;
    while  tline~=-1
        tline=fgetl(fh);
        if tline~=-1 p=p+1; readstr{p}=tline; end
    end
    fclose(fh);

    linefeed=char([13 10]);
    fh=fopen(newfn,'w');
    for x=1:length(readstr)
        fprintf(fh, '%s', [readstr{x} linefeed]);
    end
    fclose(fh);

    % Writes new file
    pathname=[Savesettings.path_root '\qq_localsettings.' fileext]; % 
    linefeed=char([13 10]);
    fh=fopen(pathname,'w');

    Savesettings=rmfield(Savesettings,{'path_code','path_root','scrwidth','scrheight'}); % Fields that are not set in qq_localsettings

    fn=fieldnames(Savesettings); fn=sort(fn);

    for x=1:length(fn)
        varname=fn{x};
        content=Savesettings.(fn{x});
        if isnumeric(content)
            if length(content)>1
                contentstr='[';
                for y=1:length(content)
                    contentstr=[contentstr ' ' num2str(content(y))];
                end
                 contentstr=[contentstr ']'];
            else
                contentstr=num2str(content);
            end
        else
            contentstr=content;
        end
        comment='';
        if strmatch(varname,'defaultmethod') comment='Method to load on startup'; end
        if strmatch(varname,'editor') comment='(Obsolete)'; end
        if strmatch(varname,'path_agilent') comment='Folder for MS chemstation rawdata'; end
        if strmatch(varname,'path_cdf') comment='Folder for NetCDF (AIA format) rawdata'; end
        if strmatch(varname,'path_csv') comment='Folder for csv-import of SIM-data'; end
        if strmatch(varname,'path_matlab') comment='Folder for Matlab data'; end
        if strmatch(varname,'path_nist') comment='Folder NIST library'; end
        if strmatch(varname,'path_prs') comment='Folder Extricator/Resolver Matlab export'; end
        if strmatch(varname,'tracker') comment='For development purposes, 0 or 1'; end
        if strmatch(varname,'version') comment='Code version to use'; end
        if strmatch(varname,'windowpos') comment='Window position and size [leftposition lowerposition width height] in fractions of screen size'; end
        if strmatch(varname,'path_export') comment='Folder for exported data'; end
        if strmatch(varname,'path_qqraw') comment='Folder for Chrombox Q raw data (Matlab format)'; end
        if strmatch(varname,'path_library') comment='Folder for spectral libraries and data defining compound classes'; end
        if strmatch(varname,'path_method') comment='Folder for methods'; end
        if strmatch(varname,'path_results') comment='Folder for Chrombox Q results data'; end
        if strmatch(varname,'path_reports') comment='Folder for Chrombox Q reports'; end
        if strmatch(varname,'path_jcamp') comment='Folder for jcamp-dx data (import)'; end
        if strmatch(varname,'defaulfolders') comment='Overrides path settings with default values (qq_root\export,library,method,reports,results,qqraw)'; end
    
        printstr{x}=[varname '; ' contentstr '; ' comment];
    end

    for x=1:length(printstr)
        fprintf(fh, '%s', [printstr{x} linefeed]);
    end
    fclose(fh);   
    
    if fh==-1
        qq_message(1,'|r|Error: Could not write new settings to file. File may be open by another application')
    else
        qq_message(1,['|b|Settings saved. Old settings copied to ' newfn])
    end
   
end







