function qq_spectra(an,newspec)
 
% D = Directory data, 
% X = Loaded data
% llabels / lions = local labels/ions (before accept)

global SPEC

qq_message(2)

if nargin<1
   an=0;
end

if nargin>1 SPEC=newspec; end

% pner vinu hvis ny
h=findobj('Tag','SpectraWin'); if isempty(h) 
    openwin; 
    for x=1:length(SPEC); 
        numstr=num2str(x); numstr=[numstr blanks(4-length(numstr))]; 
        namestr{x}=[numstr(1:3) SPEC(x).name]; 
    end
    h=findobj('Tag','PlotSpecList'); set(h,'String',namestr);
end

% Alle Spektra
if an==1
    spectoggle
    allbar
    setaxes1
end
% Valgt spektrum
if an==1.1
    spectoggle
    selbar   
    setaxes1
end

% Selected+mean
if an==1.2
    spectoggle
    selmean
    setaxes1
end

if an==2
    spectoggle
    PCA
    setaxes2
end

%adjust axes
if an==10.1
    setaxes3
end

% Listselection
if an==20.1
    selaction
end




%======================================== SUBFUNCTIONS ========================================
% ------------- SELACTION ------------
function selaction

h=findobj('Tag','PlotSpecList'); sel=get(h,'Value');

h=findobj('Tag','SpecToggle','Value',1); str=get(h,'String')
if strmatch('Selected',str)
    selbar
end
if strmatch('Sel / Mean',str)
    selmean
end

% ------------- SETAXES1 ------------
function setaxes1

axis tight
xax=xlim; yax=ylim; xax(1)=floor(xax(1)); xax(2)=ceil(xax(2));
xlim(xax)

h=findobj('Tag','MinXEdit'); set(h,'String',num2str(xax(1)))
h=findobj('Tag','MaxXEdit'); set(h,'String',num2str(xax(2)))
h=findobj('Tag','MinYEdit'); set(h,'String',num2str(yax(1)))
h=findobj('Tag','MaxYEdit'); set(h,'String',num2str(yax(2)))

% ------------- SETAXES2 ------------
function setaxes2

xax=xlim; yax=ylim; 
xlim(xax)

h=findobj('Tag','MinXEdit'); set(h,'String',num2str(xax(1)))
h=findobj('Tag','MaxXEdit'); set(h,'String',num2str(xax(2)))
h=findobj('Tag','MinYEdit'); set(h,'String',num2str(yax(1)))
h=findobj('Tag','MaxYEdit'); set(h,'String',num2str(yax(2)))

% ------------- SETAXES3 ------------
function setaxes3

h=findobj('Tag','MinXEdit'); xlow=str2double(get(h,'String'));
h=findobj('Tag','MaxXEdit'); xhigh=str2double(get(h,'String'));
h=findobj('Tag','MinYEdit'); ylow=str2double(get(h,'String'));
h=findobj('Tag','MaxYEdit'); yhigh=str2double(get(h,'String'));

xlim([xlow xhigh]); ylim([ylow yhigh]);

% ------------- SELBAR ------------
function selbar
global SPEC

h=findobj('Tag','PlotSpecList'); sel=get(h,'Value');

% Barplot
cf=findobj('Tag','SpectraWin'); set(0,'CurrentFigure',cf);
bar(SPEC(sel).ions,SPEC(sel).S); 
setaxes3

% ------------- ALLBAR ------------
function allbar
global SPEC

for x=1:length(SPEC)
    SPEC(x).minmass=min(SPEC(x).ions);
    SPEC(x).maxmass=max(SPEC(x).ions);
end
minmass=min(cat(1,SPEC(:).minmass));
maxmass=max(cat(1,SPEC(:).maxmass));

masses=minmass:maxmass;
for massno=1:length(masses)
    for specno=1:length(SPEC)
        ind=find(SPEC(specno).ions==masses(massno));
        if isempty(ind)==0 
            Abund(specno,massno)=SPEC(specno).S(ind);
            masses(massno)=SPEC(specno).ions(ind);
        end
    end
end

% Barplot
cf=findobj('Tag','SpectraWin'); set(0,'CurrentFigure',cf);
bar(masses',Abund'); 
setaxes3

% ------------- SELMEAN ------------
function selmean
global SPEC

for x=1:length(SPEC)
    SPEC(x).minmass=min(SPEC(x).ions);
    SPEC(x).maxmass=max(SPEC(x).ions);
end
minmass=min(cat(1,SPEC(:).minmass));
maxmass=max(cat(1,SPEC(:).maxmass));

masses=minmass:maxmass;
Abund=repmat(NaN,length(SPEC),length(masses));
for massno=1:length(masses)
    for specno=1:length(SPEC)
        ind=find(SPEC(specno).ions==masses(massno));
        if isempty(ind)==0 
            Abund(specno,massno)=SPEC(specno).S(ind);
            masses(massno)=SPEC(specno).ions(ind);
        end
    end
end

% Kutter ut masser som ikke er i alle spektra og legger til snitt
sumv=sum(Abund);
ind=find(isnan(sumv));
Abund(:,ind)=[];
masses(ind)=[];

meanspec=mean(Abund)
h=findobj('Tag','PlotSpecList'); sel=get(h,'Value');
selspec=Abund(sel,:)
plotspec=[selspec; meanspec];

% Barplot
cf=findobj('Tag','SpectraWin'); set(0,'CurrentFigure',cf);
bar(masses',plotspec'); 
setaxes3


% ------------- PCA ------------
function PCA
global SPEC

for x=1:length(SPEC)
    SPEC(x).minmass=min(SPEC(x).ions);
    SPEC(x).maxmass=max(SPEC(x).ions);
end
minmass=min(cat(1,SPEC(:).minmass));
maxmass=max(cat(1,SPEC(:).maxmass));

masses=minmass:maxmass;
Abund=repmat(NaN,length(SPEC),length(masses));
for massno=1:length(masses)
    for specno=1:length(SPEC)
        ind=find(SPEC(specno).ions==masses(massno));
        if isempty(ind)==0 
            Abund(specno,massno)=SPEC(specno).S(ind);
            masses(massno)=SPEC(specno).ions(ind);
        end
    end
end

% Kutter ut masser som ikke er i alle spektra
sumv=sum(Abund);
ind=find(isnan(sumv));
Abund(:,ind)=[];
masses(ind)=[];

%Senterer
meanabund=repmat(mean(Abund),length(SPEC),1);
Abund=Abund-meanabund;

% Beregner norm (Avstand til snittspektrum)
A2=Abund.^2; sumA=sum(A2,2); dist=sqrt(sumA);
% PCA
[U,S,V]=svds(Abund,2); P=U*S;
% Residualer (avstand til modell)
X=U*S*V'; E=X-Abund; E2=E.^2; sumE=sum(E2,2); res=sqrt(sumE);

cf=findobj('Tag','SpectraWin'); set(0,'CurrentFigure',cf);
plot(P(:,1),P(:,2),'o'); hold on
for x=1:length(SPEC)
    plot(P(x,1),P(x,2),'or')
    numstr=num2str(x); %numstr=[numstr blanks(4-length(numstr))]; 
    diststr=num2str(dist(x)); %diststr=[diststr blanks(8-length(diststr))]; 
    resstr=num2str(res(x)); %resstr=[resstr blanks(8-length(resstr))]; 
    str=['  ' numstr ') ' diststr ' / ' resstr];
    text(P(x,1),P(x,2),str)
end
plot(0,0,'+')    
hold off

% ------------- SPECTOGGLE ------------
function spectoggle

h=findobj('Tag','SpecToggle'); set(h,'Value',0)
set(gcbo,'Value',1)


%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
gh=positions.gh;% grid height

bo=bw/5;
x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='SpectraWin'; winpar{2}='Q: Spectra'; 
winpar{3}=[0.1 0.1 0.8 0.8]; %Strrelse

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0; o=bw/2;
% CLOSE
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_closewin',3,'CloseBtn');
%p=p+1;[ui{p,1:7}] = deal('Accept','Pushbutton',colors.accept,[x(1) y(19)+bh/2 bw bh*1.5],'qq_load_agilent(10)',3,'AcceptBtn');

% Filliste
p=p+1;[ui{p,1:7}] = deal('','Listbox',[1 1 1],[x(1) y(7) bw*1.5 bh*8],'qq_spectra(20.1)',2,'PlotSpecList');

% Scale
p=p+1;[ui{p,1:7}] = deal('Min X','text',colors.bc,[x(1) y(8) bw/2 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('0','Edit',[1 1 1],[x(1)+bw/2 y(8) bw/2 eh],'qq_spectra(10.1)',2,'MinXEdit');
p=p+1;[ui{p,1:7}] = deal('Max X','text',colors.bc,[x(1) y(9) bw/2 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('100','Edit',[1 1 1],[x(1)+bw/2 y(9) bw/2 eh],'qq_spectra(10.1)',2,'MaxXEdit');
p=p+1;[ui{p,1:7}] = deal('Min Y','text',colors.bc,[x(1) y(10) bw/2 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('0','Edit',[1 1 1],[x(1)+bw/2 y(10) bw/2 eh],'qq_spectra(10.1)',2,'MinYEdit');
p=p+1;[ui{p,1:7}] = deal('Max Y','text',colors.bc,[x(1) y(11) bw/2 eh],'',2,'');
p=p+1;[ui{p,1:7}] = deal('100','Edit',[1 1 1],[x(1)+bw/2 y(11) bw/2 eh],'qq_spectra(10.1)',2,'MaxYEdit');

% Actions
p=p+1;[ui{p,1:7}] = deal('All Spectra','Togglebutton',colors.btn{1},[x(1) y(13) bw bh],'qq_spectra(1)',2,'SpecToggle');
p=p+1;[ui{p,1:7}] = deal('Selected','Togglebutton',colors.btn{1},[x(1) y(14) bw bh],'qq_spectra(1.1)',2,'SpecToggle');
p=p+1;[ui{p,1:7}] = deal('Sel / Mean','Togglebutton',colors.btn{1},[x(1) y(15) bw bh],'qq_spectra(1.2)',2,'SpecToggle');
p=p+1;[ui{p,1:7}] = deal('PCA','Togglebutton',colors.btn{1},[x(1) y(16) bw bh],'qq_spectra(2)',2,'SpecToggle');

updfcn='';
h0=qq_drawwin(winpar,ui,updfcn);

drawnow
    

%h=findobj('Tag','DirList'); set(h,'ButtonDownFcn','qq_loadcall(2)','TooltipString','Right click to change directory') 
%h=findobj('Tag','ContentsList'); set(h,'ButtonDownFcn','qq_loadcall(3)','TooltipString','Right click to Load') 
%h=findobj('Tag','rjust'); set(h,'HorizontalAlignment','right')
%---------------- AXES ----------------
h = axes('Position',[x(3) y(20) bw*7 bh*25],'Tag','SpecPlot');
















   



        


















   






   






