function qq_ucmcall(an)

global XBL XR fileset metset CL RE positions ucmset RE_ucm locset

%persistent plotupd winupd showspec     % Parametre for plot

qq_message(2); % Blank

if an==0;
    openwin;
    qq_plot_ionchrom(0); qq_plot_scale(100); 
    ucmset.seldef=0; ucmset.nquant=0; ucmset.defsaved='No'; ucmset.resultssaved='No';
    qq_ucmcall(10.1); % Reads def
    ucmset.quantified=zeros(1,length(ucmset.definitions));
end

if an==1
    ndef=length(ucmset.definitions);
    if ndef>0
        for defno=1:ndef
            ucmres=selcalc(defno);
            fn=fieldnames(ucmres); for x=1:length(fn); RE_ucm(defno).(fn{x})=ucmres.(fn{x}); end
        end   
        ucmset.quantified=ones(1,length(ucmset.definitions));
    else
        qq_message('|r|No definitions');
    end   
end
if an==2
    if ucmset.seldef>0
        ucmres=selcalc(ucmset.seldef);
        fn=fieldnames(ucmres); for x=1:length(fn); RE_ucm(ucmset.seldef).(fn{x})=ucmres.(fn{x}); end
        plotint(RE_ucm(ucmset.seldef))
    else
        qq_message('|r|Select definitions')       
    end
end
if an==1 || an==2
    ucmset.nquant=sum(ucmset.quantified);
end

% PLOT IONS
if an==4
    qq_plot_ionchrom(0); scaleplot
end

% LOAD/SAVE
% Save results
if an==8.1
    if strcmp(fileset.global_filename,'No file')
        qq_message(1,'|r|No file to save')
    else
        fnam=[locset.path_results '\' metset.path_results '\ucmres_' fileset.global_filename];
        save(fnam,'XBL','XR','RE_ucm','fileset','metset','ucmset');
        qq_message(1,['|b|Results saved in: ',fnam]);
        ucmset.resultssaved='Yes';
    end
end

% Load results
if an==8.2
    oldmet=metset;
    
    h=findobj(gcf,'Tag','FileBoxEdit'); files=get(h,'String'); val=get(h,'Value'); 
    if isempty(files)==0 nam=files{val}; else nam=''; end
    
    fnam=[locset.path_results '\' metset.path_results '\ucmres_' nam '.mat'];
    D=dir([fnam,'.*']); [a,b]=size(D);
    if a==1
        %h=findobj(gcf,'Tag','LoadMethodCheck');
        loadmeth=get(findobj(gcf,'Tag','LoadMethodCheck'),'Value');
        loaddef=get(findobj(gcf,'Tag','LoadDefCheck'),'Value');
        if loadmeth && loaddef
            %disp('---- meth+def ----')
            load(fnam,'XBL','XR','RE_ucm','fileset','metset','ucmset'); checkmet(oldmet); % Loader metset
        end
        if loadmeth && loaddef==0
            %disp('---- meth ----')
            load(fnam,'XBL','XR','RE_ucm','fileset','metset'); checkmet(oldmet); % Loader metset
        end
        if loadmeth==0 && loaddef
            %disp('---- def ----')
            load(fnam,'XBL','XR','RE_ucm','fileset','ucmset'); % Loader metset
        end        
        if loadmeth==0 && loaddef==0
            %disp('---- -- ----')
            load(fnam,'XBL','XR','RE_ucm','fileset'); % Loader metset
        end 
        qq_plot_ionchrom(0); fileset.chrom_li=1; fileset.chrom_ri=length(fileset.rt); qq_plot_scale(100); ucmset.seldef=0; writedef
        ucmset.resultssaved='Yes';
    else 
        qq_message(1,'|r|No such results file');
    end
end
% Get files
if an==8.3
    getfiles
end
% Tempsave
if an==8.4
    if isempty(XR)==0
        save('c:\qq\qq_ucm_tempsave','XBL','XR','RE_ucm','fileset','metset','ucmset');
    else
        qq_message(1,'|r|No data saved')
    end
end
% Resume
if an==8.5
    oldmet=metset;
    load('c:\qq\qq_ucm_tempsave','XBL','XR','RE_ucm','fileset','metset','ucmset'); checkmet(oldmet);
    % Filnavn & Tic
    if isfield(fileset,'file_filename') fnam=fileset.global_filename; else fnam='no file'; end
    h=findobj(gcf,'Tag','CurrentFileEdit'); set(h,'String',fnam);
    qq_plot_ionchrom(0); qq_plot_scale(100); writedef
end

% read definitions
if an==10.1
    %if isfield(metset,'file_root')==0 metset.file_root='C:\qq'; end
    A=textread([locset.path_root '\def_UCM.sdv'],'%q','whitespace','\n');
    ucmset.definitions=getdef(A);
    ucmset.defsaved='Yes';
end
% Save Def
if an==10.2
    savedef, ucmset.defsaved='Yes';
end
% Edit Definitions
if an==10.3
    %if isfield(metset,'file_root')==0 metset.file_root='C:\qq'; end
    filename=[locset.path_root '\def_UCM.sdv'];
    dos(filename)
end

% SELECT LINE
if an==20.1 && ucmset.seldef>1
    ucmset.seldef=ucmset.seldef-1; writedef; 
    if ucmset.quantified(ucmset.seldef)==1
        plotint(RE_ucm(ucmset.seldef))
    else
        qq_plot_ionchrom(0); scaleplot
    end
end
if an==20.2 && ucmset.seldef<length(ucmset.definitions)
    ucmset.seldef=ucmset.seldef+1; writedef; 
    if ucmset.quantified(ucmset.seldef)==1
        plotint(RE_ucm(ucmset.seldef))
    else 
       qq_plot_ionchrom(0); scaleplot
    end
end
if an==20.3
    h=findobj('Tag','DefNoEdit');
    val=round(str2double(get(h,'String')));
    if val<=length(ucmset.definitions) || val>=1
        ucmset.seldef=val;
    else
        set(h,'String',num2str(ucmset.seldef));
    end
        if ucmset.quantified(ucmset.seldef)==1
        plotint(RE_ucm(ucmset.seldef));
    else 
       qq_plot_ionchrom(0); scaleplot;
    end
    writedef
end


if an==20.4 && ucmset.seldef>0
    definp; scaleplot
end
    
% Report
if an==30
    sdvreport
end
    
if an==40
    movebaseline; %integrate; %qq_plot_quant
    plotint(RE_ucm(ucmset.seldef))
end

% Keypress
if an==98
    kp=double(get(gcf,'CurrentCharacter'));
    if kp==31  qq_ucmcall(20.1); end    
    if kp==30  qq_ucmcall(20.2); end
    %if kp==28 | kp==29 qq_chrom(1.35); end %
    if kp==28 | kp==29 qq_plot_scale(1.35); end %
end

if an==99
    RE_ucm=[];
    qq_closewin;
end

% UPDATE
statustext=findobj('Tag','StatusText');
str{1}=['Definitions in memory: ' num2str(length(ucmset.definitions))];
str{2}=['Quantified: ' num2str(ucmset.nquant)];
str{3}=['Current: ' num2str(ucmset.seldef)];
str{4}=['Definitions saved: ' ucmset.defsaved];
str{5}=['Results saved: ' ucmset.resultssaved];
set(statustext,'String',str)

%ucmset % TEMP
%scaleplot % TEMP

% ----------------- ----------- -----------------
% ----------------- SUFUNCTIONS ----------------- 
% ----------------- ----------- -----------------

% -------------- SUBFUNCTION CHECKMET -------------------
% Legger over felt som ikke er i lastet metode (sikrer kompatibilitet med
% gamle data)
function checkmet(oldmet)
global metset

fnam=fieldnames(oldmet); le=length(fnam);
for x=1:le
    if isfield(metset,fnam{x})==0 metset.(fnam{x})=oldmet.(fnam{x}); end
end

% -------- ------ SUBFUNCTION GETFILES -------------------
function getfiles
global fileset metset locset

searchstring=get(findobj(gcf,'Tag','SearchStringEdit'),'String');
searchstring=[locset.path_results '\' metset.path_results '\ucmres_' searchstring '.mat'];

DD=dir(searchstring);
for x=1:length(DD)
    nam=DD(x).name; ind1=strfind(nam,'.mat'); str{x}=nam(8:ind1-1);
end
if length(DD)==0 str=''; end
h=findobj(gcf,'Tag','FileBoxEdit'); set(h,'String',str); set(h,'Value',1);


%--------------- MOVEBASELINE ------------------
function movebaseline
global metset quantset ucmset RE_ucm fileset

handle_id=get(gco,'Userdata');

qq_message(1,'|b|Select new position')
[x,y] = ginput(1);

xax=fileset.chrom_plotlab;
sumtr=RE_ucm(ucmset.seldef).sumtr; 
lbx=RE_ucm(ucmset.seldef).lbx;
rbx=RE_ucm(ucmset.seldef).rbx;
lby=RE_ucm(ucmset.seldef).lby;
rby=RE_ucm(ucmset.seldef).rby;

if handle_id<0 % Left handle
    [area,locprof,lbx,rbx,lby,rby,lbx_ind,rbx_ind]=integrate(xax,sumtr,x,rbx,y,rby);
else
    [area,locprof,lbx,rbx,lby,rby,lbx_ind,rbx_ind]=integrate(xax,sumtr,lbx,x,lby,y);
end

RE_ucm(ucmset.seldef).profile=locprof; 
RE_ucm(ucmset.seldef).lbx=lbx;
RE_ucm(ucmset.seldef).rbx=rbx;
RE_ucm(ucmset.seldef).lby=lby;
RE_ucm(ucmset.seldef).rby=rby;
RE_ucm(ucmset.seldef).lbx_ind=lbx_ind;
RE_ucm(ucmset.seldef).rbx_ind=rbx_ind;
RE_ucm(ucmset.seldef).area=area;

qq_message(2)


% ------------------- INTEGRATE ----------------
function [area,locprof,lhp,rhp,lvp,rvp,lbx_ind,rbx_ind]=integrate(xax,profile,lhp,rhp,lvp,rvp)
global ucmset
ucmset.resultssaved='No'; 
if ucmset.seldef>0 ucmset.quantified(ucmset.seldef)=1; end

lbx_ind=max(find(xax<lhp));
lbx=xax(lbx_ind);

rbx_ind=min(find(xax>rhp));
rbx=xax(rbx_ind);

locprof=profile(lbx_ind:rbx_ind);
baseline=linspace(lvp,rvp,length(locprof))';
intprof=locprof-baseline;
area=sum(intprof);

% ------------------- SELCALC ----------------
function ucmres=selcalc(defno)
global XBL fileset ucmset 

[nscans,nions]=size(XBL); % TEMP
% Finds trace
ions=ucmset.definitions(defno).ions;
for x=1:length(ions)
    ionind=find(fileset.ions==ions(x));
    if isempty(ionind)
        TR(:,x)=zeros(nscans,length(ions));
    else    
       TR(:,x)=XBL(:,ionind);
   end
end
sumtr=sum(TR,2);

% Finds indices
lbl_ind=max(find(fileset.rt<ucmset.definitions(defno).blp(1)));
lbh_ind=min(find(fileset.rt>ucmset.definitions(defno).blp(2)));
rbl_ind=max(find(fileset.rt<ucmset.definitions(defno).blp(3)));
rbh_ind=min(find(fileset.rt>ucmset.definitions(defno).blp(4)));

% ALT 1
%lby=min(sumtr(lbl_ind:lbh_ind)); lbx_ind=max(find(sumtr(lbl_ind:lbh_ind)==lby))+lbl_ind-1; lbx=fileset.chrom_plotlab(lbx_ind);
%rby=min(sumtr(rbl_ind:rbh_ind)); rbx_ind=min(find(sumtr(rbl_ind:rbh_ind)==rby))+rbl_ind-1;rbx=fileset.chrom_plotlab(rbx_ind);

% ALT 2
loctr=sumtr(lbl_ind:lbh_ind); nint=ceil(length(loctr)/10); sorted=sort(loctr); tresh=mean(sorted(1:nint)); 
lbx_ind=max(find(sumtr(lbl_ind:lbh_ind)<=tresh))+lbl_ind-1; lbx=fileset.chrom_plotlab(lbx_ind); lby=sumtr(lbx_ind);
loctr=sumtr(rbl_ind:rbh_ind); nint=ceil(length(loctr)/10); sorted=sort(loctr); tresh=mean(sorted(1:nint));
rbx_ind=min(find(sumtr(rbl_ind:rbh_ind)<=tresh))+rbl_ind-1; rbx=fileset.chrom_plotlab(rbx_ind); rby=sumtr(rbx_ind);

[maxy,maxx_ind]=max(sumtr(lbl_ind:rbh_ind)); 
maxx_ind=maxx_ind+lbl_ind-1;
maxx=fileset.chrom_plotlab(maxx_ind);

if ucmset.definitions(defno).blfit==0
    lby=0;rby=0;
end

[area,locprof,lhp,rhp,lvp,rvp,lbx_ind,rbx_ind]=integrate(fileset.chrom_plotlab,sumtr,lbx,rbx,lby,rby);

ucmres.name=ucmset.definitions(defno).name;

ucmres.TR=TR;
ucmres.sumtr=sumtr;

ucmres.lbx_ind=lbx_ind;
ucmres.lbx=lbx;
ucmres.lby=lby;
ucmres.rbx_ind=rbx_ind;
ucmres.rbx=rbx;
ucmres.rby=rby;

ucmres.maxx_ind=maxx_ind;
ucmres.maxx=maxx;
ucmres.maxy=maxy;

ucmres.profile=locprof;
ucmres.area=area;

ucmres.ions=ucmset.definitions(defno).ions;


% ------------- PLOTINT ---------------
function plotint(ucmres)
global fileset metset positions

fileset.chrom_tic5=ucmres.sumtr;
fileset.chrom_tic6=min(ucmres.TR,[],2);

subplot('position',[0 0.5 1 0.5])
plot(fileset.chrom_plotlab,ucmres.sumtr,'LineWidth',2,'Color',[0 0 0])

hold on
plot(fileset.chrom_plotlab,ucmres.TR,'LineWidth',1)

plot(fileset.chrom_plotlab(ucmres.lbx_ind:ucmres.rbx_ind),ucmres.sumtr(ucmres.lbx_ind:ucmres.rbx_ind),'r','LineWidth',2)
line([ucmres.lbx ucmres.rbx],[ucmres.lby ucmres.rby],'Color',[1 0 0],'LineWidth',2)
line([ucmres.lbx ucmres.lbx],[ucmres.lby ucmres.sumtr(ucmres.lbx_ind)],'Color',[1 0 0],'LineWidth',2)
line([ucmres.rbx ucmres.rbx],[ucmres.rby ucmres.sumtr(ucmres.rbx_ind)],'Color',[1 0 0],'LineWidth',2)

menuh2=uicontextmenu; set(menuh2,'Tag','HandleMenu');
uimenu(menuh2,'Label','Move','CallBack','qq_ucmcall(40)')

lh=plot(ucmres.lbx,ucmres.lby,'o','MarkerSize',10,'MarkerEdgeColor',[1 0 0],'MarkerFaceColor',[1 1 0],...
    'UserData',-1,'Tag','BaselineHandle','ButtonDownFcn','set(gcbo,''Tag'',''SelBaselineHandle'')','UiContextMenu',menuh2);
rh=plot(ucmres.rbx,ucmres.rby,'o','MarkerSize',10,'MarkerEdgeColor',[1 0 0],'MarkerFaceColor',[1 1 0],...
    'UserData',1,'Tag','BaselineHandle','ButtonDownFcn','set(gcbo,''Tag'',''SelBaselineHandle'')','UiContextMenu',menuh2);

str{1}=['Area: ' num2str(round(ucmres.area))];
h=text(0.06,0.9,str,'VerticalAlignmen','Bottom','HorizontalAlignment','Center','FontSize',6,'FontWeight','Bold','Units','normalized'); 
    
hold off

set(gca,'Tag','Mainchrom','UserData','Ion Chromatogram')

scaleplot

% ------------------- SCALEPLOT ----------------
function scaleplot
global fileset ucmset 

lrt=ucmset.definitions(ucmset.seldef).blp(1);
rrt=ucmset.definitions(ucmset.seldef).blp(4);
o=(rrt-lrt)/100; lrt=lrt-o; rrt=rrt+o;

li=max(find(fileset.rt<lrt)); if isempty(li) li=1; end 
ri=min(find(fileset.rt>rrt)); if isempty(ri) ri=length(fileset.rt); end

fileset.chrom_li=li; fileset.chrom_ri=ri; 

qq_plot_scale(100);

% ------------------- SAVEDEF ----------------
function savedef
global metset ucmset

writestr{1}=['Name; L.basel.low; L.basel.high; R.basel.low; R.basel.high ;Fit Baseline; Ion1; Ion2; Ion...\n'];
for x=1:length(ucmset.definitions)
    str=[ucmset.definitions(x).name '; '... 
            num2str(ucmset.definitions(x).blp(1)) '; ' ...
            num2str(ucmset.definitions(x).blp(2)) '; ' ...
            num2str(ucmset.definitions(x).blp(3)) '; ' ...
            num2str(ucmset.definitions(x).blp(4)) '; ' ...
            num2str(ucmset.definitions(x).blfit)];
    ions=ucmset.definitions(x).ions;
    for y=1:length(ions); str=[str '; ' num2str(ions(y))]; end
    writestr{x+1}=[str '\n'];    
end

%if isfield(metset,'file_root')==0 metset.file_root='C:\qq'; end
fh=fopen([locset.path_root '\def_UCM.sdv'],'w');
for x=1:length(writestr)
    fprintf(fh,writestr{x});
end
fclose(fh);

% ------------------- DEFINP----------------
function definp
global ucmset colors fileset
ucmset.defsaved='No';

DefNameEdit=findobj('Tag','DefNameEdit');
lblEdit=findobj('Tag','lblEdit');
lbhEdit=findobj('Tag','lbhEdit');
rblEdit=findobj('Tag','rblEdit');
rbhEdit=findobj('Tag','rbhEdit');
ionsEdit=findobj('Tag','ionsEdit');
set([DefNameEdit lblEdit lbhEdit rblEdit rbhEdit ionsEdit],'BackgroundColor',colors.btn{3})

ucmset.definitions(ucmset.seldef).name=get(DefNameEdit,'String');

lbl=str2double(get(lblEdit,'String'));
if isnan(lbl) 
    set(lblEdit,'BackgroundColor',[1 1 0],'String',num2str(ucmset.definitions(ucmset.seldef).blp(1)))
else
    ucmset.definitions(ucmset.seldef).blp(1)=lbl;
end

lbh=str2double(get(lbhEdit,'String'));
if isnan(lbh) 
    set(lbhEdit,'BackgroundColor',[1 1 0],'String',num2str(ucmset.definitions(ucmset.seldef).blp(2)))
else
    ucmset.definitions(ucmset.seldef).blp(2)=lbh;
end

rbl=str2double(get(rblEdit,'String'));
if isnan(rbl) 
    set(rblEdit,'BackgroundColor',[1 1 0],'String',num2str(ucmset.definitions(ucmset.seldef).blp(3)))
else
    ucmset.definitions(ucmset.seldef).blp(3)=rbl;
end

rbh=str2double(get(rbhEdit,'String'));
if isnan(rbh) 
    set(rbhEdit,'BackgroundColor',[1 1 0],'String',num2str(ucmset.definitions(ucmset.seldef).blp(4)))
else
    ucmset.definitions(ucmset.seldef).blp(4)=rbh;
end

ionstr=get(ionsEdit,'String');
delp=[0 strfind(ionstr,';') length(ionstr)+1]; p=0; ion=[];
for x=1:length(delp)-1
    tion=str2double(ionstr(delp(x)+1:delp(x+1)-1)); if isnan(tion)==0; ion=[ion tion]; end
end
ion=sort(ion);

if isempty(ion) ion=ucmset.definitions(ucmset.seldef).ions; set(ionsEdit,'BackgroundColor',[1 1 0]); end
str=[]; for x=1:length(ion) str=[str num2str(ion(x)) ';']; end; str(length(str))=[]; set(ionsEdit,'String',str);
ucmset.definitions(ucmset.seldef).ions=ion;

BlCheck=findobj('Tag','BlCheck'); ucmset.definitions(ucmset.seldef).blfit=get(BlCheck,'Value');

% ------------------- WRITEDEF----------------
function writedef
global ucmset

if ucmset.seldef>0

    DefNoEdit=findobj('Tag','DefNoEdit');
    set(DefNoEdit,'String',num2str(ucmset.seldef)); 

    DefNameEdit=findobj('Tag','DefNameEdit');
    set(DefNameEdit,'String',num2str(ucmset.definitions(ucmset.seldef).name));

    lblEdit=findobj('Tag','lblEdit');
    set(lblEdit,'String',num2str(ucmset.definitions(ucmset.seldef).blp(1)));

    lbhEdit=findobj('Tag','lbhEdit');
    set(lbhEdit,'String',num2str(ucmset.definitions(ucmset.seldef).blp(2)));

    rblEdit=findobj('Tag','rblEdit');
    set(rblEdit,'String',num2str(ucmset.definitions(ucmset.seldef).blp(3)));

    rbhEdit=findobj('Tag','rbhEdit');
    set(rbhEdit,'String',num2str(ucmset.definitions(ucmset.seldef).blp(4)));

    BlCheck=findobj('Tag','BlCheck');
    set(BlCheck,'Value',ucmset.definitions(ucmset.seldef).blfit);

    ionsEdit=findobj('Tag','ionsEdit');
    str=num2str(ucmset.definitions(ucmset.seldef).ions(1)); 
    if length(ucmset.definitions(ucmset.seldef).ions)>1 
        for x=2:length(ucmset.definitions(ucmset.seldef).ions)
            str=[str ';' num2str(ucmset.definitions(ucmset.seldef).ions(x))];
        end
    end
    set(ionsEdit,'String',str);

end

% ------------------- GETDEF----------------
function ucmdef=getdef(incell)
% converts cell with strings to definitions 

p=0;
for x=2:length(incell)
    err=0;
    str=[incell{x} ';'];
    skp=strfind(str,';');
    nentr=length(skp);
    name=str(1:skp(1)-1);
    lbl=str2double(str(skp(1)+1:skp(2)-1)); if isnan(lbl) err=1; end
    lbh=str2double(str(skp(2)+1:skp(3)-1)); if isnan(lbh) err=1; end
    rbl=str2double(str(skp(3)+1:skp(4)-1)); if isnan(rbl) err=1; end
    rbh=str2double(str(skp(4)+1:skp(5)-1)); if isnan(rbh) err=1; end
    blp=sort([lbl lbh rbl rbh]);
    blfit=str2double(str(skp(5)+1:skp(6)-1));
    ion=[];
    for y=6:nentr-1
        val=str2double(str(skp(y)+1:skp(y+1)-1)); if isnan(val)==0 ion=[ion val]; end
    end
    if isempty(ion) err=1; end
    if err==0
        p=p+1;
        ucmdef(p).name=name;
        ucmdef(p).blp=blp;
        ucmdef(p).blfit=blfit;
        ucmdef(p).ions=ion;
    end
end

% ------------------- SDVREPORT ----------------
function sdvreport
global RE_ucm metset fileset locset

writestr{1}='Name; Area; lbl (min); rbl (min); lbl(abun); rbl(abund); ions \n';
for x=1:length(RE_ucm)
    str=[RE_ucm(x).name '; ' ...
        num2str(RE_ucm(x).area) '; ' ...
        num2str(RE_ucm(x).lbx) '; ' ...
        num2str(RE_ucm(x).rbx) '; ' ...
        num2str(RE_ucm(x).lby) '; ' ...
        num2str(RE_ucm(x).rby)];
    ionstr=[];
    for y=1:length(RE_ucm(x).ions)
        ionstr=[ionstr '; ' num2str(RE_ucm(x).ions(y))];
    end
    writestr{x+1}=[str ionstr '\n'];
end

filename=[locset.path_results '\' metset.path_results '\UCMQuant_' fileset.global_filename '.sdv'];
fh=fopen(filename,'w');
for x=1:length(writestr)
    fprintf(fh,writestr{x});
end
fclose(fh);
dos(filename)


%======================================== WINDOW ========================================
% ------------------- OPENWIN ---------------------
function openwin

global positions colors metset fileset

bw=positions.bw;
bh=positions.bh;
eh=positions.eh; eo=(bh-eh)/2; % edit offset
o=bw/5;
%gh=positions.gh;% grid height

x=positions.gl:positions.gw:1; % horisontalt grid
y=positions.gt+0.5:-positions.gh:0; % vertikalt grid

winpar{1}='UCMWin'; winpar{2}='Q: UCM-Quant';

% 'String','Style','Backgroundcolor','Position','Callback','Fonts'
p=0;
% RESET/CLOSE/ACCEPT
p=p+1;[ui{p,1:7}] = deal('Close','Pushbutton',colors.close,[x(1) y(20) bw bh*1.5],'qq_ucmcall(99)',3,'');

% 
% SELECT ION
p=p+1;[ui{p,1:7}] = deal('Show ions','Pushbutton',colors.bc,[x(1) y(13) bw bh],'qq_ucmcall(4)',2,'');
%p=p+1;[ui{p,1:7}] = deal('<','Pushbutton',colors.bc,[x(2) y(13) bw/3 bh],'',4,'');
%p=p+1;[ui{p,1:7}] = deal('>','Pushbutton',colors.bc,[x(2)+bw*2/3 y(13) bw/3 bh],'',4,'');
%p=p+1;[ui{p,1:7}] = deal('','Edit',colors.bc,[x(2)+bw/3 y(13) bw/3 bh],'',4,'');

% CALCULATE
p=p+1;[ui{p,1:7}] = deal('Calc All','Pushbutton',colors.btn{1},[x(1) y(14) bw bh],'qq_ucmcall(1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Calc Current','Pushbutton',colors.btn{1},[x(2) y(14) bw bh],'qq_ucmcall(2)',2,'');

% DEFINITIONS
p=p+1;[ui{p,1:7}] = deal('Read Def','Pushbutton',colors.btn{3},[x(1) y(15) bw bh],'qq_ucmcall(10.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Save Def','Pushbutton',colors.btn{3},[x(2) y(15) bw bh],'qq_ucmcall(10.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('Edit Def','Pushbutton',colors.btn{3},[x(3) y(15) bw bh],'qq_ucmcall(10.3)',2,'');
%p=p+1;[ui{p,1:7}] = deal('Add Comp','Pushbutton',colors.btn{3},[x(4) y(15) bw bh],'',2,'');

p=p+1;[ui{p,1:7}] = deal('<','Pushbutton',colors.btn{3},[x(1) y(16) bw/3 bh],'qq_ucmcall(20.1)',4,'');
p=p+1;[ui{p,1:7}] = deal('>','Pushbutton',colors.btn{3},[x(1)+bw*2/3 y(16) bw/3 bh],'qq_ucmcall(20.2)',4,'');
p=p+1;[ui{p,1:8}] = deal('','Edit',colors.btn{3},[x(1)+bw/3 y(16) bw/3 bh],'qq_ucmcall(20.3)',3,'DefNoEdit','-c');
p=p+1;[ui{p,1:8}] = deal('Name','Edit',colors.btn{3},[x(2) y(16) bw bh],'qq_ucmcall(20.4)',2,'DefNameEdit','-c');
p=p+1;[ui{p,1:8}] = deal('LB: ','Text',colors.btn{3},[x(3) y(16) bw/3 bh],'',2,'','-r');
p=p+1;[ui{p,1:8}] = deal('','Edit',colors.btn{3},[x(3)+bw/3 y(16) bw/3 bh],'qq_ucmcall(20.4)',2,'lblEdit','-r');
p=p+1;[ui{p,1:8}] = deal('','Edit',colors.btn{3},[x(3)+bw*2/3 y(16) bw/3 bh],'qq_ucmcall(20.4)',2,'lbhEdit','-r');
p=p+1;[ui{p,1:8}] = deal('RB: ','Text',colors.btn{3},[x(4) y(16) bw/3 bh],'',2,'','-r');
p=p+1;[ui{p,1:8}] = deal('','Edit',colors.btn{3},[x(4)+bw/3 y(16) bw/3 bh],'qq_ucmcall(20.4)',2,'rblEdit','-r');
p=p+1;[ui{p,1:8}] = deal('','Edit',colors.btn{3},[x(4)+bw*2/3 y(16) bw/3 bh],'qq_ucmcall(20.4)',2,'rbhEdit','-r');
p=p+1;[ui{p,1:8}] = deal('','Text',colors.btn{3},[x(5) y(16) bw bh],'',2,'','');
p=p+1;[ui{p,1:8}] = deal('Fit Basel.','Checkbox',colors.btn{3},[x(5)+bw/4 y(16) bw bh],'qq_ucmcall(20.4)',2,'BlCheck','');
p=p+1;[ui{p,1:8}] = deal('Ions: ','Text',colors.btn{3},[x(6) y(16) 2*bw/3 bh],'',2,'','-r');
p=p+1;[ui{p,1:8}] = deal('','Edit',colors.btn{3},[x(6)+bw*2/3 y(16) bw bh],'qq_ucmcall(20.4)',2,'ionsEdit','-r');

% REPORT
p=p+1;[ui{p,1:7}] = deal('Report','Pushbutton',colors.bc,[x(1) y(17) bw bh],'qq_ucmcall(30)',2,'');

hp=8;
p=p+1;[ui{p,1:7}] = deal('Load def.','Checkbox',colors.bc,[x(hp-1)+bw/6 y(20) bw*0.75 bh],'',2,'LoadDefCheck');
p=p+1;[ui{p,1:7}] = deal('Load meth.','Checkbox',colors.bc,[x(hp-2)+bw/6 y(20) bw*0.75 bh],'',2,'LoadMethodCheck');
p=p+1;[ui{p,1:7}] = deal('Save Results','Pushbutton',colors.btn{6},[x(hp)+0.75*bw y(20) bw*0.75 bh],'qq_ucmcall(8.1)',2,'');
p=p+1;[ui{p,1:7}] = deal('Load Results','Pushbutton',colors.btn{6},[x(hp) y(20) bw*0.75 bh],'qq_ucmcall(8.2)',2,'');
p=p+1;[ui{p,1:7}] = deal('Tempsave','Pushbutton',colors.btn{6},[x(hp)+bw*0.75 y(19) bw*0.75 bh],'qq_ucmcall(8.4)',2,'');
p=p+1;[ui{p,1:7}] = deal('Resume','Pushbutton',colors.btn{6},[x(hp) y(19) bw*0.75 bh],'qq_ucmcall(8.5)',2,'');

hp=8;
p=p+1;[ui{p,1:8}] = deal('Current file:','Text',colors.bc,[x(hp-1) y(13) bw*2 eh],'',2,'','-l -fh -fvp');
p=p+1;[ui{p,1:8}] = deal('','Edit',[1 1 1],[x(hp) y(13) bw*1.5 eh],'qq_ucmcall(1.1)',3,'CurrentFileEdit','-l -fh -fvp');
p=p+1;[ui{p,1:8}] = deal('Search string:','Text',colors.bc,[x(hp-1) y(14) bw eh],'',2,'','-l -fh -fvp');
p=p+1;[ui{p,1:8}] = deal('','Edit',[1 1 1],[x(hp) y(14) bw*1.5 eh],'qq_ucmcall(8.3)',3,'SearchStringEdit','-l -fh -fvp');
p=p+1;[ui{p,1:7}] = deal('','Listbox',[1 1 1],[x(hp) y(18) bw*1.5 y(14)-y(18)],'',3,'FileBoxEdit');

% STATUSTEXT
hp=x(2)+bw/2; vp=y(20); w=bw*2; h=y(17)-y(20)+bh; o=bw/10;
p=p+1;[ui{p,1:7}] = deal('','frame',colors.bc,[hp vp w h],'',2,'');
p=p+1;[ui{p,1:7}] = deal('','Text',colors.bc,[hp+o vp+o w-2*o h-2*o],'',2,'StatusText');

updfcn='qq_ucmcall(99)';
h0=qq_drawwin(winpar,ui,updfcn);
set(h0,'KeyPressFcn','qq_ucmcall(98)');

h=findobj(h0,'Tag','CurrentFileEdit');set(h,'String',fileset.global_filename)


%h=findobj('Tag','Scaleradio'); set(h,'Value',0); h=findobj(h,'String','Ret. Time');set(h,'Value',1) 
%h=findobj('Tag','Labelradio'); set(h,'Value',0); h=findobj(h,'String','Ret. Time');set(h,'Value',1) 















